// ask.cpp

#include <windows.h>
#include <stdio.h>
#include "msc.h"
#include "ask.h"
#include "oemio.h"



static int GetKey ( int nType ) ;
static int GetVirtualKey ( const INPUT_RECORD *pInputRecord ) ;
static void ConsoleClearLine ( void ) ;



// R\[L[擾AOK  CHANCELԂiANSIŁj
// bZ[W͕WG[o͂ɕ\
// W͂_CNgĂ 0 Ԃ
// nType  MB_OK ̏ꍇF         ^C  1AȊO 0 Ԃ
// nType  MB_OKCANCEL ̏ꍇF   ^C  ESC  1AȊO 0 Ԃ
// nType  MB_YESNO ̏ꍇF      ^CEESCEN  1AENTEREY  0 Ԃ
// nType  MB_YESNOCANCEL ̏ꍇF^CEESC  -1AN  1AENTEREY  0 Ԃ
int AskA ( const char *szMessage, int nType ) {

   // bZ[Wo͂ꍇ
   if ( szMessage && *szMessage ) {

      if ( fisatty ( stdout ) ) fflush ( stdout ) ;
      fflush ( stderr ) ;

      fputs ( szMessage, stderr ) ;
      fflush ( stderr ) ;

      int nResult = GetKey ( nType ) ;

      ConsoleClearLine () ;

      return nResult ;
   }

   // bZ[Wo͂Ȃꍇ
   return GetKey ( nType ) ;
}



// R\[L[擾AOK  CHANCELԂiUNICODEŁj
// bZ[W͕WG[o͂ɕ\
// W͂_CNgĂ 0 Ԃ
// nType  MB_OK ̏ꍇF      ^C  1AȊO 0 Ԃ
// nType  MB_OKCANCEL ̏ꍇF^C  ESC  1AȊO 0 Ԃ
// nType  MB_YESNO ̏ꍇF   ^CEESCEN  1AENTEREY  0 Ԃ
int AskW ( const wchar_t *szMessage, int nType ) {

   // bZ[Wo͂ꍇ
   if ( szMessage && *szMessage ) {

      if ( fisatty ( stdout ) ) fflush ( stdout ) ;
      fflush ( stderr ) ;

      fputws ( szMessage, stderr ) ;
      fflush ( stderr ) ;

      int nResult = GetKey ( nType ) ;

      ConsoleClearLine () ;

      return nResult ;
   }

   // bZ[Wo͂Ȃꍇ
   return GetKey ( nType ) ;
}



// L[擾A0  1 Ԃ
// W͂_CNgĂ 0 Ԃ
static int GetKey ( int nType ) {

   // W͂
   HANDLE hConsole = fget_osfhandle ( stdin ) ;

   unsigned long dwOldMode ;
   if ( ! GetConsoleMode ( hConsole, & dwOldMode ) ) return 0 ;   // error

   FlushConsoleInputBuffer ( hConsole ) ;
   SetConsoleMode ( hConsole, 0 ) ;    // ^C ̉߂𖳌ɂ

   int nResult = 0 ;

   while ( 1 ) {

      int cChar ;

      INPUT_RECORD InputRecord ;
      unsigned long nReadLength ;

      if ( IsNT () ) {
         if ( ! ReadConsoleInputW ( hConsole, & InputRecord, 1, & nReadLength ) || ! nReadLength ) break ;  // error
         if ( InputRecord.EventType != KEY_EVENT || ! InputRecord.Event.KeyEvent.bKeyDown ) continue ;
         cChar = (wchar_t) InputRecord.Event.KeyEvent.uChar.UnicodeChar ;
      }
      else {
         if ( ! ReadConsoleInputA ( hConsole, & InputRecord, 1, & nReadLength ) || ! nReadLength ) break ;  // error
         if ( InputRecord.EventType != KEY_EVENT || ! InputRecord.Event.KeyEvent.bKeyDown ) continue ;
         cChar = (unsigned char) InputRecord.Event.KeyEvent.uChar.AsciiChar ;
      }

      if ( ! cChar ) cChar = - GetVirtualKey ( & InputRecord ) ;

      if ( nType == MB_YESNOCANCEL ) {
         if ( cChar == 'Y' || cChar == 'y' || cChar == 0x0D ) {
            break ;
         }
         if ( cChar == 'N' || cChar == 'n' ) {
            nResult = 1 ;
            break ;
         }
         if ( cChar == 0x1B || cChar == 3 ) {
            nResult = -1 ;
            break ;
         }
      }
      if ( nType == MB_YESNO ) {
         if ( cChar == 'Y' || cChar == 'y' || cChar == 0x0D ) {
            break ;
         }
         if ( cChar == 'N' || cChar == 'n' || cChar == 0x1B || cChar == 3 ) {
            nResult = 1 ;
            break ;
         }
      }
      if ( nType == MB_OKCANCEL ) {
         if ( cChar == 3 || cChar == 0x1B ) {
            nResult = 1 ;
            break ;
         }
         if ( cChar ) {
            break ;
         }
      }
      if ( nType == MB_OK ) {
         if ( cChar == 3 ) {
            nResult = 1 ;
            break ;
         }
         if ( cChar ) {
            break ;
         }
      }
   }

   FlushConsoleInputBuffer ( hConsole ) ;
   SetConsoleMode ( hConsole, dwOldMode ) ;

   return nResult ;
}



// ʂSɉzL[R[hAʂSɃVtgL[ԂԂ
static int GetVirtualKey ( const INPUT_RECORD *pInputRecord ) {

   int nVirtualKey = pInputRecord->Event.KeyEvent.wVirtualKeyCode ;

   switch ( nVirtualKey ) {
      case VK_CAPITAL :    // CAPS LOCK key
      case VK_MENU :       // ALT key
      case VK_CONTROL :    // CTRL key
      case VK_SHIFT :      // SHIFT key
      case VK_NUMLOCK :    // NUM LOCK key
      case VK_SCROLL :     // SCROLL LOCK key
         return 0 ;
   }

   int nShiftKeyState = pInputRecord->Event.KeyEvent.dwControlKeyState ;
   nShiftKeyState &= ( RIGHT_ALT_PRESSED | LEFT_ALT_PRESSED | RIGHT_CTRL_PRESSED | LEFT_CTRL_PRESSED | SHIFT_PRESSED ) ;

   return nVirtualKey | ( nShiftKeyState << 16 ) ;
}



// R\[̂PsNA
static void ConsoleClearLine ( void ) {

   HANDLE hConsole = fget_osfhandle ( stderr ) ;
   if ( hConsole == INVALID_HANDLE_VALUE ) return ;

   CONSOLE_SCREEN_BUFFER_INFO ConsoleInfo ;
   if ( ! GetConsoleScreenBufferInfo ( hConsole, & ConsoleInfo ) ) return ;

   fputc ( '\r', stderr ) ;
   for ( int nCount = ConsoleInfo.dwSize.X - 1 ; nCount ; nCount -- ) fputc ( 0x20, stderr ) ;
   fputc ( '\r', stderr ) ;

   fflush ( stderr ) ;
}



