// chnconv_com.cpp : R\[p Chnconv

#include <windows.h>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <ctype.h>
#include <errno.h>
#include <conio.h>
#include <signal.h>
#include "msc.h"

#include "access.h"
#include "ask.h"
#include "codepage.h"
#include "fileconv.h"
#include "filename.h"
#include "oemio.h"
#include "res.h"
#include "resource.h"
#include "shfolder.h"
#include "stringex.h"
#include "wildcard.h"
#include "winmain.h"

#include "chnconv.h"
#include "chnconv_opt.h"
#include "chnconv_cp.h"
#include "conv_err.h"
#include "conv_opt.h"
#include "conv_loaddll.h"



static int nOsCodePage ;         // OS̃R[hy[W
static volatile int IsAborted ;

// O`̓ǂݍ
#include "conv_opt_gaiji.h"


int DisplayErrorMessageA ( int nErrorCode, const char *szFileName, const char *szExtension ) ;
int DisplayErrorMessageW ( int nErrorCode, const wchar_t *szFileName, const wchar_t *szExtension ) ;
int CALLBACK WildcardCallbackA ( const char *szSearchPath, WIN32_FIND_DATAA *pFindData, int nDepth, LPARAM lParam ) ;
int CALLBACK WildcardCallbackW ( const wchar_t *szSearchPath, WIN32_FIND_DATAW *pFindData, int nDepth, LPARAM lParam ) ;
int WINAPI CallChnconvExA ( const char *szSrcFileName, const char *szDstFileName, int nSrcCodePage, int nDstCodePage, void *pInfo ) ;
int WINAPI CallChnconvExW ( const wchar_t *szSrcFileName, const wchar_t *szDstFileName, int nSrcCodePage, int nDstCodePage, void *pInfo ) ;
int PrintFileStart ( int nSrcCodePage, int nDstCodePage, const CHNCONVEXINFO *pInfo ) ;
int PrintFileEnd ( int nSrcCodePage, int nDstCodePage, const CHNCONVEXINFO *pInfo ) ;
void __cdecl AbortProc ( int nSignal ) ;
int Help ( void ) ;

int SetTmOptions ( char *szString ) ;



int main ( int argc, char *argv [] ) {

   int nExitCode = 0 ;           // IR[h
   int nError = 0 ;              // G[
   int nSearchPath = 0 ;         // pX
   int nSearchDepth = 0 ;        // [
   int nExtension = 0 ;          // gq

   // for wildcard.cpp
   unsigned long dwSearchMode = WILD_SEARCH_FILE | WILD_SORT ;

   int nSrcCodePage = 0 ;        // ̓R[hy[W
   int nDstCodePage = 0 ;        // o̓R[hy[W

   char *szFont = NULL ;
   char *szGothicFont = NULL ;
   char *szFontSub = NULL ;
   char *szGothicFontSub = NULL ;

   char *szGaijiFileA = NULL ;
   wchar_t *szGaijiFileW = NULL ;

   int IsDisplayHelp = 0 ;          // wv\邩
   int IsWriteInUnicode = 0 ;       // G[o͂ Unicode 
   int IsReadOption = 0 ;           // t@Cǂݍނ
   int IsCatchErrorStrictly = 0 ;   // G[o~
   unsigned long dwFileconvMode = 0 ;  // t@Cϊ̃IvV

   char *szConfigFileNameA = NULL ;
   wchar_t *szConfigFileNameW = NULL ;


   // ̏iOj
   for ( int nCountArgv = 1 ; nCountArgv < argc ; nCountArgv ++ ) {

      if ( nError ) break ;

      char *szArgv = argv [ nCountArgv ] ;

      if ( *szArgv == '/' || *szArgv == '-' ) {
         switch ( *( szArgv + 1 ) ) {
            case 'W' :
            case 'w' :
               IsWriteInUnicode = 1 ;
               break ;
            case '?' :
               IsDisplayHelp = 1 ;
               break ;
            case '@' :
               IsReadOption = 1 ;
               if ( *( szArgv + 2 ) ) {
                  szConfigFileNameA = GetArgumentA ( nCountArgv ) + 2 ;
                  szConfigFileNameW = GetArgumentW ( nCountArgv ) + 2 ;
                  continue ;
               }
               break ;
            default :
               continue ;
         }
         if ( *( szArgv + 2 ) ) nError = nCountArgv ;
         continue ;
      }
   }


   // Wo͂ƃG[o͂ UNICODE 
   fwide ( stdout, ( IsWriteInUnicode ) ? 1 : -1 ) ;
   fwide ( stderr, ( IsWriteInUnicode ) ? 1 : -1 ) ;


   // IvVǂݍ
   if ( ! IsDisplayHelp && IsReadOption ) {
      int nResult ;
      if ( IsNT () ) nResult = ReadOptionW ( szConfigFileNameW ) ;
      else           nResult = ReadOptionA ( szConfigFileNameA ) ;
      if ( nResult ) {
         fputws ( GetStringW ( IDS_CANNOT_READ_OPTION ), stderr ) ;
         return 1 ;
      }
   }


   // ̏
   for ( int nCountArgv = 1 ; nCountArgv < argc ; nCountArgv ++ ) {

      if ( nError ) break ;

      char *szArgv = argv [ nCountArgv ] ;

      char *szString ;
      int *pCodePage ;
      int nName ;

      // IvV̎擾
      if ( *szArgv == '/' || *szArgv == '-' ) {
         switch ( *( szArgv + 1 ) ) {
            case 'C' :
            case 'c' :
               if ( nSrcCodePage && nDstCodePage ) nError = nCountArgv ;
               else if ( ! nSrcCodePage ) pCodePage = & nSrcCodePage ;
               else if ( ! nDstCodePage ) pCodePage = & nDstCodePage ;
               for ( nName = 0 ; nName < CODEPAGE_NAME_LIST_NELEM ; nName ++ ) {
                  if ( ! stricmp ( szArgv + 2, CodePageNameList [ nName ].szCodeName ) ) {
                     if ( pCodePage ) *pCodePage = CodePageNameList [ nName ].nCodePage ;
                     break ;
                  }
               }
               if ( ! ( nName < CODEPAGE_NAME_LIST_NELEM ) ) nError = nCountArgv ;
               continue ;
            case 'f' :
               szString = strchr ( szArgv, '\"' ) ;
               if ( szString ) *szString = 0 ;
               if ( ! *( szArgv + 2 ) ) nError = nCountArgv ;
               szFont = szArgv + 2 ;
               continue ;
            case 'F' :
               szString = strchr ( szArgv, '\"' ) ;
               if ( szString ) *szString = 0 ;
               if ( ! *( szArgv + 2 ) ) nError = nCountArgv ;
               szGothicFont = szArgv + 2 ;
               continue ;
            case 'p' :
               IsUseSameFont = 0 ;
               if ( ! *( szArgv + 2 ) ) continue ;    // -p w肵ꍇ
               if ( *( szArgv + 2 ) == '-' && *( szArgv + 3 ) == 0 ) {
                  IsUseSameFont = 1 ;
                  continue ;
               }
               szString = strchr ( szArgv, '\"' ) ;
               if ( szString ) *szString = 0 ;
//             if ( ! *( szArgv + 2 ) ) nError = nCountArgv ;
               szFontSub = szArgv + 2 ;
               continue ;
            case 'P' :
               IsUseSameFont = 0 ;
               if ( ! *( szArgv + 2 ) ) continue ;    // -p w肵ꍇ
               if ( *( szArgv + 2 ) == '-' && *( szArgv + 3 ) == 0 ) {
                  IsUseSameFont = 1 ;
                  continue ;
               }
               szString = strchr ( szArgv, '\"' ) ;
               if ( szString ) *szString = 0 ;
//             if ( ! *( szArgv + 2 ) ) nError = nCountArgv ;
               szGothicFontSub = szArgv + 2 ;
               continue ;
            case 'E' :
            case 'e' :
               if ( ! stricmp ( szArgv + 1, "error" ) ) {
                  IsCatchErrorStrictly = 1 ;
                  continue ;
               }
               if ( *( szArgv + 2 ) == '-' && *( szArgv + 3 ) == 0 ) IsOutputNumber = 0 ;
               else if ( *( szArgv + 2 ) == 0 ) IsOutputNumber = 1 ;
               else nError = nCountArgv ;
               continue ;
            case 'I' :
            case 'i' :
               if ( *( szArgv + 2 ) == '-' && *( szArgv + 3 ) == 0 ) IsInputNumber = 0 ;
               else if ( *( szArgv + 2 ) == 0 ) IsInputNumber = 1 ;
               else nError = nCountArgv ;
               continue ;
            case 'G' :
            case 'g' :
               if ( ! stricmp ( szArgv + 1, "gaiji" ) ) {
                  if ( IsNT () ) szGaijiFileW = wcsend ( GetArgumentW ( nCountArgv ) ) ;
                  else           szGaijiFileA = strend ( GetArgumentA ( nCountArgv ) ) ;
                  continue ;
               }
               if ( ! strheadicmp ( szArgv + 1, "gaiji:" ) ) {
                  if ( IsNT () ) {
                     szGaijiFileW = wcschr ( GetArgumentW ( nCountArgv ), ':' ) ;
                     if ( szGaijiFileW ) szGaijiFileW ++ ;
                     if ( ! szGaijiFileW || ! *szGaijiFileW ) nError = nCountArgv ;
                  }
                  else {
                     szGaijiFileA = strchr ( GetArgumentA ( nCountArgv ), ':' ) ;
                     if ( szGaijiFileA ) szGaijiFileA ++ ;
                     if ( ! szGaijiFileA || ! *szGaijiFileA ) nError = nCountArgv ;
                  }
                  continue ;
               }
               if ( *( szArgv + 2 ) == '-' && *( szArgv + 3 ) == 0 ) IsOneQuestionMark = 0 ;
               else if ( *( szArgv + 2 ) == 0 ) IsOneQuestionMark = 1 ;
               else nError = nCountArgv ;
               continue ;
            case 'K' :
            case 'k' :
               if ( *( szArgv + 2 ) == '-' && *( szArgv + 3 ) == 0 ) IsNoGbk = 0 ;
               else if ( *( szArgv + 2 ) == 0 ) IsNoGbk = 1 ;
               else nError = nCountArgv ;
               continue ;
            case 'J' :
            case 'j' :
               if ( *( szArgv + 2 ) == '-' && *( szArgv + 3 ) == 0 ) IsSenceCwFanti = 0 ;
               else if ( *( szArgv + 2 ) == 0 ) IsSenceCwFanti = 1 ;
               else nError = nCountArgv ;
               continue ;
            case 'V' :
            case 'v' :
               if ( *( szArgv + 2 ) == '-' && *( szArgv + 3 ) == 0 ) IsCwTxtFanti = 0 ;
               else if ( *( szArgv + 2 ) == 0 ) IsCwTxtFanti = 1 ;
               else nError = nCountArgv ;
               continue ;
            case 'L' :
               if ( *( szArgv + 2 ) == '-' && *( szArgv + 3 ) == 0 ) IsCjkExToLinshiDaima = 0 ;
               else if ( *( szArgv + 2 ) == 0 ) IsCjkExToLinshiDaima = 1 ;
               else nError = nCountArgv ;
               if ( IsCjkExToLinshiDaima ) IsLinshiDaimaToCjkEx = 0 ;
               continue ;
            case 'l' :
               if ( *( szArgv + 2 ) == '-' && *( szArgv + 3 ) == 0 ) IsLinshiDaimaToCjkEx = 0 ;
               else if ( *( szArgv + 2 ) == 0 ) IsLinshiDaimaToCjkEx = 1 ;
               else nError = nCountArgv ;
               if ( IsLinshiDaimaToCjkEx ) IsCjkExToLinshiDaima = 0 ;
               continue ;
            case 'M' :
            case 'm' :
               if ( ! stricmp ( szArgv + 2, "rtf" ) ) {
                  IsConvertRtf = 1 ;
                  IsConvertTxt = 0 ;
                  continue ;
               }
               if ( ! stricmp ( szArgv + 2, "txt" ) ) {
                  IsConvertTxt = 1 ;
                  IsConvertRtf = 0 ;
                  continue ;
               }
               nError = nCountArgv ;
               continue ;
            case 'N' :
            case 'n' :
               if ( tolower ( *( szArgv + 2 ) ) == 'u' ) {
                  szArgv ++ ;
                  if ( *( szArgv + 2 ) == '-' && *( szArgv + 3 ) == 0 ) IsNoUseUnicode = 0 ;
                  else if ( *( szArgv + 2 ) == 0 ) IsNoUseUnicode = 1 ;
                  else nError = nCountArgv ;
                  continue ;
               }
               if ( *( szArgv + 2 ) == '-' && *( szArgv + 3 ) == 0 ) IsGb2big5N = 0, IsBig52gbN = 0 ;
               else if ( *( szArgv + 2 ) == 0 ) IsGb2big5N = 1, IsBig52gbN = 1 ;
               else nError = nCountArgv ;
               continue ;
            case 'H' :
            case 'h' :
               if ( ! stricmp ( szArgv + 1, "hide" ) ) {
                  dwFileconvMode |= FILECONV_TO_HIDDEN ;
                  continue ;
               }
               dwFileconvMode |= FILECONV_NO_ECHO ;
               break ;
            case 'Q' :
            case 'q' :
               if ( *( szArgv + 2 ) == '-' && *( szArgv + 3 ) == 0 ) IsConvertQuotation = 0 ;
               else if ( *( szArgv + 2 ) == 0 ) IsConvertQuotation = 1 ;
               else nError = nCountArgv ;
               continue ;
            case 'S' :
            case 's' :
               dwSearchMode |= WILD_SEARCH_SUB ;
               if ( *( szArgv + 2 ) == ':' && isascii ( *( szArgv + 3 ) ) && isdigit ( *( szArgv + 3 ) ) ) {
                  errno = 0 ;
                  nSearchDepth = strtoul ( szArgv + 3, & szString, 10 ) ;
                  if ( errno == ERANGE || *szString ) nError = nCountArgv ;
                  if ( ! nSearchDepth ) dwSearchMode &= ~ WILD_SEARCH_SUB ;
                  continue ;
               }
               break ;
            case 'T' :
            case 't' :
               if ( *( szArgv + 2 ) ) {
                  if ( SetTmOptions ( szArgv + 2 ) ) nError = nCountArgv ;
                  continue ;
               }
               dwFileconvMode |= FILECONV_SAVE_TIMESTAMP ;
               break ;
            case 'U' :
            case 'u' :
               IsTxtUnicodeHtml = 1 ;
               break ;
            case 'W' :
            case 'w' :
               // IsWriteInUnicode = 1 ;
               break ;
            case 'X' :
            case 'x' :
               if ( *( szArgv + 2 ) == '-' && *( szArgv + 3 ) == 0 ) IsConvertCjkEx = 0 ;
               else if ( *( szArgv + 2 ) == 0 ) IsConvertCjkEx = 1 ;
               else nError = nCountArgv ;
               continue ;
            case 'Z' :
            case 'z' :
               if ( *( szArgv + 2 ) == '-' && *( szArgv + 3 ) == 0 ) IsHkscsPuaToCjk = 0 ;
               else if ( *( szArgv + 2 ) == 0 ) IsHkscsPuaToCjk = 1 ;
               else nError = nCountArgv ;
               continue ;
            case '7' :
               if ( *( szArgv + 2 ) == '-' && *( szArgv + 3 ) == 0 ) IsOutputCwNewFont = 0 ;
               else if ( *( szArgv + 2 ) == 0 ) IsOutputCwNewFont = 1 ;
               else nError = nCountArgv ;
               continue ;
            case '?' :
               // IsDisplayHelp = 1 ;
               break ;
            case '@' :
               // IsReadOption = 1 ;
               continue ;
            default :
               nError = nCountArgv ;
               break ;
         }
         if ( *( szArgv + 2 ) ) nError = nCountArgv ;
         continue ;
      }

      // t@C̎擾
      if ( ! nSearchPath ) {
         nSearchPath = nCountArgv ;
         continue ;
      }

      // gq̎擾
      if ( ! nExtension ) {
         nExtension = nCountArgv ;
         continue ;
      }

      nError = nCountArgv ;
   }


   // _CNǧ
   if ( nSearchPath && ! fisatty ( stdin ) || nExtension && ! fisatty ( stdout ) ) {
      fputws ( GetStringW ( IDS_CANNOT_REDIRECT ), stderr ) ;
      return 1 ;
   }

   // wv̕\
   if ( IsDisplayHelp || ! nSearchPath && fisatty ( stdin ) && ! nError ) {
      Help () ;
      return 1 ;
   }

   // G[\
   if ( nError ) {
      fwprintf ( stderr, L"%s%s\n", GetStringW ( IDS_PARAM_ERROR ), GetArgumentW ( nError ) ) ;
      return 1 ;
   }

   // R\[w
   if ( nSearchPath ) {
      wchar_t *szFileName = GetFileNameW ( GetArgumentW ( nSearchPath ) ) ;
      if ( szFileName && ! wcsicmp ( szFileName, L"CON" ) ) nSearchPath = 0 ;
   }

   // TufBNg\H
   if ( ! nSearchPath && ( dwSearchMode & WILD_SEARCH_SUB ) ) {
      fputws ( GetStringW ( IDS_CANNOT_SEARCH_SUBDIR ), stderr ) ;
      return 1 ;
   }

   // R[hy[Ww肳ꂽH
   if ( ! nSrcCodePage || ! nDstCodePage ) {
      fputws ( GetStringW ( IDS_NOT_SPECIFIED_CODEPAGE ), stderr ) ;
      return 1 ;
   }

   // ^CX^vۑ\H
   if ( ( dwFileconvMode & FILECONV_SAVE_TIMESTAMP ) && ! nExtension ) {
      fputws ( GetStringW ( IDS_CANNOT_SAVE_TIMESTAMP ), stderr ) ;
   }

   // ϊIvV̌
   if ( ( IsGb2big5N || IsBig52gbN ) && ( ! IsValidCodePage ( CP_CHINESE_SIMPLIFIED ) || ! IsValidCodePage ( CP_CHINESE_TRADITIONAL ) ) ) {
      fwprintf ( stderr, L"%s%s\n", GetStringW ( IDS_INVALID_OPTION ), L"-n" ) ;
      return 1 ;
   }


   // DLL̃[h
   if ( LoadChnconvDll () ) {
      fputws ( GetStringW ( IDS_DLL_ERROR ), stderr ) ;
      return 1 ;
   }


   CHNCONVEXINFO Info = { sizeof(CHNCONVEXINFO) } ;
   CHNFONTINFO FontInfo = { sizeof(CHNFONTINFO) } ;
   Info.pFontInfo = & FontInfo ;

   RESERVEDINFO ReservedInfo = { sizeof(RESERVEDINFO) } ;
   Info.pReserved = (void*) & ReservedInfo ;


   // IvVݒ
   Info.dwConversionMode = TranslateConversionMode ( nSrcCodePage, nDstCodePage ) ;
   Info.dwAdditionalMode = TranslateAdditionalMode ( nSrcCodePage, nDstCodePage ) ;

   // tHgTCY
   Info.nFontSize = nTmFontSize ;
   if ( ! Info.nFontSize ) Info.nFontSize = -1 ;

   // tHgݒ
   if ( nDstCodePage == CP_CHINESE_SIMPLIFIED ) {
      if ( ! szFont && *szGbFont ) szFont = szGbFont ;
      if ( ! szGothicFont && *szGbGothicFont ) szGothicFont = szGbGothicFont ;
      FontInfo.pGbFont = szFont ;
      FontInfo.pGbGothicFont = szGothicFont ;
   }
   if ( nDstCodePage == CP_CHINESE_TRADITIONAL ) {
      if ( ! szFont && *szBig5Font ) szFont = szBig5Font ;
      if ( ! szGothicFont && *szBig5GothicFont ) szGothicFont = szBig5GothicFont ;
      FontInfo.pBig5Font = szFont ;
      FontInfo.pBig5GothicFont = szGothicFont ;
   }
   if ( nDstCodePage == CP_CHINESE_SIMPLIFIED || nDstCodePage == CP_CHINESE_TRADITIONAL ) {
      if ( ! szFontSub && *szPinyinFont ) szFontSub = szPinyinFont ;
      if ( ! szGothicFontSub && *szPinyinGothicFont ) szGothicFontSub = szPinyinGothicFont ;
      FontInfo.pPinyinFont = szFontSub ;
      FontInfo.pPinyinGothicFont = szGothicFontSub ;
   }
   if ( nDstCodePage != CP_CHINESE_SIMPLIFIED && nDstCodePage != CP_CHINESE_TRADITIONAL ) {
      if ( szFont || szGothicFont || szFontSub || szGothicFontSub ) {
         fputws ( GetStringW ( IDS_CANNOT_SPECIFY_FONT ), stderr ) ;
         return 1 ;
      }
   }

   // O`̓ǂݍ
   GAIJIINFO GaijiInfo = { 0 } ;
   int nGaijiErrorLineNumber ;
   int nGaijiResult ;
   if ( IsNT () ) nGaijiResult = ReadGaijiFileW ( szGaijiFileW, nSrcCodePage, nDstCodePage, & GaijiInfo, & nGaijiErrorLineNumber ) ;
   else           nGaijiResult = ReadGaijiFileA ( szGaijiFileA, nSrcCodePage, nDstCodePage, & GaijiInfo, & nGaijiErrorLineNumber ) ;
   if ( nGaijiResult < 0 ) {
      if ( nGaijiErrorLineNumber ) fwprintf ( stderr, GetStringW ( IDS_GAIJIFILE_ERROR ), nGaijiErrorLineNumber ) ;
      else                         fputws ( GetStringW ( IDS_GAIJIFILE_FAILED ), stderr ) ;
      return 1 ;
   }
   Info.pSrcToDst          = GaijiInfo.pSrcToDst ;
   Info.nNumberOfSrcToDst  = GaijiInfo.nNumberOfSrcToDst ;
   Info.pSrcToUc           = GaijiInfo.pSrcToUc ;
   Info.nNumberOfSrcToUc   = GaijiInfo.nNumberOfSrcToUc ;


   // VOi֐w
   signal ( SIGINT, AbortProc ) ;


   if ( IsNT () ) {

      // t@Cw肵Ȃꍇ
      if ( ! nSearchPath ) {
         // s
         int nResult = CallChnconvExW ( NULL, NULL, nSrcCodePage, nDstCodePage, & Info ) ;
         // G[𕪐
         if ( nResult && DisplayErrorMessageW ( nResult, NULL, NULL ) ) nExitCode = 1 ;
      }
      // t@Cw肵ꍇ
      else {

         // ChJ[h̓WJ
         WILDCARDW *Wildcard = SearchWildcardW ( NULL, GetArgumentW ( nSearchPath ), dwSearchMode, WildcardCallbackW, nSearchDepth ) ;

         if ( Wildcard == WILDCARD_ERROR ) {
            if ( IsAborted ) fputws ( GetStringW ( IDS_ABORTED ), stderr ) ;
            else             fputws ( GetStringW ( IDS_TOO_MANY_FILES ), stderr ) ;
            return 1 ;
         }

         if ( Wildcard == NULL ) {
            fputws ( GetStringW ( IDS_FILE_NOT_FOUND ), stderr ) ;
            return 1 ;
         }

         wchar_t *szExtension = ( nExtension ) ? GetArgumentW ( nExtension ) : NULL ;
         wchar_t *szDirName = NULL ;

         nExitCode = 0 ;
         if ( szExtension && *szExtension == '.' ) szExtension ++ ;  // gq '.' 폜

         int IsPrintStartEnd = ( IsNecChineseCodePage ( nSrcCodePage ) && ! szExtension ) ;
         if ( IsPrintStartEnd ) ReservedInfo.dwMode = RESERVEDMODE_NO_START_END ;
         if ( IsPrintStartEnd ) PrintFileStart ( nSrcCodePage, nDstCodePage, & Info ) ;

         // t@C݂ꍇ
         for ( const wchar_t *szString = GetFirstFileW ( Wildcard ) ; szString ; szString = GetNextFileW ( Wildcard ) ) {

            // ~
            if ( IsAborted && DisplayErrorMessageW ( CONV_ERROR_ABORTED, NULL, NULL ) < 0 ) { nExitCode = 1 ; break ; }

            // tH_̎擾
            if ( ! GetFileNameW ( szString ) ) {
               free ( szDirName ) ;
               szDirName = wcsdup_expand ( szString, (size_t) -1, MAX_PATH ) ;
               if ( ! szDirName && DisplayErrorMessageW ( FILECONV_ERROR_MEMORY, szString, NULL ) < 0 ) { nExitCode = 1 ; break ; }
               continue ;
            }

            // t@C̎擾
            const wchar_t *szFileName ;
            if ( szDirName ) szFileName = ChangeFileNameW ( szDirName, szString ) ;
            else             szFileName = szString ;

            // s
            int nResult = FileConvertW ( szFileName, szExtension, CallChnconvExW, nSrcCodePage, nDstCodePage, & Info, dwFileconvMode ) ;

            // G[𕪐
            if ( nResult ) {
               if ( DisplayErrorMessageW ( nResult, szFileName, szExtension ) < 0 ) { nExitCode = 1 ; break ; }
               if ( IsCatchErrorStrictly ) { nExitCode = 1 ; break ; }
               continue ;
            }
         }

         free ( szDirName ) ;

         if ( IsPrintStartEnd ) PrintFileEnd ( nSrcCodePage, nDstCodePage, & Info ) ;

         // ChJ[hnh̉
         CloseWildcardW ( Wildcard ) ;
      }
   }
   else {

      // t@Cw肵Ȃꍇ
      if ( ! nSearchPath ) {
         // s
         int nResult = CallChnconvExA ( NULL, NULL, nSrcCodePage, nDstCodePage, & Info ) ;
         // G[𕪐
         if ( nResult && DisplayErrorMessageA ( nResult, NULL, NULL ) < 0 ) nExitCode = 1 ;
      }
      // t@Cw肵ꍇ
      else {

         // ChJ[h̓WJ
         WILDCARDA *Wildcard = SearchWildcardA ( NULL, GetArgumentA ( nSearchPath ), dwSearchMode, WildcardCallbackA, nSearchDepth ) ;

         if ( Wildcard == WILDCARD_ERROR ) {
            if ( IsAborted ) fputws ( GetStringW ( IDS_ABORTED ), stderr ) ;
            else             fputws ( GetStringW ( IDS_TOO_MANY_FILES ), stderr ) ;
            return 1 ;
         }

         if ( Wildcard == NULL ) {
            fputws ( GetStringW ( IDS_FILE_NOT_FOUND ), stderr ) ;
            return 1 ;
         }

         char *szExtension = ( nExtension ) ? GetArgumentA ( nExtension ) : NULL ;
         char *szDirName = NULL ;

         nExitCode = 0 ;
         if ( szExtension && *szExtension == '.' ) szExtension ++ ;  // gq '.' 폜

         int IsPrintStartEnd = ( IsNecChineseCodePage ( nSrcCodePage ) && ! szExtension ) ;
         if ( IsPrintStartEnd ) ReservedInfo.dwMode = RESERVEDMODE_NO_START_END ;
         if ( IsPrintStartEnd ) PrintFileStart ( nSrcCodePage, nDstCodePage, & Info ) ;

         // t@C݂ꍇ
         for ( const char *szString = GetFirstFileA ( Wildcard ) ; szString ; szString = GetNextFileA ( Wildcard ) ) {

            // ~
            if ( IsAborted && DisplayErrorMessageA ( CONV_ERROR_ABORTED, NULL, NULL ) < 0 ) { nExitCode = 1 ; break ; }

            // tH_̎擾
            if ( ! GetFileNameA ( szString ) ) {
               free ( szDirName ) ;
               szDirName = strdup_expand ( szString, (size_t) -1, MAX_PATH ) ;
               if ( ! szDirName && DisplayErrorMessageA ( FILECONV_ERROR_MEMORY, szString, NULL ) < 0 ) { nExitCode = 1 ; break ; }
               continue ;
            }

            // t@C̎擾
            const char *szFileName ;
            if ( szDirName ) szFileName = ChangeFileNameA ( szDirName, szString ) ;
            else             szFileName = szString ;

            // s
            int nResult = FileConvertA ( szFileName, szExtension, CallChnconvExA, nSrcCodePage, nDstCodePage, & Info, dwFileconvMode ) ;

            // G[𕪐
            if ( nResult ) {
               if ( DisplayErrorMessageA ( nResult, szFileName, szExtension ) < 0 ) { nExitCode = 1 ; break ; }
               if ( IsCatchErrorStrictly ) { nExitCode = 1 ; break ; }
               continue ;
            }
         }

         free ( szDirName ) ;

         if ( IsPrintStartEnd ) PrintFileEnd ( nSrcCodePage, nDstCodePage, & Info ) ;

         // ChJ[hnh̉
         CloseWildcardA ( Wildcard ) ;
      }
   }


   FreeGaijiInfo ( & GaijiInfo ) ;

   return nExitCode ;
}



// Ro[^̃G[bZ[Wo
// ߂ĺAȂ 0 AsȂ 1 Aps\ȎsȂ -1 Ԃ
int DisplayErrorMessageA ( int nErrorCode, const char *szFileName, const char *szExtension ) {

   if ( ! szFileName ) szFileName = "" ;
   if ( ! szExtension ) szExtension = "" ;

   wchar_t szFileNameW [ MAX_PATH ] ;
   wchar_t szExtensionW [ MAX_PATH ] ;

   a2wlcpy ( szFileNameW, szFileName, MAX_PATH ) ;
   a2wlcpy ( szExtensionW, szExtension, MAX_PATH ) ;

   return DisplayErrorMessageW ( nErrorCode, szFileNameW, szExtensionW ) ;
}



// Ro[^̃G[bZ[Wo
// ߂ĺAȂ 0 AsȂ 1 Aps\ȎsȂ -1 Ԃ
int DisplayErrorMessageW ( int nErrorCode, const wchar_t *szFileName, const wchar_t *szExtension ) {

   if ( ! szFileName ) szFileName = L"" ;
   if ( ! szExtension ) szExtension = L"" ;

   switch ( nErrorCode ) {
      case CONV_SUCCESS :
         return 0 ;
      case CONV_ERROR_WRITE :
         fwprintf ( stderr, L"\r%s%s", szFileName, GetStringW ( IDS_WRITE_ERROR ) ) ;
         return 1 ;
      case CONV_ERROR_READ :
         fwprintf ( stderr, L"\r%s%s", szFileName, GetStringW ( IDS_ACCESS_DENIED ) ) ;
         return 1 ;
      case CONV_ERROR_FORMAT :
         fwprintf ( stderr, L"\r%s%s", szFileName, GetStringW ( IDS_INVALID_FORMAT ) ) ;
         return 1 ;
      case CONV_ERROR_BRACE :
         fwprintf ( stderr, L"\r%s%s", szFileName, GetStringW ( IDS_BRACE_ERROR ) ) ;
         return 1 ;
      case CONV_ERROR_MEMORY :
         fwprintf ( stderr, L"\r%s%s", szFileName, GetStringW ( IDS_NOT_ENOUGH_MEMORY ) ) ;
         return -1 ;
      case CONV_ERROR_CODEPAGE :
         fputws ( GetStringW ( IDS_INVALID_CODEPAGE ), stderr ) ;
         return -1 ;
      case CONV_ERROR_ABORTED :
         fwprintf ( stderr, L"\r%s%s", szFileName, GetStringW ( IDS_ABORTED ) ) ;
         return -1 ;
      case FILECONV_ERROR_ACCESS :
         fwprintf ( stderr, L"%s%s", szFileName, GetStringW ( IDS_ACCESS_DENIED ) ) ;
         return 1 ;
      case FILECONV_ERROR_EXTENSION :
         fwprintf ( stderr, L"\r%s%s", szExtension, GetStringW ( IDS_INVALID_EXTENSION ) ) ;
         return -1 ;
      case FILECONV_ERROR_MEMORY :
         fwprintf ( stderr, L"%s%s", szFileName, GetStringW ( IDS_NOT_ENOUGH_MEMORY ) ) ;
         return -1 ;
      default :
         fputws ( GetStringW ( IDS_UNKNOWN_ERROR ), stderr ) ;
         return -1 ;
   }
}



// ChJ[h̃R[obN֐
// TCY 0 ̃t@CrATufBNg̐[𐧌䂷
int CALLBACK WildcardCallbackA ( const char *szSearchPath, WIN32_FIND_DATAA *pFindData, int nDepth, LPARAM lParam ) {
   if ( ! pFindData->nFileSizeLow && ! pFindData->nFileSizeHigh ) return 0 ;
   if ( lParam ) if ( nDepth > lParam ) return -1 ;
   return 1 ;
}



// ChJ[h̃R[obN֐
// TCY 0 ̃t@CrATufBNg̐[𐧌䂷
int CALLBACK WildcardCallbackW ( const wchar_t *szSearchPath, WIN32_FIND_DATAW *pFindData, int nDepth, LPARAM lParam ) {
   if ( ! pFindData->nFileSizeLow && ! pFindData->nFileSizeHigh ) return 0 ;
   if ( lParam ) if ( nDepth > lParam ) return -1 ;
   return 1 ;
}



// I֐
void __cdecl AbortProc ( int nSignal ) {
   IsAborted = 1 ;
   AbortWildcard () ;
   if ( AbortChnconv ) AbortChnconv () ;
   else {
      fputws ( GetStringW ( IDS_ABORTED ), stderr ) ;
      DisableAlertOnClose () ;
      exit ( 1 ) ;
   }
   signal ( nSignal, AbortProc ) ;
}



////////////////////////////////////////////
//           ϊ֐̌Ăяo           //
////////////////////////////////////////////



int WINAPI CallChnconvExA ( const char *szSrcFileName, const char *szDstFileName, int nSrcCodePage, int nDstCodePage, void *pInfo ) {
   return ChnconvExA ( szSrcFileName, szDstFileName, nSrcCodePage, nDstCodePage, (CHNCONVEXINFO*) pInfo ) ;
}



int WINAPI CallChnconvExW ( const wchar_t *szSrcFileName, const wchar_t *szDstFileName, int nSrcCodePage, int nDstCodePage, void *pInfo ) {
   return ChnconvExW ( szSrcFileName, szDstFileName, nSrcCodePage, nDstCodePage, (CHNCONVEXINFO*) pInfo ) ;
}



int PrintFileStart ( int nSrcCodePage, int nDstCodePage, const CHNCONVEXINFO *pInfo ) {

   CHNCONVEXINFO Info = *pInfo ;

   RESERVEDINFO ReservedInfo = { sizeof(RESERVEDINFO) } ;
   Info.pReserved = (void*) & ReservedInfo ;
   ReservedInfo.dwMode = RESERVEDMODE_ONLY_START ;

   if ( IsNT () ) {
      int nResult = ChnconvExW ( NULL, NULL, nSrcCodePage, nDstCodePage, (CHNCONVEXINFO*) & Info ) ;
      if ( nResult ) { DisplayErrorMessageW ( nResult, NULL, NULL ) ; exit ( 1 ) ; }
   }
   else {
      int nResult = ChnconvExA ( NULL, NULL, nSrcCodePage, nDstCodePage, (CHNCONVEXINFO*) & Info ) ;
      if ( nResult ) { DisplayErrorMessageA ( nResult, NULL, NULL ) ; exit ( 1 ) ; }
   }

   return 0 ;
}



int PrintFileEnd ( int nSrcCodePage, int nDstCodePage, const CHNCONVEXINFO *pInfo ) {

   CHNCONVEXINFO Info = *pInfo ;

   RESERVEDINFO ReservedInfo = { sizeof(RESERVEDINFO) } ;
   Info.pReserved = (void*) & ReservedInfo ;
   ReservedInfo.dwMode = RESERVEDMODE_ONLY_END ;

   if ( IsNT () ) {
      int nResult = ChnconvExW ( NULL, NULL, nSrcCodePage, nDstCodePage, (CHNCONVEXINFO*) & Info ) ;
      if ( nResult ) { DisplayErrorMessageW ( nResult, NULL, NULL ) ; exit ( 1 ) ; }
   }
   else {
      int nResult = ChnconvExA ( NULL, NULL, nSrcCodePage, nDstCodePage, (CHNCONVEXINFO*) & Info ) ;
      if ( nResult ) { DisplayErrorMessageA ( nResult, NULL, NULL ) ; exit ( 1 ) ; }
   }

   return 0 ;
}



////////////////////////////////////////////
//              eNmCg              //
////////////////////////////////////////////



// eNmCg֘ÃIvVw
// szString ɂ /t ̂Ƃ̕w
//  0 As 1 Ԃ
int SetTmOptions ( char *szString ) {

   static unsigned long dwTmPropMode = 0 ;

   if ( *szString == 'P' || *szString == 'p' ) {
      szString ++ ;
      if ( ! *szString ) {
         dwTmPropMode |= TMMODE_ASCII_ALL ;
         IsUseSameFont = 0 ;
         return 0 ;
      }
      if ( *szString == '=' ) {
         return 0 ;
      }
      if ( isascii ( *szString ) && isdigit ( *szString ) ) {
         errno = 0 ;
         unsigned long dwTmPropMode = strtoul ( szString, & szString, 10 ) ;
         if ( errno == ERANGE || *szString ) return 1 ;

         if ( dwTmPropMode & TMMODE_ASCII_ALPHA ) IsUseSameFont = 0 ;
         if ( dwTmPropMode & TMMODE_WRITE_COMMENT ) IsWriteTmComment = 0 ;

         return 0 ;
      }
      return 1 ;
   }

   if ( *szString == 'Z' || *szString == 'z' ) {
      szString ++ ;
      if ( isascii ( *szString ) && isdigit ( *szString ) ) {
         errno = 0 ;
         int nFontSize = strtoul ( szString, & szString, 10 ) ;
         if ( errno == ERANGE || *szString ) return 1 ;
         else                                nTmFontSize = nFontSize ;
         return 0 ;
      }
      return 1 ;
   }

   if ( *szString == 'C' || *szString == 'c' ) {
      szString ++ ;
      if ( ! *szString ) {
         IsWriteTmComment = 1 ;
         return 0 ;
      }
      return 1 ;
   }

   return 1 ;
}



////////////////////////////////////////////
//                 wv                 //
////////////////////////////////////////////



// wv\
// o[WԂ
int Help ( void ) {


   // R}h
   static const wchar_t szCommandName [] = L"CHNCONV" ;


   int nVersion = 0 ;


   // ĨL[vvg𖳌
   DisableAlertOnClose () ;


   // o[W擾
   if ( ! hChnconv && LoadChnconvDll () ) {
      fputws ( GetStringW ( IDS_DLL_ERROR ), stderr ) ;
      if ( fisatty ( stdout ) && AskW ( GetStringW ( IDS_ASK_DISPLAY_HELP ), MB_YESNO ) ) return 1 ;
      FILEVERSION FileVersion ;
      if ( ! GetFileVersion ( & FileVersion ) ) nVersion = TranslateVersionInfo ( & FileVersion ) ;
   }
   else {
      nVersion = GetDllVersion () ;
   }


   // T

   fwprintf ( stdout, L" %s   version %d.%02d  %s  %s\n", szCommandName, nVersion / 100, nVersion % 100, GetVersionCopyrightW (), WIN3264BIT_SUFFIX_W ) ;
   fwprintf ( stdout, GetStringW ( IDS_HELP_100 ), szCommandName ) ;
   fwprintf ( stdout, GetStringW ( IDS_HELP_101 ), szCommandName ) ;
   fwprintf ( stdout, GetStringW ( IDS_HELP_102 ), szCommandName ) ;

   fputws ( GetStringW ( IDS_HELP_103 ), stdout ) ;


   if ( fisatty ( stdout ) && AskW ( GetStringW ( IDS_HELP_107 ), MB_YESNO ) ) return 1 ;


   // R[hy[Ww̐

   fputws ( GetStringW ( IDS_HELP_200 ), stdout ) ;
   fputws ( GetStringW ( IDS_HELP_201 ), stdout ) ;
   fputws ( GetStringW ( IDS_HELP_202 ), stdout ) ;
   fputws ( GetStringW ( IDS_HELP_203 ), stdout ) ;


   if ( fisatty ( stdout ) && AskW ( GetStringW ( IDS_PRESS_ANY_KEY ), MB_OK ) ) return 1 ;


   // IvV̐

   fputws ( GetStringW ( IDS_HELP_204 ), stdout ) ;

   if ( fisatty ( stdout ) && AskW ( GetStringW ( IDS_PRESS_ANY_KEY ), MB_OK ) ) return 1 ;

   fputws ( GetStringW ( IDS_HELP_205 ), stdout ) ;


   if ( fisatty ( stdout ) && AskW ( GetStringW ( IDS_PRESS_ANY_KEY ), MB_OK ) ) return 1 ;


   // 

   fputws ( GetStringW ( IDS_HELP_206 ), stdout ) ;

   if ( ! IsConsole () && fisatty ( stdout ) && fisatty ( stderr ) && AskW ( GetStringW ( IDS_PRESS_ANY_KEY ), MB_OK ) ) return 1 ;

   return 1 ;
}



