// conv_opt.cpp

#include <windows.h>
#include <stdio.h>
#include <ctype.h>
#include "msc.h"
#include "access.h"
#include "filename.h"
#include "res.h"
#include "resource.h"
#include "shfolder.h"
#include "stringex.h"

#if defined RTFCONV_EXE || defined RTFCONV_COM || defined SETUP_R
#include "rtfconv.h"
#include "rtfconv_opt.h"
#include "uniblock.h"
#endif

#if defined CHNCONV_EXE || defined CHNCONV_COM || defined SETUP_C
#include "chnconv.h"
#include "chnconv_opt.h"
#include "codepage.h"
#endif

#include "conv_opt.h"


// for CHNCONV.EXE/COM and RTFCONV.EXE/COM



////////////////////////////////////////
//       ÑIvVݒ       //
////////////////////////////////////////



static int TranslateAfterReadOption ( void ) ;
static int ReadOptionFile ( FILE *Fin ) ;
void __cdecl FreeFontNameArray ( void ) ;



// NɃIvV̎擾iANSIŁj
// t@CȂ 1 ȏԂ
// [mۂłȂ Ԃ
//  0 Ԃ
int ReadOptionA ( const char *szFileName ) {

   char szFileNameBuffer [ MAX_PATH ] ;

   if ( ! szFileName ) {

      GetModuleFileNameA ( NULL, szFileNameBuffer, MAX_PATH ) ;
      ChangeFileNameA ( szFileNameBuffer, CFG_FILENAME_A ) ;

      szFileName = szFileNameBuffer ;
   }


#if defined RTFCONV_EXE || defined CHNCONV_EXE || defined SETUP_R || defined SETUP_C
   if ( ! IsFileWritableA ( szFileName ) ) IsOptionReadOnly = 1 ;
#endif


   FILE *Fin = fopen ( szFileName, "rb" ) ;
   if ( ! Fin ) return 1 ;

   int nResult = ReadOptionFile ( Fin ) ;

   fclose ( Fin ) ;

   TranslateAfterReadOption () ;

   return nResult ;
}



// NɃIvV̎擾iUNICODEŁj
// t@CȂ 1 ȏԂ
// [mۂłȂ Ԃ
//  0 Ԃ
int ReadOptionW ( const wchar_t *szFileName ) {

   wchar_t szFileNameBuffer [ MAX_PATH ] ;

   if ( ! szFileName ) {

      if ( GetSpecialFolderPathW ( NULL, szFileNameBuffer, CSIDL_APPDATA, 0 ) ) return 1 ;

      wcscat ( szFileNameBuffer, L"\\Harigaya" ) ;

      SetPathSeparatorW ( szFileNameBuffer, ADD_SEPARATOR_ALWAYS ) ;
      wcscat ( szFileNameBuffer, CFG_FILENAME_W ) ;

      szFileName = szFileNameBuffer ;
   }


#if defined RTFCONV_EXE || defined CHNCONV_EXE || defined SETUP_R || defined SETUP_C
   if ( ! IsFileWritableW ( szFileName ) ) IsOptionReadOnly = 1 ;
#endif


   FILE *Fin = wfopen ( szFileName, L"rb" ) ;
   if ( ! Fin ) return 1 ;

   int nResult = ReadOptionFile ( Fin ) ;

   fclose ( Fin ) ;

   TranslateAfterReadOption () ;

   return nResult ;
}



// IvV̎擾ɒ
static int TranslateAfterReadOption ( void ) {

#if defined RTFCONV_EXE || defined CHNCONV_EXE
   if ( nSavedSrcType >= 0 && nSavedSrcType < SRC_TYPE_NELEM ) nSrcType = nSavedSrcType ;
   if ( nSavedDstType >= 0 && nSavedDstType < DST_TYPE_NELEM ) nDstType = nSavedDstType ;

   for ( int nCount = 0 ; nCount < AVAILABLE_CODE_LIST_NELEM ; nCount ++ ) {
      if ( nSavedSrcCode == ( AvailableCodeList [ nCount ] ).nCodePage ) nSrcCode = nCount ;
      if ( nSavedDstCode == ( AvailableCodeList [ nCount ] ).nCodePage ) nDstCode = nCount ;
   }
#endif

#if defined RTFCONV_EXE
   if ( IsNoJis83New && IsNoJis83Old ) IsNoJis83Old = 0 ;
#endif

#if defined CHNCONV_EXE || defined CHNCONV_COM
   if ( ! IsValidCodePage ( CP_CHINESE_SIMPLIFIED ) || ! IsValidCodePage ( CP_CHINESE_TRADITIONAL ) ) {
      IsGb2big5N = 0 ;
      IsBig52gbN = 0 ;
   }
#endif

#if defined CHNCONV_EXE
   if ( nSavedDstCode == CP_JAPANESE_TM ) nDstCode = 0 ;
#endif

   return 0 ;
}



static int GetOptionInteger ( char *szString, const char *szName, int *pValue ) ;
static int GetOptionStringA ( char *szString, const char *szName, char *szValue, int nMaxLen ) ;
static int GetOptionWideString ( char *szString, const char *szName, wchar_t *szValue, int nMaxLen ) ;
static int GetOptionBinary ( char *szString, const char *szName, unsigned short *pValue, int nLen ) ;



// IvVt@C̓ǂݍ
// [mۂłȂƂ́AԂ
//  0 Ԃ
static int ReadOptionFile ( FILE *Fin ) {


   char szLineBuffer [ OPTION_FILE_LINE_BUFFER ] ;


   while ( fgets ( szLineBuffer, OPTION_FILE_LINE_BUFFER, Fin ) ) {


      // sƂ
      if ( ! strchr ( szLineBuffer, '\n' ) ) {
         while ( 1 ) {
            int C = fgetc ( Fin ) ;
            if ( C == '\n' || C == EOF ) break ;
         }
      }


      // l̎擾
      for ( int nCount = 0 ; nCount < OPTION_INTEGER_LIST_NELEM ; nCount ++ ) {

         int *pValue = ( OptionIntegerList [ nCount ] ).nValue ;

         if ( ! GetOptionInteger ( szLineBuffer, ( OptionIntegerList [ nCount ] ).szName, pValue ) ) {

#if defined RTFCONV_EXE || defined CHNCONV_EXE || defined SETUP_R || defined SETUP_C
            if ( pValue == & nSavedSrcType || pValue == & nSavedDstType ) IsSaveCode = 1 ;
            if ( pValue == & nSavedSrcCode || pValue == & nSavedDstCode ) IsSaveCode = 1 ;
            if ( pValue == & nSavedWindowX || pValue == & nSavedWindowY ) IsSaveWindow = 1 ;
#endif
#if defined RTFCONV_EXE || defined RTFCONV_COM || defined SETUP_R
            if ( pValue == & nUnmappableCharFormat && nUnmappableCharFormat >= UNMAPPABLE_CHAR_FORMAT_LIST_NELEM ) nUnmappableCharFormat = 0 ;
#endif
#if defined CHNCONV_EXE || defined CHNCONV_COM || defined SETUP_C
            if ( pValue == & IsLinshiDaimaToCjkEx && *pValue ) IsCjkExToLinshiDaima = 0 ;
            if ( pValue == & IsCjkExToLinshiDaima && *pValue ) IsLinshiDaimaToCjkEx = 0 ;
#endif
            goto READ_NEXT_LINE ;
         }
      }


      // ̎擾
      for ( int nCount = 0 ; nCount < OPTION_STRING_LIST_A_NELEM ; nCount ++ ) {

         char *szValue = ( OptionStringListA [ nCount ] ).szValue ;

         if ( ! GetOptionStringA ( szLineBuffer, ( OptionStringListA [ nCount ] ).szName, szValue, ( OptionStringListA [ nCount ] ).nMaxSize ) ) {

#if defined RTFCONV_EXE || defined CHNCONV_EXE || defined SETUP_R || defined SETUP_C
            if ( szValue == szBrowsePathA ) IsSavePath = 1 ;
#endif

#if defined RTFCONV_EXE || defined RTFCONV_COM || defined SETUP_R
            if ( szValue == szFontNameArrayDummy ) {

               if ( ! FontNameArray ) {
                  FontNameArray = (char*) malloc ( FONTNAME_ARRAY_SIZE ) ;
                  if ( ! FontNameArray ) return -1 ;
                  atexit ( FreeFontNameArray ) ;
                  memzero ( FontNameArray, FONTNAME_ARRAY_SIZE ) ;
               }

               char *szString ;
               errno = 0 ;
               int nIndex = strtoul ( szFontNameArrayDummy, & szString, 10 ) ;
               if ( ! errno && *szString && nIndex >= 0 && nIndex < UNICODE_BLOCK_NELEM ) {
                  szString ++ ;
                  while ( isascii ( *szString ) && isspace ( *szString ) ) szString ++ ;
                  strlcpy ( FontNameArray + nIndex * LF_FACESIZE, szString, LF_FACESIZE ) ;
               }
            }
#endif
            goto READ_NEXT_LINE ;
         }
      }


#if defined RTFCONV_EXE || defined CHNCONV_EXE || defined SETUP_R || defined SETUP_C
      // ̎擾 (UNICODE)
      for ( int nCount = 0 ; nCount < OPTION_STRING_LIST_W_NELEM ; nCount ++ ) {

         wchar_t *szValue = ( OptionStringListW [ nCount ] ).szValue ;

         if ( ! GetOptionWideString ( szLineBuffer, ( OptionStringListW [ nCount ] ).szName, szValue, ( OptionStringListW [ nCount ] ).nMaxSize ) ) {

#if defined RTFCONV_EXE || defined CHNCONV_EXE || defined SETUP_R || defined SETUP_C
            if ( szValue == szBrowsePathW ) IsSavePath = 1 ;
#endif
            goto READ_NEXT_LINE ;
         }
      }
#endif


#if defined RTFCONV_EXE || defined RTFCONV_COM || defined SETUP_R
      // oCi[̎擾
      for ( int nCount = 0 ; nCount < OPTION_BINARY_LIST_NELEM ; nCount ++ ) {

         unsigned short *pValue = ( OptionBinaryList [ nCount ] ).pValue ;

         if ( ! GetOptionBinary ( szLineBuffer, ( OptionBinaryList [ nCount ] ).szName, pValue, ( OptionBinaryList [ nCount ] ).nSize ) ) {

#if ! defined SETUP_R
            if ( pValue == LangIdArray ) IsLangIdUserDefined = 1 ;
#endif
            goto READ_NEXT_LINE ;
         }
      }
#endif

      READ_NEXT_LINE :;
   }


   return 0 ;
}



// es琔l̃IvV擾
// IvV̖Ov 0 Ԃ
static int GetOptionInteger ( char *szString, const char *szName, int *pValue ) {

   if ( ! strheadicmp ( szString, szName ) ) {

      szString += strlen ( szName ) ;

      if ( isascii ( *szString ) && isspace ( *szString ) ) {

         while ( isascii ( *szString ) && isspace ( *szString ) ) szString ++ ;

         errno = 0 ;
         if ( *szString == '-' ) *pValue = strtol ( szString, & szString, 10 ) ;
         else                    *pValue = strtoul ( szString, & szString, 10 ) ;
         while ( errno ) *pValue = 0 ;

         return 0 ;
      }
   }

   return 1 ;
}



// es當̃IvV擾
// IvV̖Ov 0 Ԃ
static int GetOptionStringA ( char *szString, const char *szName, char *szValue, int nMaxLen ) {

   if ( ! strheadicmp ( szString, szName ) ) {

      szString += strlen ( szName ) ;

      if ( isascii ( *szString ) && isspace ( *szString ) ) {

         while ( isascii ( *szString ) && isspace ( *szString ) ) szString ++ ;

         szString = strtokex ( szString, NULL ) ;
         if ( szString ) strlcpy ( szValue, szString, nMaxLen ) ;
         else            *szValue = 0 ;

         return 0 ;
      }
   }

   return 1 ;
}



// esUnicodẽIvV擾
// IvV̖Ov 0 Ԃ
static int GetOptionWideString ( char *szString, const char *szName, wchar_t *szValue, int nMaxLen ) {

   if ( ! strheadicmp ( szString, szName ) ) {

      szString += strlen ( szName ) ;

      if ( isascii ( *szString ) && isspace ( *szString ) ) {

         while ( isascii ( *szString ) && isspace ( *szString ) ) szString ++ ;
         if ( *szString == '\"' ) szString ++ ;

         wchar_t *szCurrent = szValue ;
         char szDigitBuffer [ 0x10 ] ;

         while ( isascii ( *szString ) && isxdigit ( *szString ) ) {
            if ( szCurrent - szValue >= nMaxLen ) break ;
            strlcpy ( szDigitBuffer, szString, 4 + 1 ) ;    // four digits and one null
            *szCurrent = (wchar_t) strtoul ( szDigitBuffer, NULL, 0x10 ) ;
            szString += 4 ;
            szCurrent ++ ;
         }

         *szCurrent = 0 ;
         return 0 ;
      }
   }

   return 1 ;
}



#if defined RTFCONV_EXE || defined RTFCONV_COM || defined SETUP_R
// esoCi[̃IvV擾
// IvV̖Ov 0 Ԃ
static int GetOptionBinary ( char *szString, const char *szName, unsigned short *pValue, int nLen ) {

   if ( ! strheadicmp ( szString, szName ) ) {

      szString += strlen ( szName ) ;

      if ( isascii ( *szString ) && isspace ( *szString ) ) {

         while ( isascii ( *szString ) && isspace ( *szString ) ) szString ++ ;
         if ( *szString == '\"' ) szString ++ ;

         unsigned short *pCurrent = pValue ;
         char szDigitBuffer [ 0x10 ] ;

         while ( isascii ( *szString ) && isxdigit ( *szString ) ) {
            if ( pCurrent - pValue >= nLen ) break ;
            strlcpy ( szDigitBuffer, szString, 4 + 1 ) ;    // four digits and one null
            *pCurrent = (wchar_t) strtoul ( szDigitBuffer, NULL, 0x10 ) ;
            szString += 4 ;
            pCurrent ++ ;
         }

         return 0 ;
      }
   }

   return 1 ;
}
#endif



#if defined RTFCONV_EXE || defined RTFCONV_COM || defined SETUP_R
void __cdecl FreeFontNameArray ( void ) {
   free ( FontNameArray ) ;
}
#endif



////////////////////////////////////////
//       ĨIvVݒ       //
////////////////////////////////////////



#if defined RTFCONV_EXE || defined CHNCONV_EXE || defined SETUP_R || defined SETUP_C
#ifndef CONV_OPT_OLD


#include "mkdir.h"


static int TranslateBeforeWriteOption ( void ) ;
static int WriteOptionFile ( FILE *Fout ) ;



// IɃIvV̐ݒiANSIŁj
//  0 As 0 ȊOԂ
int WriteOptionA ( const char *szFileName ) {

   char szFileNameBuffer [ MAX_PATH ] ;

   if ( ! szFileName ) {

      GetModuleFileNameA ( NULL, szFileNameBuffer, MAX_PATH ) ;
      ChangeFileNameA ( szFileNameBuffer, CFG_FILENAME_A ) ;

      szFileName = szFileNameBuffer ;
   }


   TranslateBeforeWriteOption () ;

   FILE *Fout = fsopen ( szFileName, "wb", _SH_DENYWR ) ;
   if ( ! Fout ) return 1 ;

   int nResult = WriteOptionFile ( Fout ) ;

   fclose ( Fout ) ;

   return nResult ;
}



// IɃIvV̐ݒiUNICODEŁj
//  0 As 0 ȊOԂ
int WriteOptionW ( const wchar_t *szFileName ) {

   wchar_t szFileNameBuffer [ MAX_PATH ] ;

   if ( ! szFileName ) {

      if ( GetSpecialFolderPathW ( NULL, szFileNameBuffer, CSIDL_APPDATA, 0 ) ) return 1 ;

      wcscat ( szFileNameBuffer, L"\\Harigaya" ) ;

      if ( ! IsFolderExistW ( szFileNameBuffer ) && MakeDirectoryW ( szFileNameBuffer, NULL ) ) return 1 ;

      SetPathSeparatorW ( szFileNameBuffer, ADD_SEPARATOR_ALWAYS ) ;
      wcscat ( szFileNameBuffer, CFG_FILENAME_W ) ;

      szFileName = szFileNameBuffer ;
   }


   TranslateBeforeWriteOption () ;

   FILE *Fout = wfsopen ( szFileName, L"wb", _SH_DENYWR ) ;
   if ( ! Fout ) return 1 ;

   int nResult = WriteOptionFile ( Fout ) ;

   fclose ( Fout ) ;

   return nResult ;
}



static int TranslateBeforeWriteOption ( void ) {

#if defined RTFCONV_EXE || defined CHNCONV_EXE
   if ( IsNT () ) w2alcpy ( szBrowsePathA, szBrowsePathW, MAX_PATH ) ;
#endif

#if defined RTFCONV_EXE || defined CHNCONV_EXE
   nSavedSrcType = nSrcType ;
   nSavedDstType = nDstType ;

   nSavedSrcCode = ( AvailableCodeList [ nSrcCode ] ).nCodePage ;
   nSavedDstCode = ( AvailableCodeList [ nDstCode ] ).nCodePage ;
#endif

   return 0 ;
}



// IvVt@C̏
//  0 As 0 ȊOԂ
static int WriteOptionFile ( FILE *Fout ) {


   fprintf ( Fout, "// Options for %s\r\n\r\n", GetStringA ( IDS_COMMANDNAME ) ) ;


   // l̕ۑ
   for ( int nCount = 0 ; nCount < OPTION_INTEGER_LIST_NELEM ; nCount ++ ) {

      const char *szName = ( OptionIntegerList [ nCount ] ).szName ;
      int *pValue = ( OptionIntegerList [ nCount ] ).nValue ;

#if defined RTFCONV_EXE || defined CHNCONV_EXE || defined SETUP_R || defined SETUP_C
      if ( ( pValue == & nSavedSrcType || pValue == & nSavedDstType ) && ! IsSaveCode ) continue ;
      if ( ( pValue == & nSavedSrcCode || pValue == & nSavedDstCode ) && ! IsSaveCode ) continue ;
#endif
      if ( ( pValue == & nSavedWindowX || pValue == & nSavedWindowY ) && ! IsSaveWindow ) continue ;

      fprintf ( Fout, "%s %d\r\n", szName, *pValue ) ;
   }


   // ̕ۑ
   for ( int nCount = 0 ; nCount < OPTION_STRING_LIST_A_NELEM ; nCount ++ ) {

      const char *szName = ( OptionStringListA [ nCount ] ).szName ;
      char *szValue = ( OptionStringListA [ nCount ] ).szValue ;

      if ( szValue == szBrowsePathA && ! IsSavePath ) continue ;
#if defined RTFCONV_EXE || defined SETUP_R
      if ( szValue == szFontNameArrayDummy ) continue ;
#endif

      if ( *szValue ) fprintf ( Fout, "%s \"%s\"\r\n", szName, szValue ) ;
   }


   // ̕ۑ(UNICODE)
   if ( IsNT () ) {
      for ( int nCount = 0 ; nCount < OPTION_STRING_LIST_W_NELEM ; nCount ++ ) {

         const char *szName = ( OptionStringListW [ nCount ] ).szName ;
         wchar_t *szValue = ( OptionStringListW [ nCount ] ).szValue ;

         if ( szValue == szBrowsePathW && ! IsSavePath ) continue ;
         if ( *szValue ) {
            fprintf ( Fout, "%s ", szName ) ;
            for ( wchar_t *szString = szValue ; *szString ; szString ++ ) fprintf ( Fout, "%04X", *szString ) ;
            fprintf ( Fout, "\r\n" ) ;
         }
      }
   }


#if defined RTFCONV_EXE || defined SETUP_R
   // oCi[̕ۑ
   for ( int nCount = 0 ; nCount < OPTION_BINARY_LIST_NELEM ; nCount ++ ) {

      const char *szName = ( OptionBinaryList [ nCount ] ).szName ;
      unsigned short *pValue = ( OptionBinaryList [ nCount ] ).pValue ;

#if ! defined SETUP_R
      if ( ! IsLangIdUserDefined && pValue == LangIdArray ) continue ;
#endif

      if ( pValue ) {
         fprintf ( Fout, "%s ", szName ) ;
         for ( unsigned short *pCurrent = pValue ; pCurrent - pValue < ( OptionBinaryList [ nCount ] ).nSize ; pCurrent ++ ) fprintf ( Fout, "%04X", *pCurrent ) ;
         fprintf ( Fout, "\r\n" ) ;
      }
   }
#endif


#if defined RTFCONV_EXE || defined SETUP_R
   // tHg̕ۑ
   if ( FontNameArray ) {
      for ( int nCount = 0 ; nCount < OPTION_STRING_LIST_A_NELEM ; nCount ++ ) {

         const char *szName = ( OptionStringListA [ nCount ] ).szName ;
         char *szValue = ( OptionStringListA [ nCount ] ).szValue ;

         if ( szValue == szFontNameArrayDummy ) {
            for ( int nIndex = 0 ; nIndex < UNICODE_BLOCK_NELEM ; nIndex ++ ) {
               char *szValue = FontNameArray + nIndex * LF_FACESIZE ;
               if ( *szValue ) fprintf ( Fout, "%s \"%d, %s\"\r\n", szName, nIndex, szValue ) ;
            }

            break ;
         }
      }
   }
#endif


   return 0 ;
}



#endif // #ifndef CONV_OPT_OLD
#endif // #if defined RTFCONV_EXE || defined CHNCONV_EXE || defined SETUP_R || defined SETUP_C

