// storestr.cpp

#include <windows.h>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <ctype.h>
#include <limits.h>
#include "msc.h"
#include "storestr.h"



#define DEBUG_STORESTR  0


// obt@TCY
#define INIT_BUFFER_SIZE 0x400

// PKoCg
#define ONE_MEGA_BYTE 0x100000

// qsort ()
typedef int ( __cdecl *QSORT_COMPARE_FUNCTION ) ( const void *, const void * ) ;


// This function is not supported in Win95
#define StrCmpLogicalW StrCmpLogicalW_
typedef int ( WINAPI *STRCMPLOGICALW ) ( LPCWSTR psz1, LPCWSTR psz2 ) ;
static HINSTANCE hShlwapi  ;
static STRCMPLOGICALW StrCmpLogicalW ;

static int LoadShlwapiDll ( void ) ;
static int FreeLibraryOnDetach ( void ) ;



////////////////////////////////////////
//               ANSI               //
////////////////////////////////////////



// obt@ɂ߂iANSIŁj
// obt@̊mۂɎsƂ́Aobt@NA STOREDSTRINGS_ERROR Ԃ
// nhɂ FreeStoredStrings () Ăяo
// oɂ GetFirstString ()  GetNextString () Ăяo
// vf̌ GetStringCount () т
// nh܂ł́Aǉ邱Ƃł
STOREDSTRINGSA *StoreStringsA ( STOREDSTRINGSA *StoredStrings, const char *szString ) {

   if ( StoredStrings == STOREDSTRINGS_ERROR ) return (STOREDSTRINGSA*) STOREDSTRINGS_ERROR ;

   if ( ! StoredStrings ) {
      StoredStrings = (STOREDSTRINGSA*) malloc ( sizeof(STOREDSTRINGSA) ) ;
      if ( ! StoredStrings ) return (STOREDSTRINGSA*) STOREDSTRINGS_ERROR ;
      memzero ( StoredStrings, sizeof(STOREDSTRINGSA) ) ;
   }

   if ( szString ) {

      size_t nStringLen = strlen ( szString ) ;
      if ( ! nStringLen ) return StoredStrings ;
      size_t dwRequiredBufferSize = ( StoredStrings->szWrite - StoredStrings->szStart + nStringLen + 2 ) * sizeof(char) ;

      if ( StoredStrings->dwBufferSize < dwRequiredBufferSize ) {

         size_t dwNewBufferSize ;
         if ( ! StoredStrings->dwBufferSize )                    dwNewBufferSize = INIT_BUFFER_SIZE ;
         else if ( StoredStrings->dwBufferSize < ONE_MEGA_BYTE ) dwNewBufferSize = StoredStrings->dwBufferSize * 4 ;
         else                                                    dwNewBufferSize = StoredStrings->dwBufferSize + ONE_MEGA_BYTE ;

         if ( dwNewBufferSize < dwRequiredBufferSize ) dwNewBufferSize = dwRequiredBufferSize ;

         if ( DEBUG_STORESTR ) {
            FILE *Fout = fopen ( "storestr.debug.txt", "ac" ) ;
            fprintf ( Fout, "%p, %p, %s\n", (void*) StoredStrings->dwBufferSize, (void*) dwNewBufferSize, szString ) ;
            fclose ( Fout ) ;
         }

         char *szNewBuffer = (char*) realloc ( StoredStrings->szStart, dwNewBufferSize ) ;

         if ( ! szNewBuffer || StoredStrings->dwBufferSize > dwNewBufferSize ) {
            FreeStoredStringsA ( StoredStrings ) ;
            return (STOREDSTRINGSA*) STOREDSTRINGS_ERROR ;
         }

         char *szOldBuffer = StoredStrings->szStart ;
         StoredStrings->szStart = szNewBuffer ;
         StoredStrings->szWrite += szNewBuffer - szOldBuffer ;
         StoredStrings->szRead += szNewBuffer - szOldBuffer ;
         StoredStrings->szSortStart += szNewBuffer - szOldBuffer ;
         StoredStrings->dwBufferSize = dwNewBufferSize ;
      }

      strcpy ( StoredStrings->szWrite, szString ) ;
      StoredStrings->szWrite += nStringLen + 1 ;
      *( StoredStrings->szWrite ) = 0 ;
      StoredStrings->nCount ++ ;
   }

   return StoredStrings ;
}



// obt@iANSIŁj
void FreeStoredStringsA ( STOREDSTRINGSA *StoredStrings ) {
   if ( ! StoredStrings || StoredStrings == STOREDSTRINGS_ERROR ) return ;
   free ( StoredStrings->szStart ) ;
   free ( StoredStrings ) ;
   return ;
}



// obt@ŏ̕ԂiANSIŁj
// 񂪂Ȃ΁ANULL Ԃ
const char *GetFirstStringA ( STOREDSTRINGSA *StoredStrings ) {
   if ( ! StoredStrings || StoredStrings == STOREDSTRINGS_ERROR ) return NULL ;
   return StoredStrings->szRead = StoredStrings->szStart ;
}



// obt@玟̕ԂiANSIŁj
// 񂪂Ȃ΁ANULL Ԃ
// GetFirstString () ĂяoOȂ΁A͕s
const char *GetNextStringA ( STOREDSTRINGSA *StoredStrings ) {
   if ( ! StoredStrings || StoredStrings == STOREDSTRINGS_ERROR ) return NULL ;
   char *szNext = strend ( StoredStrings->szRead ) + 1 ;
   if ( *szNext ) return StoredStrings->szRead = szNext ;
   return NULL ;
}



// obt@̌̕ԂiANSIŁj
size_t GetStringCountA ( STOREDSTRINGSA *StoredStrings ) {
   if ( ! StoredStrings || StoredStrings == STOREDSTRINGS_ERROR ) return 0 ;
   return StoredStrings->nCount ;
}



// obt@̕\[giANSIŁj
// CompareFuntion ɂ͑gݍ݂̔r֐܂̓[U`̔r֐w
// O MarkSortStart () ĂяoꂽAȍ~ɒǉꂽ̂݃\[g
int SortStoredStringsA ( STOREDSTRINGSA *StoredStrings, int ( __cdecl *CompareFunction ) ( const char **, const char ** ) ) {

   STOREDSTRINGSA *StoredStringsTmp = NULL ;
   size_t nCount ;
   int nResult = 1 ;

   char *szStart ;
   size_t nItem ;

   if ( ! StoredStrings ) return 0 ;
   if ( ! CompareFunction ) return 0 ;

   if ( CompareFunction == CompareStoredStringsNumericalA || CompareFunction == CompareStoredStringsNumericalRevA ) LoadShlwapiDll () ;

   if ( StoredStrings->szSortStart ) {
      szStart = StoredStrings->szSortStart ;
      nItem = StoredStrings->nCount - StoredStrings->nSortStartCount ;
   }
   else {
      szStart = StoredStrings->szStart ;
      nItem = StoredStrings->nCount ;
   }

   if ( nItem <= 1 ) return 0 ;

   char **pPointerToName = (char**) malloc ( ( nItem ) * sizeof(char*) ) ;
   if ( ! pPointerToName ) return 1 ;

   char *szStringGet = szStart ;
   for ( nCount = 0 ; nCount < nItem ; nCount ++ ) {
      pPointerToName [ nCount ] = szStringGet ;
      szStringGet = strend ( szStringGet ) + 1 ;
   }

   qsort ( pPointerToName, nItem, sizeof(char*), (QSORT_COMPARE_FUNCTION) CompareFunction ) ;

   for ( nCount = 0 ; nCount < nItem ; nCount ++ ) {
      StoredStringsTmp = StoreStringsA ( StoredStringsTmp, pPointerToName [ nCount ] ) ;
      if ( StoredStringsTmp == STOREDSTRINGS_ERROR ) break ;
   }
   if ( StoredStringsTmp && StoredStringsTmp != STOREDSTRINGS_ERROR ) {
      memmove ( szStart, GetFirstStringA ( StoredStringsTmp ), ( szStringGet - szStart ) * sizeof(char) ) ;
      FreeStoredStringsA ( StoredStringsTmp ) ;
      nResult = 0 ;
   }

   free ( pPointerToName ) ;
   return nResult ;
}



// ȍ~ɒǉꂽ̂ SortStoredStrings () Ń\[giANSIŁj
int MarkSortStartA ( STOREDSTRINGSA *StoredStrings ) {
   if ( ! StoredStrings || StoredStrings == STOREDSTRINGS_ERROR ) return 1 ;
   StoredStrings->szSortStart = StoredStrings->szWrite ;
   StoredStrings->nSortStartCount = StoredStrings->nCount ;
   return 0 ;
}



// MarkSortStartŎw肳ꂽ}[NiANSIŁj
int UnmarkSortStartA ( STOREDSTRINGSA *StoredStrings ) {
   if ( ! StoredStrings || StoredStrings == STOREDSTRINGS_ERROR ) return 1 ;
   StoredStrings->szSortStart = NULL ;
   StoredStrings->nSortStartCount = 0 ;
   return 0 ;
}



// obt@}[Nꂽŏ̕ԂiANSIŁj
// 񂪂Ȃ΁ANULL Ԃ
const char *GetFirstMarkedStringA ( STOREDSTRINGSA *StoredStrings ) {
   if ( ! StoredStrings || StoredStrings == STOREDSTRINGS_ERROR ) return NULL ;
   if ( StoredStrings->szSortStart ) return StoredStrings->szRead = StoredStrings->szSortStart ;
   else                              return StoredStrings->szRead = StoredStrings->szStart ;
}



////////////////////////////////////////
//              UNICODE             //
////////////////////////////////////////



// obt@ɂ߂iUNICODEŁj
// obt@̊mۂɎsƂ́Aobt@NA STOREDSTRINGS_ERROR Ԃ
// nhɂ FreeStoredStrings () Ăяo
// oɂ GetFirstString ()  GetNextString () Ăяo
// vf̌ GetStringCount () т
// nh܂ł́Aǉ邱Ƃł
STOREDSTRINGSW *StoreStringsW ( STOREDSTRINGSW *StoredStrings, const wchar_t *szString ) {

   if ( StoredStrings == STOREDSTRINGS_ERROR ) return (STOREDSTRINGSW*) STOREDSTRINGS_ERROR ;

   if ( ! StoredStrings ) {
      StoredStrings = (STOREDSTRINGSW*) malloc ( sizeof(STOREDSTRINGSW) ) ;
      if ( ! StoredStrings ) return (STOREDSTRINGSW*) STOREDSTRINGS_ERROR ;
      memzero ( StoredStrings, sizeof(STOREDSTRINGSW) ) ;
   }

   if ( szString ) {

      size_t nStringLen = wcslen ( szString ) ;
      if ( ! nStringLen ) return StoredStrings ;
      size_t dwRequiredBufferSize = ( StoredStrings->szWrite - StoredStrings->szStart + nStringLen + 2 ) * sizeof(wchar_t) ;

      if ( StoredStrings->dwBufferSize < dwRequiredBufferSize ) {

         size_t dwNewBufferSize ;
         if ( ! StoredStrings->dwBufferSize )                    dwNewBufferSize = INIT_BUFFER_SIZE ;
         else if ( StoredStrings->dwBufferSize < ONE_MEGA_BYTE ) dwNewBufferSize = StoredStrings->dwBufferSize * 4 ;
         else                                                    dwNewBufferSize = StoredStrings->dwBufferSize + ONE_MEGA_BYTE ;

         if ( dwNewBufferSize < dwRequiredBufferSize ) dwNewBufferSize = dwRequiredBufferSize ;

         if ( DEBUG_STORESTR ) {
            FILE *Fout = fopen ( "storestr.debug.txt", "ac" ) ;
            char *szTmp = w2adup ( szString ) ;
            fprintf ( Fout, "%p, %p, %s\n", (void*) StoredStrings->dwBufferSize, (void*) dwNewBufferSize, szTmp ) ;
            free ( szTmp ) ;
            fclose ( Fout ) ;
         }

         wchar_t *szNewBuffer = (wchar_t*) realloc ( StoredStrings->szStart, dwNewBufferSize ) ;

         if ( ! szNewBuffer || StoredStrings->dwBufferSize > dwNewBufferSize ) {
            FreeStoredStringsW ( StoredStrings ) ;
            return (STOREDSTRINGSW*) STOREDSTRINGS_ERROR ;
         }

         wchar_t *szOldBuffer = StoredStrings->szStart ;
         StoredStrings->szStart = szNewBuffer ;
         StoredStrings->szWrite += szNewBuffer - szOldBuffer ;
         StoredStrings->szRead += szNewBuffer - szOldBuffer ;
         StoredStrings->szSortStart += szNewBuffer - szOldBuffer ;
         StoredStrings->dwBufferSize = dwNewBufferSize ;
      }

      wcscpy ( StoredStrings->szWrite, szString ) ;
      StoredStrings->szWrite += nStringLen + 1 ;
      *( StoredStrings->szWrite ) = 0 ;
      StoredStrings->nCount ++ ;
   }

   return StoredStrings ;
}



// obt@
void FreeStoredStringsW ( STOREDSTRINGSW *StoredStrings ) {
   if ( ! StoredStrings || StoredStrings == STOREDSTRINGS_ERROR ) return ;
   free ( StoredStrings->szStart ) ;
   free ( StoredStrings ) ;
   return ;
}



// obt@ŏ̕ԂiUNICODEŁj
// 񂪂Ȃ΁ANULL Ԃ
const wchar_t *GetFirstStringW ( STOREDSTRINGSW *StoredStrings ) {
   if ( ! StoredStrings || StoredStrings == STOREDSTRINGS_ERROR ) return NULL ;
   return StoredStrings->szRead = StoredStrings->szStart ;
}



// obt@玟̕ԂiUNICODEŁj
// 񂪂Ȃ΁ANULL Ԃ
// GetFirstString () ĂяoOȂ΁A͕s
const wchar_t *GetNextStringW ( STOREDSTRINGSW *StoredStrings ) {
   if ( ! StoredStrings || StoredStrings == STOREDSTRINGS_ERROR ) return NULL ;
   wchar_t *szNext = wcsend ( StoredStrings->szRead ) + 1 ;
   if ( *szNext ) return StoredStrings->szRead = szNext ;
   return NULL ;
}



// obt@̌̕ԂiUNICODEŁj
size_t GetStringCountW ( STOREDSTRINGSW *StoredStrings ) {
   if ( ! StoredStrings || StoredStrings == STOREDSTRINGS_ERROR ) return 0 ;
   return StoredStrings->nCount ;
}



// obt@̕\[giUNICODEŁj
// CompareFuntion ɂ͑gݍ݂̔r֐܂̓[U`̔r֐w
// O MarkSortStart () ĂяoꂽAȍ~ɒǉꂽ̂݃\[g
int SortStoredStringsW ( STOREDSTRINGSW *StoredStrings, int ( __cdecl *CompareFunction ) ( const wchar_t **, const wchar_t ** ) ) {

   STOREDSTRINGSW *StoredStringsTmp = NULL ;
   size_t nCount ;
   int nResult = 1 ;

   wchar_t *szStart ;
   size_t nItem ;

   if ( ! StoredStrings ) return 0 ;
   if ( ! CompareFunction ) return 0 ;

   if ( CompareFunction == CompareStoredStringsNumericalW || CompareFunction == CompareStoredStringsNumericalRevW ) LoadShlwapiDll () ;

   if ( StoredStrings->szSortStart ) {
      szStart = StoredStrings->szSortStart ;
      nItem = StoredStrings->nCount - StoredStrings->nSortStartCount ;
   }
   else {
      szStart = StoredStrings->szStart ;
      nItem = StoredStrings->nCount ;
   }

   if ( nItem <= 1 ) return 0 ;

   wchar_t **pPointerToName = (wchar_t**) malloc ( ( nItem ) * sizeof(wchar_t*) ) ;
   if ( ! pPointerToName ) return 1 ;

   wchar_t *szStringGet = szStart ;
   for ( nCount = 0 ; nCount < nItem ; nCount ++ ) {
      pPointerToName [ nCount ] = szStringGet ;
      szStringGet = wcsend ( szStringGet ) + 1 ;
   }

   qsort ( pPointerToName, nItem, sizeof(wchar_t*), (QSORT_COMPARE_FUNCTION) CompareFunction ) ;

   for ( nCount = 0 ; nCount < nItem ; nCount ++ ) {
      StoredStringsTmp = StoreStringsW ( StoredStringsTmp, pPointerToName [ nCount ] ) ;
      if ( StoredStringsTmp == STOREDSTRINGS_ERROR ) break ;
   }
   if ( StoredStringsTmp && StoredStringsTmp != STOREDSTRINGS_ERROR ) {
      memmove ( szStart, GetFirstStringW ( StoredStringsTmp ), ( szStringGet - szStart ) * sizeof(wchar_t) ) ;
      FreeStoredStringsW ( StoredStringsTmp ) ;
      nResult = 0 ;
   }

   free ( pPointerToName ) ;
   return nResult ;
}



// ȍ~ɒǉꂽ̂ SortStoredStrings () Ń\[giUNICODEŁj
int MarkSortStartW ( STOREDSTRINGSW *StoredStrings ) {
   if ( ! StoredStrings || StoredStrings == STOREDSTRINGS_ERROR ) return 1 ;
   StoredStrings->szSortStart = StoredStrings->szWrite ;
   StoredStrings->nSortStartCount = StoredStrings->nCount ;
   return 0 ;
}



// MarkSortStartŎw肳ꂽ}[NiUNICODEŁj
int UnmarkSortStartW ( STOREDSTRINGSW *StoredStrings ) {
   if ( ! StoredStrings || StoredStrings == STOREDSTRINGS_ERROR ) return 1 ;
   StoredStrings->szSortStart = NULL ;
   StoredStrings->nSortStartCount = 0 ;
   return 0 ;
}



// obt@}[Nꂽŏ̕ԂiUNICODEŁj
// 񂪂Ȃ΁ANULL Ԃ
const wchar_t *GetFirstMarkedStringW ( STOREDSTRINGSW *StoredStrings ) {
   if ( ! StoredStrings || StoredStrings == STOREDSTRINGS_ERROR ) return NULL ;
   if ( StoredStrings->szSortStart ) return StoredStrings->szRead = StoredStrings->szSortStart ;
   else                              return StoredStrings->szRead = StoredStrings->szStart ;
}



////////////////////////////////////////
//           r֐iCRTj          //
////////////////////////////////////////



// Ń\[giANSIŁj
int __cdecl CompareStoredStringsA ( const char **pArg1, const char **pArg2 ) {
   return strcmp ( *pArg1, *pArg2 ) ;
}



// tŃ\[giANSIŁj
int __cdecl CompareStoredStringsRevA ( const char **pArg1, const char **pArg2 ) {
   return - strcmp ( *pArg1, *pArg2 ) ;
}



// Ń\[giUNICODEŁj
int __cdecl CompareStoredStringsW ( const wchar_t **pArg1, const wchar_t **pArg2 ) {
   return wcscmp ( *pArg1, *pArg2 ) ;
}



// tŃ\[giUNICODEŁj
int __cdecl CompareStoredStringsRevW ( const wchar_t **pArg1, const wchar_t **pArg2 ) {
   return - wcscmp ( *pArg1, *pArg2 ) ;
}



////////////////////////////////////////
//         r֐iLOCALEj         //
////////////////////////////////////////



static int CompareStringSystemA ( LCID Locale, DWORD dwFlags, LPCSTR szSrc, int nSrc, LPCSTR szDst, int nDst ) ;
static int CompareStringSystemW ( LCID Locale, DWORD dwFlags, LPCWSTR szSrc, int nSrc, LPCWSTR szDst, int nDst ) ;



// Ń\[giANSIŁj
int __cdecl CompareStoredStringsLocaleA ( const char **pArg1, const char **pArg2 ) {
   return CompareStringSystemA ( LOCALE_SYSTEM_DEFAULT, 0, *pArg1, -1, *pArg2, -1 ) ;
}



// tŃ\[giANSIŁj
int __cdecl CompareStoredStringsLocaleRevA ( const char **pArg1, const char **pArg2 ) {
   return - CompareStringSystemA ( LOCALE_SYSTEM_DEFAULT, 0, *pArg1, -1, *pArg2, -1 ) ;
}



// Ń\[giUNICODEŁj
int __cdecl CompareStoredStringsLocaleW ( const wchar_t **pArg1, const wchar_t **pArg2 ) {
   return CompareStringSystemW ( LOCALE_SYSTEM_DEFAULT, 0, *pArg1, -1, *pArg2, -1 ) ;
}



// tŃ\[giUNICODEŁj
int __cdecl CompareStoredStringsLocaleRevW ( const wchar_t **pArg1, const wchar_t **pArg2 ) {
   return - CompareStringSystemW ( LOCALE_SYSTEM_DEFAULT, 0, *pArg1, -1, *pArg2, -1 ) ;
}



////////////////////////////////////////
//        r֐iNUMERICALj       //
////////////////////////////////////////



static int CompareStringLogicalA ( const char *szSrc, const char *szDst ) ;
static int CompareStringLogicalW ( const wchar_t *szSrc, const wchar_t *szDst ) ;



// Ń\[giANSIŁj
int __cdecl CompareStoredStringsNumericalA ( const char **pArg1, const char **pArg2 ) {
   return CompareStringLogicalA ( *pArg1, *pArg2 ) ;
}



// tŃ\[giANSIŁj
int __cdecl CompareStoredStringsNumericalRevA ( const char **pArg1, const char **pArg2 ) {
   return - CompareStringLogicalA ( *pArg1, *pArg2 ) ;
}



// Ń\[giUNICODEŁj
int __cdecl CompareStoredStringsNumericalW ( const wchar_t **pArg1, const wchar_t **pArg2 ) {
   return CompareStringLogicalW ( *pArg1, *pArg2 ) ;
}



// tŃ\[giUNICODEŁj
int __cdecl CompareStoredStringsNumericalRevW ( const wchar_t **pArg1, const wchar_t **pArg2 ) {
   return - CompareStringLogicalW ( *pArg1, *pArg2 ) ;
}



////////////////////////////////////////
//          CompareString ()          //
////////////////////////////////////////



static int CompareStringSystemA ( LCID Locale, DWORD dwFlags, LPCSTR szSrc, int nSrc, LPCSTR szDst, int nDst ) {
   int nResult = CompareStringA ( Locale, dwFlags, szSrc, nSrc, szDst, nDst ) ;
   if ( nResult ) return nResult - CSTR_EQUAL ;
   return 0 ;
}



static int CompareStringSystemW ( LCID Locale, DWORD dwFlags, LPCWSTR szSrc, int nSrc, LPCWSTR szDst, int nDst ) {

   if ( IsNT () ) {
      int nResult = CompareStringW ( Locale, dwFlags, szSrc, nSrc, szDst, nDst ) ;
      if ( nResult ) return nResult - CSTR_EQUAL ;
      return 0 ;
   }

   size_t nSrcA, nDstA ;
   char *szSrcA = w2aduplen_expand ( szSrc, nSrc, 0, & nSrcA ) ;
   char *szDstA = w2aduplen_expand ( szDst, nDst, 0, & nDstA ) ;

   int nResult = 0 ;
   if ( szSrcA && szDstA && nSrcA <= INT_MAX && nDstA <= INT_MAX ) {
      nResult = CompareStringA ( Locale, dwFlags, szSrcA, (int) nSrcA, szDstA, (int) nDstA ) ;
   }

   free ( szSrcA ) ;
   free ( szDstA ) ;

   if ( nResult ) return nResult - CSTR_EQUAL ;
   return 0 ;
}



////////////////////////////////////////
//          StrCmpLogical ()          //
////////////////////////////////////////



static int LoadShlwapiDll ( void ) {

   static volatile int IsTried ;

#ifndef STRCMP_LOGICAL_TEST
   if ( IsWinXPorLater () && ! IsTried ) {
#ifdef _MT
      EnterCriticalSection ( & LoadDllSection ) ;
      __try {
         if ( ! IsTried ) {
#endif
            if ( ! hShlwapi && ( hShlwapi = LoadLibraryW ( L"SHLWAPI.DLL" ) ) ) FreeLibraryOnDetach () ;
            GETPROCADDRESS ( hShlwapi, STRCMPLOGICALW, StrCmpLogicalW ) ;
            IsTried = 1 ;
#ifdef _MT
         }
      } __finally {
         LeaveCriticalSection ( & LoadDllSection ) ;
      }
#endif
   }
#else
   fprintf ( stderr, "Testing StrCmpLogical...\n" ) ;
#endif

   return ( StrCmpLogicalW ) ? 0 : 1 ;
}



// StrCmpLogicalW()  ANSI
static int StrCmpLogicalA ( const char *szSrc, const char *szDst ) {

   wchar_t *szSrcW = a2wdup ( szSrc ) ;
   wchar_t *szDstW = a2wdup ( szDst ) ;

   int nResult = 0 ;
   if ( szSrcW && szDstW ) nResult = StrCmpLogicalW ( szSrcW, szDstW ) ;

   free ( szSrcW ) ;
   free ( szDstW ) ;

   return nResult ;
}



static int CompareStringLogicalA ( const char *szSrc, const char *szDst ) {

   if ( StrCmpLogicalW ) return StrCmpLogicalA ( szSrc, szDst ) ;

   if ( ! szSrc || ! szDst ) return 0 ;

   const char *szSrcStart = szSrc ;
   const char *szDstStart = szDst ;

   while ( *szSrc || *szDst ) {

      if ( isascii ( *szSrc ) && isdigit ( *szSrc ) && isascii ( *szDst ) && isdigit ( *szDst ) ) {

         unsigned long nSrc = strtoul ( szSrc, & szSrc, 10 ) ;
         unsigned long nDst = strtoul ( szDst, & szDst, 10 ) ;

         if ( nSrc < nDst ) return -1 ;
         if ( nSrc > nDst ) return 1 ;

      }
      else if ( *szSrc && *szDst ) {

         const char *szSrcSaved = szSrc ;
         const char *szDstSaved = szDst ;

         while ( *szSrc && ! ( isascii ( *szSrc ) && isdigit ( *szSrc ) ) ) szSrc ++ ;
         while ( *szDst && ! ( isascii ( *szDst ) && isdigit ( *szDst ) ) ) szDst ++ ;

         int nResult = CompareStringSystemA ( LOCALE_SYSTEM_DEFAULT, NORM_IGNORECASE, szSrcSaved, (int) ( szSrc - szSrcSaved ), szDstSaved, (int) ( szDst - szDstSaved ) ) ;
         if ( nResult ) return nResult ;

      }
      else {
         if ( *szSrc ) return 1 ;
         if ( *szDst ) return -1 ;
      }
   }

   return CompareStringSystemA ( LOCALE_SYSTEM_DEFAULT, 0, szSrcStart, -1, szDstStart, -1 ) ;
}



static int CompareStringLogicalW ( const wchar_t *szSrc, const wchar_t *szDst ) {

   if ( StrCmpLogicalW ) return StrCmpLogicalW ( szSrc, szDst ) ;

   if ( ! szSrc || ! szDst ) return 0 ;

   const wchar_t *szSrcStart = szSrc ;
   const wchar_t *szDstStart = szDst ;

   while ( *szSrc || *szDst ) {

      if ( isascii ( *szSrc ) && isdigit ( *szSrc ) && isascii ( *szDst ) && isdigit ( *szDst ) ) {

         unsigned long nSrc = wcstoul ( szSrc, & szSrc, 10 ) ;
         unsigned long nDst = wcstoul ( szDst, & szDst, 10 ) ;

         if ( nSrc < nDst ) return -1 ;
         if ( nSrc > nDst ) return 1 ;

      }
      else if ( *szSrc && *szDst ) {

         const wchar_t *szSrcSaved = szSrc ;
         const wchar_t *szDstSaved = szDst ;

         while ( *szSrc && ! ( isascii ( *szSrc ) && isdigit ( *szSrc ) ) ) szSrc ++ ;
         while ( *szDst && ! ( isascii ( *szDst ) && isdigit ( *szDst ) ) ) szDst ++ ;

         int nResult = CompareStringSystemW ( LOCALE_SYSTEM_DEFAULT, NORM_IGNORECASE, szSrcSaved, (int) ( szSrc - szSrcSaved ), szDstSaved, (int) ( szDst - szDstSaved ) ) ;
         if ( nResult ) return nResult ;

      }
      else {
         if ( *szSrc ) return 1 ;
         if ( *szDst ) return -1 ;
      }
   }

   return CompareStringSystemW ( LOCALE_SYSTEM_DEFAULT, 0, szSrcStart, -1, szDstStart, -1 ) ;
}



////////////////////////////////////////
//              ʊ֐              //
////////////////////////////////////////



static void __cdecl ExitProc ( void ) {
   if ( hShlwapi ) FreeLibrary ( hShlwapi ) ;
}



static int FreeLibraryOnDetach ( void ) {
#ifdef _USRDLL
   return atexit ( ExitProc ) ;
#else
   return 0 ;
#endif
}



