// storestr.h

#ifndef STORESTR_H
#define STORESTR_H


#ifdef __cplusplus
extern "C" {
#endif


#define STOREDSTRINGS_ERROR   ( (void*) -1 )


// STOREDSTRINGS \́iANSIŁj
typedef struct {
   char           *szStart ;        // obt@̐擪AhX
   char           *szRead ;         // obt@̓ǂݏop̃AhX
   char           *szWrite ;        // obt@̏ݗp̃AhX
   size_t         dwBufferSize ;    // mۂobt@̃TCYioCgj
   size_t         nCount ;          // vf̌
   char           *szSortStart ;    // \[gn߂ʒu
   size_t         nSortStartCount ; // \[gn߂ʒu܂ł̗vf̐
} STOREDSTRINGSA ;


// STOREDSTRINGS \́iUNICODEŁj
typedef struct {
   wchar_t        *szStart ;        // obt@̐擪AhX
   wchar_t        *szRead ;         // obt@̓ǂݏop̃AhX
   wchar_t        *szWrite ;        // obt@̏ݗp̃AhX
   size_t         dwBufferSize ;    // mۂobt@̃TCYioCgj
   size_t         nCount ;          // vf̌
   wchar_t        *szSortStart ;    // \[gn߂ʒu
   size_t         nSortStartCount ; // \[gn߂ʒu܂ł̗vf̐
} STOREDSTRINGSW ;


STOREDSTRINGSA *StoreStringsA ( STOREDSTRINGSA *StoredStrings, const char *szString ) ;
void FreeStoredStringsA ( STOREDSTRINGSA *StoredStrings ) ;
const char *GetFirstStringA ( STOREDSTRINGSA *StoredStrings ) ;
const char *GetNextStringA ( STOREDSTRINGSA *StoredStrings ) ;
size_t GetStringCountA ( STOREDSTRINGSA *StoredStrings ) ;
int SortStoredStringsA ( STOREDSTRINGSA *StoredStrings, int ( __cdecl *CompareFunction ) ( const char **, const char ** ) ) ;
int MarkSortStartA ( STOREDSTRINGSA *StoredStrings ) ;
int UnmarkSortStartA ( STOREDSTRINGSA *StoredStrings ) ;
const char *GetFirstMarkedStringA ( STOREDSTRINGSA *StoredStrings ) ;

STOREDSTRINGSW *StoreStringsW ( STOREDSTRINGSW *StoredStrings, const wchar_t *szString ) ;
void FreeStoredStringsW ( STOREDSTRINGSW *StoredStrings ) ;
const wchar_t *GetFirstStringW ( STOREDSTRINGSW *StoredStrings ) ;
const wchar_t *GetNextStringW ( STOREDSTRINGSW *StoredStrings ) ;
size_t GetStringCountW ( STOREDSTRINGSW *StoredStrings ) ;
int SortStoredStringsW ( STOREDSTRINGSW *StoredStrings, int ( __cdecl *CompareFunction ) ( const wchar_t **, const wchar_t ** ) ) ;
int MarkSortStartW ( STOREDSTRINGSW *StoredStrings ) ;
int UnmarkSortStartW ( STOREDSTRINGSW *StoredStrings ) ;
const wchar_t *GetFirstMarkedStringW ( STOREDSTRINGSW *StoredStrings ) ;


#ifdef UNICODE
#define STOREDSTRINGS         STOREDSTRINGSW
#define StoreStrings          StoreStringsW
#define FreeStoredStrings     FreeStoredStringsW
#define GetFirstString        GetFirstStringW
#define GetNextString         GetNextStringW
#define GetStringCount        GetStringCountW
#define SortStoredStrings     SortStoredStringsW
#define MarkSortStart         MarkSortStartW
#define UnmarkSortStart       UnmarkSortStartW
#define GetFirstMarkedString  GetFirstMarkedStringW
#else
#define STOREDSTRINGS         STOREDSTRINGSA
#define StoreStrings          StoreStringsA
#define FreeStoredStrings     FreeStoredStringsA
#define GetFirstString        GetFirstStringA
#define GetNextString         GetNextStringA
#define GetStringCount        GetStringCountA
#define SortStoredStrings     SortStoredStringsA
#define MarkSortStart         MarkSortStartA
#define UnmarkSortStart       UnmarkSortStartA
#define GetFirstMarkedString  GetFirstMarkedStringA
#endif


int __cdecl CompareStoredStringsA ( const char **pArg1, const char **pArg2 ) ;
int __cdecl CompareStoredStringsRevA ( const char **pArg1, const char **pArg2 ) ;
int __cdecl CompareStoredStringsLocaleA ( const char **pArg1, const char **pArg2 ) ;
int __cdecl CompareStoredStringsLocaleRevA ( const char **pArg1, const char **pArg2 ) ;
int __cdecl CompareStoredStringsNumericalA ( const char **pArg1, const char **pArg2 ) ;
int __cdecl CompareStoredStringsNumericalRevA ( const char **pArg1, const char **pArg2 ) ;

int __cdecl CompareStoredStringsW ( const wchar_t **pArg1, const wchar_t **pArg2 ) ;
int __cdecl CompareStoredStringsRevW ( const wchar_t **pArg1, const wchar_t **pArg2 ) ;
int __cdecl CompareStoredStringsLocaleW ( const wchar_t **pArg1, const wchar_t **pArg2 ) ;
int __cdecl CompareStoredStringsLocaleRevW ( const wchar_t **pArg1, const wchar_t **pArg2 ) ;
int __cdecl CompareStoredStringsNumericalW ( const wchar_t **pArg1, const wchar_t **pArg2 ) ;
int __cdecl CompareStoredStringsNumericalRevW ( const wchar_t **pArg1, const wchar_t **pArg2 ) ;


#ifdef UNICODE
#define CompareStoredStrings              CompareStoredStringsW
#define CompareStoredStringsRev           CompareStoredStringsRevW
#define CompareStoredStringsLocale        CompareStoredStringsLocaleW
#define CompareStoredStringsLocaleRev     CompareStoredStringsLocaleRevW
#define CompareStoredStringsNumerical     CompareStoredStringsNumericalW
#define CompareStoredStringsNumericalRev  CompareStoredStringsNumericalRevW
#else
#define CompareStoredStrings              CompareStoredStringsA
#define CompareStoredStringsRev           CompareStoredStringsRevA
#define CompareStoredStringsLocale        CompareStoredStringsLocaleA
#define CompareStoredStringsLocaleRev     CompareStoredStringsLocaleRevA
#define CompareStoredStringsNumerical     CompareStoredStringsNumericalA
#define CompareStoredStringsNumericalRev  CompareStoredStringsNumericalRevA
#endif


#ifdef __cplusplus
}
#endif

#endif


