// wildcard.h

#ifndef WILDCARD_H
#define WILDCARD_H


#include "storestr.h"


#ifdef __cplusplus
extern "C" {
#endif


// [h dwFlags
#define WILD_SEARCH_FILE               1     // t@C
#define WILD_SEARCH_FOLDER             2     // fBNg
#define WILD_SEARCH_HIDDEN             4     // Bt@CEVXet@C
#define WILD_SHORTNAME                 8     // V[gt@Co͂
#define WILD_SEARCH_SUB             0x10     // TufBNg
#define WILD_SEARCH_HIDDENSUB       0x20     // BTufBNg
#define WILD_WITHPATH               0x40     // pXtŏo
#define WILD_SORT                   0x80     // \[g
#define WILD_SORT_REVERSE          0x100     // tɃ\[g
#define WILD_XP_STYLE              0x200     // XPX^CŃ\[g (WILD_SORT܂WILD_SORT_REVERSEƓɎw肷)
#define WILD_NO_PIVOT_DIR         0x1000     // fBNgo͂Ȃ
#define WILD_SEARCH_CURDIR        0x2000     // "."  ".." o͂
#define WILD_NO_EMPTY_DIR         0x4000     // t@ĈȂfBNgo͂ȂiWILD_SEARCH_FOLDERƓɎw)
#define WILD_ONLY_EMPTY_DIR       0x8000     // t@CTufBNĝfBNgo͂ȂiWILD_SEARCH_FOLDERƓɎw)
#ifndef _CONSOLE
#define WILD_PEEKMESSAGE      0x80000000     // bZ[W[v܂킷
#endif

//  WILD_SEARCH_FILE  WILD_SEARCH_FOLDER w肳ĂȂ
// I WILD_SEARCH_FILE w


#define WILDCARD_ERROR  ( (void*) -1 )


// ChJ[h\
typedef struct {
   STOREDSTRINGSA *StoredNames ;    // t@C
} WILDCARDA ;


// ChJ[h\
typedef struct {
   STOREDSTRINGSW *StoredNames ;    // t@C
} WILDCARDW ;


WILDCARDA *WINAPI SearchWildcardA ( WILDCARDA *Wildcard, const char *szSearchPath, unsigned long dwFlags, int ( CALLBACK *Callback ) ( const char *szSearchPath, WIN32_FIND_DATAA *FindData, int nDepth, LPARAM lParam ), LPARAM lParam ) ;
void WINAPI CloseWildcardA ( WILDCARDA *Wildcard ) ;
const char *WINAPI GetFirstFileA ( WILDCARDA *Wildcard ) ;
const char *WINAPI GetNextFileA ( WILDCARDA *Wildcard ) ;
size_t WINAPI GetFileCountA ( WILDCARDA *Wildcard ) ;

WILDCARDW *WINAPI SearchWildcardW ( WILDCARDW *Wildcard, const wchar_t *szSearchPath, unsigned long dwFlags, int ( CALLBACK *Callback ) ( const wchar_t *szSearchPath, WIN32_FIND_DATAW *FindData, int nDepth, LPARAM lParam ), LPARAM lParam ) ;
void WINAPI CloseWildcardW ( WILDCARDW *Wildcard ) ;
const wchar_t *WINAPI GetFirstFileW ( WILDCARDW *Wildcard ) ;
const wchar_t *WINAPI GetNextFileW ( WILDCARDW *Wildcard ) ;
size_t WINAPI GetFileCountW ( WILDCARDW *Wildcard ) ;

int WINAPI AbortWildcard ( void ) ;


#ifdef UNICODE
#define WILDCARD              WILDCARDW
#define SearchWildcard        SearchWildcardW
#define CloseWildcard         CloseWildcardW
#define GetFirstFile          GetFirstFileW
#define GetNextFile           GetNextFileW
#define GetFileCount          GetFileCountW
#else
#define WILDCARD              WILDCARDA
#define SearchWildcard        SearchWildcardA
#define CloseWildcard         CloseWildcardA
#define GetFirstFile          GetFirstFileA
#define GetNextFile           GetNextFileA
#define GetFileCount          GetFileCountA
#endif


#ifdef __cplusplus
}
#endif

#endif


