// conv_pkmsg.cpp

#include <windows.h>
#include <stdlib.h>
#include <string.h>
#include "msc.h"
#include "conv_pkmsg.h"



#define PeekMessageA PeekMessageA_
#define PeekMessageW PeekMessageW_
#define TranslateMessage TranslateMessage_
#define DispatchMessageA DispatchMessageA_
#define DispatchMessageW DispatchMessageW_
#define IsDialogMessageA IsDialogMessageA_
#define IsDialogMessageW IsDialogMessageW_

#define IsWindowUnicode IsWindowUnicode_
#define GetActiveWindow GetActiveWindow_
#define GetClassNameA GetClassNameA_
#define GetClassNameW GetClassNameW_

typedef BOOL ( WINAPI *PEEKMESSAGEA ) ( LPMSG lpMsg, HWND hWnd, UINT wMsgFilterMin, UINT wMsgFilterMax, UINT wRemoveMsg ) ;
typedef BOOL ( WINAPI *PEEKMESSAGEW ) ( LPMSG lpMsg, HWND hWnd, UINT wMsgFilterMin, UINT wMsgFilterMax, UINT wRemoveMsg ) ;
typedef BOOL ( WINAPI *TRANSLATEMESSAGE ) ( CONST MSG *lpMsg ) ;
typedef LRESULT ( WINAPI *DISPATCHMESSAGEA ) ( CONST MSG *lpMsg ) ;
typedef LRESULT ( WINAPI *DISPATCHMESSAGEW ) ( CONST MSG *lpMsg ) ;
typedef BOOL ( WINAPI *ISDIALOGMESSAGEA ) ( HWND hDlg, LPMSG lpMsg ) ;
typedef BOOL ( WINAPI *ISDIALOGMESSAGEW ) ( HWND hDlg, LPMSG lpMsg ) ;

typedef BOOL ( WINAPI *ISWINDOWUNICODE ) ( HWND hWnd ) ;
typedef HWND ( WINAPI *GETACTIVEWINDOW ) ( VOID ) ;
typedef int ( WINAPI *GETCLASSNAMEA ) ( HWND hWnd, LPSTR lpClassName, int nMaxCount ) ;
typedef int ( WINAPI *GETCLASSNAMEW ) ( HWND hWnd, LPWSTR lpClassName, int nMaxCount ) ;

static HINSTANCE        hUser32 ;
static PEEKMESSAGEA     PeekMessageA ;
static PEEKMESSAGEW     PeekMessageW ;
static TRANSLATEMESSAGE TranslateMessage ;
static DISPATCHMESSAGEA DispatchMessageA ;
static DISPATCHMESSAGEW DispatchMessageW ;
static ISDIALOGMESSAGEA IsDialogMessageA ;
static ISDIALOGMESSAGEW IsDialogMessageW ;

static ISWINDOWUNICODE  IsWindowUnicode ;
static GETACTIVEWINDOW  GetActiveWindow ;
static GETCLASSNAMEA    GetClassNameA ;
static GETCLASSNAMEW    GetClassNameW ;



static void __cdecl FreeUser32 ( void ) ;



// USER32.DLL [h
// EBhE hDialog  IsUnicode ݒ肷
// s 0 ȊOԂ
int InitPeekMessage ( HWND *phDialog, int *pIsUnicode ) {

   static volatile int IsTried ;

   if ( ! IsTried ) {

      EnterCriticalSection ( & LoadDllSection ) ;
      __try {

         if ( ! IsTried ) {

            HINSTANCE hDll ;
            if ( IsNT () ) hDll = LoadLibraryW ( L"USER32.DLL" ) ;
            else           hDll = LoadLibraryA (  "USER32.DLL" ) ;

            int IsError = 0 ;
            if ( GETPROCADDRESS ( hDll, PEEKMESSAGEA, PeekMessageA ) ) IsError = 1 ;
            if ( GETPROCADDRESS ( hDll, PEEKMESSAGEW, PeekMessageW ) ) IsError = 1 ;
            if ( GETPROCADDRESS ( hDll, TRANSLATEMESSAGE, TranslateMessage ) ) IsError = 1 ;
            if ( GETPROCADDRESS ( hDll, DISPATCHMESSAGEA, DispatchMessageA ) ) IsError = 1 ;
            if ( GETPROCADDRESS ( hDll, DISPATCHMESSAGEW, DispatchMessageW ) ) IsError = 1 ;
            if ( GETPROCADDRESS ( hDll, ISDIALOGMESSAGEA, IsDialogMessageA ) ) IsError = 1 ;
            if ( GETPROCADDRESS ( hDll, ISDIALOGMESSAGEW, IsDialogMessageW ) ) IsError = 1 ;

            if ( GETPROCADDRESS ( hDll, ISWINDOWUNICODE, IsWindowUnicode ) ) IsError = 1 ;
            if ( GETPROCADDRESS ( hDll, GETACTIVEWINDOW, GetActiveWindow ) ) IsError = 1 ;
            if ( GETPROCADDRESS ( hDll, GETCLASSNAMEA, GetClassNameA ) ) IsError = 1 ;
            if ( GETPROCADDRESS ( hDll, GETCLASSNAMEW, GetClassNameW ) ) IsError = 1 ;

            if ( IsError ) {
               FreeLibrary ( hDll ) ;
            }
            else {
               atexit ( FreeUser32 ) ;
               hUser32 = hDll ;
            }

            IsTried = 1 ;
         }

      } __finally {
         LeaveCriticalSection ( & LoadDllSection ) ;
      }
   }


   if ( hUser32 ) {
      HWND hWnd = GetActiveWindow () ;
      if ( hWnd ) {
         if ( IsNT () ) {
            wchar_t szClassName [ MAX_PATH ] ;
            GetClassNameW ( hWnd, szClassName, MAX_PATH ) ;
            if ( ! wcscmp ( szClassName, L"#32770" ) ) *phDialog = hWnd ;
            else                                       *phDialog = NULL ;
         }
         else {
            char szClassName [ MAX_PATH ] ;
            GetClassNameA ( hWnd, szClassName, MAX_PATH ) ;
            if ( ! strcmp ( szClassName, "#32770" ) ) *phDialog = hWnd ;
            else                                      *phDialog = NULL ;
         }
         *pIsUnicode = IsWindowUnicode ( hWnd ) ;
      }
      else {
         *pIsUnicode = IsNT () ;
      }
   }

   return ( hUser32 ) ? 0 : 1 ;
}



// USER32.DLL 
static void __cdecl FreeUser32 ( void ) {
   if ( hUser32 ) FreeLibrary ( hUser32 ) ;
}



// bZ[W[v܂킷
int PeekMessageProc ( HWND hDialog, int IsUnicode ) {

   MSG Msg ;

   if ( IsUnicode ) {
      while ( PeekMessageW ( & Msg, NULL, 0, 0, PM_REMOVE ) ) {
         if ( ! hDialog || ! IsDialogMessageW ( hDialog, & Msg ) ) {
            TranslateMessage ( & Msg ) ;
            DispatchMessageW ( & Msg ) ;
         }
      }
   }
   else {
      while ( PeekMessageA ( & Msg, NULL, 0, 0, PM_REMOVE ) ) {
         if ( ! hDialog || ! IsDialogMessageA ( hDialog, & Msg ) ) {
            TranslateMessage ( & Msg ) ;
            DispatchMessageA ( & Msg ) ;
         }
      }
   }

   return 0 ;
}



