// unicode.h

#ifndef UNICODE_H
#define UNICODE_H



//////////////////////////////
//        SURROGATES        //
//////////////////////////////



#define IsFourByteLetter(x)   ( (x) & 0xFFFF0000 )



//////////////////////////////
//     PRIVATE USE AREA     //
//////////////////////////////



static inline int IsUnicodePua   ( long x ) { return ( x >= 0xE000 && x <= 0xF8FF ) ; }



//////////////////////////////
//            CJK           //
//////////////////////////////



static inline int IsCjk          ( long x ) { return ( x >=  0x4E00 && x <=  0x9FFF ) ; }
static inline int IsCjkCmpt      ( long x ) { return ( x >=  0xF900 && x <=  0xFAFF ) ; }    // ̂͌݊̕ł͂Ȃ uninorm.cpp mF
static inline int IsCjkExA       ( long x ) { return ( x >=  0x3400 && x <=  0x4DBF ) ; }
static inline int IsCjkExB       ( long x ) { return ( x >= 0x20000 && x <= 0x2F7FF ) ; }
static inline int IsCjkExC       ( long x ) { return ( x >= 0x2A700 && x <= 0x2B73F ) ; }
static inline int IsCjkExCmpt    ( long x ) { return ( x >= 0x2F800 && x <= 0x2FAFF ) ; }

static inline int IsCjkBmp       ( long x ) { return ( IsCjk(x) || IsCjkCmpt(x) || IsCjkExA(x) ) ; }
static inline int IsCjkNonBmp    ( long x ) { return ( IsCjkExB(x) || IsCjkExC(x) || IsCjkExCmpt(x) ) ; }

static inline int IsCjkEx        ( long x ) { return ( IsCjkExA(x) || IsCjkNonBmp(x) ) ; }
static inline int IsCjkNonCmpt   ( long x ) { return ( IsCjk(x) || IsCjkExA(x) || IsCjkExB(x) || IsCjkExC(x) ) ; }


static inline int IsCjkAll       ( long x ) { return ( IsCjkBmp(x) || IsCjkNonBmp(x) ) ; }



static inline int IsCjkRadicals  ( long x ) { return ( x >= 0x2E80 && x <= 0x2FDF ) ; }
#define CJK_RADICALS_START    0x2E80


static inline int IsCjkKanbun    ( long x ) { return ( x >= 0x3190 && x <= 0x319F ) ; }



//////////////////////////////
//          HANGUL          //
//////////////////////////////



static inline int IsHangulJamoLeading  ( long x ) { return ( x >= 0x1100 && x <= 0x115F || x >= 0xA960 && x <= 0xA97C ) ; }
static inline int IsHangulJamoVowel    ( long x ) { return ( x >= 0x1160 && x <= 0x11A7 || x >= 0xD7B0 && x <= 0xD7C6 ) ; }
static inline int IsHangulJamoTrailing ( long x ) { return ( x >= 0x11A8 && x <= 0x11FF || x >= 0xD7CB && x <= 0xD7FB ) ; }



#endif


