// uniftz2jtz.cpp

#include "msc.h"
#include "uniftz2jtz.h"



int UniFtzToJtz ( int cUnicode ) {


   static const unsigned short szSrc_34 [] = { 0x346F, 0x3473,  0x3493, 0xFFFF } ;
   static const unsigned long  szDst_34 [] = { 0x3454, 0x3447, 0x20242, } ;

   static const unsigned short szSrc_36 [] = { 0x3614, 0x361A, 0x36C6, 0xFFFF } ;
   static const unsigned long  szDst_36 [] = { 0x35F7, 0x360E, 0x36CA, } ;

   static const unsigned short szSrc_37 [] = { 0x3704, 0x370F, 0xFFFF } ;
   static const unsigned long  szDst_37 [] = { 0x36AF, 0x36E3, } ;

   static const unsigned short szSrc_38 [] = { 0x3801, 0x380F,  0x389D, 0xFFFF } ;
   static const unsigned long  szDst_38 [] = { 0x37E5, 0x37C6, 0x222C8, } ;

   static const unsigned short szSrc_39 [] = { 0x396E,  0x398E, 0x39A1, 0xFFFF } ;
   static const unsigned long  szDst_39 [] = { 0x3918, 0x226EF, 0x39F0, } ;

   static const unsigned short szSrc_3A [] = { 0x3A5C, 0x3A73, 0xFFFF } ;
   static const unsigned long  szDst_3A [] = { 0x3A2B, 0x39D0, } ;

   static const unsigned short szSrc_3D [] = {  0x3D4B,  0x3D57,  0x3DFF, 0xFFFF } ;
   static const unsigned long  szDst_3D [] = { 0x22651, 0x23CC6, 0x24237, } ;

   static const unsigned short szSrc_3F [] = {  0x3FD7, 0xFFFF } ;
   static const unsigned long  szDst_3F [] = { 0x24ECA, } ;

   static const unsigned short szSrc_40 [] = {  0x4009,  0x406A, 0x407B,  0x408E, 0xFFFF } ;
   static const unsigned long  szDst_40 [] = { 0x25062, 0x251E2, 0x4025, 0x2539D, } ;

   static const unsigned short szSrc_42 [] = { 0x42B7, 0x42D9, 0x42DA, 0x42F9, 0x42FB,  0x42FF, 0xFFFF } ;
   static const unsigned long  szDst_42 [] = { 0x4336, 0x433A, 0x433B, 0x433F, 0x433E, 0x26213, } ;

   static const unsigned short szSrc_43 [] = {  0x4308,  0x430B,  0x4316,  0x431D,  0x431F,  0x4325,  0x4330,  0x437D, 0x43B1, 0xFFFF } ;
   static const unsigned long  szDst_43 [] = { 0x26216, 0x26218, 0x2621C, 0x2621F, 0x2621E, 0x26220, 0x26219, 0x26360, 0x43AC, } ;

   static const unsigned short szSrc_46 [] = { 0x4661, 0xFFFF } ;
   static const unsigned long  szDst_46 [] = { 0x464C, } ;

   static const unsigned short szSrc_47 [] = {  0x477B, 0x477C,  0x4788, 0xFFFF } ;
   static const unsigned long  szDst_47 [] = { 0x27E55, 0x478D, 0x27E51, } ;

   static const unsigned short szSrc_49 [] = { 0x4947,  0x4969, 0x4971,  0x4978,  0x4998, 0x499B, 0x499F,  0x49B3, 0xFFFF } ;
   static const unsigned long  szDst_49 [] = { 0x4982, 0x28C56, 0x497E, 0x289EE, 0x28E04, 0x49B6, 0x49B7, 0x28DFF, } ;

   static const unsigned short szSrc_4A [] = {  0x4A8F,  0x4A97,  0x4A98,  0x4AF4, 0xFFFF } ;
   static const unsigned long  szDst_4A [] = { 0x293FC, 0x29400, 0x293FF, 0x29597, } ;

   static const unsigned short szSrc_4B [] = {  0x4B18,  0x4B1D,  0x4B1E,  0x4B40,  0x4B43,  0x4B7F,  0x4B9D,  0x4B9E,  0x4BA0,  0x4BAB,  0x4BB3,  0x4BBE, 0x4BC0,  0x4BE4, 0xFFFF } ;
   static const unsigned long  szDst_4B [] = { 0x2966E, 0x2966F, 0x29667, 0x29807, 0x29808, 0x299ED, 0x299F0, 0x29A01, 0x299FF, 0x29A07, 0x29A0F, 0x299EA, 0x4BC5, 0x29A48, } ;

   static const unsigned short szSrc_4C [] = {  0x4C16, 0x4C3E,  0x4C59,  0x4C6C,  0x4C70, 0x4C77, 0x4C7D, 0x4C81,  0x4C96, 0x4C98,  0x4CB0, 0xFFFF } ;
   static const unsigned long  szDst_4C [] = { 0x29BD2, 0x9C83, 0x29F88, 0x29F8A, 0x29F8B, 0x4CA3, 0x4C9D, 0x9CDA, 0x29F82, 0x9CE4, 0x2A242, } ;

   static const unsigned short szSrc_4D [] = { 0x4D09,  0x4D2C,  0x4D34,  0x4D73, 0xFFFF } ;
   static const unsigned long  szDst_4D [] = { 0x9E6E, 0x2A388, 0x2A38B, 0x2A445, } ;

   static const unsigned short szSrc_4E [] = { 0x4E17, 0x4E20, 0x4E21, 0x4E46, 0x4E55, 0x4E57, 0x4E79, 0x4E80, 0x4E81, 0x4E8A, 0x4E90, 0x4E97, 0x4E9C, 0x4E9D, 0x4EAF, 0x4EB0, 0x4EB1, 0x4EB7, 0x4EBE, 0x4ECF, 0x4EED, 0x4EEE, 0xFFFF } ;
   static const unsigned long  szDst_4E [] = { 0x4E16, 0x4E18, 0x4E24, 0x4E45, 0x864E, 0x4E58, 0x4E7E, 0x9F9F, 0x4E7E, 0x4E8B, 0x4E8E, 0x5C81, 0x4E9A, 0x9F50, 0x4EAB, 0x4EAC, 0x591C, 0x5EC9, 0x4EA1, 0x4F5B, 0x4EDE, 0x5047, } ;

   static const unsigned short szSrc_4F [] = { 0x4F1C, 0x4F31, 0x4FA1, 0x4FAB, 0x4FAD, 0x4FE5, 0x4FF2, 0x4FFB, 0xFFFF } ;
   static const unsigned long  szDst_4F [] = { 0x5005, 0x4F60, 0x4EF7, 0x4F5E, 0x5C3D, 0x4F21, 0x6548, 0x5907, } ;

   static const unsigned short szSrc_50 [] = { 0x5002, 0x5008, 0x5010, 0x5024, 0x5032, 0x5036, 0x5038, 0x5039, 0x5051, 0x5058, 0x5078, 0x5079, 0x508C, 0x50C3, 0x50CD, 0x50DE, 0xFFFF } ;
   static const unsigned long  szDst_50 [] = { 0x5E76, 0x4FEB, 0x500F, 0x503C, 0x3448, 0x4FF1, 0x776C, 0x4FED, 0x343D, 0x4F83, 0x5077, 0x5907, 0x3437, 0x5907, 0x52A8, 0x4F2A, } ;

   static const unsigned short szSrc_51 [] = { 0x5101, 0x510E,  0x5133, 0x5138, 0x514E, 0x5150, 0x5160, 0x5166, 0x516A, 0x517E, 0x517F, 0x5184, 0x5186, 0x5190, 0x519D, 0x51A3, 0x51A6, 0x51A8, 0x51A9, 0x51BA, 0x51C3, 0x51D6, 0x51E2, 0x51E3, 0x51E6, 0x51E8, 0x51EC, 0x51EE, 0x51F4, 0x51FE, 0xFFFF } ;
   static const unsigned long  szDst_51 [] = { 0x4FCA, 0x50A4, 0x202C2, 0x3469, 0x5154, 0x513F, 0x515C, 0x4EA1, 0x4FDE, 0x5180, 0x827A, 0x5189, 0x5706, 0x5192, 0x5B9C, 0x6700, 0x5BC7, 0x5BCC, 0x5199, 0x6CEF, 0x6D82, 0x51C6, 0x51E1, 0x51E1, 0x5904, 0x98CE, 0x98CE, 0x98CE, 0x51ED, 0x51FD, } ;

   static const unsigned short szSrc_52 [] = { 0x5204, 0x5214, 0x5226, 0x5227, 0x5234, 0x523C, 0x524F, 0x5257, 0x5259, 0x5263, 0x5264, 0x5270, 0x5271, 0x5273, 0x5279,  0x527E, 0x528E, 0x528F, 0x5292, 0x5294, 0x529A, 0x52B4, 0x52B9, 0x52C5, 0x52CC, 0x52D1, 0x52E0, 0x52E7, 0x52F2, 0xFFFF } ;
   static const unsigned long  szDst_52 [] = { 0x5203, 0x6289, 0x52AB, 0x52AB, 0x5241, 0x52AB, 0x521B, 0x522C, 0x521B, 0x5251, 0x5242, 0x5269, 0x5251, 0x5284, 0x622E, 0x206C5, 0x5251, 0x34E5, 0x5251, 0x5251, 0x3509, 0x52B3, 0x6548, 0x6555, 0x5026, 0x6555, 0x622E, 0x529D, 0x52CB, } ;

   static const unsigned short szSrc_53 [] = { 0x5303, 0x5304, 0x5332, 0x5333, 0x5346, 0x534B, 0x5358, 0x537D, 0x5380, 0x5390, 0x539B, 0x53A0, 0x53A1, 0x53AF, 0x53B0, 0x53B3, 0x53B5, 0x53BA, 0x53C4, 0x53C5, 0x53CE, 0x53D3, 0x53DC, 0xFFFF } ;
   static const unsigned long  szDst_53 [] = { 0x4E10, 0x4E10, 0x5941, 0x5941, 0x5352, 0x4E16, 0x5355, 0x5373, 0x819D, 0x5E9E, 0x5385, 0x5395, 0x539F, 0x5386, 0x5382, 0x4E25, 0x6E90, 0x53BB, 0x53C1, 0x53C2, 0x6536, 0x4E8B, 0x53DF, } ;

   static const unsigned short szSrc_54 [] = { 0x541A, 0x543F, 0x5449, 0x544C, 0x5451, 0x546A, 0x548A, 0x54B2, 0x54B5,  0x54EF, 0x54F6, 0xFFFF } ;
   static const unsigned long  szDst_54 [] = { 0x54BF, 0x544A, 0x5434, 0x53EB, 0x541E, 0x5492, 0x548C, 0x7B11, 0x4F89, 0x20BDF, 0x54A9, } ;

   static const unsigned short szSrc_55 [] = { 0x5515, 0x5516, 0x5518, 0x5553, 0x5554, 0x558E, 0x559E, 0x55A9, 0x55B6, 0x55C1,  0x55F0, 0x55F8, 0xFFFF } ;
   static const unsigned long  szDst_55 [] = { 0x5523, 0x54D1, 0x542F, 0x542F, 0x542F, 0x359E, 0x5527, 0x55BB, 0x8425, 0x557C, 0x20BB6, 0x55F7, } ;

   static const unsigned short szSrc_56 [] = { 0x5620, 0x5628, 0x5637,  0x5645, 0x5650, 0x5651, 0x565A, 0x565B, 0x565D, 0x5694, 0x56A2, 0x56BB, 0x56D8, 0x56D9, 0x56E3, 0x56EC, 0x56EF, 0x56F2, 0x56F3, 0xFFFF } ;
   static const unsigned long  szDst_56 [] = { 0x560E, 0x5578, 0x55E5, 0x20BE0, 0x5668, 0x55E5, 0x358A, 0x556E, 0x549D, 0x568F, 0x56CA, 0x56A3, 0x56DE, 0x56E0, 0x56E2, 0x56DE, 0x56FD, 0x56F4, 0x56FE, } ;

   static const unsigned short szSrc_57 [] = { 0x5700, 0x5705, 0x570E, 0x570F, 0x5717, 0x5727, 0x577F, 0x579C, 0x57BB, 0x57C0, 0x57D3, 0x57FF, 0xFFFF } ;
   static const unsigned long  szDst_57 [] = { 0x56FD, 0x51FD, 0x5706, 0x5708, 0x56FE, 0x538B, 0x9644, 0x579B, 0x575D, 0x5782, 0x57D2, 0x6CE5, } ;

   static const unsigned short szSrc_58 [] = { 0x5816, 0x5818, 0x5822, 0x5826, 0x5841, 0x585F, 0x5861, 0x5869, 0x5872, 0x588D, 0x5896, 0x5897, 0x58AA, 0x58B6, 0x58C3, 0x58C4, 0x58CA, 0x58CB, 0x58CC, 0x58D0, 0x58DC, 0x58E0, 0x58EA, 0x58F1, 0x58F2, 0x58F7, 0x58F8, 0x58FB, 0xFFFF } ;
   static const unsigned long  szDst_58 [] = { 0x57B4, 0x584D, 0x5821, 0x9636, 0x5792, 0x846C, 0x586B, 0x76D0, 0x573A, 0x5848, 0x5854, 0x589E, 0x58A9, 0x57AF, 0x7586, 0x91CE, 0x574F, 0x57B1, 0x58E4, 0x73BA, 0x575B, 0x5784, 0x5846, 0x58F9, 0x5356, 0x58F6, 0x58F6, 0x5A7F, } ;

   static const unsigned short szSrc_59 [] = { 0x5900, 0x5905, 0x5909, 0x5918, 0x591B, 0x5923, 0x5932, 0x594C, 0x5968, 0x596C, 0x59AC, 0x59B7, 0x59B8, 0x59C9, 0x59D9, 0x59E2, 0x59E7, 0x59EB, 0x59F8, 0xFFFF } ;
   static const unsigned long  szDst_59 [] = { 0x5BFF, 0x964D, 0x53D8, 0x536F, 0x591A, 0x68A6, 0x672C, 0x70B9, 0x5956, 0x5956, 0x5992, 0x4F84, 0x5A40, 0x59CA, 0x598A, 0x5A1F, 0x5978, 0x59EC, 0x598D, } ;

   static const unsigned short szSrc_5A [] = { 0x5A24, 0x5A2C, 0x5A2F, 0x5A3F, 0x5A63, 0x5A7E, 0x5A86, 0x5A8D, 0x5AB0, 0x5AD0, 0x5AF0, 0xFFFF } ;
   static const unsigned long  szDst_5A [] = { 0x5986, 0x59A9, 0x5A31, 0x5A40, 0x59FB, 0x5077, 0x5AE9, 0x5987, 0x36C0, 0x5B32, 0x5AE9, } ;

   static const unsigned short szSrc_5B [] = { 0x5B00, 0x5B22, 0x5B4B, 0x5B76, 0x5B7C, 0x5B82, 0x5B90, 0x5B9F, 0x5BBB, 0x5BBC, 0x5BC3, 0x5BD5, 0x5BD7, 0x5BDB, 0x5BDC, 0x5BF3, 0x5BFE, 0xFFFF } ;
   static const unsigned long  szDst_5B [] = { 0x59AB, 0x5A18, 0x36E4, 0x5B73, 0x5B7D, 0x5197, 0x5B9C, 0x5B9E, 0x5BC6, 0x5BC7, 0x51A4, 0x5B81, 0x5B81, 0x5BBD, 0x5B81, 0x5B9D, 0x5BF9, } ;

   static const unsigned short szSrc_5C [] = { 0x5C02, 0x5C05, 0x5C13, 0x5C19, 0x5C20, 0x5C26, 0x5C29, 0x5C2B, 0x5C2D, 0x5C36, 0x5C53, 0x5C5A, 0x5C5B, 0x5C85, 0x5CBA, 0x5CDD, 0x5CE9, 0x5CEF, 0x5CF5, 0xFFFF } ;
   static const unsigned long  szDst_5C [] = { 0x4E13, 0x514B, 0x5C14, 0x5C1A, 0x9C9C, 0x5C25, 0x5C2A, 0x5C2A, 0x5C27, 0x5C34, 0x5C43, 0x6F0F, 0x5C4F, 0x5742, 0x5CAD, 0x5CD2, 0x5CE8, 0x5CF0, 0x5D58, } ;

   static const unsigned short szSrc_5D [] = { 0x5D08, 0x5D10, 0x5D15, 0x5D18, 0x5D2C, 0x5D46, 0x5D53, 0x5D57, 0x5D5C, 0x5D73,  0x5D7C, 0x5D83,  0x5D88, 0x5D8B, 0x5D8C,  0x5D98, 0x5DA4,  0x5DAC, 0x5DCC, 0x5DD3, 0x5DD7, 0x5DE3, 0x5DF5, 0x5DFA, 0x5DFB, 0xFFFF } ;
   static const unsigned long  szDst_5D [] = { 0x5D07, 0x6606, 0x5D16, 0x4ED1, 0x5CBD, 0x5D47, 0x5CA9, 0x5C81, 0x5D0E, 0x5D6F, 0x21DB4, 0x5D2D, 0x21E83, 0x5C9B, 0x5C9B, 0x21E84, 0x5CE3, 0x21D4C, 0x5CA9, 0x5DC5, 0x5CA9, 0x5DE2, 0x536E, 0x5DFD, 0x5377, } ;

   static const unsigned short szSrc_5E [] = { 0x5E00, 0x5E0B, 0x5E2C, 0x5E2F, 0x5E30, 0x5E32, 0x5E47, 0x5E51, 0x5E53, 0x5E5A, 0x5E64, 0x5E71, 0x5E77, 0x5E81, 0x5E83, 0x5EBB, 0x5EBD, 0x5EBF, 0x5EC3, 0x5ECF, 0x5ED0, 0x5EF0, 0x5EF5, 0x5EF8, 0x5EF9, 0x5EFB, 0x5EFC, 0x5EFD, 0xFFFF } ;
   static const unsigned long  szDst_5E [] = { 0x531D, 0x7EB8, 0x88D9, 0x5E26, 0x5F52, 0x5E21, 0x5E2E, 0x5FBD, 0x384E, 0x5E2E, 0x5E01, 0x8955, 0x5E76, 0x5385, 0x5E7F, 0x5EB6, 0x5BD3, 0x5E99, 0x5E9F, 0x53A9, 0x53A9, 0x5385, 0x5DE1, 0x8FEA, 0x8FEB, 0x56DE, 0x4E43, 0x56DE, } ;

   static const unsigned short szSrc_5F [] = { 0x5F09, 0x5F0C, 0x5F0D, 0x5F0E, 0x5F10, 0x5F3B, 0x5F3E, 0x5F5A, 0x5F5B, 0x5F5C, 0x5F5E, 0x5F60, 0x5F72, 0x5F83, 0x5F93, 0x5FA7, 0x5FB3, 0x5FB4, 0x5FDC, 0x5FE9, 0x5FF0, 0xFFFF } ;
   static const unsigned long  szDst_5F [] = { 0x5958, 0x58F9, 0x8D30, 0x53C1, 0x8D30, 0x5F3C, 0x5F39, 0x6C47, 0x5F5D, 0x5F5D, 0x5F5D, 0x5F5F, 0x5F68, 0x5F80, 0x4ECE, 0x904D, 0x5FB7, 0x5F81, 0x5E94, 0x5306, 0x60B4, } ;

   static const unsigned short szSrc_60 [] = { 0x6031, 0x604A, 0x6056, 0x6060, 0x6061, 0x6071, 0x6075, 0x608B, 0x6091, 0x609E, 0x60A4, 0x60A9, 0x60AA, 0x60B3, 0x60E5, 0x60EA, 0xFFFF } ;
   static const unsigned long  szDst_60 [] = { 0x5306, 0x534F, 0x601D, 0x602A, 0x541D, 0x60A6, 0x60E0, 0x541D, 0x6016, 0x60AE, 0x5306, 0x607C, 0x6076, 0x5FB7, 0x607F, 0x5FB7, } ;

   static const unsigned short szSrc_61 [] = { 0x6119, 0x6133,  0x613B, 0x613C, 0x613D, 0x6142, 0x6159, 0x6164, 0x617A, 0x617D, 0x617F, 0x6185, 0x6187, 0x618D, 0x6197, 0x6198, 0x6199, 0x619C, 0x619E,  0x61A2,  0x61B9,  0x61C0,  0x61CE, 0x61D0, 0x61DC, 0x61E4, 0x61F4, 0xFFFF } ;
   static const unsigned long  szDst_61 [] = { 0x606A, 0x60E7, 0x2264F, 0x614E, 0x535A, 0x607F, 0x60ED, 0x60AB, 0x396A, 0x621A, 0x51ED, 0x6078, 0x61A9, 0x392D, 0x616D, 0x559C, 0x559C, 0x60F0, 0x619D, 0x22652, 0x22650, 0x22653, 0x22801, 0x6000, 0x61F5, 0x393D, 0x5FCF, } ;

   static const unsigned short szSrc_62 [] = {  0x6203, 0x6205, 0x621D, 0x621E, 0x6226, 0x622F, 0x6231, 0x6238, 0x6239, 0x623B, 0x623C, 0x6255, 0x6275, 0x6285, 0x628D, 0x629C, 0x629D, 0x629E, 0x62D5, 0x62DD, 0x62E0, 0x62E1, 0xFFFF } ;
   static const unsigned long  szDst_62 [] = { 0x235CB, 0x6206, 0x8D3C, 0x621B, 0x6218, 0x620F, 0x620F, 0x6237, 0x5384, 0x623E, 0x536F, 0x62C2, 0x4E8E, 0x62D8, 0x62EF, 0x62D4, 0x62D7, 0x62E9, 0x62D6, 0x62DC, 0x636E, 0x6269, } ;

   static const unsigned short szSrc_63 [] = { 0x6305, 0x630A, 0x6319, 0x6331, 0x6335, 0x633F, 0x635C, 0x6386, 0x63B2, 0x63BB, 0x63D1, 0x63D4, 0x63F7, 0x63FA, 0xFFFF } ;
   static const unsigned long  szDst_63 [] = { 0x6306, 0x5F04, 0x4E3E, 0x6332, 0x5F04, 0x63D2, 0x641C, 0x39CF, 0x63ED, 0x6414, 0x634F, 0x6374, 0x63D2, 0x6447, } ;

   static const unsigned short szSrc_64 [] = { 0x6403, 0x6407, 0x6442, 0x6483, 0x649D, 0x64A1, 0x64B9, 0x64D3, 0x64D5, 0x64E0, 0x64E1, 0x64E7, 0xFFFF } ;
   static const unsigned long  szDst_64 [] = { 0x6374, 0x63FF, 0x6444, 0x51FB, 0x39D1, 0x63BA, 0x6405, 0x39DF, 0x643A, 0x3A08, 0x62AC, 0x4E3E, } ;

   static const unsigned short szSrc_65 [] = { 0x6502, 0x6505, 0x6508, 0x651F, 0x6542, 0x654D, 0x654E, 0x656D, 0x657D, 0x6585, 0x6586, 0x6588, 0x6589, 0x658D, 0x658E, 0x65C8, 0x65D9, 0x65DC, 0x65E3, 0x65E4, 0x65F9, 0x65FE, 0xFFFF } ;
   static const unsigned long  szDst_65 [] = { 0x64C2, 0x6512, 0x6343, 0x6343, 0x53E9, 0x53D9, 0x6559, 0x626C, 0x657F, 0x6569, 0x6569, 0x5B66, 0x9F50, 0x89C9, 0x658B, 0x65D2, 0x5E61, 0x65C3, 0x65E2, 0x7978, 0x65F6, 0x6625, } ;

   static const unsigned short szSrc_66 [] = { 0x661A, 0x662C, 0x663B, 0x663F, 0x6644, 0x6648, 0x6660, 0x6669, 0x6673, 0x6681, 0x6692, 0x66A4, 0x66A6, 0x66AD, 0x66C1, 0x66C5, 0x66CD, 0x66D0, 0x66E1, 0x66F5, 0x66FD, 0xFFFF } ;
   static const unsigned long  szDst_66 [] = { 0x614E, 0x660F, 0x6602, 0x65F7, 0x6643, 0x768E, 0x665F, 0x665A, 0x6670, 0x6653, 0x6674, 0x769E, 0x5386, 0x769E, 0x66A8, 0x6654, 0x769E, 0x661F, 0x53E0, 0x66F3, 0x66FE, } ;

   static const unsigned short szSrc_67 [] = { 0x6702, 0x6716, 0x6719, 0x671E, 0x6736, 0x6780, 0x678F, 0x67A9, 0x67B1, 0x67BE, 0x67F9, 0x67FB, 0xFFFF } ;
   static const unsigned long  szDst_67 [] = { 0x52D6, 0x6717, 0x660E, 0x671F, 0x6735, 0x677E, 0x6960, 0x677E, 0x53F0, 0x67FF, 0x67FF, 0x67E5, } ;

   static const unsigned short szSrc_68 [] = { 0x6801, 0x6804, 0x681E, 0x6822, 0x6830, 0x6852, 0x685C, 0x685F,  0x6871, 0x687A, 0x6898, 0x68B9, 0x68C3, 0x68CA, 0x68E1, 0xFFFF } ;
   static const unsigned long  szDst_68 [] = { 0x67F3, 0x8363, 0x520A, 0x67CF, 0x7B4F, 0x6851, 0x6A31, 0x6808, 0x23415, 0x67F3, 0x67A7, 0x69DF, 0x68A8, 0x68CB, 0x3B4E, } ;

   static const unsigned short szSrc_69 [] = { 0x6900, 0x6909, 0x6918, 0x691C, 0x691D, 0x692B, 0x6932, 0x6936, 0x693E,  0x6947, 0x6955, 0x6961, 0x6973, 0x697D, 0x699F, 0x69B2, 0x69C0, 0x69C7, 0x69C8, 0x69D1, 0x69D5, 0x69D6, 0x69D7, 0x69D8, 0x69DE, 0x69E9, 0x69EA,  0x69EB, 0x69F9, 0xFFFF } ;
   static const unsigned long  szDst_69 [] = { 0x7897, 0x4E58, 0x695A, 0x68C0, 0x89C4, 0x6A3F, 0x3B4F, 0x68D5, 0x7B3A, 0x2348C, 0x692D, 0x6986, 0x6885, 0x4E50, 0x6893, 0x6985, 0x69C1, 0x69D9, 0x8028, 0x6885, 0x684C, 0x6A50, 0x6865, 0x6837, 0x680A, 0x6982, 0x6982, 0x233E2, 0x69D4, } ;

   static const unsigned short szSrc_6A [] = { 0x6A10,  0x6A20, 0x6A22, 0x6A29, 0x6A2B, 0x6A33, 0x6A37, 0x6A4A, 0x6A5C, 0x6A8F, 0x6A98, 0x6A9D, 0x6AAA,  0x6AAD, 0x6ABC, 0x6AC8, 0x6AC9, 0x6AD4, 0x6AD5, 0x6AFD, 0xFFFF } ;
   static const unsigned long  szDst_6A [] = { 0x6A79, 0x235CA, 0x3B64, 0x6743, 0x3B74, 0x686A, 0x4E1B, 0x69B4, 0x6A5B, 0x6734, 0x6A97, 0x696B, 0x680E, 0x23634, 0x6A83, 0x51F3, 0x6A71, 0x6803, 0x6512, 0x6A83, } ;

   static const unsigned short szSrc_6B [] = { 0x6B05, 0x6B1B, 0x6B1D, 0x6B35, 0x6B53, 0x6B57, 0x6B69, 0x6B6F, 0x6B73, 0x6B74,  0x6BA2, 0x6BA8, 0x6BB0, 0x6BB1, 0x6BBB, 0x6BCE, 0x6BF1, 0xFFFF } ;
   static const unsigned long  szDst_6B [] = { 0x6989, 0x628A, 0x90C1, 0x6B3E, 0x6B22, 0x5578, 0x6B65, 0x9F7F, 0x5C81, 0x5386, 0x23A3C, 0x3C6E, 0x3C69, 0x6B7C, 0x58F3, 0x6BCF, 0x97A0, } ;

   static const unsigned short szSrc_6C [] = { 0x6C0A, 0x6C17,  0x6C2D, 0x6C37, 0x6C5A, 0x6CA2, 0x6CB2, 0xFFFF } ;
   static const unsigned long  szDst_6C [] = { 0x6BE1, 0x6C14, 0x23C5D, 0x51B0, 0x6C61, 0x6CFD, 0x6CB1, } ;

   static const unsigned short szSrc_6D [] = { 0x6D13, 0x6D44, 0x6D96, 0x6D99, 0x6D9C, 0x6DF8, 0xFFFF } ;
   static const unsigned long  szDst_6D [] = { 0x6E0D, 0x51C0, 0x8385, 0x6CEA, 0x6E0E, 0x6E05, } ;

   static const unsigned short szSrc_6E [] = { 0x6E07, 0x6E08, 0x6E09, 0x6E0B, 0x6E13, 0x6E15, 0x6E16,  0x6E4B, 0x6E7B, 0x6E7C, 0x6E7D, 0x6E80, 0x6E8C, 0x6ED9, 0x6EDB, 0x6EDD, 0xFFFF } ;
   static const unsigned long  szDst_6E [] = { 0x6E34, 0x6D4E, 0x6D89, 0x6DA9, 0x6EAA, 0x6E0A, 0x6C88, 0x23C97, 0x6DF3, 0x6D85, 0x6DC4, 0x6EE1, 0x6CFC, 0x6C47, 0x6DEB, 0x6CF7, } ;

   static const unsigned short szSrc_6F [] = { 0x6F11, 0x6F44, 0x6F45,  0x6F55, 0x6F59, 0x6F5A, 0x6F81,  0x6F85, 0x6F91, 0x6F99, 0x6FBE, 0x6FC4, 0x6FC5,  0x6FC6, 0x6FDA, 0x6FE7, 0x6FF3, 0x6FF5, 0x6FF6, 0xFFFF } ;
   static const unsigned long  szDst_6F [] = { 0x6E89, 0x6F31, 0x704C, 0x23C98, 0x6CA9, 0x3D0B, 0x6DA9, 0x23DA9, 0x6E9C, 0x6F5F, 0x3CE0, 0x3CE1, 0x6D78, 0x23E23, 0x6E81, 0x3CD4, 0x6F5C, 0x6EE8, 0x9614, } ;

   static const unsigned short szSrc_70 [] = { 0x7002,  0x7003, 0x7007, 0x702C, 0x704E, 0x7054, 0x7061, 0x7067, 0x706E, 0x7097, 0x70B2, 0x70C9, 0x70D6, 0x70F1, 0xFFFF } ;
   static const unsigned long  szDst_70 [] = { 0x6F9B, 0x23F77, 0x3CBF, 0x6FD1, 0x6EDF, 0x6EDF, 0x3CD5, 0x6EDF, 0x5149, 0x5149, 0x70B1, 0x7115, 0x707E, 0x70AF, } ;

   static const unsigned short szSrc_71 [] = { 0x7114, 0x712D, 0x713C, 0x7151, 0x7155, 0x7171, 0x7188,  0x7189,  0x718C,  0x7193, 0x7196,  0x719A, 0x71A2, 0x71E3, 0x71F6, 0xFFFF } ;
   static const unsigned long  szDst_71 [] = { 0x7130, 0x8315, 0x70E7, 0x716E, 0x7199, 0x3DBD, 0x7199, 0x24236, 0x241C4, 0x241A1, 0x7130, 0x241F9, 0x70FD, 0x71F7, 0x3DB6, } ;

   static const unsigned short szSrc_72 [] = {  0x7204,  0x7207,  0x720C, 0x7215,  0x7216, 0x7217, 0x7224, 0x7232, 0x723C, 0x7240, 0x724E, 0x7250, 0x7255, 0x7282, 0x72A0, 0x72A2, 0x72B2, 0x72E2, 0x72E5, 0xFFFF } ;
   static const unsigned long  szDst_72 [] = { 0x241C3, 0x26D9F, 0x24193, 0x71EE, 0x241ED, 0x70E8, 0x70C2, 0x4E3A, 0x4FCE, 0x5E8A, 0x7A97, 0x95F8, 0x7A97, 0x7281, 0x727A, 0x3E3F, 0x8C7A, 0x8C89, 0x5F87, } ;

   static const unsigned short szSrc_73 [] = { 0x7302, 0x731F, 0x7328, 0x732F, 0x7341, 0x7346, 0x734B, 0x734F, 0x7354, 0x7363,  0x7369, 0x7371,  0x7381, 0x73CE, 0x73F1, 0xFFFF } ;
   static const unsigned long  szDst_73 [] = { 0x608D, 0x730E, 0x733F, 0x8C92, 0x72B8, 0x55E5, 0x55E5, 0x8C98, 0x55E5, 0x517D, 0x24783, 0x3E8D, 0x247A4, 0x73CD, 0x748E, } ;

   static const unsigned short szSrc_74 [] = { 0x7439, 0x7447, 0x7449, 0x7460, 0x74A2, 0x74AF, 0x74C8, 0x74C9, 0x74CC, 0xFFFF } ;
   static const unsigned long  szDst_74 [] = { 0x7434, 0x73B3, 0x73C9, 0x7409, 0x7409, 0x3EC5, 0x7483, 0x74D2, 0x7470, } ;

   static const unsigned short szSrc_75 [] = { 0x7501, 0x7506, 0x750E, 0x751B, 0x751E, 0x7523, 0x7541, 0x7542, 0x7544, 0x7546, 0x754D, 0x7552, 0x755E, 0x7561, 0x7567, 0x756D, 0x756E, 0x7571, 0x7573, 0x7575, 0x757A, 0x757B, 0x7582, 0x7585, 0x7589, 0x758E, 0x75A9, 0x75E9, 0x75EE, 0xFFFF } ;
   static const unsigned long  szDst_75 [] = { 0x74F6, 0x74F7, 0x7816, 0x751C, 0x5C1D, 0x4EA7, 0x7540, 0x4EA9, 0x7559, 0x4EA9, 0x754C, 0x4EA9, 0x4EA9, 0x5793, 0x7565, 0x756C, 0x4EA9, 0x7559, 0x53E0, 0x753B, 0x7586, 0x584D, 0x53E0, 0x7586, 0x53E0, 0x758F, 0x7601, 0x7626, 0x80C0, } ;

   static const unsigned short szSrc_76 [] = { 0x7602, 0x762E, 0x763B, 0x7645, 0x764E, 0x7655, 0x765B,  0x7662, 0x7667, 0x767A, 0x7683, 0x7690,  0x769F, 0x76A1, 0x76A5, 0x76B7, 0x76B9, 0x76C7, 0x76CB, 0x76CC, 0xFFFF } ;
   static const unsigned long  szDst_76 [] = { 0x75D6, 0x7606, 0x7618, 0x7624, 0x75EB, 0x75C8, 0x765D, 0x24E1C, 0x75AC, 0x53D1, 0x8C8C, 0x768B, 0x24F80, 0x769E, 0x769E, 0x9F13, 0x76B2, 0x76CD, 0x94B5, 0x7897, } ;

   static const unsigned short szSrc_77 [] = { 0x7702, 0x770C, 0x770E, 0x7718, 0x771E, 0x7721, 0x7764, 0x7798, 0x779C,  0x77A4, 0x77C1, 0x77D2, 0x77E4, 0x77E6, 0x77F4, 0xFFFF } ;
   static const unsigned long  szDst_77 [] = { 0x89C6, 0x53BF, 0x89C6, 0x614E, 0x771F, 0x89C6, 0x7765, 0x770D, 0x4056, 0x251A7, 0x7785, 0x77A2, 0x77E7, 0x4FAF, 0x7887, } ;

   static const unsigned short szSrc_78 [] = { 0x7815, 0x783F, 0x784F,  0x7899, 0x78AF, 0x78B8, 0x78BD, 0x78C7, 0x78D6, 0x78FE, 0xFFFF } ;
   static const unsigned long  szDst_78 [] = { 0x788E, 0x77FF, 0x7814, 0x2543B, 0x7459, 0x781C, 0x40B5, 0x7812, 0x782C, 0x40C5, } ;

   static const unsigned short szSrc_79 [] = { 0x7906, 0x791A, 0x792E, 0x7932, 0x7958, 0x79A5, 0x79A9, 0x79C4, 0x79CA, 0x79CC, 0x79D0, 0x79D4, 0xFFFF } ;
   static const unsigned long  szDst_79 [] = { 0x7877, 0x78D5, 0x70AE, 0x783B, 0x7B97, 0x797A, 0x7940, 0x8014, 0x5E74, 0x79CB, 0x8018, 0x7CB3, } ;

   static const unsigned short szSrc_7A [] = { 0x7A09, 0x7A0F, 0x7A2C, 0x7A2D, 0x7A32, 0x7A3A, 0x7A3E, 0x7A42, 0x7A45, 0x7A47, 0x7A49, 0x7A4F, 0x7A50, 0x7A5E, 0x7A63, 0x7A64, 0x7A7D, 0x7A93, 0x7AB0, 0x7ABB, 0x7AC3, 0x7AC6, 0x7AC8, 0x7AD2, 0x7ADA, 0x7ADC, 0x7ADD, 0x7AE2, 0x7AEA, 0x7AF8, 0x7AFE, 0xFFFF } ;
   static const unsigned long  szDst_7A [] = { 0x7CB3, 0x4149, 0x7CEF, 0x79F8, 0x7A3B, 0x7A1A, 0x7A3F, 0x7A57, 0x7CE0, 0x415F, 0x7A1A, 0x7A33, 0x79CB, 0x7A06, 0x7A70, 0x7CEF, 0x9631, 0x7A97, 0x7A91, 0x7A97, 0x7076, 0x7A77, 0x7076, 0x5947, 0x4F2B, 0x9F99, 0x5E76, 0x4FDF, 0x7AD6, 0x7ADE, 0x7BEA, } ;

   static const unsigned short szSrc_7B [] = { 0x7B36, 0x7B53, 0x7B5E, 0x7B6F, 0x7B74, 0x7B7A, 0x7B7F, 0x7B86, 0x7B92, 0x7B9A, 0x7BB2, 0x7BCF,  0x7BD8, 0x7BED, 0xFFFF } ;
   static const unsigned long  szDst_7B [] = { 0x77E2, 0x7B04, 0x7B56, 0x7BB8, 0x41F2, 0x7B50, 0x7B71, 0x7BE6, 0x5E1A, 0x5284, 0x7B45, 0x5D4C, 0x25B20, 0x7B3C, } ;

   static const unsigned short szSrc_7C [] = { 0x7C08, 0x7C12, 0x7C14, 0x7C18, 0x7C2E,  0x7C4B, 0x7C52, 0x7C56, 0x7C58, 0x7C62, 0x7C6D, 0x7C83, 0x7C87, 0x7C8B, 0x7C9B, 0x7CC6, 0x7CC9, 0x7CD3, 0x7CDB, 0x7CE4, 0x7CED, 0x7CF9, 0x7CFA, 0xFFFF } ;
   static const unsigned long  szDst_7C [] = { 0x7BB3, 0x7BE1, 0x84D1, 0x7BAB, 0x7C2A, 0x25B1E, 0x7C40, 0x7B7E, 0x85E4, 0x5941, 0x7B5B, 0x79D5, 0x7CE0, 0x7CB9, 0x8083, 0x66F2, 0x7CBD, 0x8C37, 0x7CD6, 0x9993, 0x7CBD, 0x7E9F, 0x7EA0, } ;

   static const unsigned short szSrc_7D [] = { 0x7D23, 0x7D25, 0x7D2C, 0x7D45, 0x7D4B, 0x7D4C, 0x7D5A, 0x7D5D, 0x7D75, 0x7D76, 0x7D78,  0x7D80, 0x7D82,  0x7D87, 0x7D89, 0x7D90, 0x7D99, 0x7D9A, 0x7DAB, 0x7DB3, 0x7DB5, 0x7DCD, 0x7DCF, 0x7DD0, 0x7DD1, 0x7DD3, 0x7DD4, 0x7DD6, 0x7DDC, 0x7DE4, 0x7DE5,  0x7DF0,  0x7DF7,  0x7DF8, 0x7DFC, 0xFFFF } ;
   static const unsigned long  szDst_7D [] = { 0x7DB7, 0x624E, 0x4337, 0x4339, 0x7EA9, 0x7ECF, 0x7E06, 0x7ED4, 0x7ED8, 0x7EDD, 0x8327, 0x2620C, 0x7EDF, 0x2620B, 0x7EE3, 0x433C, 0x7EE7, 0x7EED, 0x7EBF, 0x7EF7, 0x433D, 0x7F17, 0x603B, 0x7E41, 0x7EFF, 0x7EEC, 0x7EF1, 0x7EEA, 0x7EF5, 0x7EC1, 0x8913, 0x26215, 0x26209, 0x26211, 0x7F0A, } ;

   static const unsigned short szSrc_7E [] = { 0x7E01, 0x7E02, 0x7E04,  0x7E0E, 0x7E26, 0x7E27,  0x7E2C, 0x7E33,  0x7E3A, 0x7E4A, 0x7E4B, 0x7E4D,  0x7E4F,  0x7E53,  0x7E5F, 0x7E66, 0x7E6E, 0x7E78,  0x7E7B, 0x7E7F, 0x7E89, 0x7E8E, 0x7E92, 0x7E9D, 0xFFFF } ;
   static const unsigned long  szDst_7E [] = { 0x7F18, 0x603B, 0x7EF3, 0x26214, 0x7EB5, 0x7EE6, 0x2621A, 0x4338, 0x26210, 0x7EA4, 0x7CFB, 0x7EE3, 0x2621D, 0x2621B, 0x2620E, 0x8941, 0x7F30, 0x4341, 0x26221, 0x4340, 0x7F35, 0x7EA4, 0x7F20, 0x7F27, } ;

   static const unsigned short szSrc_7F [] = { 0x7F10, 0x7F37, 0x7F3B, 0x7F46, 0x7F47, 0x7F4E, 0x7F78, 0x7F80, 0x7F97, 0x7FA3, 0x7FAE, 0x7FB4, 0x7FC4, 0x7FC6, 0x7FF6, 0x7FFA, 0xFFFF } ;
   static const unsigned long  szDst_7F [] = { 0x7EBF, 0x5378, 0x7F50, 0x7F50, 0x6A3D, 0x575B, 0x7F5A, 0x7F76, 0x7F8C, 0x7FA4, 0x7FB9, 0x81BB, 0x7FC5, 0x7FE0, 0x7FF1, 0x7FF1, } ;

   static const unsigned short szSrc_80 [] = { 0x8008, 0x8009, 0x800A, 0x802E, 0x803C, 0x805F, 0x8061, 0x8068, 0x806B, 0x806E, 0x8074, 0x807C, 0x8088, 0x808E, 0x80A7, 0x80AC, 0x80BB, 0x80F7, 0xFFFF } ;
   static const unsigned long  szDst_80 [] = { 0x8007, 0x8007, 0x800B, 0x8022, 0x8043, 0x5A7F, 0x806A, 0x8054, 0x8054, 0x8054, 0x542C, 0x542C, 0x8087, 0x80AF, 0x80DA, 0x75A3, 0x80AF, 0x80F8, } ;

   static const unsigned short szSrc_81 [] = { 0x8103, 0x8107, 0x8117,  0x8125, 0x8133, 0x8141, 0x8156, 0x815F,  0x816A, 0x8193, 0x819E, 0x81B8, 0x81C8, 0x81CB, 0x81D3,  0x81D7, 0x81EF, 0xFFFF } ;
   static const unsigned long  szDst_81 [] = { 0x8106, 0x80C1, 0x543B, 0x23370, 0x8111, 0x80FC, 0x80E8, 0x81A3, 0x2336F, 0x80A0, 0x43DD, 0x9AD3, 0x814A, 0x81C0, 0x810F, 0x23391, 0x768B, } ;

   static const unsigned short szSrc_82 [] = { 0x8203, 0x820E, 0x8213, 0x8217, 0x8218, 0x8229, 0x822E, 0x824A, 0x8262, 0x826A, 0x8276, 0x82B2, 0x82FD, 0xFFFF } ;
   static const unsigned long  szDst_82 [] = { 0x8204, 0x820D, 0x8210, 0x94FA, 0x9986, 0x8239, 0x823B, 0x8236, 0x6A2F, 0x6A79, 0x8273, 0x82B1, 0x83F0, } ;

   static const unsigned short szSrc_83 [] = { 0x8318, 0x8358, 0x83B5, 0x83BE, 0x83D3, 0x83ED, 0x83F7, 0xFFFF } ;
   static const unsigned long  szDst_83 [] = { 0x8354, 0x5E84, 0x83DF, 0x83BD, 0x679C, 0x82D4, 0x5E1A, } ;

   static const unsigned short szSrc_84 [] = { 0x8405, 0x8415, 0x8420, 0x844A, 0x8458, 0x8462, 0x8464, 0x8493, 0x84AD, 0x84E1, 0xFFFF } ;
   static const unsigned long  szDst_84 [] = { 0x6625, 0x8360, 0x840C, 0x5EB5, 0x83D1, 0x76D6, 0x836E, 0x83BC, 0x520D, 0x53C2, } ;

   static const unsigned short szSrc_85 [] = { 0x8534, 0x8535, 0x853F, 0x854B, 0x8550, 0x8552, 0x855A, 0x85AB, 0x85AC, 0x85B3, 0x85CA, 0x85ED, 0x85F3, 0x85F4, 0x85FC, 0xFFFF } ;
   static const unsigned long  szDst_85 [] = { 0x9EBB, 0x85CF, 0x848D, 0x854A, 0x534E, 0x836C, 0x843C, 0x85B0, 0x836F, 0x44D5, 0x6241, 0x44D6, 0x85C1, 0x8574, 0x8431, } ;

   static const unsigned short szSrc_86 [] = { 0x8602, 0x860F, 0x8610, 0x8613, 0x8616, 0x862F, 0x8657, 0x8675, 0x8689, 0x86A6, 0x86CD, 0x86D5, 0xFFFF } ;
   static const unsigned long  szDst_86 [] = { 0x854A, 0x8614, 0x8431, 0x82CF, 0x6A97, 0x8361, 0x865A, 0x86C7, 0x868A, 0x86BA, 0x8424, 0x86D4, } ;

   static const unsigned short szSrc_87 [] = { 0x8716, 0x872F, 0x8739, 0x8744, 0x8745, 0x874B, 0x8771, 0x877F, 0x878E, 0x8799, 0x87A1, 0x87AE, 0x87C1, 0x87C7, 0x87CE, 0x87F8, 0xFFFF } ;
   static const unsigned long  szDst_87 [] = { 0x86D4, 0x868C, 0x868B, 0x86E7, 0x8695, 0x8721, 0x867B, 0x8747, 0x878D, 0x8839, 0x868A, 0x45D6, 0x868A, 0x87C6, 0x87A8, 0x8821, } ;

   static const unsigned short szSrc_88 [] = {  0x8800, 0x8807, 0x880E, 0x880F, 0x8812,  0x8819, 0x8827, 0x882D, 0x883A, 0x8842, 0x8846, 0x8847, 0x8858, 0x885E, 0x885F, 0x88A0, 0x88B4, 0x88B5, 0x88E0, 0x88E9, 0xFFFF } ;
   static const unsigned long  szDst_88 [] = { 0x273D7, 0x86CE, 0x87D2, 0x87F9, 0x8327, 0x273D6, 0x8839, 0x8702, 0x8695, 0x8844, 0x4F17, 0x8109, 0x8854, 0x536B, 0x9053, 0x889F, 0x88E4, 0x887D, 0x88D9, 0x88C8, } ;

   static const unsigned short szSrc_89 [] = { 0x890F, 0x891D, 0x8943, 0x8947, 0x894D, 0x896C,  0x8970, 0x8975, 0x8987, 0x8989, 0x898A, 0x898C, 0x898E, 0x8994, 0x899A, 0x89A5, 0x89A7, 0x89A9, 0x89B0, 0x89B3, 0x89BB, 0x89BC, 0x89D7, 0x89E7, 0x89F5, 0x89F9, 0x89FD, 0xFFFF } ;
   static const unsigned long  szDst_89 [] = { 0x890E, 0x894C, 0x8912, 0x88E5, 0x6742, 0x4653, 0x2775D, 0x8936, 0x9738, 0x7F81, 0x7F81, 0x89C2, 0x89C3, 0x89C5, 0x89C9, 0x89CD, 0x89C8, 0x7779, 0x89D1, 0x89C2, 0x89D1, 0x8999, 0x89EF, 0x89E3, 0x89E5, 0x89FF, 0x89FF, } ;

   static const unsigned short szSrc_8A [] = { 0x8A01, 0x8A22, 0x8A29, 0x8A33, 0x8A3D,  0x8A40, 0x8A64, 0x8AAC, 0x8AAD, 0x8ACC, 0x8AD0, 0xFFFF } ;
   static const unsigned long  szDst_8A [] = { 0x8BA0, 0x4723, 0x8BBB, 0x8BD1, 0x8BDF, 0x27BAA, 0x8C0E, 0x8BF4, 0x8BFB, 0x8C0F, 0x6106, } ;

   static const unsigned short szSrc_8B [] = { 0x8B21, 0x8B29, 0x8B2D, 0x8B45, 0x8B4C, 0x8B5B, 0x8B71, 0x8B72, 0x8B81, 0x8B83, 0x8B87, 0x8B8C, 0x8B8D, 0x8B8F, 0x8B90, 0x8BAC, 0xFFFF } ;
   static const unsigned long  szDst_8B [] = { 0x8C23, 0x8C1F, 0x8C2B, 0x4727, 0x8BB9, 0x8C2E, 0x5584, 0x8BA9, 0x8C2A, 0x8D5E, 0x8C04, 0x4729, 0x8C14, 0x8B86, 0x4EC7, 0x6258, } ;

   static const unsigned short szSrc_8C [] = { 0x8C53, 0x8C58, 0x8C5B, 0x8C63, 0x8C7C, 0x8C83, 0x8C99, 0x8C9B, 0x8C9F, 0x8CAD, 0x8CAE, 0x8CC9, 0x8CCD, 0x8CCE, 0x8CD4, 0x8CD6, 0x8CDB,  0x8CDF, 0x8CEB, 0x8CF0, 0x8CF7, 0xFFFF } ;
   static const unsigned long  szDst_8C [] = { 0x8273, 0x8C5A, 0x53BE, 0x8C5C, 0x8C94, 0x8C8A, 0x4759, 0x737E, 0x8D20, 0x8D28, 0x8D30, 0x6064, 0x8D43, 0x8D31, 0x5BBE, 0x8D4A, 0x8D5E, 0x27E56, 0x8D4D, 0x4790, 0x8D4D, } ;

   static const unsigned short szSrc_8D [] = {  0x8D03, 0x8D0B, 0x8D11, 0x8D12, 0x8D1C, 0x8D71, 0x8D82, 0x8DA6, 0x8DC0, 0x8DE5, 0xFFFF } ;
   static const unsigned long  szDst_8D [] = { 0x27E57, 0x8D5D, 0x8D63, 0x8D24, 0x8D43, 0x8D70, 0x8D81, 0x8D91, 0x5216, 0x8DFA, } ;

   static const unsigned short szSrc_8E [] = { 0x8E01, 0x8E28, 0x8E4F, 0x8E6E, 0x8E75, 0x8E77, 0x8E79,  0x8E98, 0x8E99, 0x8E9B,  0x8E9D, 0x8EAD, 0x8EB0, 0x8EB1, 0x8EB3, 0x8EB6, 0x8EC4, 0x8EC6,  0x8ED7, 0x8EE2, 0x8EE3, 0x8EE4, 0x8EF0, 0x8EF2, 0x8EFD, 0xFFFF } ;
   static const unsigned long  szDst_8E [] = { 0x80EB, 0x8E2A, 0x8E44, 0x8DF9, 0x8E74, 0x8E76, 0x8E4B, 0x28001, 0x8E8F, 0x8E97, 0x2816C, 0x803D, 0x4F53, 0x8EB2, 0x8EAC, 0x88F8, 0x804C, 0x4F53, 0x28405, 0x8F6C, 0x8F70, 0x8F77, 0x8F88, 0x8F71, 0x8F7B, } ;

   static const unsigned short szSrc_8F [] = {  0x8F04, 0x8F0C, 0x8F19, 0x8F27, 0x8F2D, 0x8F3A, 0x8F3C, 0x8F5C, 0x8FA0, 0x8FA2, 0x8FA4, 0x8FA7, 0x8FAC, 0x8FB3, 0x8FBA, 0x8FC3, 0x8FEF, 0xFFFF } ;
   static const unsigned long  szDst_8F [] = { 0x28408, 0x8F86, 0x8F84, 0x8EFF, 0x8F6F, 0x8F8E, 0x8F92, 0x8F00, 0x7F6A, 0x8FA3, 0x8F9E, 0x8FA8, 0x6591, 0x519C, 0x8FB9, 0x8FC2, 0x9003, } ;

   static const unsigned short szSrc_90 [] = { 0x9008, 0x900E, 0x9013, 0x9025, 0x9029, 0x902C, 0x9030, 0x9037, 0x9039, 0x903A, 0x9045, 0x905F, 0x9061, 0x9089, 0x90A8, 0x90C9, 0x90DE, 0x90F7, 0xFFFF } ;
   static const unsigned long  szDst_90 [] = { 0x8FE5, 0x9052, 0x9012, 0x56DE, 0x5954, 0x8FF8, 0x6E38, 0x9016, 0x8FBE, 0x8FDC, 0x8FDF, 0x8FDF, 0x6EAF, 0x8FB9, 0x6751, 0x90A2, 0x90CE, 0x4E61, } ;

   static const unsigned short szSrc_91 [] = { 0x9115, 0x9137, 0x913C, 0x913D, 0x9154, 0x9167, 0x918E, 0x9195, 0x9196, 0x9197, 0x91A4, 0x91B8, 0x91BB, 0x91BF, 0x91C4, 0x91C8, 0x91D2, 0x91E1,  0x91F3, 0x91FA, 0x91FC, 0x91FE, 0xFFFF } ;
   static const unsigned long  szDst_91 [] = { 0x4E61, 0x9146, 0x9142, 0x5EDB, 0x9189, 0x916C, 0x54B8, 0x9187, 0x915D, 0x9166, 0x9171, 0x917F, 0x916C, 0x91BE, 0x91BE, 0x91CA, 0x9485, 0x91DC, 0x28C3F, 0x948E, 0x91F0, 0x497A, } ;

   static const unsigned short szSrc_92 [] = { 0x9208,  0x920B, 0x920E,  0x9220, 0x9221, 0x922C,  0x922F,  0x9232,  0x9241, 0x9244, 0x9255, 0x9262, 0x9271, 0x92AD, 0x92B1,  0x92B6, 0x92BF,  0x92C9,  0x92D1, 0x92E3, 0x92E5, 0x92ED, 0x92F3, 0x92F6, 0xFFFF } ;
   static const unsigned long  szDst_92 [] = { 0x949A, 0x28C42, 0x94A9, 0x28C41, 0x949F, 0x94CE, 0x28C44, 0x28C43, 0x28C45, 0x94C1, 0x94B7, 0x94B5, 0x77FF, 0x94B1, 0x94DE, 0x28C47, 0x955B, 0x28C48, 0x28C4B, 0x94D8, 0x9503, 0x9510, 0x94F8, 0x950D, } ;

   static const unsigned short szSrc_93 [] = { 0x9307, 0x932C, 0x9332, 0x9340, 0x9341, 0x9343,  0x9344, 0x9348, 0x9369, 0x936B,  0x936E, 0x9373, 0x937F, 0x9384, 0x9387,  0x939D, 0x93AD,  0x93AF,  0x93B7, 0x93B8, 0x93BB, 0x93BF, 0x93C1,  0x93C6,  0x93C9, 0x93E9, 0x93F0, 0x93FA, 0xFFFF } ;
   static const unsigned long  szDst_93 [] = { 0x952B, 0x70BC, 0x5F55, 0x951D, 0x9528, 0x952A, 0x28C49, 0x9533, 0x9518, 0x9539, 0x28C4E, 0x9274, 0x9531, 0x953F, 0x9545, 0x28C4F, 0x9547, 0x28C4D, 0x28C3E, 0x954C, 0x9501, 0x954E, 0x9501, 0x28C4C, 0x28C52, 0x933E, 0x955A, 0x497D, } ;

   static const unsigned short szSrc_94 [] = { 0x9402,  0x9404,  0x940E,  0x940F, 0x941C, 0x941D, 0x9421, 0x9425, 0x9426, 0x9427, 0x942F, 0x9454, 0x945A, 0x945B, 0x9465, 0x9479, 0x9481, 0x94C7, 0xFFFF } ;
   static const unsigned long  szDst_94 [] = { 0x954F, 0x28C51, 0x28C53, 0x28C54, 0x9566, 0x9562, 0x94C1, 0x4985, 0x950E, 0x950F, 0x4983, 0x9572, 0x94BB, 0x77FF, 0x9565, 0x9569, 0x4986, 0x5228, } ;

   static const unsigned short szSrc_95 [] = { 0x9587,  0x958D,  0x9590, 0x9599, 0x95A2, 0x95A7, 0x95B2, 0x95D7, 0x95D8, 0xFFFF } ;
   static const unsigned long  szDst_95 [] = { 0x95ED, 0x28E02, 0x28E03, 0x95F9, 0x5173, 0x54C4, 0x9605, 0x5173, 0x6597, } ;

   static const unsigned short szSrc_96 [] = { 0x9627, 0x962B, 0x9652, 0x9657, 0x9665, 0x967A, 0x967B, 0x9681, 0x9682, 0x9696, 0x96A0, 0x96A3, 0x96AF, 0x96B2, 0x96B7, 0x96D1, 0xFFFF } ;
   static const unsigned long  szDst_96 [] = { 0x9661, 0x576F, 0x579D, 0x5CED, 0x9677, 0x9669, 0x5819, 0x5830, 0x9634, 0x575E, 0x9690, 0x90BB, 0x9666, 0x9A98, 0x96B6, 0x6742, } ;

   static const unsigned short szSrc_97 [] = { 0x970A, 0x971B, 0x9736, 0x973B, 0x9751, 0x975D, 0x9763, 0x9764, 0x9766, 0x976D, 0x9771, 0x9789, 0x978C, 0x97B1, 0x97B5, 0x97BD, 0x97BE, 0x97C8, 0x97E4, 0x97EE, 0x97EF, 0x97F2, 0xFFFF } ;
   static const unsigned long  szDst_97 [] = { 0x7075, 0x7075, 0x96F1, 0x974A, 0x9752, 0x9754, 0x9762, 0x75B1, 0x4A44, 0x97E7, 0x97E7, 0x9F17, 0x978D, 0x97EC, 0x978B, 0x9792, 0x9774, 0x889C, 0x889C, 0x97ED, 0x97F1, 0x9F51, } ;

   static const unsigned short szSrc_98 [] = { 0x980B, 0x981A, 0x981F, 0x9825, 0x982C, 0x982E, 0x9834, 0x983A, 0x983C, 0x983D, 0x983E, 0x983F,  0x9843, 0x9847, 0x984B, 0x9854, 0x9855, 0x985A, 0x9866, 0x986C, 0x9895,  0x98B0,  0x98B7,  0x98BE, 0x98C3, 0x98C7, 0x98C8, 0x98DC, 0x98E0, 0x98E1, 0x98E4, 0x98EE, 0x98F0, 0x98F1, 0x98FF, 0xFFFF } ;
   static const unsigned long  szDst_98 [] = { 0x987E, 0x9888, 0x989D, 0x9890, 0x988A, 0x9892, 0x9896, 0x9893, 0x8D56, 0x9893, 0x9AED, 0x9AED, 0x29596, 0x60B4, 0x816E, 0x989C, 0x663E, 0x98A0, 0x6194, 0x98A5, 0x9896, 0x29665, 0x2966A, 0x2966B, 0x98D8, 0x98D9, 0x98DA, 0x7FFB, 0x9963, 0x9910, 0x9972, 0x996E, 0x996D, 0x98E7, 0x9973, } ;

   static const unsigned short szSrc_99 [] = { 0x9901, 0x9904, 0x990E, 0x990F, 0x991C, 0x991D, 0x9920, 0x9936, 0x9937,  0x9938, 0x9939, 0x993B, 0x994A, 0x994D, 0x995D, 0x9962, 0x99BF, 0x99C4, 0x99C5, 0x99C6, 0x99C8,  0x99CE,  0x99DA, 0x99DE, 0x99E1,  0x99E7,  0x99E9, 0x99F5,  0x99F6, 0xFFFF } ;
   static const unsigned long  szDst_99 [] = { 0x996A, 0x9978, 0x9979, 0x997B, 0x9983, 0x9970, 0x997C, 0x9989, 0x9987, 0x2980C, 0x7CD6, 0x7CD5, 0x9993, 0x81B3, 0x998D, 0x9995, 0x9A74, 0x9A6E, 0x9A7F, 0x9A71, 0x9A71, 0x299E8, 0x299EB, 0x9A7C, 0x9A82, 0x299F2, 0x299F4, 0x9A9D, 0x299FA, } ;

   static const unsigned short szSrc_9A [] = { 0x9A08, 0x9A0C, 0x9A10, 0x9A12, 0x9A13,  0x9A14, 0x9A18,  0x9A1A,  0x9A1D,  0x9A1F, 0x9A27, 0x9A28,  0x9A2A,  0x9A4B, 0x9A51, 0x9A58, 0x9AAA, 0x9AB5, 0x9ABD, 0x9AC4, 0x9AC8, 0x9AD9, 0x9AE0, 0x9AE4, 0x9AE5, 0x9AE8, 0x9AE9, 0x9AEA, 0x9AF4, 0xFFFF } ;
   static const unsigned long  szDst_9A [] = { 0x9A88, 0x9A94, 0x9A8C, 0x9A9A, 0x9A8C, 0x29A00, 0x9AA2, 0x29A0A, 0x29A03, 0x29A08, 0x4BC4, 0x9A52, 0x29A04, 0x299EF, 0x9A9D, 0x9AA1, 0x9AAB, 0x4F53, 0x817F, 0x9AD3, 0x8180, 0x9AD8, 0x9AE1, 0x9AF9, 0x9AEF, 0x9AE1, 0x9B13, 0x53D1, 0x4F5B, } ;

   static const unsigned short szSrc_9B [] = { 0x9B00, 0x9B02, 0x9B09, 0x9B26, 0x9B2A, 0x9B2C, 0x9B2D, 0x9B30, 0x9B39, 0x9B57, 0x9B62, 0x9B63,  0x9B65, 0x9B81, 0x9B83, 0x9B8A, 0x9B8B, 0x9B8C, 0x9B8D, 0x9B8E, 0x9B9C, 0x9B9D,  0x9B9F, 0x9BA3, 0x9BB3,  0x9BB8, 0x9BBA,  0x9BC4, 0x9BCB, 0x9BD2, 0x9BDD,  0x9BF1, 0x9BF4, 0x9BF5,  0x9BF6, 0x9BFF, 0xFFFF } ;
   static const unsigned long  szDst_9B [] = { 0x5243, 0x9B13, 0x9B03, 0x6597, 0x6597, 0x6597, 0x6597, 0x90C1, 0x9B36, 0x4E11, 0x9C7E, 0x9C6E, 0x29F79, 0x9C85, 0x9C86, 0x9C8C, 0x9C89, 0x9CA7, 0x9C8F, 0x9C87, 0x9C98, 0x9C9E, 0x29F7E, 0x4C9F, 0x9C93, 0x29F83, 0x9C9D, 0x29F81, 0x9CA8, 0x9CAC, 0x9CB4, 0x29F87, 0x9CBA, 0x9CB9, 0x29F7C, 0x9CCA, } ;

   static const unsigned short szSrc_9C [] = { 0x9C01, 0x9C02, 0x9C03, 0x9C06, 0x9C0C, 0x9C0F, 0x9C10, 0x9C1B, 0x9C1F, 0x9C20, 0x9C27, 0x9C2E, 0x9C35, 0x9C3A, 0x9C42, 0x9C45,  0x9C47, 0x9C53, 0x9C5D, 0x9C64, 0x9C6F, 0x9C76, 0x9C7B, 0x9CEB, 0x9CEC, 0x9CEE, 0x9CEF,  0x9CFC, 0x9CFE, 0xFFFF } ;
   static const unsigned long  szDst_9C [] = { 0x9CC8, 0x9C97, 0x9CC2, 0x4CA0, 0x4CA1, 0x9CBE, 0x9CC4, 0x9CC1, 0x9CD1, 0x9CCB, 0x4CA2, 0x9CC1, 0x9CD8, 0x9CB9, 0x9CC9, 0x9CD9, 0x29F8C, 0x9CDD, 0x9CBC, 0x9CE1, 0x9CE0, 0x9C9E, 0x9C9C, 0x96C1, 0x51EB, 0x9E21, 0x51E4, 0x2A243, 0x4D13, } ;

   static const unsigned short szSrc_9D [] = { 0x9D02, 0x9D0E,  0x9D1C, 0x9D2C,  0x9D32, 0x9D34, 0x9D37, 0x9D41, 0x9D44, 0x9D49, 0x9D50,  0x9D5A, 0x9D5E, 0x9D6E, 0x9D76, 0x9D7E, 0x9D84, 0x9D8F, 0x9D93, 0x9DA5, 0x9DAA, 0x9DC0, 0x9DC4, 0x9DC6, 0x9DC9,  0x9DD4,  0x9DE8, 0xFFFF } ;
   static const unsigned long  szDst_9D [] = { 0x9D03, 0x9E25, 0x2A248, 0x83BA, 0x2A246, 0x9E3B, 0x4D15, 0x4D14, 0x9E31, 0x9E3E, 0x9E40, 0x2A24D, 0x9E45, 0x9E50, 0x9E26, 0x9E4D, 0x4D16, 0x9E21, 0x9E4B, 0x9E5B, 0x4D17, 0x9E5A, 0x9E21, 0x9DCF, 0x4D18, 0x2A251, 0x2A24A, } ;

   static const unsigned short szSrc_9E [] = { 0x9E02, 0x9E0A, 0x9E0C, 0x9E0E, 0x9E18, 0x9E78, 0x9E7B, 0x9E81, 0x9E84, 0x9E85, 0x9E90, 0x9E95, 0x9E9E,  0x9EA8, 0x9EAA, 0x9EAB, 0x9EAF,  0x9EB2, 0x9EB9, 0x9EBA, 0x9EBD, 0x9ED2, 0x9ED9, 0x9EF1, 0xFFFF } ;
   static const unsigned long  szDst_9E [] = { 0x3D89, 0x4D19, 0x9E71, 0x83BA, 0x9E74, 0x78B1, 0x78B1, 0x7C97, 0x7C97, 0x72CD, 0x9E9F, 0x9E87, 0x7350, 0x2A38A, 0x9762, 0x9762, 0x66F2, 0x2A389, 0x9EB4, 0x9762, 0x4E48, 0x9ED1, 0x9ED8, 0x9EDB, } ;

   static const unsigned short szSrc_9F [] = { 0x9F02, 0x9F03, 0x9F04, 0x9F05, 0x9F08, 0x9F26, 0x9F53, 0x9F5A, 0x9F62, 0x9F69, 0x9F8E, 0x9F91, 0x9F9D, 0x9F9E, 0x9FA5, 0xFFFF } ;
   static const unsigned long  szDst_9F [] = { 0x9F0C, 0x86D9, 0x86DB, 0x8718, 0x9CD6, 0x8C82, 0x9F80, 0x9F70, 0x9F84, 0x54AC, 0x5E9E, 0x4DAE, 0x79CB, 0x9CD6, 0x5401, } ;

   static const unsigned short szSrc_F9 [] = { 0xF92C, 0xF979, 0xF995, 0xF9E7, 0xF9F1, 0xFFFF } ;
   static const unsigned long  szDst_F9 [] = { 0x90CE, 0x51C9, 0x5E74, 0x91CC, 0x90BB, } ;

   static const unsigned short szSrc_FA [] = { 0xFA11, 0xFA14, 0xFA18, 0xFA1F, 0xFA20, 0xFA23, 0xFFFF } ;
   static const unsigned long  szDst_FA [] = { 0x5D0E, 0x6989, 0x793C, 0x814A, 0x8612, 0x8D73, } ;

   static const unsigned short szSrc_203 [] = {  0x0325, 0xFFFF } ;
   static const unsigned long  szDst_203 [] = { 0x201BF, } ;

   static const unsigned short szSrc_207 [] = {  0x0786, 0xFFFF } ;
   static const unsigned long  szDst_207 [] = { 0x206C6, } ;

   static const unsigned short szSrc_20D [] = { 0x0DF4, 0xFFFF } ;
   static const unsigned long  szDst_20D [] = { 0x3583, } ;

   static const unsigned short szSrc_210 [] = {  0x1060, 0xFFFF } ;
   static const unsigned long  szDst_210 [] = { 0x20C1A, } ;

   static const unsigned short szSrc_217 [] = { 0x17B5, 0xFFFF } ;
   static const unsigned long  szDst_217 [] = { 0x36DF, } ;

   static const unsigned short szSrc_218 [] = { 0x1839, 0x1883, 0xFFFF } ;
   static const unsigned long  szDst_218 [] = { 0x36FF, 0x36E0, } ;

   static const unsigned short szSrc_21F [] = {  0x1F57, 0xFFFF } ;
   static const unsigned long  szDst_21F [] = { 0x21E03, } ;

   static const unsigned short szSrc_228 [] = {  0x28DA,  0x28ED, 0xFFFF } ;
   static const unsigned long  szDst_228 [] = { 0x2261D, 0x2261E, } ;

   static const unsigned short szSrc_229 [] = {  0x2931, 0xFFFF } ;
   static const unsigned long  szDst_229 [] = { 0x22619, } ;

   static const unsigned short szSrc_232 [] = {  0x32CB, 0xFFFF } ;
   static const unsigned long  szDst_232 [] = { 0x23223, } ;

   static const unsigned short szSrc_236 [] = { 0x364E, 0xFFFF } ;
   static const unsigned long  szDst_236 [] = { 0x3B63, } ;

   static const unsigned short szSrc_237 [] = {  0x3755, 0xFFFF } ;
   static const unsigned long  szDst_237 [] = { 0x23637, } ;

   static const unsigned short szSrc_23B [] = {  0x3BE9,  0x3BF4, 0xFFFF } ;
   static const unsigned long  szDst_23B [] = { 0x23BE3, 0x23B64, } ;

   static const unsigned short szSrc_23F [] = {  0x3FC9, 0xFFFF } ;
   static const unsigned long  szDst_23F [] = { 0x23DAB, } ;

   static const unsigned short szSrc_244 [] = {  0x4473,  0x44CE, 0xFFFF } ;
   static const unsigned long  szDst_244 [] = { 0x243BB, 0x243BA, } ;

   static const unsigned short szSrc_246 [] = {  0x46EE, 0xFFFF } ;
   static const unsigned long  szDst_246 [] = { 0x2466F, } ;

   static const unsigned short szSrc_248 [] = {  0x489F, 0xFFFF } ;
   static const unsigned long  szDst_248 [] = { 0x24762, } ;

   static const unsigned short szSrc_24A [] = { 0x4ABA, 0x4AE9, 0xFFFF } ;
   static const unsigned long  szDst_24A [] = { 0x3ED8, 0x3ECF, } ;

   static const unsigned short szSrc_24E [] = {  0x4E2B, 0xFFFF } ;
   static const unsigned long  szDst_24E [] = { 0x24DA7, } ;

   static const unsigned short szSrc_258 [] = { 0x58A2, 0xFFFF } ;
   static const unsigned long  szDst_258 [] = { 0x416A, } ;

   static const unsigned short szSrc_25A [] = {  0x5A10, 0xFFFF } ;
   static const unsigned long  szDst_25A [] = { 0x259C2, } ;

   static const unsigned short szSrc_25F [] = {  0x5FCA, 0xFFFF } ;
   static const unsigned long  szDst_25F [] = { 0x26208, } ;

   static const unsigned short szSrc_260 [] = {  0x6085,  0x60C4, 0xFFFF } ;
   static const unsigned long  szDst_260 [] = { 0x26212, 0x26217, } ;

   static const unsigned short szSrc_263 [] = {  0x63E9, 0xFFFF } ;
   static const unsigned long  szDst_263 [] = { 0x26360, } ;

   static const unsigned short szSrc_26A [] = {  0x6ABD, 0xFFFF } ;
   static const unsigned long  szDst_26A [] = { 0x26A29, } ;

   static const unsigned short szSrc_272 [] = {  0x72B1, 0xFFFF } ;
   static const unsigned long  szDst_272 [] = { 0x272B6, } ;

   static const unsigned short szSrc_275 [] = {  0x7525, 0xFFFF } ;
   static const unsigned long  szDst_275 [] = { 0x274AD, } ;

   static const unsigned short szSrc_277 [] = { 0x7735, 0x775E, 0xFFFF } ;
   static const unsigned long  szDst_277 [] = { 0x464A, 0x461B, } ;

   static const unsigned short szSrc_27A [] = { 0x7A59, 0x7A7E, 0xFFFF } ;
   static const unsigned long  szDst_27A [] = { 0x4725, 0x46D3, } ;

   static const unsigned short szSrc_27D [] = { 0x7D73,  0x7D94, 0xFFFF } ;
   static const unsigned long  szDst_27D [] = { 0x478C, 0x27E53, } ;

   static const unsigned short szSrc_281 [] = {  0x814D,  0x81C1, 0xFFFF } ;
   static const unsigned long  szDst_281 [] = { 0x28074, 0x27FC8, } ;

   static const unsigned short szSrc_282 [] = {  0x820A,  0x820C, 0x82B0, 0x82B8,  0x82BB, 0x82E2, 0xFFFF } ;
   static const unsigned long  szDst_282 [] = { 0x280BA, 0x28104, 0x4880, 0x4881, 0x28406, 0x4882, } ;

   static const unsigned short szSrc_283 [] = {  0x83AE,  0x83E0,  0x83E5, 0xFFFF } ;
   static const unsigned long  szDst_283 [] = { 0x28409, 0x28407, 0x2840A, } ;

   static const unsigned short szSrc_288 [] = {  0x88BF,  0x88C8,  0x88E7, 0xFFFF } ;
   static const unsigned long  szDst_288 [] = { 0x28859, 0x2887A, 0x28828, } ;

   static const unsigned short szSrc_289 [] = {  0x895B, 0x89AB, 0x89DC,  0x89F1, 0xFFFF } ;
   static const unsigned long  szDst_289 [] = { 0x28C40, 0x4980, 0x4981, 0x28C4A, } ;

   static const unsigned short szSrc_28A [] = {  0x8AD2, 0xFFFF } ;
   static const unsigned long  szDst_28A [] = { 0x28C50, } ;

   static const unsigned short szSrc_28B [] = {  0x8B82, 0x8BC5, 0xFFFF } ;
   static const unsigned long  szDst_28B [] = { 0x28C55, 0x497F, } ;

   static const unsigned short szSrc_28C [] = {  0x8CD1,  0x8CD5, 0xFFFF } ;
   static const unsigned long  szDst_28C [] = { 0x28E01, 0x28E00, } ;

   static const unsigned short szSrc_28D [] = {  0x8D17,  0x8D69,  0x8D78,  0x8D80,  0x8D8F,  0x8DAE,  0x8DB2,  0x8DF2, 0xFFFF } ;
   static const unsigned long  szDst_28D [] = { 0x28E05, 0x28E06, 0x28E07, 0x28E09, 0x28E0A, 0x28E0C, 0x28E0B, 0x28E0E, } ;

   static const unsigned short szSrc_28E [] = {  0x8E43, 0xFFFF } ;
   static const unsigned long  szDst_28E [] = { 0x28E44, } ;

   static const unsigned short szSrc_293 [] = {  0x93A2,  0x93EA, 0xFFFF } ;
   static const unsigned long  szDst_293 [] = { 0x293FE, 0x293FD, } ;

   static const unsigned short szSrc_294 [] = {  0x94E3, 0xFFFF } ;
   static const unsigned long  szDst_294 [] = { 0x29595, } ;

   static const unsigned short szSrc_295 [] = {  0x95C0, 0xFFFF } ;
   static const unsigned long  szDst_295 [] = { 0x29666, } ;

   static const unsigned short szSrc_296 [] = {  0x9600,  0x961D,  0x9639,  0x963A,  0x9648,  0x969B,  0x96A5,  0x96B5,  0x96C6,  0x96E9, 0xFFFF } ;
   static const unsigned long  szDst_296 [] = { 0x29669, 0x2966D, 0x29668, 0x2966C, 0x29670, 0x297FF, 0x29800, 0x29801, 0x29802, 0x29803, } ;

   static const unsigned short szSrc_297 [] = {  0x9707,  0x9726,  0x9735,  0x9754,  0x9784,  0x97A6, 0x97AF,  0x97B1, 0xFFFF } ;
   static const unsigned long  szDst_297 [] = { 0x29809, 0x29806, 0x2980A, 0x2980B, 0x2980E, 0x2980F, 0x4B6A, 0x29805, } ;

   static const unsigned short szSrc_298 [] = {  0x9863,  0x987A,  0x98A1,  0x98B4,  0x98B8,  0x98BE,  0x98CF, 0x98D1,  0x98F5,  0x98FA, 0xFFFF } ;
   static const unsigned long  szDst_298 [] = { 0x29856, 0x299E6, 0x299EC, 0x299F5, 0x299F3, 0x299EE, 0x299F6, 0x4BC3, 0x299FB, 0x299FC, } ;

   static const unsigned short szSrc_299 [] = {  0x990A,  0x9919,  0x9932,  0x9938,  0x9944,  0x9947,  0x9949,  0x9951,  0x99C6, 0xFFFF } ;
   static const unsigned long  szDst_299 [] = { 0x299E9, 0x29A06, 0x29A09, 0x29A05, 0x29A0B, 0x29A0D, 0x299F1, 0x29A0C, 0x29A10, } ;

   static const unsigned short szSrc_29B [] = {  0x9B59,  0x9B6F, 0xFFFF } ;
   static const unsigned long  szDst_29B [] = { 0x29B23, 0x29B3E, } ;

   static const unsigned short szSrc_29C [] = {  0x9C00,  0x9C39,  0x9CE4, 0xFFFF } ;
   static const unsigned long  szDst_29C [] = { 0x29B24, 0x29C30, 0x29C92, } ;

   static const unsigned short szSrc_29D [] = {  0x9D35,  0x9D69,  0x9D79, 0x9D98,  0x9DB0,  0x9DB1,  0x9DF0, 0xFFFF } ;
   static const unsigned long  szDst_29D [] = { 0x29D0C, 0x29F7A, 0x29F7B, 0x4C9E, 0x29F7F, 0x29F7D, 0x29F84, } ;

   static const unsigned short szSrc_29E [] = {  0x9E03,  0x9E26, 0xFFFF } ;
   static const unsigned long  szDst_29E [] = { 0x29F85, 0x29F86, } ;

   static const unsigned short szSrc_29F [] = {  0x9F47,  0x9FEA, 0xFFFF } ;
   static const unsigned long  szDst_29F [] = { 0x29F8E, 0x2A244, } ;

   static const unsigned short szSrc_2A0 [] = {  0xA026,  0xA03E,  0xA048,  0xA056,  0xA086,  0xA0CD,  0xA0CF, 0xFFFF } ;
   static const unsigned long  szDst_2A0 [] = { 0x2A245, 0x2A24B, 0x2A249, 0x2A24C, 0x2A24E, 0x2A250, 0x2A24F, } ;

   static const unsigned short szSrc_2A1 [] = {  0xA106,  0xA115,  0xA1F3, 0xFFFF } ;
   static const unsigned long  szDst_2A1 [] = { 0x2A254, 0x2A252, 0x2A255, } ;

   static const unsigned short szSrc_2A2 [] = {  0xA23C, 0xFFFF } ;
   static const unsigned long  szDst_2A2 [] = { 0x2A253, } ;

   static const unsigned short szSrc_2A5 [] = {  0xA535, 0xFFFF } ;
   static const unsigned long  szDst_2A5 [] = { 0x2A52D, } ;

   static const unsigned short szSrc_2A6 [] = {  0xA600,  0xA62F, 0xFFFF } ;
   static const unsigned long  szDst_2A6 [] = { 0x2A68F, 0x2A690, } ;


   const unsigned short *szSrc ;
   const unsigned long *szDst ;

   switch ( cUnicode >> 8 ) {
      case 0x34 :
         szSrc = szSrc_34 ;
         szDst = szDst_34 ;
         break ;
      case 0x36 :
         szSrc = szSrc_36 ;
         szDst = szDst_36 ;
         break ;
      case 0x37 :
         szSrc = szSrc_37 ;
         szDst = szDst_37 ;
         break ;
      case 0x38 :
         szSrc = szSrc_38 ;
         szDst = szDst_38 ;
         break ;
      case 0x39 :
         szSrc = szSrc_39 ;
         szDst = szDst_39 ;
         break ;
      case 0x3A :
         szSrc = szSrc_3A ;
         szDst = szDst_3A ;
         break ;
      case 0x3D :
         szSrc = szSrc_3D ;
         szDst = szDst_3D ;
         break ;
      case 0x3F :
         szSrc = szSrc_3F ;
         szDst = szDst_3F ;
         break ;
      case 0x40 :
         szSrc = szSrc_40 ;
         szDst = szDst_40 ;
         break ;
      case 0x42 :
         szSrc = szSrc_42 ;
         szDst = szDst_42 ;
         break ;
      case 0x43 :
         szSrc = szSrc_43 ;
         szDst = szDst_43 ;
         break ;
      case 0x46 :
         szSrc = szSrc_46 ;
         szDst = szDst_46 ;
         break ;
      case 0x47 :
         szSrc = szSrc_47 ;
         szDst = szDst_47 ;
         break ;
      case 0x49 :
         szSrc = szSrc_49 ;
         szDst = szDst_49 ;
         break ;
      case 0x4A :
         szSrc = szSrc_4A ;
         szDst = szDst_4A ;
         break ;
      case 0x4B :
         szSrc = szSrc_4B ;
         szDst = szDst_4B ;
         break ;
      case 0x4C :
         szSrc = szSrc_4C ;
         szDst = szDst_4C ;
         break ;
      case 0x4D :
         szSrc = szSrc_4D ;
         szDst = szDst_4D ;
         break ;
      case 0x4E :
         szSrc = szSrc_4E ;
         szDst = szDst_4E ;
         break ;
      case 0x4F :
         szSrc = szSrc_4F ;
         szDst = szDst_4F ;
         break ;
      case 0x50 :
         szSrc = szSrc_50 ;
         szDst = szDst_50 ;
         break ;
      case 0x51 :
         szSrc = szSrc_51 ;
         szDst = szDst_51 ;
         break ;
      case 0x52 :
         szSrc = szSrc_52 ;
         szDst = szDst_52 ;
         break ;
      case 0x53 :
         szSrc = szSrc_53 ;
         szDst = szDst_53 ;
         break ;
      case 0x54 :
         szSrc = szSrc_54 ;
         szDst = szDst_54 ;
         break ;
      case 0x55 :
         szSrc = szSrc_55 ;
         szDst = szDst_55 ;
         break ;
      case 0x56 :
         szSrc = szSrc_56 ;
         szDst = szDst_56 ;
         break ;
      case 0x57 :
         szSrc = szSrc_57 ;
         szDst = szDst_57 ;
         break ;
      case 0x58 :
         szSrc = szSrc_58 ;
         szDst = szDst_58 ;
         break ;
      case 0x59 :
         szSrc = szSrc_59 ;
         szDst = szDst_59 ;
         break ;
      case 0x5A :
         szSrc = szSrc_5A ;
         szDst = szDst_5A ;
         break ;
      case 0x5B :
         szSrc = szSrc_5B ;
         szDst = szDst_5B ;
         break ;
      case 0x5C :
         szSrc = szSrc_5C ;
         szDst = szDst_5C ;
         break ;
      case 0x5D :
         szSrc = szSrc_5D ;
         szDst = szDst_5D ;
         break ;
      case 0x5E :
         szSrc = szSrc_5E ;
         szDst = szDst_5E ;
         break ;
      case 0x5F :
         szSrc = szSrc_5F ;
         szDst = szDst_5F ;
         break ;
      case 0x60 :
         szSrc = szSrc_60 ;
         szDst = szDst_60 ;
         break ;
      case 0x61 :
         szSrc = szSrc_61 ;
         szDst = szDst_61 ;
         break ;
      case 0x62 :
         szSrc = szSrc_62 ;
         szDst = szDst_62 ;
         break ;
      case 0x63 :
         szSrc = szSrc_63 ;
         szDst = szDst_63 ;
         break ;
      case 0x64 :
         szSrc = szSrc_64 ;
         szDst = szDst_64 ;
         break ;
      case 0x65 :
         szSrc = szSrc_65 ;
         szDst = szDst_65 ;
         break ;
      case 0x66 :
         szSrc = szSrc_66 ;
         szDst = szDst_66 ;
         break ;
      case 0x67 :
         szSrc = szSrc_67 ;
         szDst = szDst_67 ;
         break ;
      case 0x68 :
         szSrc = szSrc_68 ;
         szDst = szDst_68 ;
         break ;
      case 0x69 :
         szSrc = szSrc_69 ;
         szDst = szDst_69 ;
         break ;
      case 0x6A :
         szSrc = szSrc_6A ;
         szDst = szDst_6A ;
         break ;
      case 0x6B :
         szSrc = szSrc_6B ;
         szDst = szDst_6B ;
         break ;
      case 0x6C :
         szSrc = szSrc_6C ;
         szDst = szDst_6C ;
         break ;
      case 0x6D :
         szSrc = szSrc_6D ;
         szDst = szDst_6D ;
         break ;
      case 0x6E :
         szSrc = szSrc_6E ;
         szDst = szDst_6E ;
         break ;
      case 0x6F :
         szSrc = szSrc_6F ;
         szDst = szDst_6F ;
         break ;
      case 0x70 :
         szSrc = szSrc_70 ;
         szDst = szDst_70 ;
         break ;
      case 0x71 :
         szSrc = szSrc_71 ;
         szDst = szDst_71 ;
         break ;
      case 0x72 :
         szSrc = szSrc_72 ;
         szDst = szDst_72 ;
         break ;
      case 0x73 :
         szSrc = szSrc_73 ;
         szDst = szDst_73 ;
         break ;
      case 0x74 :
         szSrc = szSrc_74 ;
         szDst = szDst_74 ;
         break ;
      case 0x75 :
         szSrc = szSrc_75 ;
         szDst = szDst_75 ;
         break ;
      case 0x76 :
         szSrc = szSrc_76 ;
         szDst = szDst_76 ;
         break ;
      case 0x77 :
         szSrc = szSrc_77 ;
         szDst = szDst_77 ;
         break ;
      case 0x78 :
         szSrc = szSrc_78 ;
         szDst = szDst_78 ;
         break ;
      case 0x79 :
         szSrc = szSrc_79 ;
         szDst = szDst_79 ;
         break ;
      case 0x7A :
         szSrc = szSrc_7A ;
         szDst = szDst_7A ;
         break ;
      case 0x7B :
         szSrc = szSrc_7B ;
         szDst = szDst_7B ;
         break ;
      case 0x7C :
         szSrc = szSrc_7C ;
         szDst = szDst_7C ;
         break ;
      case 0x7D :
         szSrc = szSrc_7D ;
         szDst = szDst_7D ;
         break ;
      case 0x7E :
         szSrc = szSrc_7E ;
         szDst = szDst_7E ;
         break ;
      case 0x7F :
         szSrc = szSrc_7F ;
         szDst = szDst_7F ;
         break ;
      case 0x80 :
         szSrc = szSrc_80 ;
         szDst = szDst_80 ;
         break ;
      case 0x81 :
         szSrc = szSrc_81 ;
         szDst = szDst_81 ;
         break ;
      case 0x82 :
         szSrc = szSrc_82 ;
         szDst = szDst_82 ;
         break ;
      case 0x83 :
         szSrc = szSrc_83 ;
         szDst = szDst_83 ;
         break ;
      case 0x84 :
         szSrc = szSrc_84 ;
         szDst = szDst_84 ;
         break ;
      case 0x85 :
         szSrc = szSrc_85 ;
         szDst = szDst_85 ;
         break ;
      case 0x86 :
         szSrc = szSrc_86 ;
         szDst = szDst_86 ;
         break ;
      case 0x87 :
         szSrc = szSrc_87 ;
         szDst = szDst_87 ;
         break ;
      case 0x88 :
         szSrc = szSrc_88 ;
         szDst = szDst_88 ;
         break ;
      case 0x89 :
         szSrc = szSrc_89 ;
         szDst = szDst_89 ;
         break ;
      case 0x8A :
         szSrc = szSrc_8A ;
         szDst = szDst_8A ;
         break ;
      case 0x8B :
         szSrc = szSrc_8B ;
         szDst = szDst_8B ;
         break ;
      case 0x8C :
         szSrc = szSrc_8C ;
         szDst = szDst_8C ;
         break ;
      case 0x8D :
         szSrc = szSrc_8D ;
         szDst = szDst_8D ;
         break ;
      case 0x8E :
         szSrc = szSrc_8E ;
         szDst = szDst_8E ;
         break ;
      case 0x8F :
         szSrc = szSrc_8F ;
         szDst = szDst_8F ;
         break ;
      case 0x90 :
         szSrc = szSrc_90 ;
         szDst = szDst_90 ;
         break ;
      case 0x91 :
         szSrc = szSrc_91 ;
         szDst = szDst_91 ;
         break ;
      case 0x92 :
         szSrc = szSrc_92 ;
         szDst = szDst_92 ;
         break ;
      case 0x93 :
         szSrc = szSrc_93 ;
         szDst = szDst_93 ;
         break ;
      case 0x94 :
         szSrc = szSrc_94 ;
         szDst = szDst_94 ;
         break ;
      case 0x95 :
         szSrc = szSrc_95 ;
         szDst = szDst_95 ;
         break ;
      case 0x96 :
         szSrc = szSrc_96 ;
         szDst = szDst_96 ;
         break ;
      case 0x97 :
         szSrc = szSrc_97 ;
         szDst = szDst_97 ;
         break ;
      case 0x98 :
         szSrc = szSrc_98 ;
         szDst = szDst_98 ;
         break ;
      case 0x99 :
         szSrc = szSrc_99 ;
         szDst = szDst_99 ;
         break ;
      case 0x9A :
         szSrc = szSrc_9A ;
         szDst = szDst_9A ;
         break ;
      case 0x9B :
         szSrc = szSrc_9B ;
         szDst = szDst_9B ;
         break ;
      case 0x9C :
         szSrc = szSrc_9C ;
         szDst = szDst_9C ;
         break ;
      case 0x9D :
         szSrc = szSrc_9D ;
         szDst = szDst_9D ;
         break ;
      case 0x9E :
         szSrc = szSrc_9E ;
         szDst = szDst_9E ;
         break ;
      case 0x9F :
         szSrc = szSrc_9F ;
         szDst = szDst_9F ;
         break ;
      case 0xF9 :
         szSrc = szSrc_F9 ;
         szDst = szDst_F9 ;
         break ;
      case 0xFA :
         szSrc = szSrc_FA ;
         szDst = szDst_FA ;
         break ;
      case 0x203 :
         szSrc = szSrc_203 ;
         szDst = szDst_203 ;
         break ;
      case 0x207 :
         szSrc = szSrc_207 ;
         szDst = szDst_207 ;
         break ;
      case 0x20D :
         szSrc = szSrc_20D ;
         szDst = szDst_20D ;
         break ;
      case 0x210 :
         szSrc = szSrc_210 ;
         szDst = szDst_210 ;
         break ;
      case 0x217 :
         szSrc = szSrc_217 ;
         szDst = szDst_217 ;
         break ;
      case 0x218 :
         szSrc = szSrc_218 ;
         szDst = szDst_218 ;
         break ;
      case 0x21F :
         szSrc = szSrc_21F ;
         szDst = szDst_21F ;
         break ;
      case 0x228 :
         szSrc = szSrc_228 ;
         szDst = szDst_228 ;
         break ;
      case 0x229 :
         szSrc = szSrc_229 ;
         szDst = szDst_229 ;
         break ;
      case 0x232 :
         szSrc = szSrc_232 ;
         szDst = szDst_232 ;
         break ;
      case 0x236 :
         szSrc = szSrc_236 ;
         szDst = szDst_236 ;
         break ;
      case 0x237 :
         szSrc = szSrc_237 ;
         szDst = szDst_237 ;
         break ;
      case 0x23B :
         szSrc = szSrc_23B ;
         szDst = szDst_23B ;
         break ;
      case 0x23F :
         szSrc = szSrc_23F ;
         szDst = szDst_23F ;
         break ;
      case 0x244 :
         szSrc = szSrc_244 ;
         szDst = szDst_244 ;
         break ;
      case 0x246 :
         szSrc = szSrc_246 ;
         szDst = szDst_246 ;
         break ;
      case 0x248 :
         szSrc = szSrc_248 ;
         szDst = szDst_248 ;
         break ;
      case 0x24A :
         szSrc = szSrc_24A ;
         szDst = szDst_24A ;
         break ;
      case 0x24E :
         szSrc = szSrc_24E ;
         szDst = szDst_24E ;
         break ;
      case 0x258 :
         szSrc = szSrc_258 ;
         szDst = szDst_258 ;
         break ;
      case 0x25A :
         szSrc = szSrc_25A ;
         szDst = szDst_25A ;
         break ;
      case 0x25F :
         szSrc = szSrc_25F ;
         szDst = szDst_25F ;
         break ;
      case 0x260 :
         szSrc = szSrc_260 ;
         szDst = szDst_260 ;
         break ;
      case 0x263 :
         szSrc = szSrc_263 ;
         szDst = szDst_263 ;
         break ;
      case 0x26A :
         szSrc = szSrc_26A ;
         szDst = szDst_26A ;
         break ;
      case 0x272 :
         szSrc = szSrc_272 ;
         szDst = szDst_272 ;
         break ;
      case 0x275 :
         szSrc = szSrc_275 ;
         szDst = szDst_275 ;
         break ;
      case 0x277 :
         szSrc = szSrc_277 ;
         szDst = szDst_277 ;
         break ;
      case 0x27A :
         szSrc = szSrc_27A ;
         szDst = szDst_27A ;
         break ;
      case 0x27D :
         szSrc = szSrc_27D ;
         szDst = szDst_27D ;
         break ;
      case 0x281 :
         szSrc = szSrc_281 ;
         szDst = szDst_281 ;
         break ;
      case 0x282 :
         szSrc = szSrc_282 ;
         szDst = szDst_282 ;
         break ;
      case 0x283 :
         szSrc = szSrc_283 ;
         szDst = szDst_283 ;
         break ;
      case 0x288 :
         szSrc = szSrc_288 ;
         szDst = szDst_288 ;
         break ;
      case 0x289 :
         szSrc = szSrc_289 ;
         szDst = szDst_289 ;
         break ;
      case 0x28A :
         szSrc = szSrc_28A ;
         szDst = szDst_28A ;
         break ;
      case 0x28B :
         szSrc = szSrc_28B ;
         szDst = szDst_28B ;
         break ;
      case 0x28C :
         szSrc = szSrc_28C ;
         szDst = szDst_28C ;
         break ;
      case 0x28D :
         szSrc = szSrc_28D ;
         szDst = szDst_28D ;
         break ;
      case 0x28E :
         szSrc = szSrc_28E ;
         szDst = szDst_28E ;
         break ;
      case 0x293 :
         szSrc = szSrc_293 ;
         szDst = szDst_293 ;
         break ;
      case 0x294 :
         szSrc = szSrc_294 ;
         szDst = szDst_294 ;
         break ;
      case 0x295 :
         szSrc = szSrc_295 ;
         szDst = szDst_295 ;
         break ;
      case 0x296 :
         szSrc = szSrc_296 ;
         szDst = szDst_296 ;
         break ;
      case 0x297 :
         szSrc = szSrc_297 ;
         szDst = szDst_297 ;
         break ;
      case 0x298 :
         szSrc = szSrc_298 ;
         szDst = szDst_298 ;
         break ;
      case 0x299 :
         szSrc = szSrc_299 ;
         szDst = szDst_299 ;
         break ;
      case 0x29B :
         szSrc = szSrc_29B ;
         szDst = szDst_29B ;
         break ;
      case 0x29C :
         szSrc = szSrc_29C ;
         szDst = szDst_29C ;
         break ;
      case 0x29D :
         szSrc = szSrc_29D ;
         szDst = szDst_29D ;
         break ;
      case 0x29E :
         szSrc = szSrc_29E ;
         szDst = szDst_29E ;
         break ;
      case 0x29F :
         szSrc = szSrc_29F ;
         szDst = szDst_29F ;
         break ;
      case 0x2A0 :
         szSrc = szSrc_2A0 ;
         szDst = szDst_2A0 ;
         break ;
      case 0x2A1 :
         szSrc = szSrc_2A1 ;
         szDst = szDst_2A1 ;
         break ;
      case 0x2A2 :
         szSrc = szSrc_2A2 ;
         szDst = szDst_2A2 ;
         break ;
      case 0x2A5 :
         szSrc = szSrc_2A5 ;
         szDst = szDst_2A5 ;
         break ;
      case 0x2A6 :
         szSrc = szSrc_2A6 ;
         szDst = szDst_2A6 ;
         break ;
      default :
         szSrc = NULL ;
         szDst = NULL ;
         break ;
   }

   if ( szSrc ) {
      unsigned short cSrc = (unsigned short) cUnicode ;
      if ( cSrc != 0xFFFF ) {
         for ( const unsigned short *p = szSrc ; *p <= cSrc ; p ++ ) {
            if ( *p == cSrc ) return szDst [ p - szSrc ] ;
         }
      }
   }

   return 0 ;
}



int IsHaveUniFtzToJtz ( int cBig5 ) {

   switch ( cBig5 ) {
      case 0xB360 :
      case 0xBAF9 :
      case 0xC053 :
      case 0xC0BD :
      case 0xC35F :
      case 0xC37D :
      case 0xC46F :
      case 0xC4D8 :
      case 0xC4FC :
      case 0xD467 :
      case 0xD5C8 :
      case 0xD6E7 :
      case 0xD6E8 :
      case 0xD746 :
      case 0xD7DF :
      case 0xD7FA :
      case 0xD858 :
      case 0xD86B :
      case 0xD87B :
      case 0xD95A :
      case 0xD9BB :
      case 0xD9F8 :
      case 0xDBDA :
      case 0xDC79 :
      case 0xDC7B :
      case 0xDCFA :
      case 0xDDF0 :
      case 0xDEEF :
      case 0xDF49 :
      case 0xDF59 :
      case 0xE0CC :
      case 0xE1AC :
      case 0xE1AE :
      case 0xE1B4 :
      case 0xE1CF :
      case 0xE1D2 :
      case 0xE2BC :
      case 0xE540 :
      case 0xE57D :
      case 0xE5A9 :
      case 0xE5D2 :
      case 0xE5E5 :
      case 0xE5F3 :
      case 0xE5FD :
      case 0xE645 :
      case 0xE646 :
      case 0xE64B :
      case 0xE667 :
      case 0xE6E3 :
      case 0xE6EE :
      case 0xE740 :
      case 0xE7E9 :
      case 0xE867 :
      case 0xE879 :
      case 0xE87D :
      case 0xE8CB :
      case 0xE8E4 :
      case 0xE95E :
      case 0xE9F1 :
      case 0xEA5B :
      case 0xEA79 :
      case 0xEAB1 :
      case 0xEAC5 :
      case 0xEAD3 :
      case 0xEBB7 :
      case 0xEC68 :
      case 0xEC69 :
      case 0xECE5 :
      case 0xED55 :
      case 0xED6E :
      case 0xEDAD :
      case 0xEDD3 :
      case 0xEDE0 :
      case 0xEE61 :
      case 0xEECF :
      case 0xEF4A :
      case 0xEF5E :
      case 0xEF77 :
      case 0xEFA5 :
      case 0xEFE7 :
      case 0xEFEB :
      case 0xF073 :
      case 0xF077 :
      case 0xF0A9 :
      case 0xF0F0 :
      case 0xF156 :
      case 0xF158 :
      case 0xF1C9 :
      case 0xF1CC :
      case 0xF1DD :
      case 0xF25A :
      case 0xF269 :
      case 0xF26B :
      case 0xF2B1 :
      case 0xF2C1 :
      case 0xF2C8 :
      case 0xF2DB :
      case 0xF3AE :
      case 0xF3B4 :
      case 0xF3B7 :
      case 0xF3BC :
      case 0xF3C0 :
      case 0xF3DB :
      case 0xF4AC :
      case 0xF4C4 :
      case 0xF4EB :
      case 0xF4F7 :
      case 0xF4FA :
      case 0xF55E :
      case 0xF573 :
      case 0xF5A4 :
      case 0xF5BF :
      case 0xF64F :
      case 0xF6DB :
      case 0xF7DA :
      case 0xF7E8 :
      case 0xF840 :
      case 0xF846 :
      case 0xF872 :
      case 0xF8AE :
      case 0xF8C6 :
      case 0xF8DC :
      case 0xF9C1 :
         return 1 ;
   }

   return 0 ;
}



