// unijtz2ftz.cpp

#include "msc.h"
#include "unijtz2ftz.h"



int UniJtzToFtz ( int cUnicode ) {


   static const unsigned short szSrc_34 [] = { 0x3437, 0x343D, 0x3447, 0x3448, 0x3454, 0x3469, 0x34E5, 0xFFFF } ;
   static const unsigned long  szDst_34 [] = { 0x508C, 0x5051, 0x3473, 0x5032, 0x346F, 0x5138, 0x528F, } ;

   static const unsigned short szSrc_35 [] = { 0x3509, 0x358A, 0x359E, 0x35F7, 0xFFFF } ;
   static const unsigned long  szDst_35 [] = { 0x529A, 0x565A, 0x558E, 0x3614, } ;

   static const unsigned short szSrc_36 [] = { 0x360E, 0x36AF, 0x36C0, 0x36CA,  0x36DF,  0x36E0, 0x36E3, 0x36E4,  0x36FF, 0xFFFF } ;
   static const unsigned long  szDst_36 [] = { 0x361A, 0x3704, 0x5AB0, 0x36C6, 0x217B5, 0x21883, 0x370F, 0x5B4B, 0x21839, } ;

   static const unsigned short szSrc_37 [] = { 0x37C6, 0x37E5, 0xFFFF } ;
   static const unsigned long  szDst_37 [] = { 0x380F, 0x3801, } ;

   static const unsigned short szSrc_38 [] = { 0x384E, 0xFFFF } ;
   static const unsigned long  szDst_38 [] = { 0x5E53, } ;

   static const unsigned short szSrc_39 [] = { 0x3918, 0x392D, 0x393D, 0x396A, 0x39CF, 0x39D0, 0x39D1, 0x39DF, 0x39F0, 0xFFFF } ;
   static const unsigned long  szDst_39 [] = { 0x396E, 0x618D, 0x61E4, 0x617A, 0x6386, 0x3A73, 0x649D, 0x64D3, 0x39A1, } ;

   static const unsigned short szSrc_3A [] = { 0x3A08, 0x3A2B, 0xFFFF } ;
   static const unsigned long  szDst_3A [] = { 0x64E0, 0x3A5C, } ;

   static const unsigned short szSrc_3B [] = { 0x3B4E, 0x3B4F,  0x3B63, 0x3B64, 0x3B74, 0xFFFF } ;
   static const unsigned long  szDst_3B [] = { 0x68E1, 0x6932, 0x2364E, 0x6A22, 0x6A2B, } ;

   static const unsigned short szSrc_3C [] = { 0x3C69, 0x3C6E, 0x3CBF, 0x3CD4, 0x3CD5, 0x3CE0, 0x3CE1, 0xFFFF } ;
   static const unsigned long  szDst_3C [] = { 0x6BB0, 0x6BA8, 0x7007, 0x6FE7, 0x7061, 0x6FBE, 0x6FC4, } ;

   static const unsigned short szSrc_3D [] = { 0x3D0B, 0x3D89, 0x3DB6, 0x3DBD, 0xFFFF } ;
   static const unsigned long  szDst_3D [] = { 0x6F5A, 0x9E02, 0x71F6, 0x7171, } ;

   static const unsigned short szSrc_3E [] = { 0x3E3F, 0x3E8D, 0x3EC5,  0x3ECF,  0x3ED8, 0xFFFF } ;
   static const unsigned long  szDst_3E [] = { 0x72A2, 0x7371, 0x74AF, 0x24AE9, 0x24ABA, } ;

   static const unsigned short szSrc_40 [] = { 0x4025, 0x4056, 0x40B5, 0x40C5, 0xFFFF } ;
   static const unsigned long  szDst_40 [] = { 0x407B, 0x779C, 0x78BD, 0x78FE, } ;

   static const unsigned short szSrc_41 [] = { 0x4149, 0x415F,  0x416A, 0x41F2, 0xFFFF } ;
   static const unsigned long  szDst_41 [] = { 0x7A0F, 0x7A47, 0x258A2, 0x7B74, } ;

   static const unsigned short szSrc_43 [] = { 0x4336, 0x4337, 0x4338, 0x4339, 0x433A, 0x433B, 0x433C, 0x433D, 0x433E, 0x433F, 0x4340, 0x4341, 0x43AC, 0x43DD, 0xFFFF } ;
   static const unsigned long  szDst_43 [] = { 0x42B7, 0x7D2C, 0x7E33, 0x7D45, 0x42D9, 0x42DA, 0x7D90, 0x7DB5, 0x42FB, 0x42F9, 0x7E7F, 0x7E78, 0x43B1, 0x819E, } ;

   static const unsigned short szSrc_44 [] = { 0x44D5, 0x44D6, 0xFFFF } ;
   static const unsigned long  szDst_44 [] = { 0x85B3, 0x85ED, } ;

   static const unsigned short szSrc_45 [] = { 0x45D6, 0xFFFF } ;
   static const unsigned long  szDst_45 [] = { 0x87AE, } ;

   static const unsigned short szSrc_46 [] = {  0x461B,  0x464A, 0x464C, 0x4653,  0x46D3, 0xFFFF } ;
   static const unsigned long  szDst_46 [] = { 0x2775E, 0x27735, 0x4661, 0x896C, 0x27A7E, } ;

   static const unsigned short szSrc_47 [] = { 0x4723,  0x4725, 0x4727, 0x4729, 0x4759,  0x478C, 0x478D, 0x4790, 0xFFFF } ;
   static const unsigned long  szDst_47 [] = { 0x8A22, 0x27A59, 0x8B45, 0x8B8C, 0x8C99, 0x27D73, 0x477C, 0x8CF0, } ;

   static const unsigned short szSrc_48 [] = {  0x4880,  0x4881,  0x4882, 0xFFFF } ;
   static const unsigned long  szDst_48 [] = { 0x282B0, 0x282B8, 0x282E2, } ;

   static const unsigned short szSrc_49 [] = { 0x497A, 0x497D, 0x497E,  0x497F,  0x4980,  0x4981, 0x4982, 0x4983, 0x4985, 0x4986, 0x49B6, 0x49B7, 0xFFFF } ;
   static const unsigned long  szDst_49 [] = { 0x91FE, 0x93FA, 0x4971, 0x28BC5, 0x289AB, 0x289DC, 0x4947, 0x942F, 0x9425, 0x9481, 0x499B, 0x499F, } ;

   static const unsigned short szSrc_4A [] = { 0x4A44, 0xFFFF } ;
   static const unsigned long  szDst_4A [] = { 0x9766, } ;

   static const unsigned short szSrc_4B [] = {  0x4B6A,  0x4BC3, 0x4BC4, 0x4BC5, 0xFFFF } ;
   static const unsigned long  szDst_4B [] = { 0x297AF, 0x298D1, 0x9A27, 0x4BC0, } ;

   static const unsigned short szSrc_4C [] = { 0x4C9D,  0x4C9E, 0x4C9F, 0x4CA0, 0x4CA1, 0x4CA2, 0x4CA3, 0xFFFF } ;
   static const unsigned long  szDst_4C [] = { 0x4C7D, 0x29D98, 0x9BA3, 0x9C06, 0x9C0C, 0x9C27, 0x4C77, } ;

   static const unsigned short szSrc_4D [] = { 0x4D13, 0x4D14, 0x4D15, 0x4D16, 0x4D17, 0x4D18, 0x4D19, 0x4DAE, 0xFFFF } ;
   static const unsigned long  szDst_4D [] = { 0x9CFE, 0x9D41, 0x9D37, 0x9D84, 0x9DAA, 0x9DC9, 0x9E0A, 0x9F91, } ;

   static const unsigned short szSrc_4F [] = { 0x4F21, 0x4FEB, 0xFFFF } ;
   static const unsigned long  szDst_4F [] = { 0x4FE5, 0x5008, } ;

   static const unsigned short szSrc_50 [] = { 0x50A4, 0xFFFF } ;
   static const unsigned long  szDst_50 [] = { 0x510E, } ;

   static const unsigned short szSrc_52 [] = { 0x522C, 0xFFFF } ;
   static const unsigned long  szDst_52 [] = { 0x5257, } ;

   static const unsigned short szSrc_53 [] = { 0x53C1, 0xFFFF } ;
   static const unsigned long  szDst_53 [] = { 0x53C4, } ;

   static const unsigned short szSrc_54 [] = { 0x549D, 0xFFFF } ;
   static const unsigned long  szDst_54 [] = { 0x565D, } ;

   static const unsigned short szSrc_57 [] = { 0x57AF, 0x57B1, 0x57B4, 0xFFFF } ;
   static const unsigned long  szDst_57 [] = { 0x58B6, 0x58CB, 0x5816, } ;

   static const unsigned short szSrc_58 [] = { 0x5846, 0xFFFF } ;
   static const unsigned long  szDst_58 [] = { 0x58EA, } ;

   static const unsigned short szSrc_5C [] = { 0x5CBD, 0xFFFF } ;
   static const unsigned long  szDst_5C [] = { 0x5D2C, } ;

   static const unsigned short szSrc_5F [] = { 0x5F0E, 0x5F5F, 0x5F68, 0xFFFF } ;
   static const unsigned long  szDst_5F [] = { 0x53C4, 0x5F60, 0x5F72, } ;

   static const unsigned short szSrc_60 [] = { 0x60AE, 0xFFFF } ;
   static const unsigned long  szDst_60 [] = { 0x609E, } ;

   static const unsigned short szSrc_63 [] = { 0x6306, 0xFFFF } ;
   static const unsigned long  szDst_63 [] = { 0x6305, } ;

   static const unsigned short szSrc_65 [] = { 0x6569, 0x6586, 0xFFFF } ;
   static const unsigned long  szDst_65 [] = { 0x6585, 0x6585, } ;

   static const unsigned short szSrc_67 [] = { 0x67A7, 0xFFFF } ;
   static const unsigned long  szDst_67 [] = { 0x6898, } ;

   static const unsigned short szSrc_68 [] = { 0x686A, 0xFFFF } ;
   static const unsigned long  szDst_68 [] = { 0x6A33, } ;

   static const unsigned short szSrc_69 [] = { 0x6985, 0xFFFF } ;
   static const unsigned long  szDst_69 [] = { 0x69B2, } ;

   static const unsigned short szSrc_6E [] = { 0x6E81, 0xFFFF } ;
   static const unsigned long  szDst_6E [] = { 0x6FDA, } ;

   static const unsigned short szSrc_6F [] = { 0x6F9B, 0xFFFF } ;
   static const unsigned long  szDst_6F [] = { 0x7002, } ;

   static const unsigned short szSrc_71 [] = { 0x71F7, 0xFFFF } ;
   static const unsigned long  szDst_71 [] = { 0x71E3, } ;

   static const unsigned short szSrc_72 [] = { 0x72B8, 0xFFFF } ;
   static const unsigned long  szDst_72 [] = { 0x7341, } ;

   static const unsigned short szSrc_75 [] = { 0x75AC, 0x75D6, 0xFFFF } ;
   static const unsigned long  szDst_75 [] = { 0x7667, 0x7602, } ;

   static const unsigned short szSrc_76 [] = { 0x7606, 0x765D, 0xFFFF } ;
   static const unsigned long  szDst_76 [] = { 0x762E, 0x765B, } ;

   static const unsigned short szSrc_77 [] = { 0x770D, 0xFFFF } ;
   static const unsigned long  szDst_77 [] = { 0x7798, } ;

   static const unsigned short szSrc_78 [] = { 0x781C, 0xFFFF } ;
   static const unsigned long  szDst_78 [] = { 0x78B8, } ;

   static const unsigned short szSrc_7C [] = { 0x7C08, 0x7CE4, 0xFFFF } ;
   static const unsigned long  szDst_7C [] = { 0x7BB3, 0x994A, } ;

   static const unsigned short szSrc_7D [] = { 0x7DD5, 0xFFFF } ;
   static const unsigned long  szDst_7D [] = { 0x7E83, } ;

   static const unsigned short szSrc_7E [] = { 0x7E9F, 0x7ED4, 0x7EEC, 0xFFFF } ;
   static const unsigned long  szDst_7E [] = { 0x7CF9, 0x7D5D, 0x7DD3, } ;

   static const unsigned short szSrc_80 [] = { 0x8022, 0x80E8, 0xFFFF } ;
   static const unsigned long  szDst_80 [] = { 0x802E, 0x8156, } ;

   static const unsigned short szSrc_83 [] = { 0x836C, 0x836E, 0xFFFF } ;
   static const unsigned long  szDst_83 [] = { 0x8552, 0x8464, } ;

   static const unsigned short szSrc_85 [] = { 0x85F3, 0xFFFF } ;
   static const unsigned long  szDst_85 [] = { 0x85C1, } ;

   static const unsigned short szSrc_86 [] = { 0x860F, 0x86E7, 0xFFFF } ;
   static const unsigned long  szDst_86 [] = { 0x8614, 0x8744, } ;

   static const unsigned short szSrc_87 [] = { 0x87A8, 0xFFFF } ;
   static const unsigned long  szDst_87 [] = { 0x87CE, } ;

   static const unsigned short szSrc_89 [] = { 0x8999, 0x89C3, 0x89CD, 0xFFFF } ;
   static const unsigned long  szDst_89 [] = { 0x89BC, 0x898E, 0x89A5, } ;

   static const unsigned short szSrc_8B [] = { 0x8BA0, 0x8BBB, 0xFFFF } ;
   static const unsigned long  szDst_8B [] = { 0x8A01, 0x8A29, } ;

   static const unsigned short szSrc_8C [] = { 0x8C51, 0xFFFF } ;
   static const unsigned long  szDst_8C [] = { 0x8C52, } ;

   static const unsigned short szSrc_8D [] = { 0x8D20, 0xFFFF } ;
   static const unsigned long  szDst_8D [] = { 0x8C9F, } ;

   static const unsigned short szSrc_8F [] = { 0x8F71, 0x8F77, 0xFFFF } ;
   static const unsigned long  szDst_8F [] = { 0x8EF2, 0x8EE4, } ;

   static const unsigned short szSrc_91 [] = { 0x91FC, 0xFFFF } ;
   static const unsigned long  szDst_91 [] = { 0x91F0, } ;

   static const unsigned short szSrc_94 [] = { 0x9485, 0x948E, 0x949A, 0x94B7, 0x94D8, 0x94DE, 0xFFFF } ;
   static const unsigned long  szDst_94 [] = { 0x91D2, 0x91FA, 0x9208, 0x9255, 0x92E3, 0x92B1, } ;

   static const unsigned short szSrc_95 [] = { 0x9503, 0x950D, 0x950E, 0x950F, 0x9518, 0x951D, 0x952A, 0x952B, 0x9533, 0x953F, 0x9545, 0x954E, 0x9565, 0x9569, 0x9572, 0xFFFF } ;
   static const unsigned long  szDst_95 [] = { 0x92E5, 0x92F6, 0x9426, 0x9427, 0x9369, 0x9340, 0x9343, 0x9307, 0x9348, 0x9384, 0x9387, 0x93BF, 0x9465, 0x9479, 0x9454, } ;

   static const unsigned short szSrc_96 [] = { 0x9666, 0xFFFF } ;
   static const unsigned long  szDst_96 [] = { 0x96AF, } ;

   static const unsigned short szSrc_97 [] = { 0x973B, 0x9754, 0x9792, 0xFFFF } ;
   static const unsigned long  szDst_97 [] = { 0x974A, 0x975D, 0x97BD, } ;

   static const unsigned short szSrc_98 [] = { 0x9892, 0x98A5, 0x98DA, 0xFFFF } ;
   static const unsigned long  szDst_98 [] = { 0x982E, 0x986C, 0x98C8, } ;

   static const unsigned short szSrc_99 [] = { 0x9963, 0x9973, 0x9978, 0x9979, 0x997B, 0x9983, 0x9987, 0x9989, 0x9993, 0x9995, 0xFFFF } ;
   static const unsigned long  szDst_99 [] = { 0x98E0, 0x98FF, 0x9904, 0x990E, 0x990F, 0x991C, 0x9937, 0x9936, 0x994A, 0x9962, } ;

   static const unsigned short szSrc_9B [] = { 0x9B36, 0x9BF5, 0xFFFF } ;
   static const unsigned long  szDst_9B [] = { 0x9B39, 0x9C3A, } ;

   static const unsigned short szSrc_9C [] = { 0x9C1B, 0x9C7E, 0x9C83, 0x9C85, 0x9C86, 0x9C87, 0x9C89, 0x9C8C, 0x9C8F, 0x9C93, 0x9C97, 0x9C98, 0x9C9D, 0x9CAC, 0x9CB4, 0x9CB9, 0x9CBA, 0x9CBC, 0x9CBE, 0x9CC1, 0x9CC2, 0x9CC8, 0x9CC9, 0x9CCA, 0x9CCB, 0x9CD1, 0x9CD8, 0x9CD9, 0x9CDA, 0x9CE0, 0x9CE1, 0x9CE4, 0xFFFF } ;
   static const unsigned long  szDst_9C [] = { 0x9C2E, 0x9B62, 0x4C3E, 0x9B81, 0x9B83, 0x9B8E, 0x9B8B, 0x9B8A, 0x9B8D, 0x9BB3, 0x9C02, 0x9B9C, 0x9BBA, 0x9BD2, 0x9BDD, 0x9C3A, 0x9BF4, 0x9C5D, 0x9C0F, 0x9C2E, 0x9C03, 0x9C01, 0x9C42, 0x9BFF, 0x9C20, 0x9C1F, 0x9C35, 0x9C45, 0x4C81, 0x9C6F, 0x9C64, 0x4C98, } ;

   static const unsigned short szSrc_9E [] = { 0x9E3B, 0x9E40, 0x9E4B, 0x9E50, 0x9E5B, 0x9E6E, 0x9E71, 0x9E74, 0xFFFF } ;
   static const unsigned long  szDst_9E [] = { 0x9D34, 0x9D50, 0x9D93, 0x9D6E, 0x9DA5, 0x4D09, 0x9E0C, 0x9E18, } ;

   static const unsigned short szSrc_9F [] = { 0x9F0C, 0xFFFF } ;
   static const unsigned long  szDst_9F [] = { 0x9F02, } ;

   static const unsigned short szSrc_201 [] = {  0x01BF, 0xFFFF } ;
   static const unsigned long  szDst_201 [] = { 0x20325, } ;

   static const unsigned short szSrc_202 [] = { 0x0242, 0x02C2, 0xFFFF } ;
   static const unsigned long  szDst_202 [] = { 0x3493, 0x5133, } ;

   static const unsigned short szSrc_206 [] = { 0x06C5,  0x06C6, 0xFFFF } ;
   static const unsigned long  szDst_206 [] = { 0x527E, 0x20786, } ;

   static const unsigned short szSrc_20B [] = { 0x0BB6, 0x0BDF, 0x0BE0, 0xFFFF } ;
   static const unsigned long  szDst_20B [] = { 0x55F0, 0x54EF, 0x5645, } ;

   static const unsigned short szSrc_20C [] = {  0x0C1A, 0xFFFF } ;
   static const unsigned long  szDst_20C [] = { 0x21060, } ;

   static const unsigned short szSrc_21D [] = { 0x1D4C, 0x1DB4, 0xFFFF } ;
   static const unsigned long  szDst_21D [] = { 0x5DAC, 0x5D7C, } ;

   static const unsigned short szSrc_21E [] = {  0x1E03, 0x1E83, 0x1E84, 0xFFFF } ;
   static const unsigned long  szDst_21E [] = { 0x21F57, 0x5D88, 0x5D98, } ;

   static const unsigned short szSrc_222 [] = { 0x22C8, 0xFFFF } ;
   static const unsigned long  szDst_222 [] = { 0x389D, } ;

   static const unsigned short szSrc_226 [] = {  0x2619,  0x261D,  0x261E, 0x264F, 0x2650, 0x2651, 0x2652, 0x2653, 0x26EF, 0xFFFF } ;
   static const unsigned long  szDst_226 [] = { 0x22931, 0x228DA, 0x228ED, 0x613B, 0x61B9, 0x3D4B, 0x61A2, 0x61C0, 0x398E, } ;

   static const unsigned short szSrc_228 [] = { 0x2801, 0xFFFF } ;
   static const unsigned long  szDst_228 [] = { 0x61CE, } ;

   static const unsigned short szSrc_232 [] = {  0x3223, 0xFFFF } ;
   static const unsigned long  szDst_232 [] = { 0x232CB, } ;

   static const unsigned short szSrc_233 [] = { 0x336F, 0x3370, 0x3391, 0x33E2, 0xFFFF } ;
   static const unsigned long  szDst_233 [] = { 0x816A, 0x8125, 0x81D7, 0x69EB, } ;

   static const unsigned short szSrc_234 [] = { 0x3415, 0x348C, 0xFFFF } ;
   static const unsigned long  szDst_234 [] = { 0x6871, 0x6947, } ;

   static const unsigned short szSrc_235 [] = { 0x35CA, 0x35CB, 0xFFFF } ;
   static const unsigned long  szDst_235 [] = { 0x6A20, 0x6203, } ;

   static const unsigned short szSrc_236 [] = { 0x3634,  0x3637, 0xFFFF } ;
   static const unsigned long  szDst_236 [] = { 0x6AAD, 0x23755, } ;

   static const unsigned short szSrc_23A [] = { 0x3A3C, 0xFFFF } ;
   static const unsigned long  szDst_23A [] = { 0x6BA2, } ;

   static const unsigned short szSrc_23B [] = {  0x3B64,  0x3BE3, 0xFFFF } ;
   static const unsigned long  szDst_23B [] = { 0x23BF4, 0x23BE9, } ;

   static const unsigned short szSrc_23C [] = { 0x3C5D, 0x3C97, 0x3C98, 0x3CC6, 0xFFFF } ;
   static const unsigned long  szDst_23C [] = { 0x6C2D, 0x6E4B, 0x6F55, 0x3D57, } ;

   static const unsigned short szSrc_23D [] = { 0x3DA9,  0x3DAB, 0xFFFF } ;
   static const unsigned long  szDst_23D [] = { 0x6F85, 0x23FC9, } ;

   static const unsigned short szSrc_23E [] = { 0x3E23, 0xFFFF } ;
   static const unsigned long  szDst_23E [] = { 0x6FC6, } ;

   static const unsigned short szSrc_23F [] = { 0x3F77, 0xFFFF } ;
   static const unsigned long  szDst_23F [] = { 0x7003, } ;

   static const unsigned short szSrc_241 [] = { 0x4193, 0x41A1, 0x41C3, 0x41C4, 0x41ED, 0x41F9, 0xFFFF } ;
   static const unsigned long  szDst_241 [] = { 0x720C, 0x7193, 0x7204, 0x718C, 0x7216, 0x719A, } ;

   static const unsigned short szSrc_242 [] = { 0x4236, 0x4237, 0xFFFF } ;
   static const unsigned long  szDst_242 [] = { 0x7189, 0x3DFF, } ;

   static const unsigned short szSrc_243 [] = {  0x43BA,  0x43BB, 0xFFFF } ;
   static const unsigned long  szDst_243 [] = { 0x244CE, 0x24473, } ;

   static const unsigned short szSrc_246 [] = {  0x466F, 0xFFFF } ;
   static const unsigned long  szDst_246 [] = { 0x246EE, } ;

   static const unsigned short szSrc_247 [] = {  0x4762, 0x4783, 0x47A4, 0xFFFF } ;
   static const unsigned long  szDst_247 [] = { 0x2489F, 0x7369, 0x7381, } ;

   static const unsigned short szSrc_24D [] = {  0x4DA7, 0xFFFF } ;
   static const unsigned long  szDst_24D [] = { 0x24E2B, } ;

   static const unsigned short szSrc_24E [] = { 0x4E1C, 0x4ECA, 0xFFFF } ;
   static const unsigned long  szDst_24E [] = { 0x7662, 0x3FD7, } ;

   static const unsigned short szSrc_24F [] = { 0x4F80, 0xFFFF } ;
   static const unsigned long  szDst_24F [] = { 0x769F, } ;

   static const unsigned short szSrc_250 [] = { 0x5062, 0xFFFF } ;
   static const unsigned long  szDst_250 [] = { 0x4009, } ;

   static const unsigned short szSrc_251 [] = { 0x51A7, 0x51E2, 0xFFFF } ;
   static const unsigned long  szDst_251 [] = { 0x77A4, 0x406A, } ;

   static const unsigned short szSrc_253 [] = { 0x539D, 0xFFFF } ;
   static const unsigned long  szDst_253 [] = { 0x408E, } ;

   static const unsigned short szSrc_254 [] = { 0x543B, 0xFFFF } ;
   static const unsigned long  szDst_254 [] = { 0x7899, } ;

   static const unsigned short szSrc_259 [] = {  0x59C2, 0xFFFF } ;
   static const unsigned long  szDst_259 [] = { 0x25A10, } ;

   static const unsigned short szSrc_25B [] = { 0x5B1E, 0x5B20, 0xFFFF } ;
   static const unsigned long  szDst_25B [] = { 0x7C4B, 0x7BD8, } ;

   static const unsigned short szSrc_262 [] = {  0x6208, 0x6209, 0x620B, 0x620C, 0x620E, 0x620F, 0x6210, 0x6211,  0x6212, 0x6213, 0x6214, 0x6215, 0x6216,  0x6217, 0x6218, 0x6219, 0x621A, 0x621B, 0x621C, 0x621D, 0x621E, 0x621F, 0x6220, 0x6221, 0xFFFF } ;
   static const unsigned long  szDst_262 [] = { 0x25FCA, 0x7DF7, 0x7D87, 0x7D80, 0x7E5F, 0x7DCD, 0x7E3A, 0x7DF8, 0x26085, 0x42FF, 0x7E0E, 0x7DF0, 0x4308, 0x260C4, 0x430B, 0x4330, 0x7E2C, 0x7E53, 0x4316, 0x7E4F, 0x431F, 0x431D, 0x4325, 0x7E7B, } ;

   static const unsigned short szSrc_263 [] = { 0x6360, 0xFFFF } ;
   static const unsigned long  szDst_263 [] = { 0x437D, } ;

   static const unsigned short szSrc_26A [] = {  0x6A29, 0xFFFF } ;
   static const unsigned long  szDst_26A [] = { 0x26ABD, } ;

   static const unsigned short szSrc_26D [] = { 0x6D9F, 0xFFFF } ;
   static const unsigned long  szDst_26D [] = { 0x7207, } ;

   static const unsigned short szSrc_272 [] = {  0x72B6, 0xFFFF } ;
   static const unsigned long  szDst_272 [] = { 0x272B1, } ;

   static const unsigned short szSrc_273 [] = { 0x73D6, 0x73D7, 0xFFFF } ;
   static const unsigned long  szDst_273 [] = { 0x8819, 0x8800, } ;

   static const unsigned short szSrc_274 [] = {  0x74AD, 0xFFFF } ;
   static const unsigned long  szDst_274 [] = { 0x27525, } ;

   static const unsigned short szSrc_277 [] = { 0x775D, 0xFFFF } ;
   static const unsigned long  szDst_277 [] = { 0x8970, } ;

   static const unsigned short szSrc_27B [] = { 0x7BAA, 0xFFFF } ;
   static const unsigned long  szDst_27B [] = { 0x8A40, } ;

   static const unsigned short szSrc_27E [] = { 0x7E51,  0x7E53, 0x7E55, 0x7E56, 0x7E57, 0xFFFF } ;
   static const unsigned long  szDst_27E [] = { 0x4788, 0x27D94, 0x477B, 0x8CDF, 0x8D03, } ;

   static const unsigned short szSrc_27F [] = {  0x7FC8, 0xFFFF } ;
   static const unsigned long  szDst_27F [] = { 0x281C1, } ;

   static const unsigned short szSrc_280 [] = { 0x8001,  0x8074,  0x80BA, 0xFFFF } ;
   static const unsigned long  szDst_280 [] = { 0x8E98, 0x2814D, 0x2820A, } ;

   static const unsigned short szSrc_281 [] = {  0x8104, 0x816C, 0xFFFF } ;
   static const unsigned long  szDst_281 [] = { 0x2820C, 0x8E9D, } ;

   static const unsigned short szSrc_284 [] = { 0x8405,  0x8406,  0x8407, 0x8408,  0x8409,  0x840A, 0xFFFF } ;
   static const unsigned long  szDst_284 [] = { 0x8ED7, 0x282BB, 0x283E0, 0x8F04, 0x283AE, 0x283E5, } ;

   static const unsigned short szSrc_288 [] = {  0x8828,  0x8859,  0x887A, 0xFFFF } ;
   static const unsigned long  szDst_288 [] = { 0x288E7, 0x288BF, 0x288C8, } ;

   static const unsigned short szSrc_289 [] = { 0x89EE, 0xFFFF } ;
   static const unsigned long  szDst_289 [] = { 0x4978, } ;

   static const unsigned short szSrc_28C [] = { 0x8C3E, 0x8C3F,  0x8C40, 0x8C41, 0x8C42, 0x8C43, 0x8C44, 0x8C45, 0x8C47, 0x8C48, 0x8C49,  0x8C4A, 0x8C4B, 0x8C4C, 0x8C4D, 0x8C4E, 0x8C4F,  0x8C50, 0x8C51, 0x8C52, 0x8C53, 0x8C54,  0x8C55, 0x8C56, 0xFFFF } ;
   static const unsigned long  szDst_28C [] = { 0x93B7, 0x91F3, 0x2895B, 0x9220, 0x920B, 0x9232, 0x922F, 0x9241, 0x92B6, 0x92C9, 0x9344, 0x289F1, 0x92D1, 0x93C6, 0x93AF, 0x936E, 0x939D, 0x28AD2, 0x9404, 0x93C9, 0x940E, 0x940F, 0x28B82, 0x4969, } ;

   static const unsigned short szSrc_28D [] = { 0x8DFF, 0xFFFF } ;
   static const unsigned long  szDst_28D [] = { 0x49B3, } ;

   static const unsigned short szSrc_28E [] = {  0x8E00,  0x8E01, 0x8E02, 0x8E03, 0x8E04,  0x8E05,  0x8E06,  0x8E07,  0x8E09,  0x8E0A,  0x8E0B,  0x8E0C,  0x8E0E,  0x8E44, 0xFFFF } ;
   static const unsigned long  szDst_28E [] = { 0x28CD5, 0x28CD1, 0x958D, 0x9590, 0x4998, 0x28D17, 0x28D69, 0x28D78, 0x28D80, 0x28D8F, 0x28DB2, 0x28DAE, 0x28DF2, 0x28E43, } ;

   static const unsigned short szSrc_293 [] = { 0x93FC,  0x93FD,  0x93FE, 0x93FF, 0xFFFF } ;
   static const unsigned long  szDst_293 [] = { 0x4A8F, 0x293EA, 0x293A2, 0x4A98, } ;

   static const unsigned short szSrc_294 [] = { 0x9400, 0xFFFF } ;
   static const unsigned long  szDst_294 [] = { 0x4A97, } ;

   static const unsigned short szSrc_295 [] = {  0x9595, 0x9596, 0x9597, 0xFFFF } ;
   static const unsigned long  szDst_295 [] = { 0x294E3, 0x9843, 0x4AF4, } ;

   static const unsigned short szSrc_296 [] = { 0x9665,  0x9666, 0x9667,  0x9668,  0x9669, 0x966A, 0x966B,  0x966C,  0x966D, 0x966E, 0x966F,  0x9670, 0xFFFF } ;
   static const unsigned long  szDst_296 [] = { 0x98B0, 0x295C0, 0x4B1E, 0x29639, 0x29600, 0x98B7, 0x98BE, 0x2963A, 0x2961D, 0x4B18, 0x4B1D, 0x29648, } ;

   static const unsigned short szSrc_297 [] = {  0x97FF, 0xFFFF } ;
   static const unsigned long  szDst_297 [] = { 0x2969B, } ;

   static const unsigned short szSrc_298 [] = {  0x9800,  0x9801,  0x9802,  0x9803,  0x9805,  0x9806, 0x9807, 0x9808,  0x9809,  0x980A,  0x980B, 0x980C,  0x980E,  0x980F,  0x9856, 0xFFFF } ;
   static const unsigned long  szDst_298 [] = { 0x296A5, 0x296B5, 0x296C6, 0x296E9, 0x297B1, 0x29726, 0x4B40, 0x4B43, 0x29707, 0x29735, 0x29754, 0x9938, 0x29784, 0x297A6, 0x29863, } ;

   static const unsigned short szSrc_299 [] = {  0x99E6, 0x99E8,  0x99E9, 0x99EA, 0x99EB,  0x99EC, 0x99ED,  0x99EE, 0x99EF, 0x99F0,  0x99F1, 0x99F2,  0x99F3, 0x99F4,  0x99F5,  0x99F6, 0x99FA,  0x99FB,  0x99FC, 0x99FF, 0xFFFF } ;
   static const unsigned long  szDst_299 [] = { 0x2987A, 0x99CE, 0x2990A, 0x4BBE, 0x99DA, 0x298A1, 0x4B7F, 0x298BE, 0x9A4B, 0x4B9D, 0x29949, 0x99E7, 0x298B8, 0x99E9, 0x298B4, 0x298CF, 0x99F6, 0x298F5, 0x298FA, 0x4BA0, } ;

   static const unsigned short szSrc_29A [] = { 0x9A00, 0x9A01, 0x9A02, 0x9A03, 0x9A04,  0x9A05,  0x9A06, 0x9A07, 0x9A08,  0x9A09, 0x9A0A,  0x9A0B,  0x9A0C,  0x9A0D, 0x9A0F,  0x9A10, 0x9A48, 0xFFFF } ;
   static const unsigned long  szDst_29A [] = { 0x9A14, 0x4B9E, 0x9A44, 0x9A1D, 0x9A2A, 0x29938, 0x29919, 0x4BAB, 0x9A1F, 0x29932, 0x9A1A, 0x29944, 0x29951, 0x29947, 0x4BB3, 0x299C6, 0x4BE4, } ;

   static const unsigned short szSrc_29B [] = {  0x9B23,  0x9B24,  0x9B3E, 0x9BD2, 0xFFFF } ;
   static const unsigned long  szDst_29B [] = { 0x29B59, 0x29C00, 0x29B6F, 0x4C16, } ;

   static const unsigned short szSrc_29C [] = {  0x9C30,  0x9C92, 0xFFFF } ;
   static const unsigned long  szDst_29C [] = { 0x29C39, 0x29CE4, } ;

   static const unsigned short szSrc_29D [] = {  0x9D0C, 0xFFFF } ;
   static const unsigned long  szDst_29D [] = { 0x29D35, } ;

   static const unsigned short szSrc_29F [] = { 0x9F79,  0x9F7A,  0x9F7B, 0x9F7C,  0x9F7D, 0x9F7E,  0x9F7F, 0x9F81, 0x9F82, 0x9F83,  0x9F84,  0x9F85,  0x9F86, 0x9F87, 0x9F88, 0x9F8A, 0x9F8B, 0x9F8C,  0x9F8E, 0xFFFF } ;
   static const unsigned long  szDst_29F [] = { 0x9B65, 0x29D69, 0x29D79, 0x9BF6, 0x29DB1, 0x9B9F, 0x29DB0, 0x9BC4, 0x4C96, 0x9BB8, 0x29DF0, 0x29E03, 0x29E26, 0x9BF1, 0x4C59, 0x4C6C, 0x4C70, 0x9C47, 0x29F47, } ;

   static const unsigned short szSrc_2A2 [] = { 0xA242, 0xA243,  0xA244,  0xA245, 0xA246, 0xA248,  0xA249, 0xA24A,  0xA24B,  0xA24C, 0xA24D,  0xA24E,  0xA24F,  0xA250, 0xA251,  0xA252,  0xA253,  0xA254,  0xA255, 0xFFFF } ;
   static const unsigned long  szDst_2A2 [] = { 0x4CB0, 0x9CFC, 0x29FEA, 0x2A026, 0x9D32, 0x9D1C, 0x2A048, 0x9DE8, 0x2A03E, 0x2A056, 0x9D5A, 0x2A086, 0x2A0CF, 0x2A0CD, 0x9DD4, 0x2A115, 0x2A23C, 0x2A106, 0x2A1F3, } ;

   static const unsigned short szSrc_2A3 [] = { 0xA388, 0xA389, 0xA38A, 0xA38B, 0xFFFF } ;
   static const unsigned long  szDst_2A3 [] = { 0x4D2C, 0x9EB2, 0x9EA8, 0x4D34, } ;

   static const unsigned short szSrc_2A4 [] = { 0xA445, 0xFFFF } ;
   static const unsigned long  szDst_2A4 [] = { 0x4D73, } ;

   static const unsigned short szSrc_2A5 [] = {  0xA52D, 0xFFFF } ;
   static const unsigned long  szDst_2A5 [] = { 0x2A535, } ;

   static const unsigned short szSrc_2A6 [] = {  0xA68F,  0xA690, 0xFFFF } ;
   static const unsigned long  szDst_2A6 [] = { 0x2A600, 0x2A62F, } ;


   const unsigned short *szSrc ;
   const unsigned long *szDst ;

   switch ( cUnicode >> 8 ) {
      case 0x34 :
         szSrc = szSrc_34 ;
         szDst = szDst_34 ;
         break ;
      case 0x35 :
         szSrc = szSrc_35 ;
         szDst = szDst_35 ;
         break ;
      case 0x36 :
         szSrc = szSrc_36 ;
         szDst = szDst_36 ;
         break ;
      case 0x37 :
         szSrc = szSrc_37 ;
         szDst = szDst_37 ;
         break ;
      case 0x38 :
         szSrc = szSrc_38 ;
         szDst = szDst_38 ;
         break ;
      case 0x39 :
         szSrc = szSrc_39 ;
         szDst = szDst_39 ;
         break ;
      case 0x3A :
         szSrc = szSrc_3A ;
         szDst = szDst_3A ;
         break ;
      case 0x3B :
         szSrc = szSrc_3B ;
         szDst = szDst_3B ;
         break ;
      case 0x3C :
         szSrc = szSrc_3C ;
         szDst = szDst_3C ;
         break ;
      case 0x3D :
         szSrc = szSrc_3D ;
         szDst = szDst_3D ;
         break ;
      case 0x3E :
         szSrc = szSrc_3E ;
         szDst = szDst_3E ;
         break ;
      case 0x40 :
         szSrc = szSrc_40 ;
         szDst = szDst_40 ;
         break ;
      case 0x41 :
         szSrc = szSrc_41 ;
         szDst = szDst_41 ;
         break ;
      case 0x43 :
         szSrc = szSrc_43 ;
         szDst = szDst_43 ;
         break ;
      case 0x44 :
         szSrc = szSrc_44 ;
         szDst = szDst_44 ;
         break ;
      case 0x45 :
         szSrc = szSrc_45 ;
         szDst = szDst_45 ;
         break ;
      case 0x46 :
         szSrc = szSrc_46 ;
         szDst = szDst_46 ;
         break ;
      case 0x47 :
         szSrc = szSrc_47 ;
         szDst = szDst_47 ;
         break ;
      case 0x48 :
         szSrc = szSrc_48 ;
         szDst = szDst_48 ;
         break ;
      case 0x49 :
         szSrc = szSrc_49 ;
         szDst = szDst_49 ;
         break ;
      case 0x4A :
         szSrc = szSrc_4A ;
         szDst = szDst_4A ;
         break ;
      case 0x4B :
         szSrc = szSrc_4B ;
         szDst = szDst_4B ;
         break ;
      case 0x4C :
         szSrc = szSrc_4C ;
         szDst = szDst_4C ;
         break ;
      case 0x4D :
         szSrc = szSrc_4D ;
         szDst = szDst_4D ;
         break ;
      case 0x4F :
         szSrc = szSrc_4F ;
         szDst = szDst_4F ;
         break ;
      case 0x50 :
         szSrc = szSrc_50 ;
         szDst = szDst_50 ;
         break ;
      case 0x52 :
         szSrc = szSrc_52 ;
         szDst = szDst_52 ;
         break ;
      case 0x53 :
         szSrc = szSrc_53 ;
         szDst = szDst_53 ;
         break ;
      case 0x54 :
         szSrc = szSrc_54 ;
         szDst = szDst_54 ;
         break ;
      case 0x57 :
         szSrc = szSrc_57 ;
         szDst = szDst_57 ;
         break ;
      case 0x58 :
         szSrc = szSrc_58 ;
         szDst = szDst_58 ;
         break ;
      case 0x5C :
         szSrc = szSrc_5C ;
         szDst = szDst_5C ;
         break ;
      case 0x5F :
         szSrc = szSrc_5F ;
         szDst = szDst_5F ;
         break ;
      case 0x60 :
         szSrc = szSrc_60 ;
         szDst = szDst_60 ;
         break ;
      case 0x63 :
         szSrc = szSrc_63 ;
         szDst = szDst_63 ;
         break ;
      case 0x65 :
         szSrc = szSrc_65 ;
         szDst = szDst_65 ;
         break ;
      case 0x67 :
         szSrc = szSrc_67 ;
         szDst = szDst_67 ;
         break ;
      case 0x68 :
         szSrc = szSrc_68 ;
         szDst = szDst_68 ;
         break ;
      case 0x69 :
         szSrc = szSrc_69 ;
         szDst = szDst_69 ;
         break ;
      case 0x6E :
         szSrc = szSrc_6E ;
         szDst = szDst_6E ;
         break ;
      case 0x6F :
         szSrc = szSrc_6F ;
         szDst = szDst_6F ;
         break ;
      case 0x71 :
         szSrc = szSrc_71 ;
         szDst = szDst_71 ;
         break ;
      case 0x72 :
         szSrc = szSrc_72 ;
         szDst = szDst_72 ;
         break ;
      case 0x75 :
         szSrc = szSrc_75 ;
         szDst = szDst_75 ;
         break ;
      case 0x76 :
         szSrc = szSrc_76 ;
         szDst = szDst_76 ;
         break ;
      case 0x77 :
         szSrc = szSrc_77 ;
         szDst = szDst_77 ;
         break ;
      case 0x78 :
         szSrc = szSrc_78 ;
         szDst = szDst_78 ;
         break ;
      case 0x7C :
         szSrc = szSrc_7C ;
         szDst = szDst_7C ;
         break ;
      case 0x7D :
         szSrc = szSrc_7D ;
         szDst = szDst_7D ;
         break ;
      case 0x7E :
         szSrc = szSrc_7E ;
         szDst = szDst_7E ;
         break ;
      case 0x80 :
         szSrc = szSrc_80 ;
         szDst = szDst_80 ;
         break ;
      case 0x83 :
         szSrc = szSrc_83 ;
         szDst = szDst_83 ;
         break ;
      case 0x85 :
         szSrc = szSrc_85 ;
         szDst = szDst_85 ;
         break ;
      case 0x86 :
         szSrc = szSrc_86 ;
         szDst = szDst_86 ;
         break ;
      case 0x87 :
         szSrc = szSrc_87 ;
         szDst = szDst_87 ;
         break ;
      case 0x89 :
         szSrc = szSrc_89 ;
         szDst = szDst_89 ;
         break ;
      case 0x8B :
         szSrc = szSrc_8B ;
         szDst = szDst_8B ;
         break ;
      case 0x8C :
         szSrc = szSrc_8C ;
         szDst = szDst_8C ;
         break ;
      case 0x8D :
         szSrc = szSrc_8D ;
         szDst = szDst_8D ;
         break ;
      case 0x8F :
         szSrc = szSrc_8F ;
         szDst = szDst_8F ;
         break ;
      case 0x91 :
         szSrc = szSrc_91 ;
         szDst = szDst_91 ;
         break ;
      case 0x94 :
         szSrc = szSrc_94 ;
         szDst = szDst_94 ;
         break ;
      case 0x95 :
         szSrc = szSrc_95 ;
         szDst = szDst_95 ;
         break ;
      case 0x96 :
         szSrc = szSrc_96 ;
         szDst = szDst_96 ;
         break ;
      case 0x97 :
         szSrc = szSrc_97 ;
         szDst = szDst_97 ;
         break ;
      case 0x98 :
         szSrc = szSrc_98 ;
         szDst = szDst_98 ;
         break ;
      case 0x99 :
         szSrc = szSrc_99 ;
         szDst = szDst_99 ;
         break ;
      case 0x9B :
         szSrc = szSrc_9B ;
         szDst = szDst_9B ;
         break ;
      case 0x9C :
         szSrc = szSrc_9C ;
         szDst = szDst_9C ;
         break ;
      case 0x9E :
         szSrc = szSrc_9E ;
         szDst = szDst_9E ;
         break ;
      case 0x9F :
         szSrc = szSrc_9F ;
         szDst = szDst_9F ;
         break ;
      case 0x201 :
         szSrc = szSrc_201 ;
         szDst = szDst_201 ;
         break ;
      case 0x202 :
         szSrc = szSrc_202 ;
         szDst = szDst_202 ;
         break ;
      case 0x206 :
         szSrc = szSrc_206 ;
         szDst = szDst_206 ;
         break ;
      case 0x20B :
         szSrc = szSrc_20B ;
         szDst = szDst_20B ;
         break ;
      case 0x20C :
         szSrc = szSrc_20C ;
         szDst = szDst_20C ;
         break ;
      case 0x21D :
         szSrc = szSrc_21D ;
         szDst = szDst_21D ;
         break ;
      case 0x21E :
         szSrc = szSrc_21E ;
         szDst = szDst_21E ;
         break ;
      case 0x222 :
         szSrc = szSrc_222 ;
         szDst = szDst_222 ;
         break ;
      case 0x226 :
         szSrc = szSrc_226 ;
         szDst = szDst_226 ;
         break ;
      case 0x228 :
         szSrc = szSrc_228 ;
         szDst = szDst_228 ;
         break ;
      case 0x232 :
         szSrc = szSrc_232 ;
         szDst = szDst_232 ;
         break ;
      case 0x233 :
         szSrc = szSrc_233 ;
         szDst = szDst_233 ;
         break ;
      case 0x234 :
         szSrc = szSrc_234 ;
         szDst = szDst_234 ;
         break ;
      case 0x235 :
         szSrc = szSrc_235 ;
         szDst = szDst_235 ;
         break ;
      case 0x236 :
         szSrc = szSrc_236 ;
         szDst = szDst_236 ;
         break ;
      case 0x23A :
         szSrc = szSrc_23A ;
         szDst = szDst_23A ;
         break ;
      case 0x23B :
         szSrc = szSrc_23B ;
         szDst = szDst_23B ;
         break ;
      case 0x23C :
         szSrc = szSrc_23C ;
         szDst = szDst_23C ;
         break ;
      case 0x23D :
         szSrc = szSrc_23D ;
         szDst = szDst_23D ;
         break ;
      case 0x23E :
         szSrc = szSrc_23E ;
         szDst = szDst_23E ;
         break ;
      case 0x23F :
         szSrc = szSrc_23F ;
         szDst = szDst_23F ;
         break ;
      case 0x241 :
         szSrc = szSrc_241 ;
         szDst = szDst_241 ;
         break ;
      case 0x242 :
         szSrc = szSrc_242 ;
         szDst = szDst_242 ;
         break ;
      case 0x243 :
         szSrc = szSrc_243 ;
         szDst = szDst_243 ;
         break ;
      case 0x246 :
         szSrc = szSrc_246 ;
         szDst = szDst_246 ;
         break ;
      case 0x247 :
         szSrc = szSrc_247 ;
         szDst = szDst_247 ;
         break ;
      case 0x24D :
         szSrc = szSrc_24D ;
         szDst = szDst_24D ;
         break ;
      case 0x24E :
         szSrc = szSrc_24E ;
         szDst = szDst_24E ;
         break ;
      case 0x24F :
         szSrc = szSrc_24F ;
         szDst = szDst_24F ;
         break ;
      case 0x250 :
         szSrc = szSrc_250 ;
         szDst = szDst_250 ;
         break ;
      case 0x251 :
         szSrc = szSrc_251 ;
         szDst = szDst_251 ;
         break ;
      case 0x253 :
         szSrc = szSrc_253 ;
         szDst = szDst_253 ;
         break ;
      case 0x254 :
         szSrc = szSrc_254 ;
         szDst = szDst_254 ;
         break ;
      case 0x259 :
         szSrc = szSrc_259 ;
         szDst = szDst_259 ;
         break ;
      case 0x25B :
         szSrc = szSrc_25B ;
         szDst = szDst_25B ;
         break ;
      case 0x262 :
         szSrc = szSrc_262 ;
         szDst = szDst_262 ;
         break ;
      case 0x263 :
         szSrc = szSrc_263 ;
         szDst = szDst_263 ;
         break ;
      case 0x26A :
         szSrc = szSrc_26A ;
         szDst = szDst_26A ;
         break ;
      case 0x26D :
         szSrc = szSrc_26D ;
         szDst = szDst_26D ;
         break ;
      case 0x272 :
         szSrc = szSrc_272 ;
         szDst = szDst_272 ;
         break ;
      case 0x273 :
         szSrc = szSrc_273 ;
         szDst = szDst_273 ;
         break ;
      case 0x274 :
         szSrc = szSrc_274 ;
         szDst = szDst_274 ;
         break ;
      case 0x277 :
         szSrc = szSrc_277 ;
         szDst = szDst_277 ;
         break ;
      case 0x27B :
         szSrc = szSrc_27B ;
         szDst = szDst_27B ;
         break ;
      case 0x27E :
         szSrc = szSrc_27E ;
         szDst = szDst_27E ;
         break ;
      case 0x27F :
         szSrc = szSrc_27F ;
         szDst = szDst_27F ;
         break ;
      case 0x280 :
         szSrc = szSrc_280 ;
         szDst = szDst_280 ;
         break ;
      case 0x281 :
         szSrc = szSrc_281 ;
         szDst = szDst_281 ;
         break ;
      case 0x284 :
         szSrc = szSrc_284 ;
         szDst = szDst_284 ;
         break ;
      case 0x288 :
         szSrc = szSrc_288 ;
         szDst = szDst_288 ;
         break ;
      case 0x289 :
         szSrc = szSrc_289 ;
         szDst = szDst_289 ;
         break ;
      case 0x28C :
         szSrc = szSrc_28C ;
         szDst = szDst_28C ;
         break ;
      case 0x28D :
         szSrc = szSrc_28D ;
         szDst = szDst_28D ;
         break ;
      case 0x28E :
         szSrc = szSrc_28E ;
         szDst = szDst_28E ;
         break ;
      case 0x293 :
         szSrc = szSrc_293 ;
         szDst = szDst_293 ;
         break ;
      case 0x294 :
         szSrc = szSrc_294 ;
         szDst = szDst_294 ;
         break ;
      case 0x295 :
         szSrc = szSrc_295 ;
         szDst = szDst_295 ;
         break ;
      case 0x296 :
         szSrc = szSrc_296 ;
         szDst = szDst_296 ;
         break ;
      case 0x297 :
         szSrc = szSrc_297 ;
         szDst = szDst_297 ;
         break ;
      case 0x298 :
         szSrc = szSrc_298 ;
         szDst = szDst_298 ;
         break ;
      case 0x299 :
         szSrc = szSrc_299 ;
         szDst = szDst_299 ;
         break ;
      case 0x29A :
         szSrc = szSrc_29A ;
         szDst = szDst_29A ;
         break ;
      case 0x29B :
         szSrc = szSrc_29B ;
         szDst = szDst_29B ;
         break ;
      case 0x29C :
         szSrc = szSrc_29C ;
         szDst = szDst_29C ;
         break ;
      case 0x29D :
         szSrc = szSrc_29D ;
         szDst = szDst_29D ;
         break ;
      case 0x29F :
         szSrc = szSrc_29F ;
         szDst = szDst_29F ;
         break ;
      case 0x2A2 :
         szSrc = szSrc_2A2 ;
         szDst = szDst_2A2 ;
         break ;
      case 0x2A3 :
         szSrc = szSrc_2A3 ;
         szDst = szDst_2A3 ;
         break ;
      case 0x2A4 :
         szSrc = szSrc_2A4 ;
         szDst = szDst_2A4 ;
         break ;
      case 0x2A5 :
         szSrc = szSrc_2A5 ;
         szDst = szDst_2A5 ;
         break ;
      case 0x2A6 :
         szSrc = szSrc_2A6 ;
         szDst = szDst_2A6 ;
         break ;
      default :
         szSrc = NULL ;
         szDst = NULL ;
         break ;
   }

   if ( szSrc ) {
      unsigned short cSrc = (unsigned short) cUnicode ;
      if ( cSrc != 0xFFFF ) {
         for ( const unsigned short *p = szSrc ; *p <= cSrc ; p ++ ) {
            if ( *p == cSrc ) return szDst [ p - szSrc ] ;
         }
      }
   }

   return 0 ;
}



