// chnconv_exe.cpp : Ro[^̃EBhEC^[tFCX

#include <windows.h>
#include <stdio.h>
#include <ctype.h>
#include "msc.h"

#include "access.h"
#include "brsfile.h"
#include "cjkctype.h"
#include "codepage.h"
#include "filename.h"
#include "guifont.h"
#include "mui.h"
#include "mvwnd.h"
#include "nls.h"
#include "res.h"
#include "resource.h"
#include "sendmsg.h"
#include "shfileop.h"
#include "shfolder.h"
#include "shortcut.h"
#include "stringex.h"
#include "thread.h"
#include "tmpfile.h"
#include "winmain.h"

#include "chnconv.h"
#include "chnconv_opt.h"
#include "chnconv_cp.h"

#include "conv_err.h"
#include "conv_opt.h"
#include "conv_loaddll.h"
#include "conv_icon.h"
#include "conv_opt_gaiji.h"



// for debug
#define DEBUG_TAB_CONTROL  0     // ^uRg[
#define DEBUG_DRAW_ICON    0     // 󋵕\ACR̃TCY
#define DEBUG_SEMAPHORE    0     // ϊ̃_CAO`


static int nVersion ;
static int nOsCodePage ;         // OS̃R[hy[W

static char szCommandNameA [ SHORTSTRING_MAX ] ;
static wchar_t szCommandNameW [ SHORTSTRING_MAX ] ;

static char *szConfigFileNameA ;
static wchar_t *szConfigFileNameW ;

#define TEMPFILE_HEADER_A      "chn"
#define TEMPFILE_HEADER_W     L"chn"

INT_PTR CALLBACK MainDialogProc ( HWND hWnd, unsigned int dwMessage, WPARAM wParam, LPARAM lParam ) ;


// for XP Style
static HINSTANCE hUxTheme ;
typedef HRESULT ( WINAPI *ENABLETHEMEDIALOGTEXTURE ) ( HWND hwnd, DWORD dwFlags ) ;
static ENABLETHEMEDIALOGTEXTURE EnableThemeDialogTexture ;
#define ETDT_ENABLETAB 0x06



int main ( int argc, char *argv [] ) {


   int nError = 0 ;     // G[
   int nMuiLangIdSpecified = 0 ;


   if ( DEBUG_TAB_CONTROL || DEBUG_DRAW_ICON || DEBUG_SEMAPHORE ) {
      MessageBoxA ( NULL, "Debug Version", "CHNCONV.EXE", MB_OK ) ;
   }

   // for XP Visual Style
   InitCommonControls () ;

   // for XP Visual Style
   if ( IsWinXPorLater () ) {
      hUxTheme = LoadLibraryW ( L"UxTheme.dll" ) ;
      GETPROCADDRESS ( hUxTheme, ENABLETHEMEDIALOGTEXTURE, EnableThemeDialogTexture ) ;
   }

   // VXe擾
   nOsCodePage = GetACP () ;

   // \[X̌
   if ( IsNT () ) InitMuiLibraryW ( RT_DIALOG, IDD_DIALOG_MAIN, NULL, MUILANG_PREFIX_W ) ;
   else           InitMuiLibraryA ( RT_DIALOG, IDD_DIALOG_MAIN, NULL, MUILANG_PREFIX_A ) ;

   // o[W
   FILEVERSION FileVersion ;
   if ( ! GetFileVersion ( & FileVersion ) ) nVersion = TranslateVersionInfo ( & FileVersion ) ;


   // ̎擾
   for ( int nCountArgv = 1 ; nCountArgv < argc ; nCountArgv ++ ) {
      char *szArgv = argv [ nCountArgv ] ;
      if ( *szArgv == '/' || *szArgv == '-' ) {
         switch ( *( szArgv + 1 ) ) {
            case 'E' :
            case 'e' :
               nMuiLangIdSpecified = LANGID_ENGLISH ;
               break ;
            case 'J' :
            case 'j' :
               nMuiLangIdSpecified = LANGID_JAPANESE ;
               break ;
            case 'L' :
            case 'l' :
               if ( *( szArgv + 2 ) ) {
                  char *szString ;
                  errno = 0 ;
                  int nLangId = strtoul ( szArgv + 2, & szString, 0x10 ) ;
                  if ( errno || *szString ) { nError = nCountArgv ; break ; }
                  nMuiLangIdSpecified = nLangId ;
                  continue ;
               }
               nError = nCountArgv ;
               break ;
            case 'W' :
            case 'w' :
               IsIgnoreSaveWindow = 1 ;
               break ;
            case '@' :
               if ( *( szArgv + 2 ) ) {
                  szConfigFileNameA = GetArgumentA ( nCountArgv ) + 2 ;
                  szConfigFileNameW = GetArgumentW ( nCountArgv ) + 2 ;
                  continue ;
               }
               break ;
            default :
               nError = nCountArgv ;
               break ;
         }
         if ( *( szArgv + 2 ) ) nError = nCountArgv ;
         continue ;
      }
      nError = nCountArgv ;
   }


   // \̐ݒiR}hC̎wj
   if ( nMuiLangIdSpecified ) LoadMuiLibrary ( nMuiLangIdSpecified ) ;
   // 
   LoadStringExA ( IDS_COMMANDNAME, szCommandNameA, SHORTSTRING_MAX ) ;
   if ( IsNT () ) LoadStringExW ( IDS_COMMANDNAME, szCommandNameW, SHORTSTRING_MAX ) ;


   // G[\
   if ( nError ) {
      if ( IsNT () ) MessageBoxFormatW ( NULL, szCommandNameW, MB_OK, L"%s%s\n", GetStringW ( IDS_PARAM_ERROR ), GetArgumentW ( nError ) ) ;
      else           MessageBoxFormatA ( NULL, szCommandNameA, MB_OK,  "%s%s\n", GetStringA ( IDS_PARAM_ERROR ), GetArgumentA ( nError ) ) ;
      return 1 ;
   }


   // tHg
   if ( nOsCodePage == CP_CHINESE_SIMPLIFIED ) {
      szDefaultGbFont = DEFAULT_GB_FONT_L ;
      szDefaultGbGothicFont = DEFAULT_GB_GOTHIC_FONT_L ;
   }
   if ( nOsCodePage == CP_CHINESE_TRADITIONAL ) {
      szDefaultBig5Font = DEFAULT_BIG5_FONT_L ;
      szDefaultBig5GothicFont = DEFAULT_BIG5_GOTHIC_FONT_L ;
   }


   // tHg̏lݒ
   strcpy ( szGbFont, szDefaultGbFont ) ;
   strcpy ( szGbGothicFont, szDefaultGbGothicFont ) ;
   strcpy ( szBig5Font, szDefaultBig5Font ) ;
   strcpy ( szBig5GothicFont, szDefaultBig5GothicFont ) ;
   strcpy ( szPinyinFont, szDefaultPinyinFont ) ;
   strcpy ( szPinyinGothicFont, szDefaultPinyinGothicFont ) ;


   // IvV擾
   int IsConfigFileNotFound ;
   if ( IsNT () ) IsConfigFileNotFound = ReadOptionW ( szConfigFileNameW ) ;
   else           IsConfigFileNotFound = ReadOptionA ( szConfigFileNameA ) ;
   if ( IsConfigFileNotFound < 0 ) {
      if ( IsNT () ) MessageBoxW ( NULL, GetStringW ( IDS_NOT_ENOUGH_MEMORY ), szCommandNameW, MB_OK ) ;
      else           MessageBoxA ( NULL, GetStringA ( IDS_NOT_ENOUGH_MEMORY ), szCommandNameA, MB_OK ) ;
      return 1 ;
   }
   if ( IsConfigFileNotFound && ( szConfigFileNameA || szConfigFileNameW ) ) {
      if ( IsNT () ) MessageBoxFormatW ( NULL, szCommandNameW, MB_OK, L"%s\n\n%s\n", GetStringW ( IDS_CANNOT_READ_OPTION ), szConfigFileNameW ) ;
      else           MessageBoxFormatA ( NULL, szCommandNameA, MB_OK,  "%s\n\n%s\n", GetStringA ( IDS_CANNOT_READ_OPTION ), szConfigFileNameA ) ;
      return 1 ;
   }


   // \̐ݒit@C̎wj
   if ( ! nMuiLangIdSpecified && nSavedMuiLangId ) {
      LoadMuiLibrary ( nSavedMuiLangId ) ;
      // Ǖ
      LoadStringExA ( IDS_COMMANDNAME, szCommandNameA, SHORTSTRING_MAX ) ;
      if ( IsNT () ) LoadStringExW ( IDS_COMMANDNAME, szCommandNameW, SHORTSTRING_MAX ) ;
   }


   // tH_擾
   if ( IsNT () ) {
      if ( ! *szBrowsePathW ) {
         if ( *szBrowsePathA ) {
            a2wlcpy ( szBrowsePathW, szBrowsePathA, MAX_PATH ) ;
         }
         else {
            GetSpecialFolderPathW ( NULL, szBrowsePathW, CSIDL_PERSONAL, 0 ) ;
            if ( ! *szBrowsePathW ) wcscpy ( szBrowsePathW, L"C:\\" ) ;
         }
      }
   }
   else {
      if ( ! *szBrowsePathA ) {
         if ( *szBrowsePathW ) {
            w2alcpy ( szBrowsePathA, szBrowsePathW, MAX_PATH ) ;
         }
         else {
            GetSpecialFolderPathA ( NULL, szBrowsePathA, CSIDL_PERSONAL, 0 ) ;
            if ( ! *szBrowsePathA ) strcpy ( szBrowsePathA, "C:\\" ) ;
         }
      }
   }

   // _CAÕACe̐`FbN
   if ( ! IsDlgItemIdConformable () ) {
      if ( IsNT () ) MessageBoxW ( NULL, GetStringW ( IDS_UNKNOWN_ERROR ), szCommandNameW, MB_OK ) ;
      else           MessageBoxA ( NULL, GetStringA ( IDS_UNKNOWN_ERROR ), szCommandNameA, MB_OK ) ;
      return 0 ;
   }


   // _CAO\
   if ( IsNT () ) DialogBoxExW ( IDD_DIALOG_MAIN, NULL, MainDialogProc ) ;
   else           DialogBoxExA ( IDD_DIALOG_MAIN, NULL, MainDialogProc ) ;

   // IvVۑ
   if ( IsOptionChanged || IsSavePath || IsSaveCode || IsSaveWindow || IsConfigFileNotFound ) {
      if ( IsNT () ) WriteOptionW ( szConfigFileNameW ) ;
      else           WriteOptionA ( szConfigFileNameA ) ;
   }

   return 0 ;
}



////////////////////////////////////////////
//            C_CAO            //
////////////////////////////////////////////



int SetSemaphore ( int nValue ) ;
#define LockSemaphore()       SetSemaphore ( 1 )   // if success, return 0
#define UnlockSemaphore()     SetSemaphore ( 0 )
#define IsLockedSemaphore()   ( SetSemaphore ( -1 ) != 0 )


typedef struct {
   HWND           hWnd ;
   volatile int   *pIsAborted ;
} CONVERSIONTHREADINFO ;

int ConversionThread ( void *pConversionThreadInfo ) ;


int SetOption ( HWND hWnd ) ;
int DisplayHelp ( HWND hWnd ) ;
int SetMainDialogTitle ( HWND hWnd, int nMode ) ;
int DisplaySupportedFormat ( HWND hWnd, int nType, int nCode ) ;

int CallBrowseForFile ( HWND hWnd, int nFileNumber, int IsDestination ) ;
#define BrowseSrcFileName(hWnd,nFileNumber)  CallBrowseForFile(hWnd,nFileNumber,0)
#define BrowseDstFileName(hWnd,nFileNumber)  CallBrowseForFile(hWnd,nFileNumber,1)

static WNDPROC OldEditCtrlProc ;
LRESULT CALLBACK NewEditCtrlProcA ( HWND hWnd, unsigned int dwMessage, WPARAM wParam, LPARAM lParam ) ;
LRESULT CALLBACK NewEditCtrlProcW ( HWND hWnd, unsigned int dwMessage, WPARAM wParam, LPARAM lParam ) ;



// C_CAO
INT_PTR CALLBACK MainDialogProc ( HWND hWnd, unsigned int dwMessage, WPARAM wParam, LPARAM lParam ) {

   static HFONT hFont ;
   static HICON hIcon ;
   static volatile int IsAborted ;
   int nId ;

   switch ( dwMessage ) {

      case WM_INITDIALOG :

         // EBhE\ʒu
         if ( IsSaveWindow && ! IsIgnoreSaveWindow ) SetWindowPos ( hWnd, NULL, nSavedWindowX, nSavedWindowY, 0, 0, SWP_NOSIZE | SWP_NOZORDER ) ;
         else                                        MoveWindowToCenter ( hWnd ) ;
         ShiftWindow ( hWnd ) ;
         MoveWindowTitleIntoDesktop ( hWnd ) ;

         // ^Cgݒ
         hIcon = GetIcon ( IDI_ICON_2 ) ;
         if ( hIcon ) Wm_SetIcon ( hWnd, ICON_BIG, hIcon ) ;   // ICON_BIGłȂ ALT+TAB ŃACR\łȂ
         SetMainDialogTitle ( hWnd, 0 ) ;

         // bZ[W̏
         for ( int nCount = 0 ; nCount < SRC_DST_FILE_NELEM ; nCount ++ ) SetStatusIcon ( hWnd, nCount, STATUS_ICON_READY ) ;

         if ( DEBUG_DRAW_ICON ) DisplayControlSize ( hWnd, IDC_STATIC_STATUS_MIN ) ;

         // WI{^ݒ
         CheckDlgButton ( hWnd, nSrcType + IDC_CHECK_SRC_TYPE_MIN, BST_CHECKED ) ;
         CheckDlgButton ( hWnd, nDstType + IDC_CHECK_DST_TYPE_MIN, BST_CHECKED ) ;
         DisplaySupportedFormat ( hWnd, nSrcType, nSrcCode ) ;

         // R{{bNX̐ݒ
         Dlg_ComboBox_ResetContent ( hWnd, IDC_COMBO_SRC_CODE ) ;
         for ( int nCount = 0 ; nCount < AVAILABLE_CODE_LIST_NELEM ; nCount ++ ) {
            if ( IsNT () ) Dlg_ComboBox_InsertStringW ( hWnd, IDC_COMBO_SRC_CODE, -1, GetStringW ( ( AvailableCodeList [ nCount ] ).nNameId ) ) ;
            else           Dlg_ComboBox_InsertStringA ( hWnd, IDC_COMBO_SRC_CODE, -1, GetStringA ( ( AvailableCodeList [ nCount ] ).nNameId ) ) ;
         }
         Dlg_ComboBox_ResetContent ( hWnd, IDC_COMBO_DST_CODE ) ;
         for ( int nCount = 0 ; nCount < AVAILABLE_CODE_LIST_NELEM ; nCount ++ ) {
            if ( IsNecChineseCodePage ( ( AvailableCodeList [ nCount ] ).nCodePage ) ) continue ;
            if ( IsNT () ) Dlg_ComboBox_InsertStringW ( hWnd, IDC_COMBO_DST_CODE, -1, GetStringW ( ( AvailableCodeList [ nCount ] ).nNameId ) ) ;
            else           Dlg_ComboBox_InsertStringA ( hWnd, IDC_COMBO_DST_CODE, -1, GetStringA ( ( AvailableCodeList [ nCount ] ).nNameId ) ) ;
         }

         if ( nSrcType == TYPE_PSEUDO ) {
            Dlg_ComboBox_SetCurSel ( hWnd, IDC_COMBO_SRC_CODE, nSrcCode ) ;
            Dlg_EnableWindow ( hWnd, IDC_COMBO_SRC_CODE, TRUE ) ;
         }
         else {
            Dlg_ComboBox_SetCurSel ( hWnd, IDC_COMBO_SRC_CODE, -1 ) ;
            Dlg_EnableWindow ( hWnd, IDC_COMBO_SRC_CODE, FALSE ) ;
         }

         if ( nDstType == TYPE_PSEUDO ) {
            Dlg_ComboBox_SetCurSel ( hWnd, IDC_COMBO_DST_CODE, nDstCode ) ;
            Dlg_EnableWindow ( hWnd, IDC_COMBO_DST_CODE, TRUE ) ;
         }
         else {
            Dlg_ComboBox_SetCurSel ( hWnd, IDC_COMBO_DST_CODE, -1 ) ;
            Dlg_EnableWindow ( hWnd, IDC_COMBO_DST_CODE, FALSE ) ;
         }

         // tHg쐬
         hFont = CreateFontByCodePage ( GetDialogFontHeight ( IDD_DIALOG_MAIN ), 0 ) ;
         if ( hFont ) {
            for ( int nCount = 0 ; nCount < SRC_DST_FILE_NELEM ; nCount ++ ) {
               Dlg_Wm_SetFont ( hWnd, IDC_EDIT_SRC_MIN + nCount, hFont, TRUE ) ;
               Dlg_Wm_SetFont ( hWnd, IDC_EDIT_DST_MIN + nCount, hFont, TRUE ) ;
            }
         }

         // GfBbgRg[̃}[Wݒ (Win95΍)
         if ( IsWin95 () ) {
            for ( int nCount = 0 ; nCount < SRC_DST_FILE_NELEM ; nCount ++ ) {
               Dlg_Edit_SetMargins ( hWnd, IDC_EDIT_SRC_MIN + nCount, 1, 1 ) ;
               Dlg_Edit_SetMargins ( hWnd, IDC_EDIT_DST_MIN + nCount, 1, 1 ) ;
            }
         }

         // GfBbgRg[͂̒̐
         for ( int nCount = 0 ; nCount < SRC_DST_FILE_NELEM ; nCount ++ ) {
            Dlg_Edit_LimitText ( hWnd, IDC_EDIT_SRC_MIN + nCount, MAX_PATH - 1 ) ;
            Dlg_Edit_LimitText ( hWnd, IDC_EDIT_DST_MIN + nCount, MAX_PATH - 1 ) ;
         }

         // GfBbgRg[tbN
         if ( IsNT () ) OldEditCtrlProc = GetWindowProcW ( GetDlgItem ( hWnd, IDC_EDIT_SRC_MIN ) ) ;
         else           OldEditCtrlProc = GetWindowProcA ( GetDlgItem ( hWnd, IDC_EDIT_SRC_MIN ) ) ;
         for ( int nCount = 0 ; nCount < SRC_DST_FILE_NELEM ; nCount ++ ) {
            if ( IsNT () ) {
               SetWindowProcW ( GetDlgItem ( hWnd, IDC_EDIT_SRC_MIN + nCount ), NewEditCtrlProcW ) ;
               SetWindowProcW ( GetDlgItem ( hWnd, IDC_EDIT_DST_MIN + nCount ), NewEditCtrlProcW ) ;
            }
            else {
               SetWindowProcA ( GetDlgItem ( hWnd, IDC_EDIT_SRC_MIN + nCount ), NewEditCtrlProcA ) ;
               SetWindowProcA ( GetDlgItem ( hWnd, IDC_EDIT_DST_MIN + nCount ), NewEditCtrlProcA ) ;
            }
            DragAcceptFiles ( GetDlgItem ( hWnd, IDC_EDIT_SRC_MIN + nCount ), TRUE ) ;
            DragAcceptFiles ( GetDlgItem ( hWnd, IDC_EDIT_DST_MIN + nCount ), TRUE ) ;
         }

         return TRUE ;


      case WM_COMMAND :

         // ϊ͖
         if ( IsLockedSemaphore () ) {
            if ( LOWORD ( wParam ) == IDCANCEL ) {
               if ( AbortChnconv ) AbortChnconv () ;
               IsAborted = 1 ;
               return TRUE ;
            }
            if ( HIWORD ( wParam ) == CBN_SETFOCUS ) {
               Dlg_SetFocus ( hWnd, IDOK ) ;
               return TRUE ;
            }
            if ( HIWORD ( wParam ) == EN_SETFOCUS ) {
               Dlg_SetFocus ( hWnd, IDOK ) ;
               return TRUE ;
            }
            if ( HIWORD ( wParam ) == BN_CLICKED ) {
               Dlg_SetFocus ( hWnd, IDOK ) ;
               CheckRadioButton ( hWnd, IDC_CHECK_SRC_TYPE_MIN, IDC_CHECK_SRC_TYPE_MIN + SRC_TYPE_NELEM - 1, nSrcType + IDC_CHECK_SRC_TYPE_MIN ) ;
               CheckRadioButton ( hWnd, IDC_CHECK_DST_TYPE_MIN, IDC_CHECK_DST_TYPE_MIN + DST_TYPE_NELEM - 1, nDstType + IDC_CHECK_DST_TYPE_MIN ) ;
               return TRUE ;
            }
            return TRUE ;
         }

         // ϊ̎s
         if ( LOWORD ( wParam ) == IDOK ) {

            // 
            IsAborted = 0 ;

            static CONVERSIONTHREADINFO ConversionThreadInfo ;
            ConversionThreadInfo.hWnd = hWnd ;
            ConversionThreadInfo.pIsAborted = & IsAborted ;
#ifdef _MT
            // s֐Ăяoi}`Xbhj
            if ( BeginThread ( ConversionThread, (void*) & ConversionThreadInfo, NULL ) ) {
               if ( IsNT () ) MessageBoxW ( hWnd, GetStringW ( IDS_NOT_ENOUGH_MEMORY ), szCommandNameW, MB_OK ) ;
               else           MessageBoxA ( hWnd, GetStringA ( IDS_NOT_ENOUGH_MEMORY ), szCommandNameA, MB_OK ) ;
            }
#else
            // s֐ĂяoiVOXbhj
            ConversionThread ( (void*) & ConversionThreadInfo ) ;
#endif
            return TRUE ;
         }

         // I
         if ( LOWORD ( wParam ) == IDCANCEL ) {

            if ( IsConfirmOnExit ) {
               int nResult ;
               if ( IsNT () ) nResult = MessageBoxW ( hWnd, GetStringW ( IDS_CONFIRM_ON_EXIT ), szCommandNameW, MB_YESNO ) ;
               else           nResult = MessageBoxA ( hWnd, GetStringA ( IDS_CONFIRM_ON_EXIT ), szCommandNameA, MB_YESNO ) ;
               if ( nResult != IDYES ) return TRUE ;
            }

            if ( IsSaveWindow ) {
               RECT Rect ;
               if ( ! GetWindowNormalPositionRect ( hWnd, & Rect ) ) IsSaveWindow = 0 ;
               nSavedWindowX = Rect.left ;
               nSavedWindowY = Rect.top ;
            }

            EndDialog ( hWnd, IDCANCEL ) ;
            return TRUE ;
         }

         // ̓t@C̎Q
         if ( (unsigned) ( LOWORD ( wParam ) - IDC_BUTTON_SRC_MIN ) < SRC_DST_FILE_NELEM ) {
            BrowseSrcFileName ( hWnd, LOWORD ( wParam ) - IDC_BUTTON_SRC_MIN ) ;
            return TRUE ;
         }

         // o͂̃t@C̎Q
         if ( (unsigned) ( LOWORD ( wParam ) - IDC_BUTTON_DST_MIN ) < SRC_DST_FILE_NELEM ) {
            BrowseDstFileName ( hWnd, LOWORD ( wParam ) - IDC_BUTTON_DST_MIN ) ;
            return TRUE ;
         }


         // ̓WI{^̐ݒ
         if ( (unsigned) ( LOWORD ( wParam ) - IDC_CHECK_SRC_TYPE_MIN ) < SRC_TYPE_NELEM ) {

            nSrcType = LOWORD ( wParam ) - IDC_CHECK_SRC_TYPE_MIN ;

            // bZ[W̏
            for ( int nCount = 0 ; nCount < SRC_DST_FILE_NELEM ; nCount ++ ) SetStatusIcon ( hWnd, nCount, STATUS_ICON_READY ) ;

            if ( nSrcType == TYPE_PSEUDO ) {
               Dlg_ComboBox_SetCurSel ( hWnd, IDC_COMBO_SRC_CODE, nSrcCode ) ;
               Dlg_EnableWindow ( hWnd, IDC_COMBO_SRC_CODE, TRUE ) ;
            }
            else {
               Dlg_ComboBox_SetCurSel ( hWnd, IDC_COMBO_SRC_CODE, -1 ) ;
               Dlg_EnableWindow ( hWnd, IDC_COMBO_SRC_CODE, FALSE ) ;
            }

            DisplaySupportedFormat ( hWnd, nSrcType, nSrcCode ) ;
            return TRUE ;
         }

         // o̓WI{^̐ݒ
         if ( (unsigned) ( LOWORD ( wParam ) - IDC_CHECK_DST_TYPE_MIN ) < DST_TYPE_NELEM ) {

            nDstType = LOWORD ( wParam ) - IDC_CHECK_DST_TYPE_MIN ;

            // bZ[W̏
            for ( int nCount = 0 ; nCount < SRC_DST_FILE_NELEM ; nCount ++ ) SetStatusIcon ( hWnd, nCount, STATUS_ICON_READY ) ;

            if ( nDstType == TYPE_PSEUDO ) {
               Dlg_ComboBox_SetCurSel ( hWnd, IDC_COMBO_DST_CODE, nDstCode ) ;
               Dlg_EnableWindow ( hWnd, IDC_COMBO_DST_CODE, TRUE ) ;
            }
            else {
               Dlg_ComboBox_SetCurSel ( hWnd, IDC_COMBO_DST_CODE, -1 ) ;
               Dlg_EnableWindow ( hWnd, IDC_COMBO_DST_CODE, FALSE ) ;
            }

            return TRUE ;
         }


         // IvVݒ
         if ( LOWORD ( wParam ) == IDC_BUTTON_OPTION ) {
            SetOption ( hWnd ) ;
            return TRUE ;
         }

         // wv\
         if ( LOWORD ( wParam ) == IDC_BUTTON_HELP ) {
            DisplayHelp ( hWnd ) ;
            return TRUE ;
         }

         // R{{bNX̑IύXƂ
         if ( HIWORD ( wParam ) == CBN_SELCHANGE ) {
            if ( LOWORD ( wParam ) == IDC_COMBO_SRC_CODE ) {
               nSrcCode = Dlg_ComboBox_GetCurSel ( hWnd, IDC_COMBO_SRC_CODE ) ;
               DisplaySupportedFormat ( hWnd, nSrcType, nSrcCode ) ;
               return TRUE ;
            }
            if ( LOWORD ( wParam ) == IDC_COMBO_DST_CODE ) {
               nDstCode = Dlg_ComboBox_GetCurSel ( hWnd, IDC_COMBO_DST_CODE ) ;
               return TRUE ;
            }
         }

         break ;


      case WM_CTLCOLOREDIT :
      case WM_CTLCOLORSTATIC :
         nId = GetDlgCtrlID ( (HWND) lParam ) ;
         if ( (unsigned) ( nId - IDC_EDIT_SRC_MIN ) < SRC_DST_FILE_NELEM ) return (INT_PTR) GetStockObject ( WHITE_BRUSH ) ;
         if ( (unsigned) ( nId - IDC_EDIT_DST_MIN ) < SRC_DST_FILE_NELEM ) return (INT_PTR) GetStockObject ( WHITE_BRUSH ) ;
         break ;


      case WM_DRAWITEM :
         if ( (unsigned) ( wParam - IDC_STATIC_STATUS_MIN ) < SRC_DST_FILE_NELEM ) {
            DrawStatusIcon ( (DRAWITEMSTRUCT*) lParam, (int) ( wParam - IDC_STATIC_STATUS_MIN ) ) ;
            SetDlgMsgResult ( hWnd, TRUE ) ;
            return TRUE ;
         }
         break ;


      case WM_DESTROY :
         if ( hFont ) {
            DeleteObject ( hFont ) ;
            hFont = NULL ;
         }
         if ( hIcon ) {
            DestroyIcon ( hIcon ) ;
            hIcon = NULL ;
         }
         break ;


      default :
         break ;
   }

   return FALSE ;
}



int SetDraggedFileNameA ( HWND hWnd, HDROP hDrop ) ;
int SetDraggedFileNameW ( HWND hWnd, HDROP hDrop ) ;



// GfBbgRg[tbNAhbOAhhbviANSIŁj
LRESULT CALLBACK NewEditCtrlProcA ( HWND hWnd, unsigned int dwMessage, WPARAM wParam, LPARAM lParam ) {
   if ( dwMessage == WM_DROPFILES ) return SetDraggedFileNameA ( hWnd, (HDROP) wParam ) ;
   else                             return CallWindowProcA ( OldEditCtrlProc, hWnd, dwMessage, wParam, lParam ) ;
}



// GfBbgRg[tbNAhbOAhhbviUNICODEŁj
LRESULT CALLBACK NewEditCtrlProcW ( HWND hWnd, unsigned int dwMessage, WPARAM wParam, LPARAM lParam ) {
   if ( dwMessage == WM_DROPFILES ) return SetDraggedFileNameW ( hWnd, (HDROP) wParam ) ;
   else                             return CallWindowProcW ( OldEditCtrlProc, hWnd, dwMessage, wParam, lParam ) ;
}



// hbOꂽt@CEBhEɕ\iANSIŁj
int SetDraggedFileNameA ( HWND hWnd, HDROP hDrop ) {

   char szFileName [ MAX_PATH ] ;

   if ( DragQueryFileA ( hDrop, (unsigned int) -1, NULL, 0 ) == 1 ) {
      DragQueryFileA ( hDrop, 0, szFileName, MAX_PATH ) ;
      char *szExtension = GetExtensionA ( szFileName ) ;
      if ( szExtension && ( ! stricmp ( szExtension, "lnk" ) || ! stricmp ( szExtension, "url" ) ) ) GetShortcutA ( szFileName, szFileName, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL ) ;
      Wm_SetTextA ( hWnd, szFileName ) ;
      MoveCaretToEnd ( hWnd ) ;
   }
   else {
      SetForegroundWindow ( GetParent ( hWnd ) ) ;
      MessageBoxA ( GetParent ( hWnd ), GetStringA ( IDS_DRAGFILE_ERROR ), szCommandNameA, MB_OK ) ;
   }

   DragFinish ( hDrop ) ;

   return 0 ;
}



// hbOꂽt@CEBhEɕ\iUNICODEŁj
int SetDraggedFileNameW ( HWND hWnd, HDROP hDrop ) {

   wchar_t szFileName [ MAX_PATH ] ;

   if ( DragQueryFileW ( hDrop, (unsigned int) -1, NULL, 0 ) == 1 ) {
      DragQueryFileW ( hDrop, 0, szFileName, MAX_PATH ) ;
      wchar_t *szExtension = GetExtensionW ( szFileName ) ;
      if ( szExtension && ( ! wcsicmp ( szExtension, L"lnk" ) || ! wcsicmp ( szExtension, L"url" ) ) ) GetShortcutW ( szFileName, szFileName, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL ) ;
      Wm_SetTextW ( hWnd, szFileName ) ;
      MoveCaretToEnd ( hWnd ) ;
   }
   else {
      SetForegroundWindow ( GetParent ( hWnd ) ) ;
      MessageBoxW ( GetParent ( hWnd ), GetStringW ( IDS_DRAGFILE_ERROR ), szCommandNameW, MB_OK ) ;
   }

   DragFinish ( hDrop ) ;

   return 0 ;
}



// C_CAÕ^Cgݒ
// nMode  0 łȂ΁Auϊv
int SetMainDialogTitle ( HWND hWnd, int nMode ) {

   if ( nMode ) {
      if ( IsNT () ) Wm_SetTextFormatW ( hWnd, L"%s  -  %s", szCommandNameW, GetStringW ( IDS_NOWCONVERTING ) ) ;
      else           Wm_SetTextFormatA ( hWnd,  "%s  -  %s", szCommandNameA, GetStringA ( IDS_NOWCONVERTING ) ) ;
   }
   else {
      if ( IsNT () ) Wm_SetTextFormatW ( hWnd, L"%s  -  version %d.%02d", szCommandNameW, nVersion / 100, nVersion % 100 ) ;
      else           Wm_SetTextFormatA ( hWnd,  "%s  -  version %d.%02d", szCommandNameA, nVersion / 100, nVersion % 100 ) ;
   }

   return 0 ;
}



////////////////////////////////////////////
//            t@C̎Q            //
////////////////////////////////////////////



int CallBrowseForFileA ( HWND hWnd, int nFileNumber, int IsDestination ) ;
int CallBrowseForFileW ( HWND hWnd, int nFileNumber, int IsDestination ) ;



// Qƃ{^̓
int CallBrowseForFile ( HWND hWnd, int nFileNumber, int IsDestination ) {

   if ( IsNT () ) return CallBrowseForFileW ( hWnd, nFileNumber, IsDestination ) ;
   else           return CallBrowseForFileA ( hWnd, nFileNumber, IsDestination ) ;
}



char *GetFileNameFilterA ( int nCodePage, int IsOnlyTxtOrRtf ) ;
wchar_t *GetFileNameFilterW ( int nCodePage, int IsOnlyTxtOrRtf ) ;
int GetCodePageFromTypeAndCode ( int nType, int nCode ) ;



// Qƃ{^̓iANSIŁj
int CallBrowseForFileA ( HWND hWnd, int nFileNumber, int IsDestination ) {

   char szFileName [ MAX_PATH ] ;
   char szFileNameTmp [ MAX_PATH ] ;
   char szResult [ MAX_PATH ] ;

   int IsOnlyTxtOrRtf = 0 ;

   int nSrcCodePage = GetCodePageFromTypeAndCode ( nSrcType, nSrcCode ) ;
   int nDstCodePage = GetCodePageFromTypeAndCode ( nDstType, nDstCode ) ;

   // bZ[W̏
   for ( int nCount = 0 ; nCount < SRC_DST_FILE_NELEM ; nCount ++ ) SetStatusIcon ( hWnd, nCount, STATUS_ICON_READY ) ;

   // o̓t@C擾
   if ( IsDestination ) {
      Dlg_Wm_GetTextA ( hWnd, IDC_EDIT_DST_MIN + nFileNumber, szFileName, MAX_PATH ) ;
      UnquoteFileNameA ( szFileName ) ;
      if ( ! IsFolderExistA ( szFileName ) ) {
         ChangeFileNameA ( szFileName, NULL ) ;
         if ( ! IsFolderExistA ( szFileName ) ) *szFileName = 0 ;
      }
   }

   // ̓t@C擾
   if ( ! IsDestination || ! *szFileName ) {
      Dlg_Wm_GetTextA ( hWnd, IDC_EDIT_SRC_MIN + nFileNumber, szFileName, MAX_PATH ) ;
      UnquoteFileNameA ( szFileName ) ;
      if ( ! IsFolderExistA ( szFileName ) ) {
         ChangeFileNameA ( szFileName, NULL ) ;
         if ( ! IsFolderExistA ( szFileName ) ) strcpy ( szFileName, szBrowsePathA ) ;
      }
   }

   // ̓t@C̊gq擾
   if ( IsDestination ) {
      Dlg_Wm_GetTextA ( hWnd, IDC_EDIT_SRC_MIN + nFileNumber, szFileNameTmp, MAX_PATH ) ;
      UnquoteFileNameA ( szFileNameTmp ) ;
      char *szExtension = GetExtensionA ( szFileNameTmp ) ;
      if ( szExtension || nSrcCodePage == CP_HZ_CHINESE_SIMPLIFIED ) IsOnlyTxtOrRtf = 1 ;
      if ( szExtension && ! stricmp ( szExtension, "RTF" ) || IsNecChineseCodePage ( nSrcCodePage ) ) IsOnlyTxtOrRtf = 2 ;
   }

   if ( ! IsDestination ) {
      if ( ! BrowseForFileA ( hWnd, szResult, MAX_PATH, szFileName, GetStringA ( IDS_SELECTSRCFILE ), GetFileNameFilterA ( nSrcCodePage, 0 ), 0 ) ) {
         Dlg_SetFocus ( hWnd, IDC_EDIT_SRC_MIN + nFileNumber ) ;
         Dlg_Wm_SetTextA ( hWnd, IDC_EDIT_SRC_MIN + nFileNumber, szResult ) ;
         Dlg_MoveCaretToEnd ( hWnd, IDC_EDIT_SRC_MIN + nFileNumber ) ;
         strcpy ( szBrowsePathA, szResult ) ;
         ChangeFileNameA ( szBrowsePathA, NULL ) ;
      }
   }
   else {
      if ( ! BrowseForFileA ( hWnd, szResult, MAX_PATH, szFileName, GetStringA ( IDS_SELECTDSTFILE ), GetFileNameFilterA ( nDstCodePage, IsOnlyTxtOrRtf ), 0 ) ) {
         Dlg_SetFocus ( hWnd, IDC_EDIT_DST_MIN + nFileNumber ) ;
         Dlg_Wm_SetTextA ( hWnd, IDC_EDIT_DST_MIN + nFileNumber, szResult ) ;
         Dlg_MoveCaretToEnd ( hWnd, IDC_EDIT_DST_MIN + nFileNumber ) ;
      }
   }

   return 0 ;
}



// Qƃ{^̓iUNICODEŁj
int CallBrowseForFileW ( HWND hWnd, int nFileNumber, int IsDestination ) {

   wchar_t szFileName [ MAX_PATH ] ;
   wchar_t szFileNameTmp [ MAX_PATH ] ;
   wchar_t szResult [ MAX_PATH ] ;

   int IsOnlyTxtOrRtf = 0 ;

   int nSrcCodePage = GetCodePageFromTypeAndCode ( nSrcType, nSrcCode ) ;
   int nDstCodePage = GetCodePageFromTypeAndCode ( nDstType, nDstCode ) ;

   // bZ[W̏
   for ( int nCount = 0 ; nCount < SRC_DST_FILE_NELEM ; nCount ++ ) SetStatusIcon ( hWnd, nCount, STATUS_ICON_READY ) ;

   // o̓t@C擾
   if ( IsDestination ) {
      Dlg_Wm_GetTextW ( hWnd, IDC_EDIT_DST_MIN + nFileNumber, szFileName, MAX_PATH ) ;
      UnquoteFileNameW ( szFileName ) ;
      if ( ! IsFolderExistW ( szFileName ) ) {
         ChangeFileNameW ( szFileName, NULL ) ;
         if ( ! IsFolderExistW ( szFileName ) ) *szFileName = 0 ;
      }
   }

   // ̓t@C擾
   if ( ! IsDestination || ! *szFileName ) {
      Dlg_Wm_GetTextW ( hWnd, IDC_EDIT_SRC_MIN + nFileNumber, szFileName, MAX_PATH ) ;
      UnquoteFileNameW ( szFileName ) ;
      if ( ! IsFolderExistW ( szFileName ) ) {
         ChangeFileNameW ( szFileName, NULL ) ;
         if ( ! IsFolderExistW ( szFileName ) ) wcscpy ( szFileName, szBrowsePathW ) ;
      }
   }

   // ̓t@C̊gq擾
   if ( IsDestination ) {
      Dlg_Wm_GetTextW ( hWnd, IDC_EDIT_SRC_MIN + nFileNumber, szFileNameTmp, MAX_PATH ) ;
      UnquoteFileNameW ( szFileNameTmp ) ;
      wchar_t *szExtension = GetExtensionW ( szFileNameTmp ) ;
      if ( szExtension || nSrcCodePage == CP_HZ_CHINESE_SIMPLIFIED ) IsOnlyTxtOrRtf = 1 ;
      if ( szExtension && ! wcsicmp ( szExtension, L"RTF" ) || IsNecChineseCodePage ( nSrcCodePage ) ) IsOnlyTxtOrRtf = 2 ;
   }

   if ( ! IsDestination ) {
      if ( ! BrowseForFileW ( hWnd, szResult, MAX_PATH, szFileName, GetStringW ( IDS_SELECTSRCFILE ), GetFileNameFilterW ( nSrcCodePage, 0 ), 0 ) ) {
         Dlg_SetFocus ( hWnd, IDC_EDIT_SRC_MIN + nFileNumber ) ;
         Dlg_Wm_SetTextW ( hWnd, IDC_EDIT_SRC_MIN + nFileNumber, szResult ) ;
         Dlg_MoveCaretToEnd ( hWnd, IDC_EDIT_SRC_MIN + nFileNumber ) ;
         wcscpy ( szBrowsePathW, szResult ) ;
         ChangeFileNameW ( szBrowsePathW, NULL ) ;
      }
   }
   else {
      if ( ! BrowseForFileW ( hWnd, szResult, MAX_PATH, szFileName, GetStringW ( IDS_SELECTDSTFILE ), GetFileNameFilterW ( nDstCodePage, IsOnlyTxtOrRtf ), 0 ) ) {
         Dlg_SetFocus ( hWnd, IDC_EDIT_DST_MIN + nFileNumber ) ;
         Dlg_Wm_SetTextW ( hWnd, IDC_EDIT_DST_MIN + nFileNumber, szResult ) ;
         Dlg_MoveCaretToEnd ( hWnd, IDC_EDIT_DST_MIN + nFileNumber ) ;
      }
   }

   return 0 ;
}



// t@CQƂŎgtB^𓾂iANSIŁj
// IsOnlyTxtOrRtf  1 ȂeLXgt@Ĉ
//                   2 Ȃ烊b`eCXgt@Ĉ
char *GetFileNameFilterA ( int nCodePage, int IsOnlyTxtOrRtf ) {

   static char szFilter [ MAX_PATH ] ;
   char *szNext = szFilter ;
   const char *szExtension ;
   const char *szExtensionAdditional ;
   const char *szName ;

   switch ( nCodePage ) {
      case CP_JAPANESE_CW :   szExtensionAdditional = ";*.CW" ; break ;
      case CP_JAPANESE_NH :   szExtensionAdditional = ";*.NH" ; break ;
      case CP_JAPANESE_CWN :  szExtensionAdditional = ";*.CWN" ; break ;
      case CP_JAPANESE_ZQ :   szExtensionAdditional = ";*.ZQ" ; break ;
      case CP_JAPANESE_CX :   szExtensionAdditional = ";*.CX" ; break ;
      case CP_JAPANESE_ZJ :   szExtensionAdditional = ";*.ZJ" ; break ;
      default :               szExtensionAdditional = "" ; break ;
   }

   switch ( nCodePage ) {
      case CP_JAPANESE_TM :            szExtension = "*.TXT;*.TEC" ; szName = GetStringA ( IDS_TMFILES ) ; break ;
      case CP_JAPANESE_FW :            szExtension = "*.TXT" ;       szName = GetStringA ( IDS_TEXTFILES ) ; break ;
      case CP_HZ_CHINESE_SIMPLIFIED :  szExtension = "*.TXT" ;       szName = GetStringA ( IDS_TEXTFILES ) ; break ;
      default :                        szExtension = "*.TXT;*.RTF" ; szName = GetStringA ( IDS_NORMALFILES ) ; break ;
   }

   switch ( IsOnlyTxtOrRtf ) {
      case 1 : szExtension = "*.TXT" ; szName = GetStringA ( IDS_TEXTFILES ) ; break ;
      case 2 : szExtension = "*.RTF" ; szName = GetStringA ( IDS_RICHTEXTFILES ) ; szExtensionAdditional = "" ; break ;
      default : break ;
   }

   strcpy ( szNext, szName ) ;
   szNext = strend ( szNext ) + 1 ;
   sprintf ( szNext, "%s%s", szExtension, szExtensionAdditional ) ;
   szNext = strend ( szNext ) + 1 ;

   strcpy ( szNext, GetStringA ( IDS_ALLFILES ) ) ;
   szNext = strend ( szNext ) + 1 ;
   strcpy ( szNext, "*.*" ) ;
   szNext = strend ( szNext ) + 1 ;

   strcpy ( szNext, "" ) ;

   return szFilter ;
}



// t@CQƂŎgtB^𓾂iUNICODEŁj
// IsOnlyTxtOrRtf  1 ȂeLXgt@Ĉ
//                   2 Ȃ烊b`eCXgt@Ĉ
wchar_t *GetFileNameFilterW ( int nCodePage, int IsOnlyTxtOrRtf ) {

   static wchar_t szFilter [ MAX_PATH ] ;
   wchar_t *szNext = szFilter ;
   const wchar_t *szExtension ;
   const wchar_t *szExtensionAdditional ;
   const wchar_t *szName ;

   switch ( nCodePage ) {
      case CP_JAPANESE_CW :   szExtensionAdditional = L";*.CW" ; break ;
      case CP_JAPANESE_NH :   szExtensionAdditional = L";*.NH" ; break ;
      case CP_JAPANESE_CWN :  szExtensionAdditional = L";*.CWN" ; break ;
      case CP_JAPANESE_ZQ :   szExtensionAdditional = L";*.ZQ" ; break ;
      case CP_JAPANESE_CX :   szExtensionAdditional = L";*.CX" ; break ;
      case CP_JAPANESE_ZJ :   szExtensionAdditional = L";*.ZJ" ; break ;
      default :               szExtensionAdditional = L"" ; break ;
   }

   switch ( nCodePage ) {
      case CP_JAPANESE_TM :            szExtension = L"*.TXT;*.TEC" ; szName = GetStringW ( IDS_TMFILES ) ; break ;
      case CP_JAPANESE_FW :            szExtension = L"*.TXT" ;       szName = GetStringW ( IDS_TEXTFILES ) ; break ;
      case CP_HZ_CHINESE_SIMPLIFIED :  szExtension = L"*.TXT" ;       szName = GetStringW ( IDS_TEXTFILES ) ; break ;
      default :                        szExtension = L"*.TXT;*.RTF" ; szName = GetStringW ( IDS_NORMALFILES ) ; break ;
   }

   switch ( IsOnlyTxtOrRtf ) {
      case 1 : szExtension = L"*.TXT" ; szName = GetStringW ( IDS_TEXTFILES ) ; break ;
      case 2 : szExtension = L"*.RTF" ; szName = GetStringW ( IDS_RICHTEXTFILES ) ; szExtensionAdditional = L"" ; break ;
      default : break ;
   }

   wcscpy ( szNext, szName ) ;
   szNext = wcsend ( szNext ) + 1 ;
   swprintf ( szNext, L"%s%s", szExtension, szExtensionAdditional ) ;
   szNext = wcsend ( szNext ) + 1 ;

   wcscpy ( szNext, GetStringW ( IDS_ALLFILES ) ) ;
   szNext = wcsend ( szNext ) + 1 ;
   wcscpy ( szNext, L"*.*" ) ;
   szNext = wcsend ( szNext ) + 1 ;

   wcscpy ( szNext, L"" ) ;

   return szFilter ;
}



// t@C̎ނ̕\
int DisplaySupportedFormat ( HWND hWnd, int nType, int nCode ) {

   int nCodePage = GetCodePageFromTypeAndCode ( nType, nCode ) ;

   if ( IsNT () ) {
      wchar_t szBuffer [ MAX_PATH ] ;
      LoadStringExW ( IDS_SUPPORTEDFORMAT, szBuffer, MAX_PATH ) ;
      if ( nCodePage == CP_HZ_CHINESE_SIMPLIFIED ) Dlg_Wm_SetTextFormatW ( hWnd, IDS_STATIC_SUPPORTEDFORMAT, L"%s%s", szBuffer, GetStringW ( IDS_TEXTFILES ) ) ;
      else if ( nCodePage == CP_JAPANESE_FW )      Dlg_Wm_SetTextFormatW ( hWnd, IDS_STATIC_SUPPORTEDFORMAT, L"%s%s", szBuffer, GetStringW ( IDS_TEXTFILES ) ) ;
      else if ( nCodePage == CP_JAPANESE_TM )      Dlg_Wm_SetTextFormatW ( hWnd, IDS_STATIC_SUPPORTEDFORMAT, L"%s%s", szBuffer, GetStringW ( IDS_TMFILES ) ) ;
      else                                         Dlg_Wm_SetTextFormatW ( hWnd, IDS_STATIC_SUPPORTEDFORMAT, L"%s%s", szBuffer, GetStringW ( IDS_NORMALFILES ) ) ;
   }
   else {
      char szBuffer [ MAX_PATH ] ;
      LoadStringExA ( IDS_SUPPORTEDFORMAT, szBuffer, MAX_PATH ) ;
      if ( nCodePage == CP_HZ_CHINESE_SIMPLIFIED ) Dlg_Wm_SetTextFormatA ( hWnd, IDS_STATIC_SUPPORTEDFORMAT, "%s%s", szBuffer, GetStringA ( IDS_TEXTFILES ) ) ;
      else if ( nCodePage == CP_JAPANESE_FW )      Dlg_Wm_SetTextFormatA ( hWnd, IDS_STATIC_SUPPORTEDFORMAT, "%s%s", szBuffer, GetStringA ( IDS_TEXTFILES ) ) ;
      else if ( nCodePage == CP_JAPANESE_TM )      Dlg_Wm_SetTextFormatA ( hWnd, IDS_STATIC_SUPPORTEDFORMAT, "%s%s", szBuffer, GetStringA ( IDS_TMFILES ) ) ;
      else                                         Dlg_Wm_SetTextFormatA ( hWnd, IDS_STATIC_SUPPORTEDFORMAT, "%s%s", szBuffer, GetStringA ( IDS_NORMALFILES ) ) ;
   }

   return 0 ;
}



// G[Ȃ 0 Ԃ
int GetCodePageFromTypeAndCode ( int nType, int nCode ) {

   switch ( nType ) {
      case TYPE_GB :     return CP_CHINESE_SIMPLIFIED ;
      case TYPE_BIG5 :   return CP_CHINESE_TRADITIONAL ;
      case TYPE_PSEUDO : if ( nCode >= 0 && nCode < AVAILABLE_CODE_LIST_NELEM ) return ( AvailableCodeList [ nCode ] ).nCodePage ;
                         else                                                   return 0 ;
      case TYPE_HZ :     return CP_HZ_CHINESE_SIMPLIFIED ;
      default :          return 0 ;
   }
}



////////////////////////////////////////////
//               r                 //
////////////////////////////////////////////



// nValue  0 ܂͐ȂAli[
// nValue ̑O̒lԂ
int SetSemaphore ( int nValue ) {

   static volatile long nSemaphore ;

   if ( nValue < 0 ) return nSemaphore ;

   return InterlockedExchange ( & nSemaphore, nValue ) ;
}



////////////////////////////////////////////
//            Ro[^N              //
////////////////////////////////////////////



int CallChnconv ( HWND hWnd, volatile int *pIsAborted ) ;



int ConversionThread ( void *pConversionThreadInfo ) {

   // Z}tH擾
   // ȍ~AUnlockSemaphore() ܂ return Ȃ
   if ( LockSemaphore () ) return 1 ;

   HWND hWnd = ( (CONVERSIONTHREADINFO*) pConversionThreadInfo )->hWnd ;
   volatile int *pIsAborted = ( (CONVERSIONTHREADINFO*) pConversionThreadInfo )->pIsAborted ;

   // hbOAhhbv֎~
   for ( int nCount = 0 ; nCount < SRC_DST_FILE_NELEM ; nCount ++ ) {
      DragAcceptFiles ( GetDlgItem ( hWnd, IDC_EDIT_SRC_MIN + nCount ), FALSE ) ;
      DragAcceptFiles ( GetDlgItem ( hWnd, IDC_EDIT_DST_MIN + nCount ), FALSE ) ;
   }

   // GfBbgRg[̕ҏW֎~
   for ( int nCount = 0 ; nCount < SRC_DST_FILE_NELEM ; nCount ++ ) {
      Dlg_Edit_SetReadOnly ( hWnd, IDC_EDIT_SRC_MIN + nCount, TRUE ) ;
      Dlg_Edit_SetReadOnly ( hWnd, IDC_EDIT_DST_MIN + nCount, TRUE ) ;
   }

   // s֐Ăяo
   if ( DEBUG_SEMAPHORE ) {
      for ( int nCount = 10 ; nCount && ! *pIsAborted ; nCount -- ) {
         Dlg_Wm_SetTextFormatA ( hWnd, IDC_EDIT_DST_MIN + SRC_DST_FILE_NELEM - 1, "%d", nCount ) ;
         Sleep ( 1000 ) ;
      }
      Dlg_Wm_SetTextA ( hWnd, IDC_EDIT_DST_MIN + SRC_DST_FILE_NELEM - 1, "" ) ;
      MessageBeep ( MB_OK ) ;
   }
   else {
      CallChnconv ( hWnd, pIsAborted ) ;
   }

   // GfBbgRg[̕ҏWĊJ
   for ( int nCount = 0 ; nCount < SRC_DST_FILE_NELEM ; nCount ++ ) {
      Dlg_Edit_SetReadOnly ( hWnd, IDC_EDIT_SRC_MIN + nCount, FALSE ) ;
      Dlg_Edit_SetReadOnly ( hWnd, IDC_EDIT_DST_MIN + nCount, FALSE ) ;
   }

   // hbOAhhbvĊJ
   for ( int nCount = 0 ; nCount < SRC_DST_FILE_NELEM ; nCount ++ ) {
      DragAcceptFiles ( GetDlgItem ( hWnd, IDC_EDIT_SRC_MIN + nCount ), TRUE ) ;
      DragAcceptFiles ( GetDlgItem ( hWnd, IDC_EDIT_DST_MIN + nCount ), TRUE ) ;
   }

   // Z}tH
   UnlockSemaphore () ;

   return 0 ;
}



int CallChnconvA ( HWND hWnd, volatile int *pIsAborted, int nSrcCodePage, int nDstCodePage, const CHNCONVEXINFO *pInfo ) ;
int CallChnconvW ( HWND hWnd, volatile int *pIsAborted, int nSrcCodePage, int nDstCodePage, const CHNCONVEXINFO *pInfo ) ;
int TestFileNameA ( HWND hWnd, int nCount ) ;
int TestFileNameW ( HWND hWnd, int nCount ) ;



// t@C擾Ro[^N
int CallChnconv ( HWND hWnd, volatile int *pIsAborted ) {


   // bZ[W̏
   for ( int nCount = 0 ; nCount < SRC_DST_FILE_NELEM ; nCount ++ ) SetStatusIcon ( hWnd, nCount, STATUS_ICON_READY ) ;


   // ̓R[h
   int nSrcCodePage = GetCodePageFromTypeAndCode ( nSrcType, nSrcCode ) ;
   int nDstCodePage = GetCodePageFromTypeAndCode ( nDstType, nDstCode ) ;

   // ̓R[hƏo̓R[hȂG[
   if ( nSrcCodePage == nDstCodePage ) {
      if ( IsNT () ) MessageBoxW ( hWnd, GetStringW ( IDS_CANNOTSAMECODE ), szCommandNameW, MB_OK ) ;
      else           MessageBoxA ( hWnd, GetStringA ( IDS_CANNOTSAMECODE ), szCommandNameA, MB_OK ) ;
      return 1 ;
   }


   // n Ԗڂ̃t@C
   for ( int nCount = 0 ; nCount < SRC_DST_FILE_NELEM ; nCount ++ ) {
      int nResult ;
      if ( IsNT () ) nResult = TestFileNameW ( hWnd, nCount ) ;
      else           nResult = TestFileNameA ( hWnd, nCount ) ;
      if ( nResult ) return 1 ;
   }


   // DLLW[擾
   if ( LoadChnconvDll () ) {
      if ( IsNT () ) MessageBoxW ( hWnd, GetStringW ( IDS_DLLERROR ), szCommandNameW, MB_OK ) ;
      else           MessageBoxA ( hWnd, GetStringA ( IDS_DLLERROR ), szCommandNameA, MB_OK ) ;
      return -1 ;
   }


   CHNCONVEXINFO Info = { sizeof(CHNCONVEXINFO) } ;
   CHNFONTINFO FontInfo = { sizeof(CHNFONTINFO) } ;
   Info.pFontInfo = & FontInfo ;

   RESERVEDINFO ReservedInfo = { sizeof(RESERVEDINFO) } ;
   Info.pReserved = (void*) & ReservedInfo ;


   // IvVݒ
   Info.dwConversionMode = TranslateConversionMode ( nSrcCodePage, nDstCodePage ) ;
   Info.dwAdditionalMode = TranslateAdditionalMode ( nSrcCodePage, nDstCodePage ) ;

   // tHgTCY
   Info.nFontSize = nTmFontSize ;
   if ( ! Info.nFontSize ) Info.nFontSize = -1 ;

   // tHgݒ
   if ( nDstCodePage == CP_CHINESE_SIMPLIFIED || nDstCodePage == CP_CHINESE_TRADITIONAL ) {
      if ( *szGbFont )           FontInfo.pGbFont = szGbFont ;
      if ( *szGbGothicFont )     FontInfo.pGbGothicFont = szGbGothicFont ;
      if ( *szBig5Font )         FontInfo.pBig5Font = szBig5Font ;
      if ( *szBig5GothicFont )   FontInfo.pBig5GothicFont = szBig5GothicFont ;
      if ( *szPinyinFont )       FontInfo.pPinyinFont = szPinyinFont ;
      if ( *szPinyinGothicFont ) FontInfo.pPinyinGothicFont = szPinyinGothicFont ;
   }

   // O`̓ǂݍ
   GAIJIINFO GaijiInfo = { 0 } ;
   int nGaijiErrorLineNumber ;
   int nGaijiResult ;
   if ( IsNT () ) nGaijiResult = ReadGaijiFileW ( NULL, nSrcCodePage, nDstCodePage, & GaijiInfo, & nGaijiErrorLineNumber ) ;
   else           nGaijiResult = ReadGaijiFileA ( NULL, nSrcCodePage, nDstCodePage, & GaijiInfo, & nGaijiErrorLineNumber ) ;
   if ( nGaijiResult < 0 ) {
      if ( IsNT () ) {
         wchar_t szBuffer [ MESSAGE_BUFFER_SIZE ] ;
         if ( nGaijiErrorLineNumber ) swprintf ( szBuffer, GetStringW ( IDS_GAIJIFILE_ERROR ), GAIJI_FILENAME_W, nGaijiErrorLineNumber ) ;
         else                         swprintf ( szBuffer, L"Reading %s -- %s", GAIJI_FILENAME_W, GetStringW ( IDS_NOT_ENOUGH_MEMORY ) ) ;
         MessageBoxW ( hWnd, szBuffer, szCommandNameW, MB_OK ) ;
      }
      else {
         char szBuffer [ MESSAGE_BUFFER_SIZE ] ;
         if ( nGaijiErrorLineNumber ) sprintf ( szBuffer, GetStringA ( IDS_GAIJIFILE_ERROR ), GAIJI_FILENAME_A, nGaijiErrorLineNumber ) ;
         else                         sprintf ( szBuffer, "Reading %s -- %s", GAIJI_FILENAME_A, GetStringA ( IDS_NOT_ENOUGH_MEMORY ) ) ;
         MessageBoxA ( hWnd, szBuffer, szCommandNameA, MB_OK ) ;
      }
      return -1 ;
   }
   Info.pSrcToDst          = GaijiInfo.pSrcToDst ;
   Info.nNumberOfSrcToDst  = GaijiInfo.nNumberOfSrcToDst ;
   Info.pSrcToUc           = GaijiInfo.pSrcToUc ;
   Info.nNumberOfSrcToUc   = GaijiInfo.nNumberOfSrcToUc ;


   int nResult ;
   if ( IsNT () ) nResult = CallChnconvW ( hWnd, pIsAborted, nSrcCodePage, nDstCodePage, & Info ) ;
   else           nResult = CallChnconvA ( hWnd, pIsAborted, nSrcCodePage, nDstCodePage, & Info ) ;

   FreeGaijiInfo ( & GaijiInfo ) ;
   return nResult ;
}



// mԖڂ̃t@CiANSIŁj
// G[Ȃ烁bZ[W\ 0 ȊOԂ
int TestFileNameA ( HWND hWnd, int nFileNumber ) {

   char szSrcFileName [ MAX_PATH ] ;
   char szDstFileName [ MAX_PATH ] ;

   Dlg_Wm_GetTextA ( hWnd, IDC_EDIT_SRC_MIN + nFileNumber, szSrcFileName, MAX_PATH ) ;
   Dlg_Wm_GetTextA ( hWnd, IDC_EDIT_DST_MIN + nFileNumber, szDstFileName, MAX_PATH ) ;
   UnquoteFileNameA ( szSrcFileName ) ;
   UnquoteFileNameA ( szDstFileName ) ;

   int nResult = 0 ;
   if ( ! *szSrcFileName && *szDstFileName ) nResult = 1 ;
   if ( *szSrcFileName && ! *szDstFileName ) nResult = 2 ;
   if ( nResult ) {
      if ( nResult == 1 ) MessageBoxFormatA ( hWnd, szCommandNameA, MB_OK, GetStringA ( IDS_SPECIFYSRCFILE ), nFileNumber + 1 ) ;
      else                MessageBoxFormatA ( hWnd, szCommandNameA, MB_OK, GetStringA ( IDS_SPECIFYDSTFILE ), nFileNumber + 1 ) ;
      return 1 ;
   }

   return 0 ;
}



// mԖڂ̃t@CiUNICODEŁj
// G[Ȃ烁bZ[W\ 0 ȊOԂ
int TestFileNameW ( HWND hWnd, int nFileNumber ) {

   wchar_t szSrcFileName [ MAX_PATH ] ;
   wchar_t szDstFileName [ MAX_PATH ] ;

   Dlg_Wm_GetTextW ( hWnd, IDC_EDIT_SRC_MIN + nFileNumber, szSrcFileName, MAX_PATH ) ;
   Dlg_Wm_GetTextW ( hWnd, IDC_EDIT_DST_MIN + nFileNumber, szDstFileName, MAX_PATH ) ;
   UnquoteFileNameW ( szSrcFileName ) ;
   UnquoteFileNameW ( szDstFileName ) ;

   int nResult = 0 ;
   if ( ! *szSrcFileName && *szDstFileName ) nResult = 1 ;
   if ( *szSrcFileName && ! *szDstFileName ) nResult = 2 ;
   if ( nResult ) {
      if ( nResult == 1 ) MessageBoxFormatW ( hWnd, szCommandNameW, MB_OK, GetStringW ( IDS_SPECIFYSRCFILE ), nFileNumber + 1 ) ;
      else                MessageBoxFormatW ( hWnd, szCommandNameW, MB_OK, GetStringW ( IDS_SPECIFYDSTFILE ), nFileNumber + 1 ) ;
      return 1 ;
   }

   return 0 ;
}



int ExecChnconvA ( HWND hWnd, char *szSrcFileName, char *szDstFileName, int nSrcCodePage, int nDstCodePage, const CHNCONVEXINFO *pInfo ) ;
int ExecChnconvW ( HWND hWnd, wchar_t *szSrcFileName, wchar_t *szDstFileName, int nSrcCodePage, int nDstCodePage, const CHNCONVEXINFO *pInfo ) ;
char *GetChnconvErrorMessageA ( int nError, int nSrcCodePage ) ;
wchar_t *GetChnconvErrorMessageW ( int nError, int nSrcCodePage ) ;

#define CP_DEFINE_CODEPAGE    0x0000FFFF     // R[hy[W̒`
#define CP_DEFINE_PSEUDOCODE  0x000F0000     // [̒`



// t@C擾Ro[^NiANSIŁj
int CallChnconvA ( HWND hWnd, volatile int *pIsAborted, int nSrcCodePage, int nDstCodePage, const CHNCONVEXINFO *pInfo ) {

   char szSrcFileName [ MAX_PATH + 0x10 ] ;
   char szDstFileName [ MAX_PATH + 0x10 ] ;
   char szMessageBuffer [ MESSAGE_BUFFER_SIZE ] ;

   int nCountSuccess = 0 ;
   int nCountFailure = 0 ;

   // ^CgύX
   // ȍ~A^Cg߂܂ return Ȃ
   SetMainDialogTitle ( hWnd, 1 ) ;

   // bZ[Wobt@̏
   *szMessageBuffer = 0 ;

   // t@C擾ϊs
   for ( int nCount = 0 ; nCount < SRC_DST_FILE_NELEM ; nCount ++ ) {

      // ߂Ɏ擾A牺֐G[Ԃ
      Dlg_Wm_GetTextA ( hWnd, IDC_EDIT_SRC_MIN + nCount, szSrcFileName, MAX_PATH + 4 ) ;
      Dlg_Wm_GetTextA ( hWnd, IDC_EDIT_DST_MIN + nCount, szDstFileName, MAX_PATH + 4 ) ;
      UnquoteFileNameA ( szSrcFileName ) ;
      UnquoteFileNameA ( szDstFileName ) ;
      if ( ! *szSrcFileName ) continue ;

      SetStatusIcon ( hWnd, nCount, STATUS_ICON_NOW ) ;

      // KvȂΏo̓t@CɊgqt
      if ( ! IsNoAddExtension && ! IsFileExistA ( szDstFileName ) ) {
         char *szSrcExtension = GetExtensionA ( szSrcFileName ) ;
         char *szDstExtension = GetExtensionA ( szDstFileName ) ;
         if ( szSrcExtension && ! stricmp ( szSrcExtension, "RTF" ) || IsNecChineseCodePage ( nSrcCodePage ) ) {
            if ( ! szDstExtension || stricmp ( szDstExtension, "RTF" ) ) {
               strcat ( szDstFileName, ".rtf" ) ;
               Dlg_Wm_SetTextA ( hWnd, IDC_EDIT_DST_1 + nCount, szDstFileName ) ;
               Dlg_MoveCaretToEnd ( hWnd, IDC_EDIT_DST_1 + nCount ) ;
            }
         }
         else {
            if ( ! szDstExtension || ( nDstCodePage & CP_DEFINE_CODEPAGE ) != CP_JAPANESE && stricmp ( szDstExtension, "TXT" ) || ! stricmp ( szDstExtension, "RTF" ) ) {
               strcat ( szDstFileName, ".txt" ) ;
               Dlg_Wm_SetTextA ( hWnd, IDC_EDIT_DST_1 + nCount, szDstFileName ) ;
               Dlg_MoveCaretToEnd ( hWnd, IDC_EDIT_DST_1 + nCount ) ;
            }
         }
      }

      // ϊs
      int nResult ;
      if ( *pIsAborted ) nResult = CONV_ERROR_ABORTED ;
      else               nResult = ExecChnconvA ( hWnd, szSrcFileName, szDstFileName, nSrcCodePage, nDstCodePage, pInfo ) ;
      if ( nResult ) {
         SetStatusIcon ( hWnd, nCount, STATUS_ICON_FAILURE ) ;
         nCountFailure ++ ;
         if ( nResult < 0 ) break ;
         if ( ! IsNoMessage ) {
            char *szTail = strend ( szMessageBuffer ) ;
            char *Auguments [] = { (char*)(LONG_PTR) ( nCount + 1 ), GetChnconvErrorMessageA ( nResult, nSrcCodePage ), 0 } ;
            FormatMessageA ( FORMAT_MESSAGE_FROM_STRING | FORMAT_MESSAGE_ARGUMENT_ARRAY, GetStringA ( IDS_CHNCONVERROR ), 0, 0, szTail, (int) ( MESSAGE_BUFFER_SIZE - ( szTail - szMessageBuffer ) ), (va_list*) Auguments ) ;
         }
      }
      else {
         SetStatusIcon ( hWnd, nCount, STATUS_ICON_SUCCESS ) ;
         nCountSuccess ++ ;
      }
   }

   // ^Cg߂
   SetMainDialogTitle ( hWnd, 0 ) ;

   if ( ! IsNoMessage ) {
      if ( nCountSuccess || nCountFailure ) sprintf ( strend ( szMessageBuffer ), GetStringA ( IDS_CONVERTEDFILE ), nCountSuccess ) ;
      else                                  strcpy ( szMessageBuffer, GetStringA ( IDS_DIDNOTCONVERTFILE ) ) ;
      MessageBoxA ( hWnd, szMessageBuffer, szCommandNameA, MB_OK ) ;
   }

   return 0 ;
}



// t@C擾Ro[^NiUNICODEŁj
int CallChnconvW ( HWND hWnd, volatile int *pIsAborted, int nSrcCodePage, int nDstCodePage, const CHNCONVEXINFO *pInfo ) {

   wchar_t szSrcFileName [ MAX_PATH + 0x10 ] ;
   wchar_t szDstFileName [ MAX_PATH + 0x10 ] ;
   wchar_t szMessageBuffer [ MESSAGE_BUFFER_SIZE ] ;

   int nCountSuccess = 0 ;
   int nCountFailure = 0 ;

   // ^CgύX
   // ȍ~A^Cg߂܂ return Ȃ
   SetMainDialogTitle ( hWnd, 1 ) ;

   // bZ[Wobt@̏
   *szMessageBuffer = 0 ;

   // t@C擾ϊs
   for ( int nCount = 0 ; nCount < SRC_DST_FILE_NELEM ; nCount ++ ) {

      // ߂Ɏ擾A牺֐G[Ԃ
      Dlg_Wm_GetTextW ( hWnd, IDC_EDIT_SRC_MIN + nCount, szSrcFileName, MAX_PATH + 4 ) ;
      Dlg_Wm_GetTextW ( hWnd, IDC_EDIT_DST_MIN + nCount, szDstFileName, MAX_PATH + 4 ) ;
      UnquoteFileNameW ( szSrcFileName ) ;
      UnquoteFileNameW ( szDstFileName ) ;
      if ( ! *szSrcFileName ) continue ;

      SetStatusIcon ( hWnd, nCount, STATUS_ICON_NOW ) ;

      // KvȂΏo̓t@CɊgqt
      if ( ! IsNoAddExtension && ! IsFileExistW ( szDstFileName ) ) {
         wchar_t *szSrcExtension = GetExtensionW ( szSrcFileName ) ;
         wchar_t *szDstExtension = GetExtensionW ( szDstFileName ) ;
         if ( szSrcExtension && ! wcsicmp ( szSrcExtension, L"RTF" ) || IsNecChineseCodePage ( nSrcCodePage ) ) {
            if ( ! szDstExtension || wcsicmp ( szDstExtension, L"RTF" ) ) {
               wcscat ( szDstFileName, L".rtf" ) ;
               Dlg_Wm_SetTextW ( hWnd, IDC_EDIT_DST_1 + nCount, szDstFileName ) ;
               Dlg_MoveCaretToEnd ( hWnd, IDC_EDIT_DST_1 + nCount ) ;
            }
         }
         else {
            if ( ! szDstExtension || ( nDstCodePage & CP_DEFINE_CODEPAGE ) != CP_JAPANESE && wcsicmp ( szDstExtension, L"TXT" ) || ! wcsicmp ( szDstExtension, L"RTF" ) ) {
               wcscat ( szDstFileName, L".txt" ) ;
               Dlg_Wm_SetTextW ( hWnd, IDC_EDIT_DST_1 + nCount, szDstFileName ) ;
               Dlg_MoveCaretToEnd ( hWnd, IDC_EDIT_DST_1 + nCount ) ;
            }
         }
      }

      // ϊs
      int nResult ;
      if ( *pIsAborted ) nResult = CONV_ERROR_ABORTED ;
      else               nResult = ExecChnconvW ( hWnd, szSrcFileName, szDstFileName, nSrcCodePage, nDstCodePage, pInfo ) ;
      if ( nResult ) {
         SetStatusIcon ( hWnd, nCount, STATUS_ICON_FAILURE ) ;
         nCountFailure ++ ;
         if ( nResult < 0 ) break ;
         if ( ! IsNoMessage ) {
            wchar_t *szTail = wcsend ( szMessageBuffer ) ;
            wchar_t *Auguments [] = { (wchar_t*)(LONG_PTR) ( nCount + 1 ), GetChnconvErrorMessageW ( nResult, nSrcCodePage ), 0 } ;
            FormatMessageW ( FORMAT_MESSAGE_FROM_STRING | FORMAT_MESSAGE_ARGUMENT_ARRAY, GetStringW ( IDS_CHNCONVERROR ), 0, 0, szTail, (int) ( MESSAGE_BUFFER_SIZE - ( szTail - szMessageBuffer ) ), (va_list*) Auguments ) ;
         }
      }
      else {
         SetStatusIcon ( hWnd, nCount, STATUS_ICON_SUCCESS ) ;
         nCountSuccess ++ ;
      }
   }

   // ^Cg߂
   SetMainDialogTitle ( hWnd, 0 ) ;

   if ( ! IsNoMessage ) {
      if ( nCountSuccess || nCountFailure ) swprintf ( wcsend ( szMessageBuffer ), GetStringW ( IDS_CONVERTEDFILE ), nCountSuccess ) ;
      else                                  wcscpy ( szMessageBuffer, GetStringW ( IDS_DIDNOTCONVERTFILE ) ) ;
      MessageBoxW ( hWnd, szMessageBuffer, szCommandNameW, MB_OK ) ;
   }

   return 0 ;
}



// CHNCONV ĂяoiANSIŁj
// ߂ĺACHNCONV ̕Ԃl̂܂ܕԂ
int ExecChnconvA ( HWND hWnd, char *szSrcFileName, char *szDstFileName, int nSrcCodePage, int nDstCodePage, const CHNCONVEXINFO *pInfo ) {

   char szRealSrcFileName [ MAX_PATH ] ;
   char szRealDstFileName [ MAX_PATH ] ;
   char szTempFileName [ MAX_PATH ] ;
   char szCurrentFolder [ MAX_PATH ] ;

   int nExitCode ;


   // {̃t@C擾
   GetSpecialFolderPathA ( hWnd, szCurrentFolder, CSIDL_PERSONAL, 0 ) ;
   SetCurrentDirectoryA ( szCurrentFolder ) ;
   if ( ! GetFullPathNameExA ( szSrcFileName, szRealSrcFileName, MAX_PATH ) ) return CONV_ERROR_READ ;
   strcpy ( szCurrentFolder, szRealSrcFileName ) ;
   ChangeFileNameA ( szCurrentFolder, NULL ) ;
   SetPathSeparatorA ( szCurrentFolder, ADD_SEPARATOR_ONLY_ROOT ) ;
   SetCurrentDirectoryA ( szCurrentFolder ) ;
   if ( ! GetFullPathNameExA ( szDstFileName, szRealDstFileName, MAX_PATH ) ) return CONV_ERROR_WRITE ;

   // JgfBNg߂
   GetModuleFileNameA ( NULL, szCurrentFolder, MAX_PATH ) ;
   ChangeFileNameA ( szCurrentFolder, NULL ) ;
   SetPathSeparatorA ( szCurrentFolder, ADD_SEPARATOR_ONLY_ROOT ) ;
   SetCurrentDirectoryA ( szCurrentFolder ) ;


   // t@CANZX̌
   if ( ! IsFileReadableA ( szRealSrcFileName ) ) return CONV_ERROR_READ ;
   if ( ! IsFileWritableA ( szRealDstFileName ) ) return CONV_ERROR_WRITE ;


   // ϊs
   if ( IsFileExistA ( szRealDstFileName ) ) {
      if ( GetTempFileNameExA ( TEMPFILE_HEADER_A, szTempFileName ) ) return CONV_ERROR_UNKNOWN ;
      nExitCode = ChnconvExA ( szRealSrcFileName, szTempFileName, nSrcCodePage, nDstCodePage, pInfo ) ;
      if ( ! nExitCode && IsFileExistA ( szRealDstFileName ) ) {
         nExitCode = CONV_ERROR_ABORTED ;
         if ( IsNoConfirm || MessageBoxFormatA ( hWnd, szCommandNameA, MB_OKCANCEL, GetStringA ( IDS_ASKOVERWRITE ), szDstFileName ) == IDOK ) {
            nExitCode = CONV_ERROR_WRITE ;
            if ( IsFileWritableA ( szRealDstFileName ) ) {
               if ( IsNoRecycle ) DeleteFileA ( szRealDstFileName ) ;
               else               ShellDeleteFileA ( NULL, szRealDstFileName, 0 ) ;
               if ( MoveFileA ( szTempFileName, szRealDstFileName ) ) nExitCode = 0 ;
            }
         }
      }
      if ( IsFileExistA ( szTempFileName ) ) DeleteFileA ( szTempFileName ) ;
   }
   else {
      nExitCode = ChnconvExA ( szRealSrcFileName, szRealDstFileName, nSrcCodePage, nDstCodePage, pInfo ) ;
      if ( nExitCode && IsFileExistA ( szRealDstFileName ) ) DeleteFileA ( szRealDstFileName ) ;
   }

   if ( ! nExitCode ) ShellChangeNotifyA ( 0, szRealDstFileName, NULL, 0 ) ;

#ifndef _MT
   if ( pInfo->dwConversionMode & CONVMODE_PEEKMESSAGE ) {
      MSG Msg ;
      while ( PeekMessageA ( & Msg, hWnd, 0, 0, PM_REMOVE ) ) {
         TranslateMessage ( & Msg ) ;
         DispatchMessageA ( & Msg ) ;
      }
   }
#endif

   return nExitCode ;
}



// CHNCONV ĂяoiUNICODEŁj
// ߂ĺACHNCONV ̕Ԃl̂܂ܕԂ
int ExecChnconvW ( HWND hWnd, wchar_t *szSrcFileName, wchar_t *szDstFileName, int nSrcCodePage, int nDstCodePage, const CHNCONVEXINFO *pInfo ) {

   wchar_t szRealSrcFileName [ MAX_PATH ] ;
   wchar_t szRealDstFileName [ MAX_PATH ] ;
   wchar_t szTempFileName [ MAX_PATH ] ;
   wchar_t szCurrentFolder [ MAX_PATH ] ;

   int nExitCode ;


   // {̃t@C擾
   GetSpecialFolderPathW ( hWnd, szCurrentFolder, CSIDL_PERSONAL, 0 ) ;
   SetCurrentDirectoryW ( szCurrentFolder ) ;
   if ( ! GetFullPathNameExW ( szSrcFileName, szRealSrcFileName, MAX_PATH ) ) return CONV_ERROR_READ ;
   wcscpy ( szCurrentFolder, szRealSrcFileName ) ;
   ChangeFileNameW ( szCurrentFolder, NULL ) ;
   SetPathSeparatorW ( szCurrentFolder, ADD_SEPARATOR_ONLY_ROOT ) ;
   SetCurrentDirectoryW ( szCurrentFolder ) ;
   if ( ! GetFullPathNameExW ( szDstFileName, szRealDstFileName, MAX_PATH ) ) return CONV_ERROR_WRITE ;

   // JgfBNg߂
   GetModuleFileNameW ( NULL, szCurrentFolder, MAX_PATH ) ;
   ChangeFileNameW ( szCurrentFolder, NULL ) ;
   SetPathSeparatorW ( szCurrentFolder, ADD_SEPARATOR_ONLY_ROOT ) ;
   SetCurrentDirectoryW ( szCurrentFolder ) ;


   // t@CANZX̌
   if ( ! IsFileReadableW ( szRealSrcFileName ) ) return CONV_ERROR_READ ;
   if ( ! IsFileWritableW ( szRealDstFileName ) ) return CONV_ERROR_WRITE ;


   // ϊs
   if ( IsFileExistW ( szRealDstFileName ) ) {
      if ( GetTempFileNameExW ( TEMPFILE_HEADER_W, szTempFileName ) ) return CONV_ERROR_UNKNOWN ;
      nExitCode = ChnconvExW ( szRealSrcFileName, szTempFileName, nSrcCodePage, nDstCodePage, pInfo ) ;
      if ( ! nExitCode && IsFileExistW ( szRealDstFileName ) ) {
         nExitCode = CONV_ERROR_ABORTED ;
         if ( IsNoConfirm || MessageBoxFormatW ( hWnd, szCommandNameW, MB_OKCANCEL, GetStringW ( IDS_ASKOVERWRITE ), szDstFileName ) == IDOK ) {
            nExitCode = CONV_ERROR_WRITE ;
            if ( IsFileWritableW ( szRealDstFileName ) ) {
               if ( IsNoRecycle ) DeleteFileW ( szRealDstFileName ) ;
               else               ShellDeleteFileW ( NULL, szRealDstFileName, 0 ) ;
               if ( MoveFileW ( szTempFileName, szRealDstFileName ) ) nExitCode = 0 ;
            }
         }
      }
      if ( IsFileExistW ( szTempFileName ) ) DeleteFileW ( szTempFileName ) ;
   }
   else {
      nExitCode = ChnconvExW ( szRealSrcFileName, szRealDstFileName, nSrcCodePage, nDstCodePage, pInfo ) ;
      if ( nExitCode && IsFileExistW ( szRealDstFileName ) ) DeleteFileW ( szRealDstFileName ) ;
   }

   if ( ! nExitCode ) ShellChangeNotifyW ( 0, szRealDstFileName, NULL, 0 ) ;

#ifndef _MT
   if ( pInfo->dwConversionMode & CONVMODE_PEEKMESSAGE ) {
      MSG Msg ;
      while ( PeekMessageW ( & Msg, hWnd, 0, 0, PM_REMOVE ) ) {
         TranslateMessage ( & Msg ) ;
         DispatchMessageW ( & Msg ) ;
      }
   }
#endif

   return nExitCode ;
}



// GetChnconvErrorMessage ̉֐
int GetStringIdFromChnconvError ( int nError, int nSrcCodePage ) {
   switch ( nError ) {
      case CONV_ERROR_READ :     return IDS_CONV_ERROR_READ ;
      case CONV_ERROR_WRITE :    return IDS_CONV_ERROR_WRITE ;
      case CONV_ERROR_FORMAT :
      case CONV_ERROR_BRACE :    return ( nSrcCodePage==CP_JAPANESE_TM ) ? IDS_CONV_ERROR_TMFORMAT : IDS_CONV_ERROR_FORMAT ;
      case CONV_ERROR_MEMORY :   return IDS_CONV_ERROR_MEMORY ;
      case CONV_ERROR_CODEPAGE : return IDS_CONV_ERROR_CODEPAGE ;
      case CONV_ERROR_ABORTED :  return IDS_CONV_ERROR_ABORTED ;
      default :                  return IDS_CONV_ERROR_UNKNOWN ;
   }
}



// CHNCONV ̃G[lɂӂ킵ԂiANSIŁj
char *GetChnconvErrorMessageA ( int nError, int nSrcCodePage ) {
   static char szBuffer [ SHORTSTRING_MAX ] ;
   LoadStringExA ( GetStringIdFromChnconvError ( nError, nSrcCodePage ), szBuffer, MAX_PATH ) ;
   return szBuffer ;
}



// CHNCONV ̃G[lɂӂ킵ԂiUNICODEŁj
wchar_t *GetChnconvErrorMessageW ( int nError, int nSrcCodePage ) {
   static wchar_t szBuffer [ SHORTSTRING_MAX ] ;
   LoadStringExW ( GetStringIdFromChnconvError ( nError, nSrcCodePage ), szBuffer, MAX_PATH ) ;
   return szBuffer ;
}



////////////////////////////////////////////
//               wv\               //
////////////////////////////////////////////



INT_PTR CALLBACK HelpDialogProc ( HWND hWnd, unsigned int dwMessage, WPARAM wParam, LPARAM lParam ) ;
int GetChnconvDllVersion ( void ) ;



int DisplayHelp ( HWND hWnd ) {
   // EBhE\
   if ( IsNT () ) DialogBoxExW ( IDD_DIALOG_HELP, hWnd, HelpDialogProc ) ;
   else           DialogBoxExA ( IDD_DIALOG_HELP, hWnd, HelpDialogProc ) ;
   return 0 ;
}



// wv\_CAO
INT_PTR CALLBACK HelpDialogProc ( HWND hWnd, unsigned int dwMessage, WPARAM wParam, LPARAM lParam ) {

   int nDllVersion ;
   int nGaijiResult ;
   int nGaijiErrorLineNumber ;

   switch ( dwMessage ) {

      case WM_INITDIALOG :

         MoveWindowToCenter ( hWnd ) ;

         // ^Cgݒ
         if ( IsNT () ) Wm_SetTextFormatW ( hWnd, L"%s  %s  %s", szCommandNameW, GetVersionCopyrightW (), WIN3264BIT_SUFFIX_W ) ;
         else           Wm_SetTextFormatA ( hWnd,  "%s  %s  %s", szCommandNameA, GetVersionCopyrightA (), WIN3264BIT_SUFFIX_A ) ;

         nDllVersion = GetChnconvDllVersion () ;
         if ( IsNT () ) nGaijiResult = ReadGaijiFileW ( NULL, 0, 0, NULL, & nGaijiErrorLineNumber ) ;
         else           nGaijiResult = ReadGaijiFileA ( NULL, 0, 0, NULL, & nGaijiErrorLineNumber ) ;

         if ( IsNT () ) {
            wchar_t szBuffer [ MESSAGE_BUFFER_SIZE ] ;
            swprintf ( szBuffer, GetStringW ( IDS_DISPLAYEXEVERSION ), nVersion / 100, nVersion % 100 ) ;
            if ( nDllVersion ) swprintf ( wcsend ( szBuffer ), GetStringW ( IDS_DISPLAYDLLVERSION ), nDllVersion / 100, nDllVersion % 100 ) ;
            else               wcscat ( szBuffer, GetStringW ( IDS_DISPLAYDLLVERSIONERROR ) ) ;
            if ( nGaijiResult > 0 ) swprintf ( wcsend ( szBuffer ), GetStringW ( IDS_GAIJIFILE_FOUND ), GAIJI_FILENAME_W ) ;
            if ( nGaijiResult < 0 ) swprintf ( wcsend ( szBuffer ), GetStringW ( IDS_GAIJIFILE_ERROR ), GAIJI_FILENAME_W, nGaijiErrorLineNumber ) ;
            Dlg_Wm_SetTextW ( hWnd, IDC_STATIC_CALL_VERSION, szBuffer ) ;
         }
         else {
            char szBuffer [ MESSAGE_BUFFER_SIZE ] ;
            sprintf ( szBuffer, GetStringA ( IDS_DISPLAYEXEVERSION ), nVersion / 100, nVersion % 100 ) ;
            if ( nDllVersion ) sprintf ( strend ( szBuffer ), GetStringA ( IDS_DISPLAYDLLVERSION ), nDllVersion / 100, nDllVersion % 100 ) ;
            else               strcat ( szBuffer, GetStringA ( IDS_DISPLAYDLLVERSIONERROR ) ) ;
            if ( nGaijiResult > 0 ) sprintf ( strend ( szBuffer ), GetStringA ( IDS_GAIJIFILE_FOUND ), GAIJI_FILENAME_A ) ;
            if ( nGaijiResult < 0 ) sprintf ( strend ( szBuffer ), GetStringA ( IDS_GAIJIFILE_ERROR ), GAIJI_FILENAME_A, nGaijiErrorLineNumber ) ;
            Dlg_Wm_SetTextA ( hWnd, IDC_STATIC_CALL_VERSION, szBuffer ) ;
         }

         return TRUE ;


      case WM_COMMAND :

         // I
         if ( LOWORD ( wParam ) == IDCANCEL ) {
            EndDialog ( hWnd, IDCANCEL ) ;
            return TRUE ;
         }

         // t@CJ
         if ( LOWORD ( wParam ) == IDC_BUTTON_OPENFILE ) {

            if ( IsNT () ) {
               wchar_t szFileName [ MAX_PATH ] ;
               GetModuleFileNameW ( NULL, szFileName, MAX_PATH ) ;
               ChangeFileNameW ( szFileName, GetStringW ( IDS_HELPFILE_FILENAME ) ) ;
               int nResult = ( ShellExecuteW ( hWnd, NULL, szFileName, NULL, szFileName, SW_SHOWDEFAULT ) <= (HINSTANCE) 32 ) ;
               if ( nResult ) MessageBoxFormatW ( hWnd, szCommandNameW, MB_OK, GetStringW ( IDS_CANNOTOPENHELPFILE ), GetFileNameW ( szFileName ) ) ;
               else           EndDialog ( hWnd, IDCANCEL ) ;
            }
            else {
               char szFileName [ MAX_PATH ] ;
               GetModuleFileNameA ( NULL, szFileName, MAX_PATH ) ;
               ChangeFileNameA ( szFileName, GetStringA ( IDS_HELPFILE_FILENAME ) ) ;
               int nResult = ( ShellExecuteA ( hWnd, NULL, szFileName, NULL, szFileName, SW_SHOWDEFAULT ) <= (HINSTANCE) 32 ) ;
               if ( nResult ) MessageBoxFormatA ( hWnd, szCommandNameA, MB_OK, GetStringA ( IDS_CANNOTOPENHELPFILE ), GetFileNameA ( szFileName ) ) ;
               else           EndDialog ( hWnd, IDCANCEL ) ;
            }

            return TRUE ;
         }

         break ;


      default :
         break ;
   }

   return FALSE ;
}



// DLL ̃o[W擾
// G[Ȃ 0 Ԃ
int GetChnconvDllVersion ( void ) {

   if ( LoadChnconvDll () ) return 0 ;

   return GetDllVersion () ;
}



////////////////////////////////////////////
//            IvVݒ              //
////////////////////////////////////////////



INT_PTR CALLBACK OptionDialogProc ( HWND hWnd, unsigned int dwMessage, WPARAM wParam, LPARAM lParam ) ;
INT_PTR CALLBACK OptionDialog1Proc ( HWND hWnd, unsigned int dwMessage, WPARAM wParam, LPARAM lParam ) ;
INT_PTR CALLBACK OptionDialog2Proc ( HWND hWnd, unsigned int dwMessage, WPARAM wParam, LPARAM lParam ) ;
INT_PTR CALLBACK OptionDialog3Proc ( HWND hWnd, unsigned int dwMessage, WPARAM wParam, LPARAM lParam ) ;
INT_PTR CALLBACK OptionDialog4Proc ( HWND hWnd, unsigned int dwMessage, WPARAM wParam, LPARAM lParam ) ;
INT_PTR CALLBACK ExModeDialogProc ( HWND hWnd, unsigned int dwMessage, WPARAM wParam, LPARAM lParam ) ;

int TabInsertItem ( HWND hTabControl, int nIndex, int nCaptionId ) ;

int GetOptionDialogFontName ( HWND hWnd, int nComboBox, char *szFontName, int nCodePage ) ;
int SetOptionDialogFontName ( HWND hWnd, int nComboBox, const char *szFontName, int nCodePage ) ;
int SetComboBoxFontName ( HWND hWnd, int nComboBox, int nCodePage ) ;

int SetComboBoxFontSize ( HWND hWnd, int nComboBox, int nDefaultFontSize ) ;
int SetComboBoxFontSizeValue ( HWND hWnd, int nComboBox, int nFontSize ) ;
int GetComboBoxFontSizeValue ( HWND hWnd, int nComboBox ) ;

int SetComboBoxMuiLangId ( HWND hWnd, int nComboBox ) ;
int GetComboBoxMuiLangId ( HWND hWnd, int nComboBox ) ;
int AllocMuiLangIdArray ( void ) ;
int FreeMuiLangIdArray ( void ) ;

#define FONTSIZE_BUFFER_MAX   8


typedef struct {
   int nTemplate ;
   int nCaption ;
   DLGPROC pDlgProc ;
   HWND hWnd ;
} PROPSHEET_DATA ;


typedef struct {
   int nPages ;
   PROPSHEET_DATA *pData ;
} PROPSHEET ;



static PROPSHEET_DATA OptionPropSheetData [] = {
   { IDD_PROPPAGE_1, IDS_PROPPAGE_1_CAPTION, OptionDialog1Proc, NULL },
   { IDD_PROPPAGE_2, IDS_PROPPAGE_2_CAPTION, OptionDialog2Proc, NULL },
   { IDD_PROPPAGE_3, IDS_PROPPAGE_3_CAPTION, OptionDialog3Proc, NULL },
   { IDD_PROPPAGE_4, IDS_PROPPAGE_4_CAPTION, OptionDialog4Proc, NULL },
} ;



int SetOption ( HWND hWnd ) {

   PROPSHEET PropSheet ;
   PropSheet.nPages = sizeof(OptionPropSheetData)/sizeof(PROPSHEET_DATA) ;
   PropSheet.pData = OptionPropSheetData ;

   if ( IsNT () ) DialogBoxParamExW ( IDD_DIALOG_OPTION, hWnd, OptionDialogProc, (LPARAM) & PropSheet ) ;
   else           DialogBoxParamExA ( IDD_DIALOG_OPTION, hWnd, OptionDialogProc, (LPARAM) & PropSheet ) ;

   if ( IsOptionChanged ) {
      int nResult ;
      if ( IsNT () ) nResult = WriteOptionW ( szConfigFileNameW ) ;
      else           nResult = WriteOptionA ( szConfigFileNameA ) ;
      if ( nResult ) {
         if ( IsNT () ) MessageBoxW ( hWnd, GetStringW ( IDS_CANNOT_SAVE_OPTION ), szCommandNameW, MB_OK ) ;
         else           MessageBoxA ( hWnd, GetStringA ( IDS_CANNOT_SAVE_OPTION ), szCommandNameA, MB_OK ) ;
      }
      else IsOptionChanged = 0 ;
   }

   return 0 ;
}



// IvVݒ_CAO
INT_PTR CALLBACK OptionDialogProc ( HWND hWnd, unsigned int dwMessage, WPARAM wParam, LPARAM lParam ) {

   static PROPSHEET_DATA *pPropSheetData ;
   static int nPropSheetPages ;
   static HWND hTabControl ;
   static RECT Rect ;
   static int nCurrentPage ;
   static HWND *pTabOrderList ;

   switch ( dwMessage ) {

      case WM_INITDIALOG :

         pPropSheetData = ( (PROPSHEET*) lParam )->pData ;
         nPropSheetPages = ( (PROPSHEET*) lParam )->nPages ;

         for ( int nCount = 0 ; nCount < nPropSheetPages ; nCount ++ ) ( pPropSheetData [ nCount ] ).hWnd = NULL ;

         if ( IsNT () ) Wm_SetTextFormatW ( hWnd, L"%s  -  %s", szCommandNameW, GetStringW ( IDS_OPTIONTITLE ) ) ;
         else           Wm_SetTextFormatA ( hWnd,  "%s  -  %s", szCommandNameA, GetStringA ( IDS_OPTIONTITLE ) ) ;

         hTabControl = GetDlgItem ( hWnd, IDC_TAB_OPTION_PROPPAGE ) ;

         // ^uRg[ɃACe}
         for ( int nCount = 0 ; nCount < nPropSheetPages ; nCount ++ ) TabInsertItem ( hTabControl, nCount, ( pPropSheetData [ nCount ] ).nCaption ) ;

         // ^uRg[̈ʒu𒲐
         GetClientRect ( hTabControl, & Rect ) ;
         TabCtrl_AdjustRect ( hTabControl, FALSE, & Rect ) ;
         MapWindowPoints ( hTabControl, hWnd, (LPPOINT) & Rect, sizeof(RECT)/sizeof(POINT) ) ;
         if ( DEBUG_TAB_CONTROL ) MessageBoxFormatA ( hWnd, "", MB_OK, "%d, %d", Rect.right - Rect.left, Rect.bottom - Rect.top ) ;

         // ^uI[_[u郊Xg쐬
         if ( 1 ) {
            int nCount = 0 ;
            for ( HWND hWndNext = hTabControl ; ( hWndNext = GetWindow ( hWndNext, GW_HWNDNEXT ) ) != NULL && hWndNext != hTabControl ; ) nCount ++ ;
            pTabOrderList = (HWND*) malloc ( sizeof(HWND*) * ( nCount + 1 ) ) ;
         }
         if ( pTabOrderList ) {
            int nCount = 0 ;
            for ( HWND hWndNext = hTabControl ; ( hWndNext = GetWindow ( hWndNext, GW_HWNDNEXT ) ) != NULL && hWndNext != hTabControl ; nCount ++ ) pTabOrderList [ nCount ] = hWndNext ;
            pTabOrderList [ nCount ] = NULL ;
         }

         // Py[Wڂ쐬
         nCurrentPage = 0 ;
         if ( IsNT () ) ( pPropSheetData [ nCurrentPage ] ).hWnd = CreateDialogExW ( ( pPropSheetData [ nCurrentPage ] ).nTemplate, hWnd, ( pPropSheetData [ nCurrentPage ] ).pDlgProc ) ;
         else           ( pPropSheetData [ nCurrentPage ] ).hWnd = CreateDialogExA ( ( pPropSheetData [ nCurrentPage ] ).nTemplate, hWnd, ( pPropSheetData [ nCurrentPage ] ).pDlgProc ) ;
         if ( EnableThemeDialogTexture ) EnableThemeDialogTexture ( ( pPropSheetData [ nCurrentPage ] ).hWnd, ETDT_ENABLETAB ) ;
         MoveWindow ( ( pPropSheetData [ nCurrentPage ] ).hWnd, Rect.left, Rect.top, Rect.right - Rect.left, Rect.bottom - Rect.top, FALSE ) ;

         // ^uI[_[u
         if ( pTabOrderList ) {
            for ( int nCount = 0 ; pTabOrderList [ nCount ] ; nCount ++ ) SetWindowPos ( pTabOrderList [ nCount ], HWND_BOTTOM, 0, 0, 0, 0, SWP_NOMOVE | SWP_NOSIZE | SWP_NOREDRAW | SWP_NOACTIVATE ) ;
         }

         ShowWindow ( ( pPropSheetData [ nCurrentPage ] ).hWnd, SW_SHOW ) ;

         return TRUE ;


      case WM_NOTIFY :

         // ^uRg[̃V[g؂ւʒmȂ
         if ( ( (NMHDR*) lParam )->code == TCN_SELCHANGE ) {
            if ( ( (NMHDR*) lParam )->hwndFrom == hTabControl ) {

               int nPrevPage = nCurrentPage ;
               nCurrentPage = TabCtrl_GetCurSel ( hTabControl ) ;

               // Vy[W쐬Ȃ쐬
               if ( ! ( pPropSheetData [ nCurrentPage ] ).hWnd ) {
                  if ( IsNT () ) ( pPropSheetData [ nCurrentPage ] ).hWnd = CreateDialogExW ( ( pPropSheetData [ nCurrentPage ] ).nTemplate, hWnd, ( pPropSheetData [ nCurrentPage ] ).pDlgProc ) ;
                  else           ( pPropSheetData [ nCurrentPage ] ).hWnd = CreateDialogExA ( ( pPropSheetData [ nCurrentPage ] ).nTemplate, hWnd, ( pPropSheetData [ nCurrentPage ] ).pDlgProc ) ;
                  if ( EnableThemeDialogTexture ) EnableThemeDialogTexture ( ( pPropSheetData [ nCurrentPage ] ).hWnd, ETDT_ENABLETAB ) ;
                  MoveWindow ( ( pPropSheetData [ nCurrentPage ] ).hWnd, Rect.left, Rect.top, Rect.right - Rect.left, Rect.bottom - Rect.top, FALSE ) ;

                  // ^uI[_[u
                  if ( pTabOrderList ) {
                     for ( int nCount = 0 ; pTabOrderList [ nCount ] ; nCount ++ ) SetWindowPos ( pTabOrderList [ nCount ], HWND_BOTTOM, 0, 0, 0, 0, SWP_NOMOVE | SWP_NOSIZE | SWP_NOREDRAW | SWP_NOACTIVATE ) ;
                  }
               }

               NMHDR NotifyMessage ;

               NotifyMessage.hwndFrom = hWnd ;
               NotifyMessage.idFrom = IDC_TAB_OPTION_PROPPAGE ;
               NotifyMessage.code = PSN_KILLACTIVE ;
               Wm_Notify ( ( pPropSheetData [ nPrevPage ] ).hWnd, & NotifyMessage ) ;

               NotifyMessage.hwndFrom = hWnd ;
               NotifyMessage.idFrom = IDC_TAB_OPTION_PROPPAGE ;
               NotifyMessage.code = PSN_SETACTIVE ;
               Wm_Notify ( ( pPropSheetData [ nCurrentPage ] ).hWnd, & NotifyMessage ) ;

               ShowWindow ( ( pPropSheetData [ nPrevPage ] ).hWnd, SW_HIDE ) ;
               ShowWindow ( ( pPropSheetData [ nCurrentPage ] ).hWnd, SW_SHOW ) ;

               return TRUE ;
            }
         }
         break ;


      case WM_COMMAND :

         // ݒs
         if ( LOWORD ( wParam ) == IDOK ) {
            for ( int nCount = 0 ; nCount < nPropSheetPages ; nCount ++ ) {
               if ( ( pPropSheetData [ nCount ] ).hWnd ) {
                  NMHDR NotifyMessage ;
                  NotifyMessage.hwndFrom = hWnd ;
                  NotifyMessage.idFrom = IDC_TAB_OPTION_PROPPAGE ;
                  NotifyMessage.code = PSN_APPLY ;
                  Wm_Notify ( ( pPropSheetData [ nCount ] ).hWnd, & NotifyMessage ) ;
               }
            }
            EndDialog ( hWnd, IDOK ) ;
            return TRUE ;
         }

         // I
         if ( LOWORD ( wParam ) == IDCANCEL ) {
            EndDialog ( hWnd, IDCANCEL ) ;
            return TRUE ;
         }

         if ( IsNT () ) return SendMessageW ( ( pPropSheetData [ nCurrentPage ] ).hWnd, dwMessage, wParam, lParam ) ;
         else           return SendMessageA ( ( pPropSheetData [ nCurrentPage ] ).hWnd, dwMessage, wParam, lParam ) ;


      case WM_DESTROY :
         free ( pTabOrderList ) ;
         break ;
   }

   return FALSE ;
}



// ^uRg[ɃACe}
int TabInsertItem ( HWND hTabControl, int nIndex, int nCaptionId ) {

   if ( IsNT () ) {
      wchar_t szBuffer [ SHORTSTRING_MAX ] ;
      LoadStringExW ( nCaptionId, szBuffer, SHORTSTRING_MAX ) ;
      TC_ITEMW TcItem ;
      TcItem.mask = TCIF_TEXT ;
      TcItem.pszText = szBuffer ;
      TabCtrl_InsertItemW ( hTabControl, nIndex, & TcItem ) ;
   }
   else {
      char szBuffer [ SHORTSTRING_MAX ] ;
      LoadStringExA ( nCaptionId, szBuffer, SHORTSTRING_MAX ) ;
      TC_ITEMA TcItem ;
      TcItem.mask = TCIF_TEXT ;
      TcItem.pszText = szBuffer ;
      TabCtrl_InsertItemA ( hTabControl, nIndex, & TcItem ) ;
   }

   return 0 ;
}



// IvVݒ_CAO
INT_PTR CALLBACK OptionDialog1Proc ( HWND hWnd, unsigned int dwMessage, WPARAM wParam, LPARAM lParam ) {

   int nCurrentSel ;

   switch ( dwMessage ) {

      case WM_INITDIALOG :

         if ( DEBUG_TAB_CONTROL ) {
            RECT Rect ;
            GetWindowRect ( hWnd, & Rect ) ;
            MessageBoxFormatA ( hWnd, "", MB_OK, "%d, %d", Rect.right - Rect.left, Rect.bottom - Rect.top ) ;
         }

         // l
         if ( IsGb2big5N ) CheckDlgButton ( hWnd, IDC_CHECK_GB2BIG5_N, BST_CHECKED ) ;
         if ( IsBig52gbN ) CheckDlgButton ( hWnd, IDC_CHECK_BIG52GB_N, BST_CHECKED ) ;
         if ( IsNoGbk ) CheckDlgButton ( hWnd, IDC_CHECK_NO_GBK, BST_CHECKED ) ;
         if ( IsSenceCwFanti ) CheckDlgButton ( hWnd, IDC_CHECK_SENSE_CW_FANTI, BST_CHECKED ) ;
         if ( IsCwTxtFanti ) CheckDlgButton ( hWnd, IDC_CHECK_CW_TXT_FANTI, BST_CHECKED ) ;
         if ( IsConvertQuotation ) CheckDlgButton ( hWnd, IDC_CHECK_QUOTATION_MARK, BST_CHECKED ) ;

         // R{{bNX̐ݒ
         Dlg_ComboBox_ResetContent ( hWnd, IDC_COMBO_UNMAPPABLE_CHAR ) ;
         if ( IsNT () ) {
            Dlg_ComboBox_InsertStringW ( hWnd, IDC_COMBO_UNMAPPABLE_CHAR, -1, GetStringW ( IDS_UNMAPPABLE_CHAR_FORMAT_0 ) ) ;
            Dlg_ComboBox_InsertStringW ( hWnd, IDC_COMBO_UNMAPPABLE_CHAR, -1, GetStringW ( IDS_UNMAPPABLE_CHAR_FORMAT_1 ) ) ;
            Dlg_ComboBox_InsertStringW ( hWnd, IDC_COMBO_UNMAPPABLE_CHAR, -1, GetStringW ( IDS_UNMAPPABLE_CHAR_FORMAT_2 ) ) ;
         }
         else {
            Dlg_ComboBox_InsertStringA ( hWnd, IDC_COMBO_UNMAPPABLE_CHAR, -1, GetStringA ( IDS_UNMAPPABLE_CHAR_FORMAT_0 ) ) ;
            Dlg_ComboBox_InsertStringA ( hWnd, IDC_COMBO_UNMAPPABLE_CHAR, -1, GetStringA ( IDS_UNMAPPABLE_CHAR_FORMAT_1 ) ) ;
            Dlg_ComboBox_InsertStringA ( hWnd, IDC_COMBO_UNMAPPABLE_CHAR, -1, GetStringA ( IDS_UNMAPPABLE_CHAR_FORMAT_2 ) ) ;
         }

         nCurrentSel = 0 ;
         if ( IsOneQuestionMark ) nCurrentSel = 1 ;
         if ( IsOutputNumber ) nCurrentSel = 2 ;
         Dlg_ComboBox_SetCurSel ( hWnd, IDC_COMBO_UNMAPPABLE_CHAR, nCurrentSel ) ;

         return TRUE ;


      case WM_COMMAND :
         // VXeT|[gĂȂΖ
         if ( LOWORD ( wParam ) == IDC_CHECK_GB2BIG5_N || LOWORD ( wParam ) == IDC_CHECK_BIG52GB_N ) {
            if ( ! IsValidCodePage ( CP_CHINESE_SIMPLIFIED ) || ! IsValidCodePage ( CP_CHINESE_TRADITIONAL ) ) {
               CheckDlgButton ( hWnd, LOWORD ( wParam ), BST_UNCHECKED ) ;
               if ( IsNT () ) MessageBoxW ( hWnd, GetStringW ( IDS_INVALID_OPTION ), szCommandNameW, MB_OK ) ;
               else           MessageBoxA ( hWnd, GetStringA ( IDS_INVALID_OPTION ), szCommandNameA, MB_OK ) ;
               return TRUE ;
            }
         }
         // xȐݒ
         if ( LOWORD ( wParam ) == IDC_BUTTON_EXMODE ) {
            if ( IsNT () ) DialogBoxExW ( IDD_DIALOG_EXMODE, hWnd, ExModeDialogProc ) ;
            else           DialogBoxExA ( IDD_DIALOG_EXMODE, hWnd, ExModeDialogProc ) ;
            return TRUE ;
         }
         break ;


      case WM_NOTIFY :
         // ݒ
         if ( ((NMHDR*) lParam )->code == PSN_APPLY ) {
            IsGb2big5N = IsDlgButtonChecked ( hWnd, IDC_CHECK_GB2BIG5_N ) ;
            IsBig52gbN = IsDlgButtonChecked ( hWnd, IDC_CHECK_BIG52GB_N ) ;
            IsNoGbk = IsDlgButtonChecked ( hWnd, IDC_CHECK_NO_GBK ) ;
            IsSenceCwFanti = IsDlgButtonChecked ( hWnd, IDC_CHECK_SENSE_CW_FANTI ) ;
            IsCwTxtFanti = IsDlgButtonChecked ( hWnd, IDC_CHECK_CW_TXT_FANTI ) ;
            IsConvertQuotation = IsDlgButtonChecked ( hWnd, IDC_CHECK_QUOTATION_MARK ) ;

            nCurrentSel = Dlg_ComboBox_GetCurSel ( hWnd, IDC_COMBO_UNMAPPABLE_CHAR ) ;
            IsOneQuestionMark = 0 ;
            IsOutputNumber = 0 ;
            if ( nCurrentSel == 1 ) IsOneQuestionMark = 1 ;
            if ( nCurrentSel == 2 ) IsOutputNumber = 1 ;

            IsOptionChanged = 1 ;
            return TRUE ;
         }
         break ;


      default :
         break ;
   }

   return FALSE ;
}



// IvVݒ_CAO
INT_PTR CALLBACK OptionDialog2Proc ( HWND hWnd, unsigned int dwMessage, WPARAM wParam, LPARAM lParam ) {

   static HFONT hGbFont ;
   static HFONT hBig5Font ;
   static HFONT hUnicodeFont ;

   switch ( dwMessage ) {

      case WM_INITDIALOG :

         // GfBbgRg[͂̒̐
         Dlg_ComboBox_LimitText ( hWnd, IDC_COMBO_GBFONT, FONTNAME_MAX ) ;
         Dlg_ComboBox_LimitText ( hWnd, IDC_COMBO_GBFONT_GOTHIC, FONTNAME_MAX ) ;
         Dlg_ComboBox_LimitText ( hWnd, IDC_COMBO_BIG5FONT, FONTNAME_MAX ) ;
         Dlg_ComboBox_LimitText ( hWnd, IDC_COMBO_BIG5FONT_GOTHIC, FONTNAME_MAX ) ;

         // tHgRg[̃tHgw
         if ( IsNT () ) {
            hUnicodeFont = CreateFontByCodePage ( GetDialogFontHeight ( IDD_PROPPAGE_2 ), 0 ) ;
            if ( hUnicodeFont ) Dlg_Wm_SetFont ( hWnd, IDC_COMBO_GBFONT, hUnicodeFont, TRUE ) ;
            if ( hUnicodeFont ) Dlg_Wm_SetFont ( hWnd, IDC_COMBO_GBFONT_GOTHIC, hUnicodeFont, TRUE ) ;
            if ( hUnicodeFont ) Dlg_Wm_SetFont ( hWnd, IDC_COMBO_BIG5FONT, hUnicodeFont, TRUE ) ;
            if ( hUnicodeFont ) Dlg_Wm_SetFont ( hWnd, IDC_COMBO_BIG5FONT_GOTHIC, hUnicodeFont, TRUE ) ;
         }
         else {
            hGbFont = CreateFontByCodePage ( GetDialogFontHeight ( IDD_PROPPAGE_2 ), CP_CHINESE_SIMPLIFIED ) ;
            hBig5Font = CreateFontByCodePage ( GetDialogFontHeight ( IDD_PROPPAGE_2 ), CP_CHINESE_TRADITIONAL ) ;
            if ( hGbFont ) Dlg_Wm_SetFont ( hWnd, IDC_COMBO_GBFONT, hGbFont, TRUE ) ;
            if ( hGbFont ) Dlg_Wm_SetFont ( hWnd, IDC_COMBO_GBFONT_GOTHIC, hGbFont, TRUE ) ;
            if ( hBig5Font ) Dlg_Wm_SetFont ( hWnd, IDC_COMBO_BIG5FONT, hBig5Font, TRUE ) ;
            if ( hBig5Font ) Dlg_Wm_SetFont ( hWnd, IDC_COMBO_BIG5FONT_GOTHIC, hBig5Font, TRUE ) ;
         }

         SetComboBoxFontName ( hWnd, IDC_COMBO_GBFONT, CP_CHINESE_SIMPLIFIED ) ;
         SetComboBoxFontName ( hWnd, IDC_COMBO_GBFONT_GOTHIC, CP_CHINESE_SIMPLIFIED ) ;
         SetComboBoxFontName ( hWnd, IDC_COMBO_BIG5FONT, CP_CHINESE_TRADITIONAL ) ;
         SetComboBoxFontName ( hWnd, IDC_COMBO_BIG5FONT_GOTHIC, CP_CHINESE_TRADITIONAL ) ;

         Dlg_ComboBox_ResetContent ( hWnd, IDC_COMBO_CW_VERSION ) ;
         if ( IsNT () ) {
            Dlg_ComboBox_AddStringW ( hWnd, IDC_COMBO_CW_VERSION, GetStringW ( IDS_CWVERSION_OLD ) ) ;
            Dlg_ComboBox_AddStringW ( hWnd, IDC_COMBO_CW_VERSION, GetStringW ( IDS_CWVERSION_NEW ) ) ;
         }
         else {
            Dlg_ComboBox_AddStringA ( hWnd, IDC_COMBO_CW_VERSION, GetStringA ( IDS_CWVERSION_OLD ) ) ;
            Dlg_ComboBox_AddStringA ( hWnd, IDC_COMBO_CW_VERSION, GetStringA ( IDS_CWVERSION_NEW ) ) ;
         }

         // l
         SetOptionDialogFontName ( hWnd, IDC_COMBO_GBFONT, szGbFont, CP_CHINESE_SIMPLIFIED ) ;
         SetOptionDialogFontName ( hWnd, IDC_COMBO_GBFONT_GOTHIC, szGbGothicFont, CP_CHINESE_SIMPLIFIED ) ;
         SetOptionDialogFontName ( hWnd, IDC_COMBO_BIG5FONT, szBig5Font, CP_CHINESE_TRADITIONAL ) ;
         SetOptionDialogFontName ( hWnd, IDC_COMBO_BIG5FONT_GOTHIC, szBig5GothicFont, CP_CHINESE_TRADITIONAL ) ;

         Dlg_ComboBox_SetCurSel ( hWnd, IDC_COMBO_CW_VERSION, IsOutputCwNewFont ) ;

         return TRUE ;


      case WM_COMMAND :

         // W֖߂
         if ( LOWORD ( wParam ) == IDC_GBFONT_DEFAULT ) {
            SetOptionDialogFontName ( hWnd, IDC_COMBO_GBFONT, szDefaultGbFont, CP_CHINESE_SIMPLIFIED ) ;
            return TRUE ;
         }
         if ( LOWORD ( wParam ) == IDC_GBFONT_GOTHIC_DEFAULT ) {
            SetOptionDialogFontName ( hWnd, IDC_COMBO_GBFONT_GOTHIC, szDefaultGbGothicFont, CP_CHINESE_SIMPLIFIED ) ;
            return TRUE ;
         }
         if ( LOWORD ( wParam ) == IDC_BIG5FONT_DEFAULT ) {
            SetOptionDialogFontName ( hWnd, IDC_COMBO_BIG5FONT, szDefaultBig5Font, CP_CHINESE_TRADITIONAL ) ;
            return TRUE ;
         }
         if ( LOWORD ( wParam ) == IDC_BIG5FONT_GOTHIC_DEFAULT ) {
            SetOptionDialogFontName ( hWnd, IDC_COMBO_BIG5FONT_GOTHIC, szDefaultBig5GothicFont, CP_CHINESE_TRADITIONAL ) ;
            return TRUE ;
         }

         break ;


      case WM_NOTIFY :
         // ݒ
         if ( ((NMHDR*) lParam )->code == PSN_APPLY ) {
            GetOptionDialogFontName ( hWnd, IDC_COMBO_GBFONT, szGbFont, CP_CHINESE_SIMPLIFIED ) ;
            GetOptionDialogFontName ( hWnd, IDC_COMBO_GBFONT_GOTHIC, szGbGothicFont, CP_CHINESE_SIMPLIFIED ) ;
            GetOptionDialogFontName ( hWnd, IDC_COMBO_BIG5FONT, szBig5Font, CP_CHINESE_TRADITIONAL ) ;
            GetOptionDialogFontName ( hWnd, IDC_COMBO_BIG5FONT_GOTHIC, szBig5GothicFont, CP_CHINESE_TRADITIONAL ) ;
            if ( ! *szGbFont ) strcpy ( szGbFont, szDefaultGbFont ) ;
            if ( ! *szGbGothicFont ) strcpy ( szGbFont, szDefaultGbGothicFont ) ;
            if ( ! *szBig5Font ) strcpy ( szBig5Font, szDefaultBig5Font ) ;
            if ( ! *szBig5GothicFont ) strcpy ( szBig5Font, szDefaultBig5GothicFont ) ;
            IsOutputCwNewFont = Dlg_ComboBox_GetCurSel ( hWnd, IDC_COMBO_CW_VERSION ) ;
            IsOptionChanged = 1 ;
            return TRUE ;
         }
         break ;


      case WM_DESTROY :
         if ( IsNT () ) {
            if ( hUnicodeFont ) {
               DeleteObject ( hUnicodeFont ) ;
               hUnicodeFont = NULL ;
            }
         }
         else {
            if ( hGbFont ) {
               DeleteObject ( hGbFont ) ;
               hGbFont = NULL ;
            }
            if ( hBig5Font ) {
               DeleteObject ( hBig5Font ) ;
               hBig5Font = NULL ;
            }
         }
         break ;


      default :
         break ;
   }

   return FALSE ;
}



// IvVݒ_CAO
INT_PTR CALLBACK OptionDialog3Proc ( HWND hWnd, unsigned int dwMessage, WPARAM wParam, LPARAM lParam ) {

   static HFONT hFont ;
   static char szPinyinFontTmp [ FONTNAME_MAX ] ;
   static char szPinyinGothicFontTmp [ FONTNAME_MAX ] ;

   switch ( dwMessage ) {

      case WM_INITDIALOG :

         // GfBbgRg[͂̒̐
         Dlg_ComboBox_LimitText ( hWnd, IDC_COMBO_PINYINFONT, FONTNAME_MAX ) ;
         Dlg_ComboBox_LimitText ( hWnd, IDC_COMBO_PINYINFONT_GOTHIC, FONTNAME_MAX ) ;

         // tHgRg[̃tHgw
         hFont = CreateFontByCodePage ( GetDialogFontHeight ( IDD_PROPPAGE_3 ), 0 ) ;
         if ( hFont ) Dlg_Wm_SetFont ( hWnd, IDC_COMBO_PINYINFONT, hFont, TRUE ) ;
         if ( hFont ) Dlg_Wm_SetFont ( hWnd, IDC_COMBO_PINYINFONT_GOTHIC, hFont, TRUE ) ;

         if ( IsUseSameFont ) CheckDlgButton ( hWnd, IDC_CHECK_SAMEFONT, BST_CHECKED ) ;
         Dlg_EnableWindow ( hWnd, IDC_COMBO_PINYINFONT, ! IsDlgButtonChecked ( hWnd, IDC_CHECK_SAMEFONT ) ) ;
         Dlg_EnableWindow ( hWnd, IDC_COMBO_PINYINFONT_GOTHIC, ! IsDlgButtonChecked ( hWnd, IDC_CHECK_SAMEFONT ) ) ;

         strcpy ( szPinyinFontTmp, szPinyinFont ) ;
         strcpy ( szPinyinGothicFontTmp, szPinyinGothicFont ) ;

         SetComboBoxFontName ( hWnd, IDC_COMBO_PINYINFONT, CP_ANSI_EUROPEAN ) ;
         SetComboBoxFontName ( hWnd, IDC_COMBO_PINYINFONT_GOTHIC, CP_ANSI_EUROPEAN ) ;

         // l
         if ( Dlg_IsWindowEnabled ( hWnd, IDC_COMBO_PINYINFONT ) ) {
            SetOptionDialogFontName ( hWnd, IDC_COMBO_PINYINFONT, szPinyinFontTmp, CP_ANSI_EUROPEAN ) ;
            SetOptionDialogFontName ( hWnd, IDC_COMBO_PINYINFONT_GOTHIC, szPinyinGothicFontTmp, CP_ANSI_EUROPEAN ) ;
         }

         return TRUE ;


      case WM_COMMAND :

         // W֖߂
         if ( LOWORD ( wParam ) == IDC_PINYINFONT_DEFAULT ) {
            if ( ! Dlg_IsWindowEnabled ( hWnd, IDC_COMBO_PINYINFONT ) ) return TRUE ;
            SetOptionDialogFontName ( hWnd, IDC_COMBO_PINYINFONT, szDefaultPinyinFont, CP_ANSI_EUROPEAN ) ;
            return TRUE ;
         }
         if ( LOWORD ( wParam ) == IDC_PINYINFONT_GOTHIC_DEFAULT ) {
            if ( ! Dlg_IsWindowEnabled ( hWnd, IDC_COMBO_PINYINFONT_GOTHIC ) ) return TRUE ;
            SetOptionDialogFontName ( hWnd, IDC_COMBO_PINYINFONT_GOTHIC, szDefaultPinyinGothicFont, CP_ANSI_EUROPEAN ) ;
            return TRUE ;
         }

         // tHg̎gpw肵Ƃ
         if ( LOWORD ( wParam ) == IDC_CHECK_SAMEFONT ) {
            if ( IsDlgButtonChecked ( hWnd, IDC_CHECK_SAMEFONT ) ) {
               GetOptionDialogFontName ( hWnd, IDC_COMBO_PINYINFONT, szPinyinFontTmp, CP_ANSI_EUROPEAN ) ;
               GetOptionDialogFontName ( hWnd, IDC_COMBO_PINYINFONT_GOTHIC, szPinyinGothicFontTmp, CP_ANSI_EUROPEAN ) ;
               Dlg_EnableWindow ( hWnd, IDC_COMBO_PINYINFONT, FALSE ) ;
               Dlg_EnableWindow ( hWnd, IDC_COMBO_PINYINFONT_GOTHIC, FALSE ) ;
               if ( IsNT () ) Dlg_Wm_SetTextW ( hWnd, IDC_COMBO_PINYINFONT, L"" ) ;
               else           Dlg_Wm_SetTextA ( hWnd, IDC_COMBO_PINYINFONT, "" ) ;
               if ( IsNT () ) Dlg_Wm_SetTextW ( hWnd, IDC_COMBO_PINYINFONT_GOTHIC, L"" ) ;
               else           Dlg_Wm_SetTextA ( hWnd, IDC_COMBO_PINYINFONT_GOTHIC, "" ) ;
            }
            else {
               Dlg_EnableWindow ( hWnd, IDC_COMBO_PINYINFONT, TRUE ) ;
               Dlg_EnableWindow ( hWnd, IDC_COMBO_PINYINFONT_GOTHIC, TRUE ) ;
               SetOptionDialogFontName ( hWnd, IDC_COMBO_PINYINFONT, szPinyinFontTmp, CP_ANSI_EUROPEAN ) ;
               SetOptionDialogFontName ( hWnd, IDC_COMBO_PINYINFONT_GOTHIC, szPinyinGothicFontTmp, CP_ANSI_EUROPEAN ) ;
            }
            return TRUE ;
         }

         break ;


      case WM_NOTIFY :
         // ݒ
         if ( ((NMHDR*) lParam )->code == PSN_APPLY ) {
            IsUseSameFont = IsDlgButtonChecked ( hWnd, IDC_CHECK_SAMEFONT ) ;
            if ( Dlg_IsWindowEnabled ( hWnd, IDC_COMBO_PINYINFONT ) ) {
               GetOptionDialogFontName ( hWnd, IDC_COMBO_PINYINFONT, szPinyinFontTmp, CP_ANSI_EUROPEAN ) ;
               GetOptionDialogFontName ( hWnd, IDC_COMBO_PINYINFONT_GOTHIC, szPinyinGothicFontTmp, CP_ANSI_EUROPEAN ) ;
            }
            strcpy ( szPinyinFont, szPinyinFontTmp ) ;
            strcpy ( szPinyinGothicFont, szPinyinGothicFontTmp ) ;
            if ( ! *szPinyinFont ) strcpy ( szPinyinFont, szDefaultPinyinFont ) ;
            if ( ! *szPinyinGothicFont ) strcpy ( szPinyinFont, szDefaultPinyinGothicFont ) ;
            IsOptionChanged = 1 ;
            return TRUE ;
         }
         break ;


      case WM_DESTROY :
         if ( hFont ) {
            DeleteObject ( hFont ) ;
            hFont = NULL ;
         }
         break ;


      default :
         break ;
   }

   return FALSE ;
}



// IvVݒ_CAO
INT_PTR CALLBACK OptionDialog4Proc ( HWND hWnd, unsigned int dwMessage, WPARAM wParam, LPARAM lParam ) {

   static HFONT hFont ;

   switch ( dwMessage ) {

      case WM_INITDIALOG :

         // l
         if ( IsSavePath ) CheckDlgButton ( hWnd, IDC_CHECK_SAVEPATH, BST_CHECKED ) ;
         if ( IsSaveCode ) CheckDlgButton ( hWnd, IDC_CHECK_SAVECODE, BST_CHECKED ) ;
         if ( IsSaveWindow ) CheckDlgButton ( hWnd, IDC_CHECK_SAVEWINDOW, BST_CHECKED ) ;
         if ( IsNoConfirm ) CheckDlgButton ( hWnd, IDC_CHECK_NO_CONFIRM, BST_CHECKED ) ;
         if ( IsNoRecycle ) CheckDlgButton ( hWnd, IDC_CHECK_NO_RECYCLE, BST_CHECKED ) ;
         if ( IsNoMessage ) CheckDlgButton ( hWnd, IDC_CHECK_NO_MESSAGE, BST_CHECKED ) ;
         if ( IsNoAddExtension ) CheckDlgButton ( hWnd, IDC_CHECK_NO_ADD_EXT, BST_CHECKED ) ;
         if ( IsConfirmOnExit ) CheckDlgButton ( hWnd, IDC_CHECK_CONFIRM_ON_EXIT, BST_CHECKED ) ;

         // tHg쐬
         hFont = CreateFontByCodePage ( GetDialogFontHeight ( IDD_PROPPAGE_4 ), 0 ) ;
         if ( hFont ) Dlg_Wm_SetFont ( hWnd, IDC_COMBO_MUI_LANG, hFont, TRUE ) ;

         SetComboBoxMuiLangId ( hWnd, IDC_COMBO_MUI_LANG ) ;

         return TRUE ;


      case WM_NOTIFY :
         // ݒ
         if ( ((NMHDR*) lParam )->code == PSN_APPLY ) {
            IsSavePath = IsDlgButtonChecked ( hWnd, IDC_CHECK_SAVEPATH ) ;
            IsSaveCode = IsDlgButtonChecked ( hWnd, IDC_CHECK_SAVECODE ) ;
            IsSaveWindow = IsDlgButtonChecked ( hWnd, IDC_CHECK_SAVEWINDOW ) ;
            IsNoConfirm = IsDlgButtonChecked ( hWnd, IDC_CHECK_NO_CONFIRM ) ;
            IsNoRecycle = IsDlgButtonChecked ( hWnd, IDC_CHECK_NO_RECYCLE ) ;
            IsNoMessage = IsDlgButtonChecked ( hWnd, IDC_CHECK_NO_MESSAGE ) ;
            IsNoAddExtension = IsDlgButtonChecked ( hWnd, IDC_CHECK_NO_ADD_EXT ) ;
            IsConfirmOnExit = IsDlgButtonChecked ( hWnd, IDC_CHECK_CONFIRM_ON_EXIT ) ;
            nSavedMuiLangId = GetComboBoxMuiLangId ( hWnd, IDC_COMBO_MUI_LANG ) ;
            IsOptionChanged = 1 ;
            return TRUE ;
         }
         break ;


      case WM_DESTROY :
         if ( hFont ) {
            DeleteObject ( hFont ) ;
            hFont = NULL ;
         }
         FreeMuiLangIdArray () ;
         break ;


      default :
         break ;
   }

   return FALSE ;
}



// xȐݒ_CAO
INT_PTR CALLBACK ExModeDialogProc ( HWND hWnd, unsigned int dwMessage, WPARAM wParam, LPARAM lParam ) {

   switch ( dwMessage ) {

      case WM_INITDIALOG :

         // l
         if ( IsConvertCjkEx ) CheckDlgButton ( hWnd, IDC_CHECK_CONVERT_CJKEX, BST_CHECKED ) ;
         if ( IsLinshiDaimaToCjkEx ) CheckDlgButton ( hWnd, IDC_CHECK_LINSHIDAIMA_TO_CJKEX, BST_CHECKED ) ;
         if ( IsCjkExToLinshiDaima ) CheckDlgButton ( hWnd, IDC_CHECK_CJKEX_TO_LINSHIDAIMA, BST_CHECKED ) ;

         if ( IsHkscsPuaToCjk ) CheckDlgButton ( hWnd, IDC_CHECK_HKSCS_TO_CJK, BST_CHECKED ) ;

         if ( IsWriteTmComment ) CheckDlgButton ( hWnd, IDC_CHECK_TM_COMMENT, BST_CHECKED ) ;

         SetComboBoxFontSize ( hWnd, IDC_COMBO_TM_FONTSIZE, nTmFontSize ) ;

         // GfBbgRg[͂̒̐
         Dlg_ComboBox_LimitText ( hWnd, IDC_COMBO_TM_FONTSIZE, FONTSIZE_BUFFER_MAX - 1 ) ;

         return TRUE ;


      case WM_COMMAND :

         // I
         if ( LOWORD ( wParam ) == IDCANCEL ) {
            EndDialog ( hWnd, IDCANCEL ) ;
            return TRUE ;
         }
         if ( LOWORD ( wParam ) == IDOK ) {
            IsConvertCjkEx = IsDlgButtonChecked ( hWnd, IDC_CHECK_CONVERT_CJKEX ) ;
            IsLinshiDaimaToCjkEx = IsDlgButtonChecked ( hWnd, IDC_CHECK_LINSHIDAIMA_TO_CJKEX ) ;
            IsCjkExToLinshiDaima = IsDlgButtonChecked ( hWnd, IDC_CHECK_CJKEX_TO_LINSHIDAIMA ) ;

            IsHkscsPuaToCjk = IsDlgButtonChecked ( hWnd, IDC_CHECK_HKSCS_TO_CJK ) ;

            IsWriteTmComment = IsDlgButtonChecked ( hWnd, IDC_CHECK_TM_COMMENT ) ;
            nTmFontSize = GetComboBoxFontSizeValue ( hWnd, IDC_COMBO_TM_FONTSIZE ) ;

            IsOptionChanged = 1 ;
            EndDialog ( hWnd, IDCANCEL ) ;
            return TRUE ;
         }

         if ( LOWORD ( wParam ) == IDC_CHECK_LINSHIDAIMA_TO_CJKEX ) {
            // `FbN{bNXύXƂ
            if ( HIWORD ( wParam ) == BN_CLICKED ) {
               if ( IsDlgButtonChecked ( hWnd, IDC_CHECK_LINSHIDAIMA_TO_CJKEX ) ) CheckDlgButton ( hWnd, IDC_CHECK_CJKEX_TO_LINSHIDAIMA, BST_UNCHECKED ) ;
            }
         }
         if ( LOWORD ( wParam ) == IDC_CHECK_CJKEX_TO_LINSHIDAIMA ) {
            // `FbN{bNXύXƂ
            if ( HIWORD ( wParam ) == BN_CLICKED ) {
               if ( IsDlgButtonChecked ( hWnd, IDC_CHECK_CJKEX_TO_LINSHIDAIMA ) ) CheckDlgButton ( hWnd, IDC_CHECK_LINSHIDAIMA_TO_CJKEX, BST_UNCHECKED ) ;
            }
         }

         // W֖߂itHgTCYj
         if ( LOWORD ( wParam ) == IDC_TM_FONTSIZE_DEFAULT ) {
            if ( ! Dlg_IsWindowEnabled ( hWnd, IDC_COMBO_TM_FONTSIZE ) ) return TRUE ;
            SetComboBoxFontSizeValue ( hWnd, IDC_COMBO_TM_FONTSIZE, DEFAULT_FONT_SIZE ) ;
            return TRUE ;
         }

         break ;


      default :
         break ;
   }

   return FALSE ;
}



////////////////////////////////////////////
//       IvVݒitHgj       //
////////////////////////////////////////////



// _CAÕtHg擾
int GetOptionDialogFontName ( HWND hWnd, int nComboBox, char *szFontName, int nCodePage ) {

   wchar_t szFontNameW [ FONTNAME_MAX ] ;

   if ( IsNT () ) {
      if ( ! IsValidCodePage ( nCodePage ) ) nCodePage = CP_ANSI_EUROPEAN ;
      Dlg_Wm_GetTextW ( hWnd, nComboBox, szFontNameW, FONTNAME_MAX ) ;
      w2alcpy_cp ( szFontName, szFontNameW, FONTNAME_MAX, nCodePage ) ;
   }
   else {
      Dlg_Wm_GetTextA ( hWnd, nComboBox, szFontName, FONTNAME_MAX ) ;
   }

   return 0 ;
}



int SetOptionDialogFontName ( HWND hWnd, int nComboBox, const char *szFontName, int nCodePage ) {

   wchar_t szFontNameW [ FONTNAME_MAX ] ;

   if ( IsNT () ) {
      if ( ! IsValidCodePage ( nCodePage ) ) nCodePage = CP_ANSI_EUROPEAN ;
      a2wlcpy_cp ( szFontNameW, szFontName, FONTNAME_MAX, nCodePage ) ;
      Dlg_Wm_SetTextW ( hWnd, nComboBox, szFontNameW ) ;
   }
   else {
      Dlg_Wm_SetTextA ( hWnd, nComboBox, szFontName ) ;
   }

   return 0 ;
}



int CALLBACK SetComboBoxFontFamilyProcA ( const LOGFONTA *lplfe, const TEXTMETRICA *lptme, unsigned long nFontType, LPARAM lParam ) ;
int CALLBACK SetComboBoxFontFamilyProcW ( const LOGFONTW *lplfe, const TEXTMETRICW *lptme, unsigned long nFontType, LPARAM lParam ) ;
int CALLBACK SetComboBoxFontNameProcA ( const LOGFONTA *lplfe, const TEXTMETRICA *lptme, unsigned long nFontType, LPARAM lParam ) ;
int CALLBACK SetComboBoxFontNameProcW ( const LOGFONTW *lplfe, const TEXTMETRICW *lptme, unsigned long nFontType, LPARAM lParam ) ;

typedef struct {
   HWND hComboBox ;
   HDC hDC ;
   int nCharset ;
   int IsFontSjis ;
   int IsFontGb ;
   int IsFontBig5 ;
   int IsFontKs ;
} SEARCHFONTNAMEINFO ;



// tHgR{{bNXɃtHgW߂
// nCodePage  -1 ȂSẴtHgW߂
int SetComboBoxFontName ( HWND hWnd, int nComboBox, int nCodePage ) {

   Dlg_ComboBox_ResetContent ( hWnd, nComboBox ) ;

   SEARCHFONTNAMEINFO SearchFontNameInfo = { 0 } ;
   SearchFontNameInfo.hComboBox = GetDlgItem ( hWnd, nComboBox ) ;
   if ( nCodePage < 0 ) SearchFontNameInfo.nCharset = DEFAULT_CHARSET ;
   else                 SearchFontNameInfo.nCharset = CodePageToCharset ( nCodePage ) ;
   SearchFontNameInfo.hDC = CreateCompatibleDC ( NULL ) ;

   if ( IsNT () ) {
      LOGFONTW LogFont = { 0 } ;
      LogFont.lfCharSet = SearchFontNameInfo.nCharset ;
      EnumFontFamiliesExW ( SearchFontNameInfo.hDC, & LogFont, SetComboBoxFontFamilyProcW, (LPARAM) & SearchFontNameInfo, 0 ) ;
   }
   else {
      LOGFONTA LogFont = { 0 } ;
      LogFont.lfCharSet = SearchFontNameInfo.nCharset ;
      EnumFontFamiliesExA ( SearchFontNameInfo.hDC, & LogFont, SetComboBoxFontFamilyProcA, (LPARAM) & SearchFontNameInfo, 0 ) ;
   }

   DeleteDC ( SearchFontNameInfo.hDC ) ;

   Dlg_ComboBox_SetMaxHeight ( hWnd, nComboBox, 16 ) ;

   return 0 ;
}



// R{{bNXɃtHgW߂vV[W (1)iANSIŁj
int CALLBACK SetComboBoxFontFamilyProcA ( const LOGFONTA *lplfe, const TEXTMETRICA *lptme, unsigned long nFontType, LPARAM lParam ) {

   SEARCHFONTNAMEINFO *pSearchFontNameInfo = (SEARCHFONTNAMEINFO*)lParam ;
   int IsSuitableFont = 0 ;

   if ( ! ( nFontType & TRUETYPE_FONTTYPE ) ) return TRUE ;
   if ( *( lplfe->lfFaceName ) == '@' ) return TRUE ;

   // SẴtHgW߂Ȃ
   if ( pSearchFontNameInfo->nCharset == DEFAULT_CHARSET ) IsSuitableFont = 1 ;
   // ̕Zbg̃tHgW߂Ȃ
   else {

      LOGFONTA LogFont = { 0 } ;
      strcpy ( LogFont.lfFaceName, lplfe->lfFaceName ) ;
      LogFont.lfCharSet = DEFAULT_CHARSET ;

      pSearchFontNameInfo->IsFontSjis = 0 ;
      pSearchFontNameInfo->IsFontGb = 0 ;
      pSearchFontNameInfo->IsFontBig5 = 0 ;
      pSearchFontNameInfo->IsFontKs = 0 ;

      // tHg̏W
      EnumFontFamiliesExA ( pSearchFontNameInfo->hDC, & LogFont, SetComboBoxFontNameProcA, (LPARAM) pSearchFontNameInfo, 0 ) ;

      // QoCgptHgW߂Ȃ
      if ( IsMultiByteCodePage ( CharsetToCodePage ( pSearchFontNameInfo->nCharset ) ) ) {
         if ( pSearchFontNameInfo->nCharset == SHIFTJIS_CHARSET    && pSearchFontNameInfo->IsFontSjis ) IsSuitableFont = 1 ;
         if ( pSearchFontNameInfo->nCharset == GB2312_CHARSET      && pSearchFontNameInfo->IsFontGb )   IsSuitableFont = 1 ;
         if ( pSearchFontNameInfo->nCharset == CHINESEBIG5_CHARSET && pSearchFontNameInfo->IsFontBig5 ) IsSuitableFont = 1 ;
         if ( pSearchFontNameInfo->nCharset == HANGUL_CHARSET      && pSearchFontNameInfo->IsFontKs )   IsSuitableFont = 1 ;
      }
      // PoCgptHgW߂Ȃ
      else {
         int nAddResult = pSearchFontNameInfo->IsFontSjis + pSearchFontNameInfo->IsFontGb + pSearchFontNameInfo->IsFontBig5 + pSearchFontNameInfo->IsFontKs ;
         if ( nAddResult == 0 || nAddResult == 4 ) IsSuitableFont = 1 ;
      }
   }

   if ( IsSuitableFont && ComboBox_FindStringExactA ( pSearchFontNameInfo->hComboBox, 0, lplfe->lfFaceName ) == CB_ERR ) {
      ComboBox_AddStringA ( pSearchFontNameInfo->hComboBox, lplfe->lfFaceName ) ;
   }

   return TRUE ;
}



// R{{bNXɃtHgW߂vV[W (1)iUNICODEŁj
int CALLBACK SetComboBoxFontFamilyProcW ( const LOGFONTW *lplfe, const TEXTMETRICW *lptme, unsigned long nFontType, LPARAM lParam ) {

   SEARCHFONTNAMEINFO *pSearchFontNameInfo = (SEARCHFONTNAMEINFO*)lParam ;
   int IsSuitableFont = 0 ;

   if ( ! ( nFontType & TRUETYPE_FONTTYPE ) ) return TRUE ;
   if ( *( lplfe->lfFaceName ) == '@' ) return TRUE ;

   // SẴtHgW߂Ȃ
   if ( pSearchFontNameInfo->nCharset == DEFAULT_CHARSET ) IsSuitableFont = 1 ;
   // ̕Zbg̃tHgW߂Ȃ
   else {

      LOGFONTW LogFont = { 0 } ;
      wcscpy ( LogFont.lfFaceName, lplfe->lfFaceName ) ;
      LogFont.lfCharSet = DEFAULT_CHARSET ;

      pSearchFontNameInfo->IsFontSjis = 0 ;
      pSearchFontNameInfo->IsFontGb = 0 ;
      pSearchFontNameInfo->IsFontBig5 = 0 ;
      pSearchFontNameInfo->IsFontKs = 0 ;

      // tHg̏W
      EnumFontFamiliesExW ( pSearchFontNameInfo->hDC, & LogFont, SetComboBoxFontNameProcW, (LPARAM) pSearchFontNameInfo, 0 ) ;

      // QoCgptHgW߂Ȃ
      if ( IsMultiByteCodePage ( CharsetToCodePage ( pSearchFontNameInfo->nCharset ) ) ) {
         if ( pSearchFontNameInfo->nCharset == SHIFTJIS_CHARSET    && pSearchFontNameInfo->IsFontSjis ) IsSuitableFont = 1 ;
         if ( pSearchFontNameInfo->nCharset == GB2312_CHARSET      && pSearchFontNameInfo->IsFontGb )   IsSuitableFont = 1 ;
         if ( pSearchFontNameInfo->nCharset == CHINESEBIG5_CHARSET && pSearchFontNameInfo->IsFontBig5 ) IsSuitableFont = 1 ;
         if ( pSearchFontNameInfo->nCharset == HANGUL_CHARSET      && pSearchFontNameInfo->IsFontKs )   IsSuitableFont = 1 ;
      }
      // PoCgptHgW߂Ȃ
      else {
         int nAddResult = pSearchFontNameInfo->IsFontSjis + pSearchFontNameInfo->IsFontGb + pSearchFontNameInfo->IsFontBig5 + pSearchFontNameInfo->IsFontKs ;
         if ( nAddResult == 0 || nAddResult == 4 ) IsSuitableFont = 1 ;
      }
   }

   if ( IsSuitableFont && ComboBox_FindStringExactW ( pSearchFontNameInfo->hComboBox, 0, lplfe->lfFaceName ) == CB_ERR ) {
      ComboBox_AddStringW ( pSearchFontNameInfo->hComboBox, lplfe->lfFaceName ) ;
   }

   return TRUE ;
}



// R{{bNXɃtHgW߂vV[W (2)iANSIŁj
int CALLBACK SetComboBoxFontNameProcA ( const LOGFONTA *lplfe, const TEXTMETRICA *lptme, unsigned long nFontType, LPARAM lParam ) {

   SEARCHFONTNAMEINFO *pSearchFontNameInfo = (SEARCHFONTNAMEINFO*)lParam ;

   if ( lptme->tmCharSet == SHIFTJIS_CHARSET )    pSearchFontNameInfo->IsFontSjis = 1 ;
   if ( lptme->tmCharSet == GB2312_CHARSET )      pSearchFontNameInfo->IsFontGb = 1 ;
   if ( lptme->tmCharSet == CHINESEBIG5_CHARSET ) pSearchFontNameInfo->IsFontBig5 = 1 ;
   if ( lptme->tmCharSet == HANGUL_CHARSET )      pSearchFontNameInfo->IsFontKs = 1 ;

   return TRUE ;
}



// R{{bNXɃtHgW߂vV[W (2)iUNICODEŁj
int CALLBACK SetComboBoxFontNameProcW ( const LOGFONTW *lplfe, const TEXTMETRICW *lptme, unsigned long nFontType, LPARAM lParam ) {

   SEARCHFONTNAMEINFO *pSearchFontNameInfo = (SEARCHFONTNAMEINFO*)lParam ;

   if ( lptme->tmCharSet == SHIFTJIS_CHARSET )    pSearchFontNameInfo->IsFontSjis = 1 ;
   if ( lptme->tmCharSet == GB2312_CHARSET )      pSearchFontNameInfo->IsFontGb = 1 ;
   if ( lptme->tmCharSet == CHINESEBIG5_CHARSET ) pSearchFontNameInfo->IsFontBig5 = 1 ;
   if ( lptme->tmCharSet == HANGUL_CHARSET )      pSearchFontNameInfo->IsFontKs = 1 ;

   return TRUE ;
}



// tHgTCYR{{bNXZbg
int SetComboBoxFontSize ( HWND hWnd, int nComboBox, int nDefaultFontSize ) {

   if ( IsNT () ) {

      wchar_t szBuffer [ FONTSIZE_BUFFER_MAX ] ;

      for ( int nCount = 50 ; nCount >= 10 ; nCount -- ) {
         if ( ( nCount > 26 || nCount < 18 ) && nCount % 2 ) continue ;
         swprintf ( szBuffer, L"%d%s", nCount / 2, ( nCount % 2 ) ? L".5" : L"" ) ;
         Dlg_ComboBox_InsertStringW ( hWnd, nComboBox, 0, szBuffer ) ;
      }

      swprintf ( szBuffer, L"%d%s", nDefaultFontSize / 2, ( nDefaultFontSize % 2 ) ? L".5" : L"" ) ;
      Dlg_Wm_SetTextW ( hWnd, nComboBox, szBuffer ) ;
   }
   else {

      char szBuffer [ FONTSIZE_BUFFER_MAX ] ;

      for ( int nCount = 50 ; nCount >= 10 ; nCount -- ) {
         if ( ( nCount > 26 || nCount < 18 ) && nCount % 2 ) continue ;
         sprintf ( szBuffer, "%d%s", nCount / 2, ( nCount % 2 ) ? ".5" : "" ) ;
         Dlg_ComboBox_InsertStringA ( hWnd, nComboBox, 0, szBuffer ) ;
      }

      sprintf ( szBuffer, "%d%s", nDefaultFontSize / 2, ( nDefaultFontSize % 2 ) ? ".5" : "" ) ;
      Dlg_Wm_SetTextA ( hWnd, nComboBox, szBuffer ) ;
   }

   Dlg_ComboBox_SetMaxHeight ( hWnd, nComboBox, 8 ) ;

   return 0 ;
}



// tHgTCYR{{bNXl擾
int GetComboBoxFontSizeValue ( HWND hWnd, int nComboBox ) {

   int nSize = DEFAULT_FONT_SIZE ;

   if ( IsNT () ) {
      wchar_t szBuffer [ FONTSIZE_BUFFER_MAX ] ;
      Dlg_Wm_GetTextW ( hWnd, nComboBox, szBuffer, FONTSIZE_BUFFER_MAX ) ;
      if ( isascii ( *szBuffer ) && isdigit ( *szBuffer ) ) {
         wchar_t *szString ;
         nSize = wcstoul ( szBuffer, & szString, 10 ) * 2 ;
         if ( szString && ! wcscmp ( szString, L".5" ) ) nSize ++ ;
      }
   }
   else {
      char szBuffer [ FONTSIZE_BUFFER_MAX ] ;
      Dlg_Wm_GetTextA ( hWnd, nComboBox, szBuffer, FONTSIZE_BUFFER_MAX ) ;
      if ( isascii ( *szBuffer ) && isdigit ( *szBuffer ) ) {
         char *szString ;
         nSize = strtoul ( szBuffer, & szString, 10 ) * 2 ;
         if ( szString && ! strcmp ( szString, ".5" ) ) nSize ++ ;
      }
   }

   return nSize ;
}



// tHgTCYR{{bNXɒlZbg
int SetComboBoxFontSizeValue ( HWND hWnd, int nComboBox, int nFontSize ) {

   if ( IsNT () ) {
      wchar_t szBuffer [ FONTSIZE_BUFFER_MAX ] ;
      swprintf ( szBuffer, L"%d%s", nFontSize / 2, ( nFontSize % 2 ) ? L".5" : L"" ) ;
      Dlg_Wm_SetTextW ( hWnd, nComboBox, szBuffer ) ;
   }
   else {
      char szBuffer [ FONTSIZE_BUFFER_MAX ] ;
      sprintf ( szBuffer, "%d%s", nFontSize / 2, ( nFontSize % 2 ) ? ".5" : "" ) ;
      Dlg_Wm_SetTextA ( hWnd, nComboBox, szBuffer ) ;
   }

   return 0 ;
}



////////////////////////////////////////////
//       IvVݒi\j       //
////////////////////////////////////////////



int SetComboBoxMuiLangIdData ( HWND hWnd, int nComboBox, int nLangId ) ;
int SetMuiLangIdArrayData ( int nIndex, int nLangId ) ;
int GetMuiLangIdArray ( int nIndex ) ;
BOOL CALLBACK SetComboBoxMuiLangIdProc ( wchar_t *szName ) ;



// \ĨR{{bNXZbg
int SetComboBoxMuiLangId ( HWND hWnd, int nComboBox ) {

   if ( ! IsNT () || AllocMuiLangIdArray () ) {
      if ( IsNT () ) Dlg_ComboBox_InsertStringW ( hWnd, nComboBox, 0, GetStringW ( IDS_DEFAULT_MUI_LANG ) ) ;
      else           Dlg_ComboBox_InsertStringA ( hWnd, nComboBox, 0, GetStringA ( IDS_DEFAULT_MUI_LANG ) ) ;
      Dlg_ComboBox_SetCurSel ( hWnd, nComboBox, 0 ) ;
      Dlg_EnableWindow ( hWnd, IDC_COMBO_MUI_LANG, FALSE ) ;
   }
   else {

      int nCurrentLangId = GetResourceLanguage () ;

      SetComboBoxMuiLangIdData ( hWnd, nComboBox, 0 ) ;
      EnumSystemLocalesW ( SetComboBoxMuiLangIdProc, LCID_INSTALLED ) ;

      LoadMuiLibrary ( nCurrentLangId ) ;

      Dlg_ComboBox_InsertStringW ( hWnd, nComboBox, 0, GetStringW ( IDS_DEFAULT_MUI_LANG ) ) ;
      SetMuiLangIdArrayData ( 0, LANGID_NEUTRAL ) ;

      int nIndexMax = Dlg_ComboBox_GetCount ( hWnd, nComboBox ) ;
      int nIndex = 0 ;

      for ( int nCount = 0 ; nCount < nIndexMax ; nCount ++ ) {
         if ( nSavedMuiLangId == GetMuiLangIdArray ( nCount ) ) {
            nIndex = nCount ;
            break ;
         }
      }

      Dlg_ComboBox_SetCurSel ( hWnd, nComboBox, nIndex ) ;

      Dlg_ComboBox_SetMaxHeight ( hWnd, nComboBox, 10 ) ;
   }

   return 0 ;
}



// \I񋓂vV[W
BOOL CALLBACK SetComboBoxMuiLangIdProc ( wchar_t *szName ) {
   LCID nLcid = wcstol ( szName, NULL, 0x10 ) ;
   LANGID nLangId = LANGIDFROMLCID ( nLcid ) ;
   if ( nLangId ) SetComboBoxMuiLangIdData ( NULL, 0, nLangId ) ;
   return TRUE ;
}



// \I񋓂vV[W̉֐
// ŏ nLangId  0 w肵āAhWnd, nComboBox 
int SetComboBoxMuiLangIdData ( HWND hWnd, int nComboBox, int nLangId ) {

   static HWND hSavedWnd ;
   static int nSavedComboBox ;

   if ( ! nLangId ) {
      hSavedWnd = hWnd ;
      nSavedComboBox = nComboBox ;
   }
   else {
      if ( ! LoadMuiLibrary ( nLangId ) ) {

         wchar_t szBuffer [ SHORTSTRING_MAX * 2 ] ;

         if ( GetLocaleInfoW ( MAKELCID ( nLangId, SORT_DEFAULT ), LOCALE_SLANGUAGE, szBuffer, SHORTSTRING_MAX ) ) {

            wchar_t szBufferSub [ SHORTSTRING_MAX ] ;
            if ( GetLocaleInfoW ( MAKELCID ( nLangId, SORT_DEFAULT ), LOCALE_SNATIVELANGNAME, szBufferSub, SHORTSTRING_MAX ) && wcscmp ( szBuffer, szBufferSub ) ) {
               wcscat ( szBuffer, L" - " ) ;
               wcscat ( szBuffer, szBufferSub ) ;
            }

            int nIndex = Dlg_ComboBox_AddStringW ( hSavedWnd, nSavedComboBox, szBuffer ) ;
            SetMuiLangIdArrayData ( nIndex, nLangId ) ;
         }
      }
   }

   return 0 ;
}



int GetComboBoxMuiLangId ( HWND hWnd, int nComboBox ) {
   int nIndex = Dlg_ComboBox_GetCurSel ( hWnd, nComboBox ) ;
   return GetMuiLangIdArray ( nIndex ) ;
}



BOOL CALLBACK CountMuiLangIdProc ( wchar_t *szName ) ;
static LANGID *pMuiLangIdArray ;
static int nMuiLangIdMax ;



// \I̔z񃁃m
// s 0 ȊOԂ
int AllocMuiLangIdArray ( void ) {

   nMuiLangIdMax = 0 ;
   EnumSystemLocalesW ( CountMuiLangIdProc, LCID_INSTALLED ) ;
   nMuiLangIdMax += 0x10 ;    // Ƃ LANGID_NEUTRAL Ȃǂ邽

   pMuiLangIdArray = (LANGID*) malloc ( ( nMuiLangIdMax ) * sizeof(LANGID) ) ;
   if ( ! pMuiLangIdArray ) return 1 ;

   return 0 ;
}



// \I̔z񃁃
int FreeMuiLangIdArray ( void ) {
   free ( pMuiLangIdArray ) ;
   pMuiLangIdArray = NULL ;
   return 0 ;
}



// \I̍ő吔𒲂ׂvV[W
BOOL CALLBACK CountMuiLangIdProc ( wchar_t *szName ) {
   nMuiLangIdMax ++ ;
   return TRUE ;
}



// \I̔z񃁃Ƀf[^i[
int SetMuiLangIdArrayData ( int nIndex, int nLangId ) {

   if ( nIndex >= 0 && nIndex < nMuiLangIdMax ) {
      memmove ( pMuiLangIdArray + nIndex + 1, pMuiLangIdArray + nIndex, sizeof(LANGID) * ( nMuiLangIdMax - nIndex - 1 ) ) ;
      pMuiLangIdArray [ nIndex ] = nLangId ;
   }

   return 0 ;
}



// \I̔z񃁃f[^擾
int GetMuiLangIdArray ( int nIndex ) {
   if ( nIndex >= 0 && nIndex < nMuiLangIdMax ) return pMuiLangIdArray [ nIndex ] ;
   return 0 ;
}



