// cjkctype.cpp

#include <windows.h>
#include <string.h>
#include <ctype.h>
#include <mbctype.h>
#include <limits.h>
#include <errno.h>
#include "msc.h"
#include "codepage.h"

#undef DEBUG_CONST_STRING
#include "cjkctype.h"



////////////////////////////////////////////
//               strlcpy ()               //
////////////////////////////////////////////



// w肳ꂽ܂ŕRs[iMULTIBYTEŁj
// bufsiz  dst Ɏ߂邱Ƃ̂łő̕iI[k܂ށj
// src ̕ԂiI[k܂܂Ȃj
size_t mbslcpylen_cp ( char *dst, const char *src, size_t srclen, size_t bufsiz, int codepage ) {

   if ( srclen == (size_t) -1 ) srclen = strlen ( src ) ;

   if ( bufsiz ) {
      size_t cpylen = ( srclen < bufsiz ) ? srclen : bufsiz - 1 ;
      memmove ( dst, src, cpylen * sizeof(char) ) ;
      mbstrunc_cp ( dst, cpylen, codepage ) ;
   }

   return srclen ;
}



////////////////////////////////////////////
//               strlcat ()               //
////////////////////////////////////////////



// w肳ꂽ܂ŕAiMULTIBYTEŁj
// bufsiz  dst Ɏ߂邱Ƃ̂łő̕iI[k܂ށj
// src  dst ̍̕vԂiI[k܂܂Ȃj
size_t mbslcat_cp ( char *dst, const char *src, size_t bufsiz, int codepage ) {

   size_t srclen = strlen ( src ) ;
   size_t dstlen = strlen ( dst ) ;

   if ( bufsiz > dstlen ) {
      size_t cpylen = srclen ;
      if ( cpylen >= bufsiz - dstlen ) cpylen = bufsiz - dstlen - 1 ;
      memmove ( dst + dstlen, src, cpylen * sizeof(char) ) ;
      mbstrunc_cp ( dst, dstlen + cpylen, codepage ) ;
   }

   return srclen + dstlen ;
}



////////////////////////////////////////////
//              strreplace ()             //
////////////////////////////////////////////



// uiMULTIBYTEŁj
// max ɂ͒uső吔܂ SIZE_MAX w肷
// pnext ɂ͍Ōɒu̒̈ʒuۑiNULLłj
// us񐔂Ԃ
size_t mbsreplace_cp ( char *string, const char *pattern, const char *replace, char **pnext, size_t max, int codepage ) {

   size_t count = 0 ;

   size_t patlen = strlen ( pattern ) ;
   size_t replen = strlen ( replace ) ;

   while ( ++ count <= max ) {

      char *p = mbsstr_cp ( string, pattern, codepage ) ;
      if ( ! p ) break ;

      if ( replen != patlen ) memmove ( p + replen, p + patlen, ( strlen ( p + patlen ) + 1 ) * sizeof(char) ) ;
      memmove ( p, replace, replen * sizeof(char) ) ;
      string = p + replen ;
   }

   if ( pnext ) *pnext = string ;

   return count - 1 ;
}



////////////////////////////////////////////
//               strcmp ()                //
////////////////////////////////////////////



// riMULTIBYTEŁj
int mbsncmp_i_cp ( const char *string1, const char *string2, size_t count, int isignore, int codepage ) {

   int c1, c2 ;
   int isprevlead1 = 0, isprevlead2 = 0 ;

   while ( 1 ) {

      if ( ! count ) return 0 ;

      c1 = (unsigned char) *string1 ;
      if ( isprevlead1 ) isprevlead1 = 0 ;
      else {
         if ( ismbblead_cp ( c1, codepage ) ) isprevlead1 = 1 ;
         else if ( isignore )                 c1 = tolower ( c1 ) ;
      }

      c2 = (unsigned char) *string2 ;
      if ( isprevlead2 ) isprevlead2 = 0 ;
      else {
         if ( ismbblead_cp ( c2, codepage ) ) isprevlead2 = 1 ;
         else if ( isignore )                 c2 = tolower ( c2 ) ;
      }

      if ( ! c1 || c1 != c2 ) break ;

      string1 ++ ;
      string2 ++ ;
      count -- ;
   }

   if ( (unsigned) c1 > (unsigned) c2 ) return 1 ;
   if ( (unsigned) c1 < (unsigned) c2 ) return -1 ;
   return 0 ;
}



////////////////////////////////////////////
//               strrcmp ()               //
////////////////////////////////////////////



// 𖖔riMULTIBYTEŁj
int mbsrncmp_i_cp ( const char *string1, const char *string2, size_t count, int isignore, int codepage ) {

   int c1, c2 ;

   const char *current1 = strend ( string1 ) - 1 ;
   const char *current2 = strend ( string2 ) - 1 ;

   while ( 1 ) {

      if ( ! count ) return 0 ;

      if ( current1 < string1 ) c1 = 0 ;
      else {
         c1 = (unsigned char) *current1 ;
         if ( ismbstrail_cp ( string1, current1, codepage ) ) c1 += 0x100 ;
         else if ( isignore )                                 c1 = tolower ( c1 ) ;
      }

      if ( current2 < string2 ) c2 = 0 ;
      else {
         c2 = (unsigned char) *current2 ;
         if ( ismbstrail_cp ( string2, current2, codepage ) ) c2 += 0x100 ;
         else if ( isignore )                                 c2 = tolower ( c2 ) ;
      }

      if ( ! c1 || c1 != c2 ) break ;

      current1 -- ;
      current2 -- ;
      count -- ;
   }

   if ( (unsigned) c1 > (unsigned) c2 ) return 1 ;
   if ( (unsigned) c1 < (unsigned) c2 ) return -1 ;
   return 0 ;
}



////////////////////////////////////////////
//              strheadcmp ()             //
////////////////////////////////////////////



// ̐擪riMULTIBYTEŁj
int mbsheadcmp_i_cp ( const char *string1, const char *string2, int isignore, int codepage ) {
   return mbsncmp_i_cp ( string1, string2, strlen ( string2 ), isignore, codepage ) ;
}



////////////////////////////////////////////
//             strtailcmp ()              //
////////////////////////////////////////////



// ̖riMULTIBYTEŁj
int mbstailcmp_i_cp ( const char *string1, const char *string2, int isignore, int codepage ) {
   return mbsrncmp_i_cp ( string1, string2, strlen ( string2 ), isignore, codepage ) ;
}



////////////////////////////////////////////
//               strstr ()                //
////////////////////////////////////////////



// 񂩂當iMULTIBYTEŁj
char *mbsstr_i_r_cp ( const char *string, const char *pattern, int isignore, int islast, int codepage ) {

   const char *result = NULL ;

   size_t patlen = strlen ( pattern ) ;
   if ( ! patlen ) return (char*) string ;

   const char *tail = string + strlen ( string ) - patlen ;

   int c2 = *pattern ;
   if ( isignore ) c2 = tolower ( c2 ) ;

   while ( string <= tail ) {

      int c1 = *string ;
      if ( isignore ) c1 = tolower ( c1 ) ;

      if ( c1 == c2 && ! mbsncmp_i_cp ( string, pattern, patlen, isignore, codepage ) ) {
         result = string ;
         if ( ! islast ) break ;
      }

      if ( ismbblead_cp ( (unsigned char) *string, codepage ) ) {
         if ( ismbbsurrogate_cp ( (unsigned char) *( string + 1 ), codepage ) ) {
            string ++ ;
            string ++ ;
         }
         string ++ ;
      }
      string ++ ;
   }

   return (char*) result ;
}



////////////////////////////////////////////
//               strchr ()                //
////////////////////////////////////////////



// 񂩂當iMULTIBYTEŁj
char *mbschr_i_r_cp ( const char *string, int c, int isignore, int islast, int codepage ) {

   const char *result = NULL ;

   if ( isignore ) c = tolower ( c ) ;

   do {

      if ( ismbblead_cp ( (unsigned char) *string, codepage ) ) {

         if ( ismbbsurrogate_cp ( (unsigned char) *( string + 1 ), codepage ) ) {
            if ( *( string + 2 ) ) {
               if ( *( string + 3 ) ) {
                  int c1 = ( (unsigned char) *( string + 0 ) << 8 ) + (unsigned char) *( string + 1 ) ;
                  int c2 = ( (unsigned char) *( string + 2 ) << 8 ) + (unsigned char) *( string + 3 ) ;
                  if ( c == ( c1 << 16 ) + c2 ) return (char*) string ;
                  string ++ ;
               }
               string ++ ;
            }
            string ++ ;
         }
         else if ( *( string + 1 ) ) {
            if ( c == ( (unsigned char) *string << 8 ) + (unsigned char) *( string + 1 ) ) return (char*) string ;
            string ++ ;
         }

      }
      else {

         int c1 = *string ;
         if ( isignore ) c1 = tolower ( c1 ) ;

         if ( c == c1 ) {
            result = string ;
            if ( ! islast ) break ;
         }
      }

   } while ( *string ++ ) ;

   return (char*) result ;
}



////////////////////////////////////////////
//          strspn (), strcspn ()         //
////////////////////////////////////////////



// keys ɑȂ string ōŏɏoʒuԂiMULTIBYTEŁj
// ȂΖԂ
size_t mbsspn_cp ( const char *string, const char *keys, int codepage ) {

   int c ;
   const char *current ;

   for ( current = string ; *current ; current ++ ) {

      int islead = ismbblead_cp ( (unsigned char) *current, codepage ) ;
      int issurrogate = ismbbsurrogate_cp ( (unsigned char) *(current + 1 ), codepage ) ;

      if ( islead ) {
         if ( issurrogate ) {
            int c1 = ( (unsigned char) *( current + 0 ) << 8 ) + (unsigned char) *( current + 1 ) ;
            int c2 = ( (unsigned char) *( current + 2 ) << 8 ) + (unsigned char) *( current + 3 ) ;
            c = ( c1 << 16 ) + c2 ;
         }
         else {
            c = ( (unsigned char) *current << 8 ) + (unsigned char) *( current + 1 ) ;
         }
      }
      else {
         c = *current ;
      }

      if ( ! mbschr_cp ( keys, c, codepage ) ) break ;

      if ( islead ) {
         if ( issurrogate ) {
            current ++ ;
            if ( *( current + 1 ) ) current ++ ;
            if ( *( current + 1 ) ) current ++ ;
         }
         else {
            if ( *( current + 1 ) ) current ++ ;
         }
      }
   }

   return current - string ;
}



// keys ɑ string ōŏɏoʒuԂiMULTIBYTEŁj
// ȂΖԂ
size_t mbscspn_cp ( const char *string, const char *keys, int codepage ) {

   int c ;
   const char *current ;

   for ( current = string ; *current ; current ++ ) {

      int islead = ismbblead_cp ( (unsigned char) *current, codepage ) ;
      int issurrogate = ismbbsurrogate_cp ( (unsigned char) *(current + 1 ), codepage ) ;

      if ( islead ) {
         if ( issurrogate ) {
            int c1 = ( (unsigned char) *( current + 0 ) << 8 ) + (unsigned char) *( current + 1 ) ;
            int c2 = ( (unsigned char) *( current + 2 ) << 8 ) + (unsigned char) *( current + 3 ) ;
            c = ( c1 << 16 ) + c2 ;
         }
         else {
            c = ( (unsigned char) *current << 8 ) + (unsigned char) *( current + 1 ) ;
         }
      }
      else {
         c = *current ;
      }

      if ( mbschr_cp ( keys, c, codepage ) ) break ;

      if ( islead ) {
         if ( issurrogate ) {
            current ++ ;
            if ( *( current + 1 ) ) current ++ ;
            if ( *( current + 1 ) ) current ++ ;
         }
         else {
            if ( *( current + 1 ) ) current ++ ;
         }
      }
   }

   return current - string ;
}



////////////////////////////////////////////
//         strspnp (), strpbrk ()         //
////////////////////////////////////////////



// keys ɑȂ string ōŏɏoʒuԂiMULTIBYTEŁj
// Ȃ NULL Ԃ
char *mbsspnp_cp ( const char *string, const char *keys, int codepage ) {

   const char *result = string + mbsspn_cp ( string, keys, codepage ) ;
   if ( *result ) return (char*) result ;

   return NULL ;
}



// keys ɑ string ōŏɏoʒuԂiMULTIBYTEŁj
// Ȃ NULL Ԃ
char *mbspbrk_cp ( const char *string, const char *keys, int codepage ) {

   const char *result = string + mbscspn_cp ( string, keys, codepage ) ;
   if ( *result ) return (char*) result ;

   return NULL ;
}



////////////////////////////////////////////
//               strlwr ()                //
////////////////////////////////////////////



// ɁiMULTIBYTEŁj
char *mbslwr_cp ( char *string, int codepage ) {

   for ( char *current = string ; *current ; current ++ ) {
      if ( ismbblead_cp ( (unsigned char) *current, codepage ) && *( current + 1 ) ) {
         current ++ ;
         continue ;
      }
      *current = tolower ( *current ) ;
   }

   return string ;
}



////////////////////////////////////////////
//               strupr ()                //
////////////////////////////////////////////



// 啶ɁiMULTIBYTEŁj
char *mbsupr_cp ( char *string, int codepage ) {

   for ( char *current = string ; *current ; current ++ ) {
      if ( ismbblead_cp ( (unsigned char) *current, codepage ) && *( current + 1 ) ) {
         current ++ ;
         continue ;
      }
      *current = toupper ( *current ) ;
   }

   return string ;
}



////////////////////////////////////////////
//               strrev ()                //
////////////////////////////////////////////



// t]iMULTIBYTEŁj
char *mbsrev_cp ( char *string, int codepage ) {

   for ( char *current = string ; *current ; current ++ ) {
      if ( ismbblead_cp ( (unsigned char) *current, codepage ) ) {
         if ( ismbbsurrogate_cp ( (unsigned char) *( current + 1 ), codepage ) ) {
            if ( *( current + 2 ) && *( current + 3 ) ) {
               char c0 = *( current + 0 ) ;
               char c1 = *( current + 1 ) ;
               char c2 = *( current + 2 ) ;
               char c3 = *( current + 3 ) ;
               *( current + 3 ) = c0 ;
               *( current + 2 ) = c1 ;
               *( current + 1 ) = c2 ;
               *( current + 0 ) = c3 ;
               current ++ ;
               current ++ ;
               current ++ ;
               continue ;
            }
            else {
               *current = 0 ;
               break ;
            }
         }
         else {
            if ( *( current + 1 ) ) {
               char c0 = *( current + 0 ) ;
               char c1 = *( current + 1 ) ;
               *( current + 1 ) = c0 ;
               *( current + 0 ) = c1 ;
               current ++ ;
               continue ;
            }
            else {
               *current = 0 ;
               break ;
            }
         }
      }
   }

   return strrev ( string ) ;
}



////////////////////////////////////////////
//               strtrunc ()              //
////////////////////////////////////////////



// ZkiMULTIBYTEŁj
// length ͍ő厚iI[k܂܂Ȃj
char *mbstrunc_cp ( char *string, size_t length, int codepage ) {

   char *end = string + length ;

   for ( char *current = string ; *current ; current ++ ) {
      if ( ismbblead_cp ( (unsigned char) *current, codepage ) ) {
         if ( ismbbsurrogate_cp ( (unsigned char) *( current + 1 ), codepage ) ) {
            if ( current >= end - 3 || ! *( current + 2 ) || ! *( current + 3 ) ) {
               *current = 0 ;
               break ;
            }
            current ++ ;
            current ++ ;
            current ++ ;
         }
         else {
            if ( current >= end - 1 || ! *( current + 1 ) ) {
               *current = 0 ;
               break ;
            }
            current ++ ;
         }
      }
      else {
         if ( current >= end ) {
            *current = 0 ;
            break ;
         }
      }
   }

   return string ;
}



////////////////////////////////////////////
//                strlen ()               //
////////////////////////////////////////////



// ԂiMULTIBYTEŁj
// QoCg͂PƂĐ
size_t mbslen_cp ( const char *string, int codepage ) {

   size_t n ;

   for ( n = 0 ; *string ; n ++, string ++ ) {
      if ( ismbblead_cp ( (unsigned char) *string, codepage ) ) {
         if ( ismbbsurrogate_cp ( (unsigned char) *( string + 1 ), codepage ) ) {
            string ++ ;
            if ( *( string + 1 ) ) string ++ ;
            if ( *( string + 1 ) ) string ++ ;
         }
         else {
            if ( *( string + 1 ) ) string ++ ;
         }
      }
   }

   return n ;
}



////////////////////////////////////////////
//               strldup ()               //
////////////////////////////////////////////



// w肳ꂽ܂ŕ𕡐iMULTIBYTEŁj
// bufsiz ͐VɎ߂邱Ƃ̂łő̕iI[k܂ށj
char *mbsldup_cp ( const char *string, size_t bufsiz, int codepage ) {

   size_t len = strlen ( string ) ;
   if ( len >= bufsiz ) len = bufsiz - 1 ;

   char *buffer = (char*) malloc ( ( len + 1 ) * sizeof(char) ) ;
   if ( buffer ) {
      memmove ( buffer, string, len * sizeof(char) ) ;
      mbstrunc_cp ( buffer, len, codepage ) ;
   }

   return buffer ;
}



////////////////////////////////////////////
//               mbsbtype ()              //
////////////////////////////////////////////



// }`oCg𔻒
int mbsbtype_cp ( const char *string, size_t count, int codepage ) {

   int isprevlead = 0 ;

   for ( const char *current = string ; *current ; current ++ ) {
      if ( size_t ( current - string ) == count ) {
         if ( isprevlead ) {
            if ( ismbbtrail_cp ( (unsigned char) *current, codepage ) ) return _MBC_TRAIL ;
            else                                                        return _MBC_ILLEGAL ;
         }
         else {
            if ( ismbblead_cp ( (unsigned char) *current, codepage ) ) return _MBC_LEAD ;
            else if ( *current )                                       return _MBC_SINGLE ;
            else                                                       return _MBC_ILLEGAL ;
         }
      }
      if ( ! isprevlead && ismbblead_cp ( (unsigned char) *current, codepage ) ) isprevlead = 1 ;
      else                                                                       isprevlead = 0 ;
   }

   return _MBC_ILLEGAL ;
}



// }`oCg𔻒
int ismbslead_cp ( const char *string, const char *current, int codepage ) {
   if ( mbsbtype_cp ( string, current - string, codepage ) == _MBC_LEAD ) return -1 ;
   return 0 ;
}



// }`oCg𔻒
int ismbstrail_cp ( const char *string, const char *current, int codepage ) {
   if ( mbsbtype_cp ( string, current - string, codepage ) == _MBC_TRAIL ) return -1 ;
   return 0 ;
}



////////////////////////////////////////////
//               jis / sjis               //
////////////////////////////////////////////



// Shift JIS  JIS ɕϊ
int jmstojis ( int c ) {

   int high = c >> 8 ;
   int low = c & 0xFF ;

   if ( high & ~ 0xFF || ! ismbblead_sjis ( high ) || ! ismbbtrail_sjis ( low ) ) return 0 ;

   if ( high <= 0x9F ) {
      if ( low < 0x9F ) high = ( high << 1 ) - 0xE1 ;
      else              high = ( high << 1 ) - 0xE0 ;
   }
   else if ( high < 0xF0 ) {
      if ( low < 0x9F ) high = ( high << 1 ) - ( 0x80 + 0xE1 ) ;
      else              high = ( high << 1 ) - ( 0x80 + 0xE0 ) ;
   }
   else return 0 ;

   if ( low < 0x7F )      low -= 0x1F ;
   else if ( low < 0x9F ) low -= 0x20 ;
   else                   low -= 0x7E ;

   return ( high << 8 ) + low ;
}



// JIS  Shift JIS ɕϊ
int jistojms ( int c ) {

   int high = c >> 8 ;
   int low = c & 0xFF ;

   if ( high < 0x21 || high > 0x7E || low < 0x21 || low > 0x7E ) return 0 ;

   if ( high & 1 ) {
      if ( low < 0x60 ) low += 0x1F ;
      else              low += 0x20 ;
   }
   else {
      low += 0x7E ;
   }

   if ( high < 0x5F ) high = ( high + 0xE1 ) >> 1 ;
   else               high = ( high + ( 0x80 + 0xE1 ) ) >> 1 ;

   return ( high << 8 ) + low ;
}



////////////////////////////////////////////
//               ctype table              //
////////////////////////////////////////////



#define JP        0x1
#define GB        0x2
#define B5        0x4
#define KR        0x8
#define JH       0x10
#define CN       0x20
#define TC       0x40
#define ET       0x80
#define IB      0x100
#define TL      0x200
#define WA      0x400
#define MG      0x800
#define MT     0x1000
#define MK     0x2000
#define EJ     0x4000
#define EG     0x8000
#define EK    0x10000
#define T6    0x20000



static unsigned long getbitmask ( int codepage ) {

   unsigned long bitmask ;

   switch ( codepage ) {
      case CP_ACP : codepage = GetACP () ; break ;
      case CP_OEMCP : codepage = GetOEMCP () ; break ;
   }

   switch ( codepage ) {
      case CP_JAPANESE : bitmask = JP ; break ;
      case CP_CHINESE_SIMPLIFIED : bitmask = GB ; break ;
      case CP_CHINESE_SIMPLIFIED_EX : bitmask = GB ; break ;
      case CP_CHINESE_TRADITIONAL : bitmask = B5 ; break ;
      case CP_CHINESE_HKSCS : bitmask = B5 ; break ;
      case CP_KOREAN : bitmask = KR ; break ;
      case CP_KOREAN_JOHAB : bitmask = JH ; break ;
      case CP_CHINESE_TRADITIONAL_CNS : bitmask = CN ; break ;
      case CP_CHINESE_TRADITIONAL_TCA : bitmask = TC ; break ;
      case CP_CHINESE_TRADITIONAL_ETEN : bitmask = ET ; break ;
      case CP_CHINESE_TRADITIONAL_IBM5550 : bitmask = IB ; break ;
      case CP_CHINESE_TRADITIONAL_TELETEXT : bitmask = TL ; break ;
      case CP_CHINESE_TRADITIONAL_WANG : bitmask = WA ; break ;
      case CP_MAC_CHINESE_SIMPLIFIED : bitmask = MG ; break ;
      case CP_MAC_CHINESE_TRADITIONAL : bitmask = MT ; break ;
      case CP_MAC_KOREAN : bitmask = MK ; break ;
      case CP_EUC_JAPANESE_MS : bitmask = EJ ; break ;
      case CP_EUC_CHINESE_SIMPLIFIED : bitmask = EG ; break ;
      case CP_EUC_KOREAN : bitmask = EK ; break ;
      case CP_EUC_KOREAN_2 : bitmask = EK ; break ;
      case CP_T61 : bitmask = T6 ; break ;
      default : bitmask = 0 ; break ;
   }

   return bitmask ;
}



int ismbblead_cp ( int c, int codepage ) {

   static const unsigned long cjkctype_lead [] = {
      /* -1 */   0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0,
      /* 00 */   0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0,
      /* 01 */   0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0,
      /* 02 */   0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0,
      /* 03 */   0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0,
      /* 04 */   0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0,
      /* 05 */   0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0,
      /* 06 */   0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0,
      /* 07 */   0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0,
      /* 08 */   0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0,
      /* 09 */   0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0,
      /* 0A */   0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0,
      /* 0B */   0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0,
      /* 0C */   0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0,
      /* 0D */   0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0,
      /* 0E */   0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0,
      /* 0F */   0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0,
      /* 10 */   0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0,
      /* 11 */   0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0,
      /* 12 */   0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0,
      /* 13 */   0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0,
      /* 14 */   0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0,
      /* 15 */   0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0,
      /* 16 */   0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0,
      /* 17 */   0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0,
      /* 18 */   0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0,
      /* 19 */   0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0,
      /* 1A */   0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0,
      /* 1B */   0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0,
      /* 1C */   0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0,
      /* 1D */   0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0,
      /* 1E */   0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0,
      /* 1F */   0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0,
      /* 20 */   0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0,
      /* 21 */   0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0,
      /* 22 */   0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0,
      /* 23 */   0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0,
      /* 24 */   0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0,
      /* 25 */   0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0,
      /* 26 */   0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0,
      /* 27 */   0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0,
      /* 28 */   0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0,
      /* 29 */   0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0,
      /* 2A */   0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0,
      /* 2B */   0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0,
      /* 2C */   0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0,
      /* 2D */   0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0,
      /* 2E */   0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0,
      /* 2F */   0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0,
      /* 30 */   0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0,
      /* 31 */   0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0,
      /* 32 */   0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0,
      /* 33 */   0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0,
      /* 34 */   0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0,
      /* 35 */   0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0,
      /* 36 */   0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0,
      /* 37 */   0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0,
      /* 38 */   0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0,
      /* 39 */   0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0,
      /* 3A */   0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0,
      /* 3B */   0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0,
      /* 3C */   0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0,
      /* 3D */   0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0,
      /* 3E */   0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0,
      /* 3F */   0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0,
      /* 40 */   0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0,
      /* 41 */   0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0,
      /* 42 */   0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0,
      /* 43 */   0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0,
      /* 44 */   0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0,
      /* 45 */   0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0,
      /* 46 */   0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0,
      /* 47 */   0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0,
      /* 48 */   0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0,
      /* 49 */   0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0,
      /* 4A */   0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0,
      /* 4B */   0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0,
      /* 4C */   0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0,
      /* 4D */   0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0,
      /* 4E */   0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0,
      /* 4F */   0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0,
      /* 50 */   0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0,
      /* 51 */   0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0,
      /* 52 */   0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0,
      /* 53 */   0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0,
      /* 54 */   0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0,
      /* 55 */   0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0,
      /* 56 */   0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0,
      /* 57 */   0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0,
      /* 58 */   0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0,
      /* 59 */   0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0,
      /* 5A */   0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0,
      /* 5B */   0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0,
      /* 5C */   0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0,
      /* 5D */   0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0,
      /* 5E */   0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0,
      /* 5F */   0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0,
      /* 60 */   0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0,
      /* 61 */   0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0,
      /* 62 */   0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0,
      /* 63 */   0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0,
      /* 64 */   0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0,
      /* 65 */   0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0,
      /* 66 */   0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0,
      /* 67 */   0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0,
      /* 68 */   0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0,
      /* 69 */   0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0,
      /* 6A */   0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0,
      /* 6B */   0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0,
      /* 6C */   0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0,
      /* 6D */   0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0,
      /* 6E */   0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0,
      /* 6F */   0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0,
      /* 70 */   0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0,
      /* 71 */   0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0,
      /* 72 */   0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0,
      /* 73 */   0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0,
      /* 74 */   0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0,
      /* 75 */   0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0,
      /* 76 */   0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0,
      /* 77 */   0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0,
      /* 78 */   0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0,
      /* 79 */   0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0,
      /* 7A */   0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0,
      /* 7B */   0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0,
      /* 7C */   0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0,
      /* 7D */   0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0,
      /* 7E */   0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0,
      /* 7F */   0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0,
      /* 80 */   0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0,
      /* 81 */   JP | GB | B5 | KR | 0  | 0  | TC | ET | IB | 0  | 0  | 0  | MT | 0  | 0  | 0  | 0  | 0  | 0,
      /* 82 */   JP | GB | B5 | KR | 0  | 0  | TC | ET | IB | 0  | 0  | 0  | MT | 0  | 0  | 0  | 0  | 0  | 0,
      /* 83 */   JP | GB | B5 | KR | 0  | 0  | TC | ET | IB | 0  | 0  | 0  | MT | 0  | 0  | 0  | 0  | 0  | 0,
      /* 84 */   JP | GB | B5 | KR | JH | 0  | TC | ET | IB | 0  | 0  | 0  | MT | 0  | 0  | 0  | 0  | 0  | 0,
      /* 85 */   JP | GB | B5 | KR | JH | 0  | 0  | ET | 0  | 0  | 0  | 0  | MT | 0  | 0  | 0  | 0  | 0  | 0,
      /* 86 */   JP | GB | B5 | KR | JH | 0  | 0  | ET | 0  | 0  | 0  | 0  | MT | 0  | 0  | 0  | 0  | 0  | 0,
      /* 87 */   JP | GB | B5 | KR | JH | 0  | 0  | ET | IB | 0  | 0  | 0  | MT | 0  | 0  | 0  | 0  | 0  | 0,
      /* 88 */   JP | GB | B5 | KR | JH | 0  | 0  | ET | 0  | 0  | 0  | 0  | MT | 0  | 0  | 0  | 0  | 0  | 0,
      /* 89 */   JP | GB | B5 | KR | JH | 0  | 0  | ET | IB | 0  | 0  | 0  | MT | 0  | 0  | 0  | 0  | 0  | 0,
      /* 8A */   JP | GB | B5 | KR | JH | 0  | 0  | ET | IB | 0  | 0  | 0  | MT | 0  | 0  | 0  | 0  | 0  | 0,
      /* 8B */   JP | GB | B5 | KR | JH | 0  | 0  | ET | IB | 0  | 0  | 0  | MT | 0  | 0  | 0  | 0  | 0  | 0,
      /* 8C */   JP | GB | B5 | KR | JH | 0  | 0  | ET | IB | 0  | 0  | 0  | MT | 0  | 0  | 0  | 0  | 0  | 0,
      /* 8D */   JP | GB | B5 | KR | JH | 0  | 0  | ET | IB | 0  | WA | 0  | MT | 0  | 0  | 0  | 0  | 0  | 0,
      /* 8E */   JP | GB | B5 | KR | JH | 0  | 0  | ET | IB | 0  | WA | 0  | MT | 0  | EJ | 0  | 0  | 0  | 0,
      /* 8F */   JP | GB | B5 | KR | JH | 0  | 0  | ET | IB | 0  | WA | 0  | MT | 0  | 0  | 0  | 0  | 0  | 0,
      /* 90 */   JP | GB | B5 | KR | JH | 0  | 0  | ET | IB | 0  | WA | 0  | MT | 0  | 0  | 0  | 0  | 0  | 0,
      /* 91 */   JP | GB | B5 | KR | JH | 0  | TC | ET | IB | 0  | WA | 0  | MT | 0  | 0  | 0  | 0  | 0  | 0,
      /* 92 */   JP | GB | B5 | KR | JH | 0  | TC | ET | IB | 0  | WA | 0  | MT | 0  | 0  | 0  | 0  | 0  | 0,
      /* 93 */   JP | GB | B5 | KR | JH | 0  | TC | ET | IB | 0  | WA | 0  | MT | 0  | 0  | 0  | 0  | 0  | 0,
      /* 94 */   JP | GB | B5 | KR | JH | 0  | TC | ET | IB | 0  | WA | 0  | MT | 0  | 0  | 0  | 0  | 0  | 0,
      /* 95 */   JP | GB | B5 | KR | JH | 0  | TC | ET | IB | 0  | WA | 0  | MT | 0  | 0  | 0  | 0  | 0  | 0,
      /* 96 */   JP | GB | B5 | KR | JH | 0  | TC | ET | IB | 0  | WA | 0  | MT | 0  | 0  | 0  | 0  | 0  | 0,
      /* 97 */   JP | GB | B5 | KR | JH | 0  | TC | ET | IB | 0  | WA | 0  | MT | 0  | 0  | 0  | 0  | 0  | 0,
      /* 98 */   JP | GB | B5 | KR | JH | 0  | TC | ET | IB | 0  | WA | 0  | MT | 0  | 0  | 0  | 0  | 0  | 0,
      /* 99 */   JP | GB | B5 | KR | JH | 0  | TC | ET | IB | 0  | WA | 0  | MT | 0  | 0  | 0  | 0  | 0  | 0,
      /* 9A */   JP | GB | B5 | KR | JH | 0  | TC | ET | IB | 0  | WA | 0  | MT | 0  | 0  | 0  | 0  | 0  | 0,
      /* 9B */   JP | GB | B5 | KR | JH | 0  | TC | ET | IB | 0  | WA | 0  | MT | 0  | 0  | 0  | 0  | 0  | 0,
      /* 9C */   JP | GB | B5 | KR | JH | 0  | TC | ET | IB | 0  | WA | 0  | MT | 0  | 0  | 0  | 0  | 0  | 0,
      /* 9D */   JP | GB | B5 | KR | JH | 0  | TC | ET | IB | 0  | WA | 0  | MT | 0  | 0  | 0  | 0  | 0  | 0,
      /* 9E */   JP | GB | B5 | KR | JH | 0  | TC | ET | IB | 0  | WA | 0  | MT | 0  | 0  | 0  | 0  | 0  | 0,
      /* 9F */   JP | GB | B5 | KR | JH | 0  | TC | ET | IB | 0  | WA | 0  | MT | 0  | 0  | 0  | 0  | 0  | 0,
      /* A0 */   0  | GB | B5 | KR | JH | 0  | TC | ET | IB | 0  | WA | 0  | MT | 0  | 0  | 0  | 0  | 0  | 0,
      /* A1 */   0  | GB | B5 | KR | JH | CN | TC | ET | IB | TL | WA | MG | MT | MK | EJ | EG | EK | 0  | 0,
      /* A2 */   0  | GB | B5 | KR | JH | CN | TC | ET | IB | TL | WA | MG | MT | MK | EJ | EG | EK | 0  | 0,
      /* A3 */   0  | GB | B5 | KR | JH | CN | TC | ET | IB | TL | WA | MG | MT | MK | EJ | EG | EK | 0  | 0,
      /* A4 */   0  | GB | B5 | KR | JH | CN | TC | ET | IB | TL | WA | MG | MT | MK | EJ | EG | EK | 0  | 0,
      /* A5 */   0  | GB | B5 | KR | JH | CN | TC | ET | IB | TL | WA | MG | MT | MK | EJ | EG | EK | 0  | 0,
      /* A6 */   0  | GB | B5 | KR | JH | CN | TC | ET | IB | TL | WA | MG | MT | MK | EJ | EG | EK | 0  | 0,
      /* A7 */   0  | GB | B5 | KR | JH | CN | TC | ET | IB | TL | WA | MG | MT | MK | EJ | EG | EK | 0  | 0,
      /* A8 */   0  | GB | B5 | KR | JH | CN | TC | ET | IB | TL | WA | MG | MT | MK | EJ | EG | EK | 0  | 0,
      /* A9 */   0  | GB | B5 | KR | JH | CN | TC | ET | IB | TL | WA | MG | MT | MK | EJ | EG | EK | 0  | 0,
      /* AA */   0  | GB | B5 | KR | JH | CN | TC | ET | IB | TL | WA | 0  | MT | MK | EJ | 0  | EK | 0  | 0,
      /* AB */   0  | GB | B5 | KR | JH | CN | TC | ET | IB | TL | WA | 0  | MT | MK | EJ | 0  | EK | 0  | 0,
      /* AC */   0  | GB | B5 | KR | JH | CN | TC | ET | IB | TL | WA | 0  | MT | MK | EJ | 0  | EK | 0  | 0,
      /* AD */   0  | GB | B5 | KR | JH | CN | TC | ET | IB | TL | WA | 0  | MT | 0  | EJ | 0  | 0  | 0  | 0,
      /* AE */   0  | GB | B5 | KR | JH | CN | TC | ET | IB | TL | WA | 0  | MT | 0  | EJ | 0  | 0  | 0  | 0,
      /* AF */   0  | GB | B5 | KR | JH | CN | TC | ET | IB | TL | WA | 0  | MT | 0  | EJ | 0  | 0  | 0  | 0,
      /* B0 */   0  | GB | B5 | KR | JH | CN | TC | 0  | IB | TL | WA | MG | MT | MK | EJ | EG | EK | 0  | 0,
      /* B1 */   0  | GB | B5 | KR | JH | CN | TC | 0  | IB | TL | WA | MG | MT | MK | EJ | EG | EK | 0  | 0,
      /* B2 */   0  | GB | B5 | KR | JH | CN | TC | 0  | IB | TL | WA | MG | MT | MK | EJ | EG | EK | 0  | 0,
      /* B3 */   0  | GB | B5 | KR | JH | CN | TC | 0  | IB | TL | WA | MG | MT | MK | EJ | EG | EK | 0  | 0,
      /* B4 */   0  | GB | B5 | KR | JH | CN | TC | 0  | IB | TL | WA | MG | MT | MK | EJ | EG | EK | 0  | 0,
      /* B5 */   0  | GB | B5 | KR | JH | CN | TC | 0  | IB | TL | WA | MG | MT | MK | EJ | EG | EK | 0  | 0,
      /* B6 */   0  | GB | B5 | KR | JH | CN | TC | 0  | IB | TL | WA | MG | MT | MK | EJ | EG | EK | 0  | 0,
      /* B7 */   0  | GB | B5 | KR | JH | CN | TC | 0  | IB | TL | WA | MG | MT | MK | EJ | EG | EK | 0  | 0,
      /* B8 */   0  | GB | B5 | KR | JH | CN | TC | 0  | IB | TL | WA | MG | MT | MK | EJ | EG | EK | 0  | 0,
      /* B9 */   0  | GB | B5 | KR | JH | CN | TC | 0  | IB | TL | WA | MG | MT | MK | EJ | EG | EK | 0  | 0,
      /* BA */   0  | GB | B5 | KR | JH | CN | TC | 0  | IB | TL | WA | MG | MT | MK | EJ | EG | EK | 0  | 0,
      /* BB */   0  | GB | B5 | KR | JH | CN | TC | 0  | IB | TL | WA | MG | MT | MK | EJ | EG | EK | 0  | 0,
      /* BC */   0  | GB | B5 | KR | JH | CN | TC | 0  | IB | TL | WA | MG | MT | MK | EJ | EG | EK | 0  | 0,
      /* BD */   0  | GB | B5 | KR | JH | CN | TC | 0  | IB | TL | WA | MG | MT | MK | EJ | EG | EK | 0  | 0,
      /* BE */   0  | GB | B5 | KR | JH | CN | TC | 0  | IB | TL | WA | MG | MT | MK | EJ | EG | EK | 0  | 0,
      /* BF */   0  | GB | B5 | KR | JH | CN | TC | 0  | IB | TL | WA | MG | MT | MK | EJ | EG | EK | 0  | 0,
      /* C0 */   0  | GB | B5 | KR | JH | CN | TC | 0  | IB | TL | WA | MG | MT | MK | EJ | EG | EK | 0  | 0,
      /* C1 */   0  | GB | B5 | KR | JH | CN | TC | 0  | IB | TL | WA | MG | MT | MK | EJ | EG | EK | T6 | 0,
      /* C2 */   0  | GB | B5 | KR | JH | CN | TC | 0  | IB | TL | WA | MG | MT | MK | EJ | EG | EK | T6 | 0,
      /* C3 */   0  | GB | B5 | KR | JH | CN | TC | 0  | IB | TL | WA | MG | MT | MK | EJ | EG | EK | T6 | 0,
      /* C4 */   0  | GB | B5 | KR | JH | CN | TC | 0  | IB | TL | WA | MG | MT | MK | EJ | EG | EK | T6 | 0,
      /* C5 */   0  | GB | B5 | KR | JH | CN | TC | 0  | IB | TL | WA | MG | MT | MK | EJ | EG | EK | T6 | 0,
      /* C6 */   0  | GB | B5 | KR | JH | CN | TC | 0  | IB | TL | WA | MG | MT | MK | EJ | EG | EK | T6 | 0,
      /* C7 */   0  | GB | B5 | KR | JH | CN | TC | 0  | IB | TL | WA | MG | MT | MK | EJ | EG | EK | T6 | 0,
      /* C8 */   0  | GB | B5 | KR | JH | CN | TC | 0  | IB | TL | WA | MG | MT | MK | EJ | EG | EK | T6 | 0,
      /* C9 */   0  | GB | B5 | KR | JH | CN | TC | 0  | IB | TL | WA | MG | MT | 0  | EJ | EG | 0  | T6 | 0,
      /* CA */   0  | GB | B5 | KR | JH | CN | TC | 0  | IB | TL | WA | MG | MT | MK | EJ | EG | EK | T6 | 0,
      /* CB */   0  | GB | B5 | KR | JH | CN | TC | 0  | IB | TL | WA | MG | MT | MK | EJ | EG | EK | T6 | 0,
      /* CC */   0  | GB | B5 | KR | JH | CN | TC | 0  | IB | TL | WA | MG | MT | MK | EJ | EG | EK | T6 | 0,
      /* CD */   0  | GB | B5 | KR | JH | CN | TC | 0  | IB | TL | WA | MG | MT | MK | EJ | EG | EK | T6 | 0,
      /* CE */   0  | GB | B5 | KR | JH | CN | TC | 0  | IB | TL | WA | MG | MT | MK | EJ | EG | EK | T6 | 0,
      /* CF */   0  | GB | B5 | KR | JH | CN | TC | 0  | IB | TL | WA | MG | MT | MK | EJ | EG | EK | T6 | 0,
      /* D0 */   0  | GB | B5 | KR | JH | CN | TC | 0  | IB | TL | WA | MG | MT | MK | EJ | EG | EK | 0  | 0,
      /* D1 */   0  | GB | B5 | KR | JH | CN | TC | 0  | IB | TL | WA | MG | MT | MK | EJ | EG | EK | 0  | 0,
      /* D2 */   0  | GB | B5 | KR | JH | CN | TC | 0  | IB | TL | WA | MG | MT | MK | EJ | EG | EK | 0  | 0,
      /* D3 */   0  | GB | B5 | KR | JH | CN | TC | 0  | IB | TL | WA | MG | MT | MK | EJ | EG | EK | 0  | 0,
      /* D4 */   0  | GB | B5 | KR | 0  | CN | TC | 0  | IB | TL | WA | MG | MT | MK | EJ | EG | EK | 0  | 0,
      /* D5 */   0  | GB | B5 | KR | 0  | CN | TC | 0  | IB | TL | WA | MG | MT | MK | EJ | EG | EK | 0  | 0,
      /* D6 */   0  | GB | B5 | KR | 0  | CN | TC | 0  | IB | TL | WA | MG | MT | MK | EJ | EG | EK | 0  | 0,
      /* D7 */   0  | GB | B5 | KR | 0  | CN | TC | 0  | IB | TL | WA | MG | MT | MK | EJ | EG | EK | 0  | 0,
      /* D8 */   0  | GB | B5 | KR | JH | CN | TC | 0  | IB | TL | WA | MG | MT | MK | EJ | EG | EK | 0  | 0,
      /* D9 */   0  | GB | B5 | KR | JH | CN | 0  | 0  | IB | TL | WA | MG | MT | MK | EJ | EG | EK | 0  | 0,
      /* DA */   0  | GB | B5 | KR | JH | CN | 0  | 0  | IB | TL | WA | MG | MT | MK | EJ | EG | EK | 0  | 0,
      /* DB */   0  | GB | B5 | KR | JH | CN | 0  | 0  | IB | TL | WA | MG | MT | MK | EJ | EG | EK | 0  | 0,
      /* DC */   0  | GB | B5 | KR | JH | CN | 0  | 0  | IB | TL | WA | MG | MT | MK | EJ | EG | EK | 0  | 0,
      /* DD */   0  | GB | B5 | KR | JH | CN | 0  | ET | IB | TL | WA | MG | MT | MK | EJ | EG | EK | 0  | 0,
      /* DE */   0  | GB | B5 | KR | JH | CN | 0  | ET | IB | TL | WA | MG | MT | MK | EJ | EG | EK | 0  | 0,
      /* DF */   0  | GB | B5 | KR | 0  | CN | TC | ET | IB | TL | WA | MG | MT | MK | EJ | EG | EK | 0  | 0,
      /* E0 */   JP | GB | B5 | KR | JH | CN | TC | ET | IB | TL | WA | MG | MT | MK | EJ | EG | EK | 0  | 0,
      /* E1 */   JP | GB | B5 | KR | JH | CN | TC | ET | IB | TL | WA | MG | MT | MK | EJ | EG | EK | 0  | 0,
      /* E2 */   JP | GB | B5 | KR | JH | CN | TC | ET | IB | TL | WA | MG | MT | MK | EJ | EG | EK | 0  | 0,
      /* E3 */   JP | GB | B5 | KR | JH | CN | TC | ET | IB | TL | WA | MG | MT | MK | EJ | EG | EK | 0  | 0,
      /* E4 */   JP | GB | B5 | KR | JH | CN | TC | ET | IB | TL | WA | MG | MT | MK | EJ | EG | EK | 0  | 0,
      /* E5 */   JP | GB | B5 | KR | JH | CN | TC | ET | IB | TL | WA | MG | MT | MK | EJ | EG | EK | 0  | 0,
      /* E6 */   JP | GB | B5 | KR | JH | CN | TC | ET | IB | TL | WA | MG | MT | MK | EJ | EG | EK | 0  | 0,
      /* E7 */   JP | GB | B5 | KR | JH | CN | TC | ET | IB | TL | WA | MG | MT | MK | EJ | EG | EK | 0  | 0,
      /* E8 */   JP | GB | B5 | KR | JH | CN | TC | ET | IB | TL | WA | MG | MT | MK | EJ | EG | EK | 0  | 0,
      /* E9 */   JP | GB | B5 | KR | JH | CN | TC | ET | 0  | TL | WA | MG | MT | MK | EJ | EG | EK | 0  | 0,
      /* EA */   JP | GB | B5 | KR | JH | CN | TC | ET | 0  | TL | WA | MG | MT | MK | EJ | EG | EK | 0  | 0,
      /* EB */   JP | GB | B5 | KR | JH | CN | TC | ET | 0  | TL | WA | MG | MT | MK | EJ | EG | EK | 0  | 0,
      /* EC */   JP | GB | B5 | KR | JH | CN | TC | ET | 0  | TL | WA | MG | MT | MK | EJ | EG | EK | 0  | 0,
      /* ED */   JP | GB | B5 | KR | JH | CN | TC | ET | 0  | TL | WA | MG | MT | MK | EJ | EG | EK | 0  | 0,
      /* EE */   JP | GB | B5 | KR | JH | CN | TC | ET | 0  | TL | WA | MG | MT | MK | EJ | EG | EK | 0  | 0,
      /* EF */   JP | GB | B5 | KR | JH | CN | TC | ET | 0  | TL | WA | MG | MT | MK | EJ | EG | EK | 0  | 0,
      /* F0 */   JP | GB | B5 | KR | JH | CN | TC | ET | 0  | TL | WA | MG | MT | MK | EJ | EG | EK | 0  | 0,
      /* F1 */   JP | GB | B5 | KR | JH | CN | TC | ET | 0  | TL | WA | MG | MT | MK | EJ | EG | EK | 0  | 0,
      /* F2 */   JP | GB | B5 | KR | JH | CN | TC | ET | 0  | TL | WA | MG | MT | MK | EJ | EG | EK | 0  | 0,
      /* F3 */   JP | GB | B5 | KR | JH | CN | TC | ET | 0  | TL | WA | MG | MT | MK | EJ | EG | EK | 0  | 0,
      /* F4 */   JP | GB | B5 | KR | JH | CN | TC | ET | 0  | TL | WA | MG | MT | MK | EJ | EG | EK | 0  | 0,
      /* F5 */   JP | GB | B5 | KR | JH | CN | TC | ET | 0  | TL | WA | MG | MT | MK | EJ | EG | EK | 0  | 0,
      /* F6 */   JP | GB | B5 | KR | JH | CN | TC | ET | 0  | TL | 0  | MG | MT | MK | EJ | EG | EK | 0  | 0,
      /* F7 */   JP | GB | B5 | KR | JH | CN | TC | ET | 0  | TL | 0  | MG | MT | MK | EJ | EG | EK | 0  | 0,
      /* F8 */   JP | GB | B5 | KR | JH | CN | TC | ET | 0  | TL | 0  | 0  | MT | MK | EJ | 0  | EK | 0  | 0,
      /* F9 */   JP | GB | B5 | KR | JH | CN | TC | ET | IB | TL | WA | 0  | MT | MK | EJ | 0  | EK | 0  | 0,
      /* FA */   JP | GB | B5 | KR | 0  | CN | TC | ET | IB | TL | WA | 0  | MT | MK | EJ | 0  | EK | 0  | 0,
      /* FB */   JP | GB | B5 | KR | 0  | CN | TC | ET | IB | TL | WA | 0  | MT | MK | EJ | 0  | EK | 0  | 0,
      /* FC */   JP | GB | B5 | KR | 0  | CN | TC | ET | 0  | TL | WA | 0  | MT | MK | EJ | 0  | EK | 0  | 0,
      /* FD */   0  | GB | B5 | KR | 0  | CN | 0  | ET | 0  | TL | 0  | 0  | 0  | MK | EJ | 0  | EK | 0  | 0,
      /* FE */   0  | GB | B5 | KR | 0  | CN | 0  | ET | 0  | TL | 0  | 0  | 0  | 0  | EJ | 0  | 0  | 0  | 0,
      /* FF */   0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0,
   } ;

   return ( cjkctype_lead + 1 ) [ c ] & getbitmask ( codepage ) ;
}



int ismbbtrail_cp ( int c, int codepage ) {

   static const unsigned long cjkctype_trail [] = {
      /* -1 */   0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0,
      /* 00 */   0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0,
      /* 01 */   0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0,
      /* 02 */   0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0,
      /* 03 */   0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0,
      /* 04 */   0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0,
      /* 05 */   0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0,
      /* 06 */   0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0,
      /* 07 */   0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0,
      /* 08 */   0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0,
      /* 09 */   0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0,
      /* 0A */   0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0,
      /* 0B */   0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0,
      /* 0C */   0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0,
      /* 0D */   0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0,
      /* 0E */   0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0,
      /* 0F */   0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0,
      /* 10 */   0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0,
      /* 11 */   0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0,
      /* 12 */   0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0,
      /* 13 */   0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0,
      /* 14 */   0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0,
      /* 15 */   0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0,
      /* 16 */   0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0,
      /* 17 */   0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0,
      /* 18 */   0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0,
      /* 19 */   0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0,
      /* 1A */   0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0,
      /* 1B */   0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0,
      /* 1C */   0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0,
      /* 1D */   0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0,
      /* 1E */   0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0,
      /* 1F */   0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0,
      /* 20 */   0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | T6 | 0,
      /* 21 */   0  | 0  | 0  | 0  | 0  | CN | 0  | 0  | 0  | TL | 0  | 0  | 0  | 0  | EJ | 0  | 0  | 0  | 0,
      /* 22 */   0  | 0  | 0  | 0  | 0  | CN | 0  | 0  | 0  | TL | 0  | 0  | 0  | 0  | EJ | 0  | 0  | 0  | 0,
      /* 23 */   0  | 0  | 0  | 0  | 0  | CN | 0  | 0  | 0  | TL | 0  | 0  | 0  | 0  | EJ | 0  | 0  | 0  | 0,
      /* 24 */   0  | 0  | 0  | 0  | 0  | CN | 0  | 0  | 0  | TL | 0  | 0  | 0  | 0  | EJ | 0  | 0  | 0  | 0,
      /* 25 */   0  | 0  | 0  | 0  | 0  | CN | 0  | 0  | 0  | TL | 0  | 0  | 0  | 0  | EJ | 0  | 0  | 0  | 0,
      /* 26 */   0  | 0  | 0  | 0  | 0  | CN | 0  | 0  | 0  | TL | 0  | 0  | 0  | 0  | EJ | 0  | 0  | 0  | 0,
      /* 27 */   0  | 0  | 0  | 0  | 0  | CN | 0  | 0  | 0  | TL | 0  | 0  | 0  | 0  | EJ | 0  | 0  | 0  | 0,
      /* 28 */   0  | 0  | 0  | 0  | 0  | CN | 0  | 0  | 0  | TL | 0  | 0  | 0  | 0  | EJ | 0  | 0  | 0  | 0,
      /* 29 */   0  | 0  | 0  | 0  | 0  | CN | 0  | 0  | 0  | TL | 0  | 0  | 0  | 0  | EJ | 0  | 0  | 0  | 0,
      /* 2A */   0  | 0  | 0  | 0  | 0  | CN | 0  | 0  | 0  | TL | 0  | 0  | 0  | 0  | EJ | 0  | 0  | 0  | 0,
      /* 2B */   0  | 0  | 0  | 0  | 0  | CN | 0  | 0  | 0  | TL | 0  | 0  | 0  | 0  | EJ | 0  | 0  | 0  | 0,
      /* 2C */   0  | 0  | 0  | 0  | 0  | CN | 0  | 0  | 0  | TL | 0  | 0  | 0  | 0  | EJ | 0  | 0  | 0  | 0,
      /* 2D */   0  | 0  | 0  | 0  | 0  | CN | 0  | 0  | 0  | TL | 0  | 0  | 0  | 0  | EJ | 0  | 0  | 0  | 0,
      /* 2E */   0  | 0  | 0  | 0  | 0  | CN | 0  | 0  | 0  | TL | 0  | 0  | 0  | 0  | EJ | 0  | 0  | 0  | 0,
      /* 2F */   0  | 0  | 0  | 0  | 0  | CN | 0  | 0  | 0  | TL | 0  | 0  | 0  | 0  | EJ | 0  | 0  | 0  | 0,
      /* 30 */   0  | 0  | 0  | 0  | 0  | CN | TC | ET | 0  | TL | WA | 0  | 0  | 0  | EJ | 0  | 0  | 0  | 0,
      /* 31 */   0  | 0  | 0  | 0  | JH | CN | TC | ET | 0  | TL | WA | 0  | 0  | 0  | EJ | 0  | 0  | 0  | 0,
      /* 32 */   0  | 0  | 0  | 0  | JH | CN | TC | ET | 0  | TL | WA | 0  | 0  | 0  | EJ | 0  | 0  | 0  | 0,
      /* 33 */   0  | 0  | 0  | 0  | JH | CN | TC | ET | 0  | TL | WA | 0  | 0  | 0  | EJ | 0  | 0  | 0  | 0,
      /* 34 */   0  | 0  | 0  | 0  | JH | CN | TC | ET | 0  | TL | WA | 0  | 0  | 0  | EJ | 0  | 0  | 0  | 0,
      /* 35 */   0  | 0  | 0  | 0  | JH | CN | TC | ET | 0  | TL | WA | 0  | 0  | 0  | EJ | 0  | 0  | 0  | 0,
      /* 36 */   0  | 0  | 0  | 0  | JH | CN | TC | ET | 0  | TL | WA | 0  | 0  | 0  | EJ | 0  | 0  | 0  | 0,
      /* 37 */   0  | 0  | 0  | 0  | JH | CN | TC | ET | 0  | TL | WA | 0  | 0  | 0  | EJ | 0  | 0  | 0  | 0,
      /* 38 */   0  | 0  | 0  | 0  | JH | CN | TC | ET | 0  | TL | WA | 0  | 0  | 0  | EJ | 0  | 0  | 0  | 0,
      /* 39 */   0  | 0  | 0  | 0  | JH | CN | TC | ET | 0  | TL | WA | 0  | 0  | 0  | EJ | 0  | 0  | 0  | 0,
      /* 3A */   0  | 0  | 0  | 0  | JH | CN | 0  | 0  | 0  | TL | 0  | 0  | 0  | 0  | EJ | 0  | 0  | 0  | 0,
      /* 3B */   0  | 0  | 0  | 0  | JH | CN | 0  | 0  | 0  | TL | 0  | 0  | 0  | 0  | EJ | 0  | 0  | 0  | 0,
      /* 3C */   0  | 0  | 0  | 0  | JH | CN | 0  | 0  | 0  | TL | 0  | 0  | 0  | 0  | EJ | 0  | 0  | 0  | 0,
      /* 3D */   0  | 0  | 0  | 0  | JH | CN | 0  | 0  | 0  | TL | 0  | 0  | 0  | 0  | EJ | 0  | 0  | 0  | 0,
      /* 3E */   0  | 0  | 0  | 0  | JH | CN | 0  | 0  | 0  | TL | 0  | 0  | 0  | 0  | EJ | 0  | 0  | 0  | 0,
      /* 3F */   0  | 0  | 0  | 0  | JH | CN | 0  | 0  | 0  | TL | 0  | 0  | 0  | 0  | EJ | 0  | 0  | 0  | 0,
      /* 40 */   JP | GB | B5 | 0  | JH | CN | 0  | 0  | IB | TL | 0  | 0  | MT | 0  | EJ | 0  | 0  | 0  | 0,
      /* 41 */   JP | GB | B5 | KR | JH | CN | TC | ET | IB | TL | WA | 0  | MT | 0  | EJ | 0  | 0  | T6 | 0,
      /* 42 */   JP | GB | B5 | KR | JH | CN | TC | ET | IB | TL | WA | 0  | MT | 0  | EJ | 0  | 0  | T6 | 0,
      /* 43 */   JP | GB | B5 | KR | JH | CN | TC | ET | IB | TL | WA | 0  | MT | 0  | EJ | 0  | 0  | T6 | 0,
      /* 44 */   JP | GB | B5 | KR | JH | CN | TC | ET | IB | TL | WA | 0  | MT | 0  | EJ | 0  | 0  | T6 | 0,
      /* 45 */   JP | GB | B5 | KR | JH | CN | TC | ET | IB | TL | WA | 0  | MT | 0  | EJ | 0  | 0  | T6 | 0,
      /* 46 */   JP | GB | B5 | KR | JH | CN | TC | ET | IB | TL | WA | 0  | MT | 0  | EJ | 0  | 0  | T6 | 0,
      /* 47 */   JP | GB | B5 | KR | JH | CN | TC | ET | IB | TL | WA | 0  | MT | 0  | EJ | 0  | 0  | T6 | 0,
      /* 48 */   JP | GB | B5 | KR | JH | CN | TC | ET | IB | TL | WA | 0  | MT | 0  | EJ | 0  | 0  | T6 | 0,
      /* 49 */   JP | GB | B5 | KR | JH | CN | TC | ET | IB | TL | WA | 0  | MT | 0  | EJ | 0  | 0  | T6 | 0,
      /* 4A */   JP | GB | B5 | KR | JH | CN | TC | ET | IB | TL | WA | 0  | MT | 0  | EJ | 0  | 0  | T6 | 0,
      /* 4B */   JP | GB | B5 | KR | JH | CN | TC | ET | IB | TL | WA | 0  | MT | 0  | EJ | 0  | 0  | T6 | 0,
      /* 4C */   JP | GB | B5 | KR | JH | CN | TC | ET | IB | TL | WA | 0  | MT | 0  | EJ | 0  | 0  | T6 | 0,
      /* 4D */   JP | GB | B5 | KR | JH | CN | TC | ET | IB | TL | WA | 0  | MT | 0  | EJ | 0  | 0  | T6 | 0,
      /* 4E */   JP | GB | B5 | KR | JH | CN | TC | ET | IB | TL | WA | 0  | MT | 0  | EJ | 0  | 0  | T6 | 0,
      /* 4F */   JP | GB | B5 | KR | JH | CN | TC | ET | IB | TL | WA | 0  | MT | 0  | EJ | 0  | 0  | T6 | 0,
      /* 50 */   JP | GB | B5 | KR | JH | CN | TC | ET | IB | TL | WA | 0  | MT | 0  | EJ | 0  | 0  | T6 | 0,
      /* 51 */   JP | GB | B5 | KR | JH | CN | TC | ET | IB | TL | WA | 0  | MT | 0  | EJ | 0  | 0  | 0  | 0,
      /* 52 */   JP | GB | B5 | KR | JH | CN | TC | ET | IB | TL | WA | 0  | MT | 0  | EJ | 0  | 0  | T6 | 0,
      /* 53 */   JP | GB | B5 | KR | JH | CN | TC | ET | IB | TL | WA | 0  | MT | 0  | EJ | 0  | 0  | T6 | 0,
      /* 54 */   JP | GB | B5 | KR | JH | CN | TC | ET | IB | TL | WA | 0  | MT | 0  | EJ | 0  | 0  | T6 | 0,
      /* 55 */   JP | GB | B5 | KR | JH | CN | TC | ET | IB | TL | WA | 0  | MT | 0  | EJ | 0  | 0  | T6 | 0,
      /* 56 */   JP | GB | B5 | KR | JH | CN | TC | ET | IB | TL | WA | 0  | MT | 0  | EJ | 0  | 0  | T6 | 0,
      /* 57 */   JP | GB | B5 | KR | JH | CN | TC | ET | IB | TL | WA | 0  | MT | 0  | EJ | 0  | 0  | T6 | 0,
      /* 58 */   JP | GB | B5 | KR | JH | CN | TC | ET | IB | TL | WA | 0  | MT | 0  | EJ | 0  | 0  | T6 | 0,
      /* 59 */   JP | GB | B5 | KR | JH | CN | TC | ET | IB | TL | WA | 0  | MT | 0  | EJ | 0  | 0  | T6 | 0,
      /* 5A */   JP | GB | B5 | KR | JH | CN | TC | ET | IB | TL | WA | 0  | MT | 0  | EJ | 0  | 0  | T6 | 0,
      /* 5B */   JP | GB | B5 | 0  | JH | CN | 0  | 0  | IB | TL | 0  | 0  | MT | 0  | EJ | 0  | 0  | 0  | 0,
      /* 5C */   JP | GB | B5 | 0  | JH | CN | 0  | 0  | IB | TL | 0  | 0  | MT | 0  | EJ | 0  | 0  | 0  | 0,
      /* 5D */   JP | GB | B5 | 0  | JH | CN | 0  | 0  | IB | TL | 0  | 0  | MT | 0  | EJ | 0  | 0  | 0  | 0,
      /* 5E */   JP | GB | B5 | 0  | JH | CN | 0  | 0  | IB | TL | 0  | 0  | MT | 0  | EJ | 0  | 0  | 0  | 0,
      /* 5F */   JP | GB | B5 | 0  | JH | CN | 0  | 0  | IB | TL | 0  | 0  | MT | 0  | EJ | 0  | 0  | 0  | 0,
      /* 60 */   JP | GB | B5 | 0  | JH | CN | 0  | 0  | IB | TL | 0  | 0  | MT | 0  | EJ | 0  | 0  | 0  | 0,
      /* 61 */   JP | GB | B5 | KR | JH | CN | TC | ET | IB | TL | WA | 0  | MT | 0  | EJ | 0  | 0  | T6 | 0,
      /* 62 */   JP | GB | B5 | KR | JH | CN | TC | ET | IB | TL | WA | 0  | MT | 0  | EJ | 0  | 0  | T6 | 0,
      /* 63 */   JP | GB | B5 | KR | JH | CN | TC | ET | IB | TL | WA | 0  | MT | 0  | EJ | 0  | 0  | T6 | 0,
      /* 64 */   JP | GB | B5 | KR | JH | CN | TC | ET | IB | TL | WA | 0  | MT | 0  | EJ | 0  | 0  | T6 | 0,
      /* 65 */   JP | GB | B5 | KR | JH | CN | TC | ET | IB | TL | WA | 0  | MT | 0  | EJ | 0  | 0  | T6 | 0,
      /* 66 */   JP | GB | B5 | KR | JH | CN | TC | ET | IB | TL | WA | 0  | MT | 0  | EJ | 0  | 0  | T6 | 0,
      /* 67 */   JP | GB | B5 | KR | JH | CN | TC | ET | IB | TL | WA | 0  | MT | 0  | EJ | 0  | 0  | T6 | 0,
      /* 68 */   JP | GB | B5 | KR | JH | CN | TC | ET | IB | TL | WA | 0  | MT | 0  | EJ | 0  | 0  | T6 | 0,
      /* 69 */   JP | GB | B5 | KR | JH | CN | TC | ET | IB | TL | WA | 0  | MT | 0  | EJ | 0  | 0  | T6 | 0,
      /* 6A */   JP | GB | B5 | KR | JH | CN | TC | ET | IB | TL | WA | 0  | MT | 0  | EJ | 0  | 0  | T6 | 0,
      /* 6B */   JP | GB | B5 | KR | JH | CN | TC | ET | IB | TL | WA | 0  | MT | 0  | EJ | 0  | 0  | T6 | 0,
      /* 6C */   JP | GB | B5 | KR | JH | CN | TC | ET | IB | TL | WA | 0  | MT | 0  | EJ | 0  | 0  | T6 | 0,
      /* 6D */   JP | GB | B5 | KR | JH | CN | TC | ET | IB | TL | WA | 0  | MT | 0  | EJ | 0  | 0  | T6 | 0,
      /* 6E */   JP | GB | B5 | KR | JH | CN | TC | ET | IB | TL | WA | 0  | MT | 0  | EJ | 0  | 0  | T6 | 0,
      /* 6F */   JP | GB | B5 | KR | JH | CN | TC | ET | IB | TL | WA | 0  | MT | 0  | EJ | 0  | 0  | T6 | 0,
      /* 70 */   JP | GB | B5 | KR | JH | CN | TC | ET | IB | TL | WA | 0  | MT | 0  | EJ | 0  | 0  | T6 | 0,
      /* 71 */   JP | GB | B5 | KR | JH | CN | TC | ET | IB | TL | WA | 0  | MT | 0  | EJ | 0  | 0  | 0  | 0,
      /* 72 */   JP | GB | B5 | KR | JH | CN | TC | ET | IB | TL | WA | 0  | MT | 0  | EJ | 0  | 0  | T6 | 0,
      /* 73 */   JP | GB | B5 | KR | JH | CN | TC | ET | IB | TL | WA | 0  | MT | 0  | EJ | 0  | 0  | T6 | 0,
      /* 74 */   JP | GB | B5 | KR | JH | CN | TC | ET | IB | TL | WA | 0  | MT | 0  | EJ | 0  | 0  | T6 | 0,
      /* 75 */   JP | GB | B5 | KR | JH | CN | TC | ET | IB | TL | WA | 0  | MT | 0  | EJ | 0  | 0  | T6 | 0,
      /* 76 */   JP | GB | B5 | KR | JH | CN | TC | ET | IB | TL | WA | 0  | MT | 0  | EJ | 0  | 0  | T6 | 0,
      /* 77 */   JP | GB | B5 | KR | JH | CN | TC | ET | IB | TL | WA | 0  | MT | 0  | EJ | 0  | 0  | T6 | 0,
      /* 78 */   JP | GB | B5 | KR | JH | CN | TC | ET | IB | TL | WA | 0  | MT | 0  | EJ | 0  | 0  | T6 | 0,
      /* 79 */   JP | GB | B5 | KR | JH | CN | TC | ET | IB | TL | WA | 0  | MT | 0  | EJ | 0  | 0  | T6 | 0,
      /* 7A */   JP | GB | B5 | KR | JH | CN | TC | ET | IB | TL | WA | 0  | MT | 0  | EJ | 0  | 0  | T6 | 0,
      /* 7B */   JP | GB | B5 | 0  | JH | CN | 0  | 0  | IB | TL | 0  | 0  | MT | 0  | EJ | 0  | 0  | 0  | 0,
      /* 7C */   JP | GB | B5 | 0  | JH | CN | 0  | 0  | IB | TL | 0  | 0  | MT | 0  | EJ | 0  | 0  | 0  | 0,
      /* 7D */   JP | GB | B5 | 0  | JH | CN | 0  | 0  | IB | TL | 0  | 0  | MT | 0  | EJ | 0  | 0  | 0  | 0,
      /* 7E */   JP | GB | B5 | 0  | JH | CN | 0  | 0  | IB | TL | 0  | 0  | MT | 0  | EJ | 0  | 0  | 0  | 0,
      /* 7F */   0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0,
      /* 80 */   JP | GB | 0  | 0  | 0  | 0  | TC | ET | IB | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0,
      /* 81 */   JP | GB | 0  | KR | JH | 0  | TC | ET | IB | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0,
      /* 82 */   JP | GB | 0  | KR | JH | 0  | TC | ET | IB | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0,
      /* 83 */   JP | GB | 0  | KR | JH | 0  | TC | ET | IB | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0,
      /* 84 */   JP | GB | 0  | KR | JH | 0  | TC | ET | IB | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0,
      /* 85 */   JP | GB | 0  | KR | JH | 0  | TC | ET | IB | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0,
      /* 86 */   JP | GB | 0  | KR | JH | 0  | TC | ET | IB | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0,
      /* 87 */   JP | GB | 0  | KR | JH | 0  | TC | ET | IB | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0,
      /* 88 */   JP | GB | 0  | KR | JH | 0  | TC | ET | IB | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0,
      /* 89 */   JP | GB | 0  | KR | JH | 0  | TC | ET | IB | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0,
      /* 8A */   JP | GB | 0  | KR | JH | 0  | TC | ET | IB | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0,
      /* 8B */   JP | GB | 0  | KR | JH | 0  | TC | ET | IB | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0,
      /* 8C */   JP | GB | 0  | KR | JH | 0  | TC | ET | IB | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0,
      /* 8D */   JP | GB | 0  | KR | JH | 0  | TC | ET | IB | 0  | WA | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0,
      /* 8E */   JP | GB | 0  | KR | JH | 0  | TC | ET | IB | 0  | WA | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0,
      /* 8F */   JP | GB | 0  | KR | JH | 0  | TC | ET | IB | 0  | WA | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0,
      /* 90 */   JP | GB | 0  | KR | JH | 0  | TC | ET | IB | 0  | WA | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0,
      /* 91 */   JP | GB | 0  | KR | JH | 0  | TC | ET | IB | 0  | WA | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0,
      /* 92 */   JP | GB | 0  | KR | JH | 0  | TC | ET | IB | 0  | WA | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0,
      /* 93 */   JP | GB | 0  | KR | JH | 0  | TC | ET | IB | 0  | WA | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0,
      /* 94 */   JP | GB | 0  | KR | JH | 0  | TC | ET | IB | 0  | WA | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0,
      /* 95 */   JP | GB | 0  | KR | JH | 0  | TC | ET | IB | 0  | WA | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0,
      /* 96 */   JP | GB | 0  | KR | JH | 0  | TC | ET | IB | 0  | WA | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0,
      /* 97 */   JP | GB | 0  | KR | JH | 0  | TC | ET | IB | 0  | WA | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0,
      /* 98 */   JP | GB | 0  | KR | JH | 0  | TC | ET | IB | 0  | WA | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0,
      /* 99 */   JP | GB | 0  | KR | JH | 0  | TC | ET | IB | 0  | WA | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0,
      /* 9A */   JP | GB | 0  | KR | JH | 0  | TC | ET | IB | 0  | WA | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0,
      /* 9B */   JP | GB | 0  | KR | JH | 0  | TC | ET | IB | 0  | WA | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0,
      /* 9C */   JP | GB | 0  | KR | JH | 0  | TC | ET | IB | 0  | WA | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0,
      /* 9D */   JP | GB | 0  | KR | JH | 0  | TC | ET | IB | 0  | WA | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0,
      /* 9E */   JP | GB | 0  | KR | JH | 0  | TC | ET | IB | 0  | WA | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0,
      /* 9F */   JP | GB | 0  | KR | JH | 0  | TC | ET | IB | 0  | WA | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0,
      /* A0 */   JP | GB | 0  | KR | JH | 0  | TC | ET | IB | 0  | WA | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0,
      /* A1 */   JP | GB | B5 | KR | JH | CN | TC | ET | IB | TL | WA | MG | MT | MK | EJ | EG | EK | 0  | 0,
      /* A2 */   JP | GB | B5 | KR | JH | CN | TC | ET | IB | TL | WA | MG | MT | MK | EJ | EG | EK | 0  | 0,
      /* A3 */   JP | GB | B5 | KR | JH | CN | TC | ET | IB | TL | WA | MG | MT | MK | EJ | EG | EK | 0  | 0,
      /* A4 */   JP | GB | B5 | KR | JH | CN | TC | ET | IB | TL | WA | MG | MT | MK | EJ | EG | EK | 0  | 0,
      /* A5 */   JP | GB | B5 | KR | JH | CN | TC | ET | IB | TL | WA | MG | MT | MK | EJ | EG | EK | 0  | 0,
      /* A6 */   JP | GB | B5 | KR | JH | CN | TC | ET | IB | TL | WA | MG | MT | MK | EJ | EG | EK | 0  | 0,
      /* A7 */   JP | GB | B5 | KR | JH | CN | TC | ET | IB | TL | WA | MG | MT | MK | EJ | EG | EK | 0  | 0,
      /* A8 */   JP | GB | B5 | KR | JH | CN | TC | ET | IB | TL | WA | MG | MT | MK | EJ | EG | EK | 0  | 0,
      /* A9 */   JP | GB | B5 | KR | JH | CN | TC | ET | IB | TL | WA | MG | MT | MK | EJ | EG | EK | 0  | 0,
      /* AA */   JP | GB | B5 | KR | JH | CN | TC | ET | IB | TL | WA | MG | MT | MK | EJ | EG | EK | 0  | 0,
      /* AB */   JP | GB | B5 | KR | JH | CN | TC | ET | IB | TL | WA | MG | MT | MK | EJ | EG | EK | 0  | 0,
      /* AC */   JP | GB | B5 | KR | JH | CN | TC | ET | IB | TL | WA | MG | MT | MK | EJ | EG | EK | 0  | 0,
      /* AD */   JP | GB | B5 | KR | JH | CN | TC | ET | IB | TL | WA | MG | MT | MK | EJ | EG | EK | 0  | 0,
      /* AE */   JP | GB | B5 | KR | JH | CN | TC | ET | IB | TL | WA | MG | MT | MK | EJ | EG | EK | 0  | 0,
      /* AF */   JP | GB | B5 | KR | JH | CN | TC | ET | IB | TL | WA | MG | MT | MK | EJ | EG | EK | 0  | 0,
      /* B0 */   JP | GB | B5 | KR | JH | CN | TC | ET | IB | TL | WA | MG | MT | MK | EJ | EG | EK | 0  | 0,
      /* B1 */   JP | GB | B5 | KR | JH | CN | TC | ET | IB | TL | WA | MG | MT | MK | EJ | EG | EK | 0  | 0,
      /* B2 */   JP | GB | B5 | KR | JH | CN | TC | ET | IB | TL | WA | MG | MT | MK | EJ | EG | EK | 0  | 0,
      /* B3 */   JP | GB | B5 | KR | JH | CN | TC | ET | IB | TL | WA | MG | MT | MK | EJ | EG | EK | 0  | 0,
      /* B4 */   JP | GB | B5 | KR | JH | CN | TC | ET | IB | TL | WA | MG | MT | MK | EJ | EG | EK | 0  | 0,
      /* B5 */   JP | GB | B5 | KR | JH | CN | TC | ET | IB | TL | WA | MG | MT | MK | EJ | EG | EK | 0  | 0,
      /* B6 */   JP | GB | B5 | KR | JH | CN | TC | ET | IB | TL | WA | MG | MT | MK | EJ | EG | EK | 0  | 0,
      /* B7 */   JP | GB | B5 | KR | JH | CN | TC | ET | IB | TL | WA | MG | MT | MK | EJ | EG | EK | 0  | 0,
      /* B8 */   JP | GB | B5 | KR | JH | CN | TC | ET | IB | TL | WA | MG | MT | MK | EJ | EG | EK | 0  | 0,
      /* B9 */   JP | GB | B5 | KR | JH | CN | TC | ET | IB | TL | WA | MG | MT | MK | EJ | EG | EK | 0  | 0,
      /* BA */   JP | GB | B5 | KR | JH | CN | TC | ET | IB | TL | WA | MG | MT | MK | EJ | EG | EK | 0  | 0,
      /* BB */   JP | GB | B5 | KR | JH | CN | TC | ET | IB | TL | WA | MG | MT | MK | EJ | EG | EK | 0  | 0,
      /* BC */   JP | GB | B5 | KR | JH | CN | TC | ET | IB | TL | WA | MG | MT | MK | EJ | EG | EK | 0  | 0,
      /* BD */   JP | GB | B5 | KR | JH | CN | TC | ET | IB | TL | WA | MG | MT | MK | EJ | EG | EK | 0  | 0,
      /* BE */   JP | GB | B5 | KR | JH | CN | TC | ET | IB | TL | WA | MG | MT | MK | EJ | EG | EK | 0  | 0,
      /* BF */   JP | GB | B5 | KR | JH | CN | TC | ET | IB | TL | WA | MG | MT | MK | EJ | EG | EK | 0  | 0,
      /* C0 */   JP | GB | B5 | KR | JH | CN | TC | ET | IB | TL | WA | MG | MT | MK | EJ | EG | EK | 0  | 0,
      /* C1 */   JP | GB | B5 | KR | JH | CN | TC | ET | IB | TL | WA | MG | MT | MK | EJ | EG | EK | 0  | 0,
      /* C2 */   JP | GB | B5 | KR | JH | CN | TC | ET | IB | TL | WA | MG | MT | MK | EJ | EG | EK | 0  | 0,
      /* C3 */   JP | GB | B5 | KR | JH | CN | TC | ET | IB | TL | WA | MG | MT | MK | EJ | EG | EK | 0  | 0,
      /* C4 */   JP | GB | B5 | KR | JH | CN | TC | ET | IB | TL | WA | MG | MT | MK | EJ | EG | EK | 0  | 0,
      /* C5 */   JP | GB | B5 | KR | JH | CN | TC | ET | IB | TL | WA | MG | MT | MK | EJ | EG | EK | 0  | 0,
      /* C6 */   JP | GB | B5 | KR | JH | CN | TC | ET | IB | TL | WA | MG | MT | MK | EJ | EG | EK | 0  | 0,
      /* C7 */   JP | GB | B5 | KR | JH | CN | TC | ET | IB | TL | WA | MG | MT | MK | EJ | EG | EK | 0  | 0,
      /* C8 */   JP | GB | B5 | KR | JH | CN | TC | ET | IB | TL | WA | MG | MT | MK | EJ | EG | EK | 0  | 0,
      /* C9 */   JP | GB | B5 | KR | JH | CN | TC | ET | IB | TL | WA | MG | MT | MK | EJ | EG | EK | 0  | 0,
      /* CA */   JP | GB | B5 | KR | JH | CN | TC | ET | IB | TL | WA | MG | MT | MK | EJ | EG | EK | 0  | 0,
      /* CB */   JP | GB | B5 | KR | JH | CN | TC | ET | IB | TL | WA | MG | MT | MK | EJ | EG | EK | 0  | 0,
      /* CC */   JP | GB | B5 | KR | JH | CN | TC | ET | IB | TL | WA | MG | MT | MK | EJ | EG | EK | 0  | 0,
      /* CD */   JP | GB | B5 | KR | JH | CN | TC | ET | IB | TL | WA | MG | MT | MK | EJ | EG | EK | 0  | 0,
      /* CE */   JP | GB | B5 | KR | JH | CN | TC | ET | IB | TL | WA | MG | MT | MK | EJ | EG | EK | 0  | 0,
      /* CF */   JP | GB | B5 | KR | JH | CN | TC | ET | IB | TL | WA | MG | MT | MK | EJ | EG | EK | 0  | 0,
      /* D0 */   JP | GB | B5 | KR | JH | CN | TC | ET | IB | TL | WA | MG | MT | MK | EJ | EG | EK | 0  | 0,
      /* D1 */   JP | GB | B5 | KR | JH | CN | TC | ET | IB | TL | WA | MG | MT | MK | EJ | EG | EK | 0  | 0,
      /* D2 */   JP | GB | B5 | KR | JH | CN | TC | ET | IB | TL | WA | MG | MT | MK | EJ | EG | EK | 0  | 0,
      /* D3 */   JP | GB | B5 | KR | JH | CN | TC | ET | IB | TL | WA | MG | MT | MK | EJ | EG | EK | 0  | 0,
      /* D4 */   JP | GB | B5 | KR | JH | CN | TC | ET | IB | TL | WA | MG | MT | MK | EJ | EG | EK | 0  | 0,
      /* D5 */   JP | GB | B5 | KR | JH | CN | TC | ET | IB | TL | WA | MG | MT | MK | EJ | EG | EK | 0  | 0,
      /* D6 */   JP | GB | B5 | KR | JH | CN | TC | ET | IB | TL | WA | MG | MT | MK | EJ | EG | EK | 0  | 0,
      /* D7 */   JP | GB | B5 | KR | JH | CN | TC | ET | IB | TL | WA | MG | MT | MK | EJ | EG | EK | 0  | 0,
      /* D8 */   JP | GB | B5 | KR | JH | CN | TC | ET | IB | TL | WA | MG | MT | MK | EJ | EG | EK | 0  | 0,
      /* D9 */   JP | GB | B5 | KR | JH | CN | TC | ET | IB | TL | WA | MG | MT | MK | EJ | EG | EK | 0  | 0,
      /* DA */   JP | GB | B5 | KR | JH | CN | TC | ET | IB | TL | WA | MG | MT | MK | EJ | EG | EK | 0  | 0,
      /* DB */   JP | GB | B5 | KR | JH | CN | TC | ET | IB | TL | WA | MG | MT | MK | EJ | EG | EK | 0  | 0,
      /* DC */   JP | GB | B5 | KR | JH | CN | TC | ET | IB | TL | WA | MG | MT | MK | EJ | EG | EK | 0  | 0,
      /* DD */   JP | GB | B5 | KR | JH | CN | TC | ET | IB | TL | WA | MG | MT | MK | EJ | EG | EK | 0  | 0,
      /* DE */   JP | GB | B5 | KR | JH | CN | TC | ET | IB | TL | WA | MG | MT | MK | EJ | EG | EK | 0  | 0,
      /* DF */   JP | GB | B5 | KR | JH | CN | TC | ET | IB | TL | WA | MG | MT | MK | EJ | EG | EK | 0  | 0,
      /* E0 */   JP | GB | B5 | KR | JH | CN | TC | ET | IB | TL | WA | MG | MT | MK | EJ | EG | EK | 0  | 0,
      /* E1 */   JP | GB | B5 | KR | JH | CN | TC | ET | IB | TL | WA | MG | MT | MK | EJ | EG | EK | T6 | 0,
      /* E2 */   JP | GB | B5 | KR | JH | CN | TC | ET | IB | TL | WA | MG | MT | MK | EJ | EG | EK | 0  | 0,
      /* E3 */   JP | GB | B5 | KR | JH | CN | TC | ET | IB | TL | WA | MG | MT | MK | EJ | EG | EK | 0  | 0,
      /* E4 */   JP | GB | B5 | KR | JH | CN | TC | ET | IB | TL | WA | MG | MT | MK | EJ | EG | EK | 0  | 0,
      /* E5 */   JP | GB | B5 | KR | JH | CN | TC | ET | IB | TL | WA | MG | MT | MK | EJ | EG | EK | 0  | 0,
      /* E6 */   JP | GB | B5 | KR | JH | CN | TC | ET | IB | TL | WA | MG | MT | MK | EJ | EG | EK | 0  | 0,
      /* E7 */   JP | GB | B5 | KR | JH | CN | TC | ET | IB | TL | WA | MG | MT | MK | EJ | EG | EK | 0  | 0,
      /* E8 */   JP | GB | B5 | KR | JH | CN | TC | ET | IB | TL | WA | MG | MT | MK | EJ | EG | EK | 0  | 0,
      /* E9 */   JP | GB | B5 | KR | JH | CN | TC | ET | IB | TL | WA | MG | MT | MK | EJ | EG | EK | 0  | 0,
      /* EA */   JP | GB | B5 | KR | JH | CN | TC | ET | IB | TL | WA | MG | MT | MK | EJ | EG | EK | 0  | 0,
      /* EB */   JP | GB | B5 | KR | JH | CN | TC | ET | IB | TL | WA | MG | MT | MK | EJ | EG | EK | 0  | 0,
      /* EC */   JP | GB | B5 | KR | JH | CN | TC | ET | IB | TL | WA | MG | MT | MK | EJ | EG | EK | 0  | 0,
      /* ED */   JP | GB | B5 | KR | JH | CN | TC | ET | IB | TL | WA | MG | MT | MK | EJ | EG | EK | 0  | 0,
      /* EE */   JP | GB | B5 | KR | JH | CN | TC | ET | IB | TL | WA | MG | MT | MK | EJ | EG | EK | 0  | 0,
      /* EF */   JP | GB | B5 | KR | JH | CN | TC | ET | IB | TL | 0  | MG | MT | MK | EJ | EG | EK | 0  | 0,
      /* F0 */   JP | GB | B5 | KR | JH | CN | TC | ET | IB | TL | WA | MG | MT | MK | EJ | EG | EK | 0  | 0,
      /* F1 */   JP | GB | B5 | KR | JH | CN | TC | ET | IB | TL | WA | MG | MT | MK | EJ | EG | EK | T6 | 0,
      /* F2 */   JP | GB | B5 | KR | JH | CN | TC | ET | IB | TL | WA | MG | MT | MK | EJ | EG | EK | 0  | 0,
      /* F3 */   JP | GB | B5 | KR | JH | CN | TC | ET | IB | TL | WA | MG | MT | MK | EJ | EG | EK | 0  | 0,
      /* F4 */   JP | GB | B5 | KR | JH | CN | TC | ET | IB | TL | WA | MG | MT | MK | EJ | EG | EK | 0  | 0,
      /* F5 */   JP | GB | B5 | KR | JH | CN | TC | ET | IB | TL | WA | MG | MT | MK | EJ | EG | EK | 0  | 0,
      /* F6 */   JP | GB | B5 | KR | JH | CN | TC | ET | IB | TL | WA | MG | MT | MK | EJ | EG | EK | 0  | 0,
      /* F7 */   JP | GB | B5 | KR | JH | CN | TC | ET | IB | TL | WA | MG | MT | MK | EJ | EG | EK | 0  | 0,
      /* F8 */   JP | GB | B5 | KR | JH | CN | TC | ET | IB | TL | WA | MG | MT | MK | EJ | EG | EK | 0  | 0,
      /* F9 */   JP | GB | B5 | KR | JH | CN | TC | ET | IB | TL | WA | MG | MT | MK | EJ | EG | EK | 0  | 0,
      /* FA */   JP | GB | B5 | KR | JH | CN | TC | ET | IB | TL | WA | MG | MT | MK | EJ | EG | EK | 0  | 0,
      /* FB */   JP | GB | B5 | KR | JH | CN | TC | ET | IB | TL | WA | MG | MT | MK | EJ | EG | EK | 0  | 0,
      /* FC */   JP | GB | B5 | KR | JH | CN | TC | ET | IB | TL | WA | MG | MT | MK | EJ | EG | EK | 0  | 0,
      /* FD */   0  | GB | B5 | KR | JH | CN | TC | ET | 0  | TL | 0  | MG | MT | MK | EJ | EG | EK | 0  | 0,
      /* FE */   0  | GB | B5 | KR | JH | CN | 0  | 0  | 0  | TL | 0  | MG | MT | MK | EJ | EG | EK | 0  | 0,
      /* FF */   0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0  | 0,
   } ;

   return ( cjkctype_trail + 1 ) [ c ] & getbitmask ( codepage ) ;
}



int ismbbkana_cp ( int c, int codepage ) {
   return ( getbitmask ( codepage ) == JP ) && ( c >= 0xA1 && c <= 0xDF ) ;
}



int ismbbsurrogate_cp ( int c, int codepage ) {
   return ( codepage == CP_CHINESE_SIMPLIFIED_EX ) && ( c <= 0x39 && c >= 0x30 ) ;
}



int ismbcp ( int codepage ) {
   if ( getbitmask ( codepage ) ) return 1 ;
   else                           return 0 ;
}



