// shfolder.h

#ifndef SHFOLDER_H
#define SHFOLDER_H


#ifdef __cplusplus
extern "C" {
#endif


LPITEMIDLIST WINAPI ShOpenItemIdListA ( const char *szPath ) ;
LPITEMIDLIST WINAPI ShOpenItemIdListW ( const wchar_t *szPath ) ;
LPITEMIDLIST WINAPI ShOpenSpecialItemIdList ( int nCsidl ) ;
int WINAPI ShCloseItemIdList ( LPITEMIDLIST pItemIdList ) ;

int WINAPI ShGetPathA ( LPCITEMIDLIST pItemIdList, char *szPath ) ;
int WINAPI ShGetPathW ( LPCITEMIDLIST pItemIdList, wchar_t *szPath ) ;
int WINAPI ShGetDisplayNameA ( LPCITEMIDLIST pItemIdList, char *szDisplayName ) ;
int WINAPI ShGetDisplayNameW ( LPCITEMIDLIST pItemIdList, wchar_t *szDisplayName ) ;
int WINAPI ShGetNameForParsingA ( LPCITEMIDLIST pItemIdList, char *szName ) ;
int WINAPI ShGetNameForParsingW ( LPCITEMIDLIST pItemIdList, wchar_t *szName ) ;

int WINAPI ShGetCsidl ( LPCITEMIDLIST pItemIdList ) ;
int WINAPI ShCompareItemIdList ( LPCITEMIDLIST pItemIdList1, LPCITEMIDLIST pItemIdList2, int *pIsError ) ;
int WINAPI ShEnumItemIdList ( LPCITEMIDLIST pItemIdList, int ( CALLBACK *CallbackProc ) ( LPITEMIDLIST pItemIdList, LPARAM lParam ), unsigned long dwFlags, LPARAM lParam ) ;
int WINAPI ShChangeNotify ( int nEvent, LPCITEMIDLIST pItemIdList1, LPCITEMIDLIST pItemIdList2, int IsImmediately ) ;

#define IsDesktopItemIdList(p)   ( ! (p)->mkid.cb )

int WINAPI ShExecuteA ( HWND hWnd, const char *szVerb, LPCITEMIDLIST pItemIdList, const char *szArguments, const char *szDirectory, int nShowCmd ) ;
int WINAPI ShExecuteW ( HWND hWnd, const wchar_t *szVerb, LPCITEMIDLIST pItemIdList, const wchar_t *szArguments, const wchar_t *szDirectory, int nShowCmd ) ;

#ifndef SFGAO_STREAM
typedef ULONG SFGAOF ;
#endif

SFGAOF WINAPI ShGetAttributes ( LPCITEMIDLIST pItemIdList ) ;


#ifdef UNICODE
#define ShOpenItemIdList ShOpenItemIdListW
#define ShGetPath ShGetPathW
#define ShGetDisplayName ShGetDisplayNameW
#define ShExecute ShExecuteW
#else
#define ShOpenItemIdList ShOpenItemIdListA
#define ShGetPath ShGetPathA
#define ShGetDisplayName ShGetDisplayNameA
#define ShExecute ShExecuteA
#endif


// for dwFlags ShEnumItemIdList
#define ENUMITEMIDLIST_FOLDER_ONLY     1
#define ENUMITEMIDLIST_FILE_ONLY       2
#define ENUMITEMIDLIST_HIDDEN          4
#define ENUMITEMIDLIST_CLOSE_BY_USER   8


int WINAPI GetSpecialFolderPathA ( HWND hWnd, char *szPath, int nCsidl, int nReserved ) ;
int WINAPI GetSpecialFolderPathW ( HWND hWnd, wchar_t *szPath, int nCsidl, int nReserved ) ;
int WINAPI OpenSpecialFolderA ( HWND hWnd, const char *szVerb, int nCsidl, int nShowCmd ) ;
int WINAPI OpenSpecialFolderW ( HWND hWnd, const wchar_t *szVerb, int nCsidl, int nShowCmd ) ;
int WINAPI ShellChangeNotifyA ( int nEvent, const char *szPathName1, const char *szPathName2, int IsImmediately ) ;
int WINAPI ShellChangeNotifyW ( int nEvent, const wchar_t *szPathName1, const wchar_t *szPathName2, int IsImmediately ) ;


#ifdef UNICODE
#define GetSpecialFolderPath GetSpecialFolderPathW
#define OpenSpecialFolder OpenSpecialFolderW
#define ShellChangeNotify ShellChangeNotifyW
#else
#define GetSpecialFolderPath GetSpecialFolderPathA
#define OpenSpecialFolder OpenSpecialFolderA
#define ShellChangeNotify ShellChangeNotifyA
#endif



//////////////////////////////////////////////////
//               CSIDL DEFINITION               //
//////////////////////////////////////////////////



#if 0    // Windows 2000/XP
// CSIDL_DESKTOP                 // C:\Documents and Settings\<user name>\fXNgbv
// CSIDL_INTERNET
// CSIDL_PROGRAMS                // C:\Documents and Settings\<user name>\X^[g j[\vO
// CSIDL_CONTROLS
// CSIDL_PRINTERS
// CSIDL_PERSONAL                // C:\Documents and Settings\<user name>\My Documents
// CSIDL_FAVORITES               // C:\Documents and Settings\<user name>\Favorites
// CSIDL_STARTUP                 // C:\Documents and Settings\<user name>\X^[g j[\vO\X^[gAbv
// CSIDL_RECENT                  // C:\Documents and Settings\<user name>\Recent
// CSIDL_SENDTO                  // C:\Documents and Settings\<user name>\SendTo
// CSIDL_BITBUCKET
// CSIDL_STARTMENU               // C:\Documents and Settings\<user name>\X^[g j[
// CSIDL_MYDOCUMENTS
// CSIDL_MYMUSIC                 // C:\Documents and Settings\<user name>\My Documents\My Music
// CSIDL_MYVIDEO
// CSIDL_DESKTOPDIRECTORY        // C:\Documents and Settings\<user name>\fXNgbv
// CSIDL_DRIVES
// CSIDL_NETWORK
// CSIDL_NETHOOD                 // C:\Documents and Settings\<user name>\NetHood
// CSIDL_FONTS                   // C:\Windows\Fonts
// CSIDL_TEMPLATES               // C:\Documents and Settings\<user name>\Templates
// CSIDL_COMMON_STARTMENU        // C:\Documents and Settings\All Users\X^[g j[
// CSIDL_COMMON_PROGRAMS         // C:\Documents and Settings\All Users\X^[g j[\vO
// CSIDL_COMMON_STARTUP          // C:\Documents and Settings\All Users\X^[g j[\vO\X^[gAbv
// CSIDL_COMMON_DESKTOPDIRECTORY // C:\Documents and Settings\All Users\fXNgbv
// CSIDL_APPDATA                 // C:\Documents and Settings\<user name>\Application Data
// CSIDL_PRINTHOOD               // C:\Documents and Settings\<user name>\PrintHood
// CSIDL_LOCAL_APPDATA           // C:\Documents and Settings\<user name>\Local Settings\Application Data
// CSIDL_ALTSTARTUP
// CSIDL_COMMON_ALTSTARTUP
// CSIDL_COMMON_FAVORITES        // C:\Documents and Settings\All Users\Favorites
// CSIDL_INTERNET_CACHE          // C:\Documents and Settings\<user name>\Local Settings\Temporary Internet Files
// CSIDL_COOKIES                 // C:\Documents and Settings\<user name>\Cookies
// CSIDL_HISTORY                 // C:\Documents and Settings\<user name>\Local Settings\History
// CSIDL_COMMON_APPDATA          // C:\Documents and Settings\All Users\Application Data
// CSIDL_WINDOWS                 // C:\Windows
// CSIDL_SYSTEM                  // C:\Windows\system32
// CSIDL_PROGRAM_FILES           // C:\Program Files
// CSIDL_MYPICTURES              // C:\Documents and Settings\<user name>\My Documents\My Pictures
// CSIDL_PROFILE                 // C:\Documents and Settings\<user name>
// CSIDL_SYSTEMX86               // C:\Windows\system32
// CSIDL_PROGRAM_FILESX86
// CSIDL_PROGRAM_FILES_COMMON    // C:\Program Files\Common Files
// CSIDL_PROGRAM_FILES_COMMONX86
// CSIDL_COMMON_TEMPLATES        // C:\Documents and Settings\All Users\Templates
// CSIDL_COMMON_DOCUMENTS
// CSIDL_COMMON_ADMINTOOLS       // C:\Documents and Settings\All Users\X^[g j[\vO\Ǘc[
// CSIDL_ADMINTOOLS              // C:\Documents and Settings\<user name>\X^[g j[\vO\Ǘc[
// CSIDL_CONNECTIONS
// CSIDL_COMMON_MUSIC            // C:\Documents and Settings\All Users\Documents\My Music
// CSIDL_COMMON_PICTURES         // C:\Documents and Settings\All Users\Documents\My Pictures
// CSIDL_COMMON_VIDEO            // C:\Documents and Settings\All Users\Documents\My Videos
// CSIDL_RESOURCES               // C:\Windows\Resources
// CSIDL_RESOURCES_LOCALIZED
// CSIDL_COMMON_OEM_LINKS
// CSIDL_CDBURN_AREA             // C:\Documents and Settings\<user name>\Local Settings\Application Data\Microsoft\CD Burning
// CSIDL_COMPUTERSNEARME
#endif


#if 0    // Windows Vista/7
// CSIDL_DESKTOP                 // C:\Users\<user name>\Desktop
// CSIDL_INTERNET
// CSIDL_PROGRAMS                // C:\Users\<user name>\AppData\Roaming\Microsoft\Windows\Start Menu\Programs
// CSIDL_CONTROLS
// CSIDL_PRINTERS
// CSIDL_PERSONAL                // C:\Users\<user name>\Documents
// CSIDL_FAVORITES               // C:\Users\<user name>\Favorites
// CSIDL_STARTUP                 // C:\Users\<user name>\AppData\Roaming\Microsoft\Windows\Start Menu\Programs\Startup
// CSIDL_RECENT                  // C:\Users\<user name>\AppData\Roaming\Microsoft\Windows\Recent
// CSIDL_SENDTO                  // C:\Users\<user name>\AppData\Roaming\Microsoft\Windows\SendTo
// CSIDL_BITBUCKET
// CSIDL_STARTMENU               // C:\Users\<user name>\AppData\Roaming\Microsoft\Windows\Start Menu
// CSIDL_MYDOCUMENTS
// CSIDL_MYMUSIC                 // C:\Users\<user name>\Music
// CSIDL_MYVIDEO                 // C:\Users\<user name>\Videos
// CSIDL_DESKTOPDIRECTORY        // C:\Users\<user name>\Desktop
// CSIDL_DRIVES
// CSIDL_NETWORK
// CSIDL_NETHOOD                 // C:\Users\<user name>\AppData\Roaming\Microsoft\Windows\Network Shortcuts
// CSIDL_FONTS                   // C:\Windows\Fonts
// CSIDL_TEMPLATES               // C:\Users\<user name>\AppData\Roaming\Microsoft\Windows\Templates
// CSIDL_COMMON_STARTMENU        // C:\ProgramData\Microsoft\Windows\Start Menu
// CSIDL_COMMON_PROGRAMS         // C:\ProgramData\Microsoft\Windows\Start Menu\Programs
// CSIDL_COMMON_STARTUP          // C:\ProgramData\Microsoft\Windows\Start Menu\Programs\Startup
// CSIDL_COMMON_DESKTOPDIRECTORY // C:\Users\Public\Desktop
// CSIDL_APPDATA                 // C:\Users\<user name>\AppData\Roaming
// CSIDL_PRINTHOOD               // C:\Users\<user name>\AppData\Roaming\Microsoft\Windows\Printer Shortcuts
// CSIDL_LOCAL_APPDATA           // C:\Users\<user name>\AppData\Local
// CSIDL_ALTSTARTUP              // C:\Users\<user name>\AppData\Roaming\Microsoft\Windows\Start Menu\Programs\Startup
// CSIDL_COMMON_ALTSTARTUP       // C:\ProgramData\Microsoft\Windows\Start Menu\Programs\Startup
// CSIDL_COMMON_FAVORITES        // C:\Users\<user name>\Favorites
// CSIDL_INTERNET_CACHE          // C:\Users\<user name>\AppData\Local\Microsoft\Windows\Temporary Internet Files
// CSIDL_COOKIES                 // C:\Users\<user name>\AppData\Roaming\Microsoft\Windows\Cookies
// CSIDL_HISTORY                 // C:\Users\<user name>\AppData\Local\Microsoft\Windows\History
// CSIDL_COMMON_APPDATA          // C:\ProgramData
// CSIDL_WINDOWS                 // C:\Windows
// CSIDL_SYSTEM                  // C:\Windows\System32
// CSIDL_PROGRAM_FILES           // C:\Program Files
// CSIDL_MYPICTURES              // C:\Users\<user name>\Pictures
// CSIDL_PROFILE                 // C:\Users\<user name>
// CSIDL_SYSTEMX86               // C:\Windows\System32
// CSIDL_PROGRAM_FILESX86        // C:\Program Files
// CSIDL_PROGRAM_FILES_COMMON    // C:\Program Files\Common Files
// CSIDL_PROGRAM_FILES_COMMONX86 // C:\Program Files\Common Files
// CSIDL_COMMON_TEMPLATES        // C:\ProgramData\Microsoft\Windows\Templates
// CSIDL_COMMON_DOCUMENTS        // C:\Users\Public\Documents
// CSIDL_COMMON_ADMINTOOLS       // C:\ProgramData\Microsoft\Windows\Start Menu\Programs\Administrative Tools
// CSIDL_ADMINTOOLS              // C:\Users\<user name>\AppData\Roaming\Microsoft\Windows\Start Menu\Programs\Administrative Tools
// CSIDL_CONNECTIONS
// CSIDL_COMMON_MUSIC            // C:\Users\Public\Music
// CSIDL_COMMON_PICTURES         // C:\Users\Public\Pictures
// CSIDL_COMMON_VIDEO            // C:\Users\Public\Videos
// CSIDL_RESOURCES               // C:\Windows\Resources
// CSIDL_RESOURCES_LOCALIZED
// CSIDL_COMMON_OEM_LINKS
// CSIDL_CDBURN_AREA             // C:\Users\<user name>\AppData\Local\Microsoft\Windows\Burn\Burn
// CSIDL_COMPUTERSNEARME
#endif



#ifndef CSIDL_DESKTOP
#define CSIDL_DESKTOP  0x0000
#endif
#ifndef CSIDL_INTERNET
#define CSIDL_INTERNET  0x0001
#endif
#ifndef CSIDL_PROGRAMS
#define CSIDL_PROGRAMS  0x0002
#endif
#ifndef CSIDL_CONTROLS
#define CSIDL_CONTROLS  0x0003
#endif
#ifndef CSIDL_PRINTERS
#define CSIDL_PRINTERS  0x0004
#endif
#ifndef CSIDL_PERSONAL
#define CSIDL_PERSONAL  0x0005
#endif
#ifndef CSIDL_FAVORITES
#define CSIDL_FAVORITES  0x0006
#endif
#ifndef CSIDL_STARTUP
#define CSIDL_STARTUP  0x0007
#endif
#ifndef CSIDL_RECENT
#define CSIDL_RECENT  0x0008
#endif
#ifndef CSIDL_SENDTO
#define CSIDL_SENDTO  0x0009
#endif
#ifndef CSIDL_BITBUCKET
#define CSIDL_BITBUCKET  0x000a
#endif
#ifndef CSIDL_STARTMENU
#define CSIDL_STARTMENU  0x000b
#endif
#ifndef CSIDL_MYDOCUMENTS
#define CSIDL_MYDOCUMENTS  0x000c
#endif
#ifndef CSIDL_MYMUSIC
#define CSIDL_MYMUSIC  0x000d
#endif
#ifndef CSIDL_MYVIDEO
#define CSIDL_MYVIDEO  0x000e
#endif
#ifndef CSIDL_DESKTOPDIRECTORY
#define CSIDL_DESKTOPDIRECTORY  0x0010
#endif
#ifndef CSIDL_DRIVES
#define CSIDL_DRIVES  0x0011
#endif
#ifndef CSIDL_NETWORK
#define CSIDL_NETWORK  0x0012
#endif
#ifndef CSIDL_NETHOOD
#define CSIDL_NETHOOD  0x0013
#endif
#ifndef CSIDL_FONTS
#define CSIDL_FONTS  0x0014
#endif
#ifndef CSIDL_TEMPLATES
#define CSIDL_TEMPLATES  0x0015
#endif
#ifndef CSIDL_COMMON_STARTMENU
#define CSIDL_COMMON_STARTMENU  0x0016
#endif
#ifndef CSIDL_COMMON_PROGRAMS
#define CSIDL_COMMON_PROGRAMS  0x0017
#endif
#ifndef CSIDL_COMMON_STARTUP
#define CSIDL_COMMON_STARTUP  0x0018
#endif
#ifndef CSIDL_COMMON_DESKTOPDIRECTORY
#define CSIDL_COMMON_DESKTOPDIRECTORY  0x0019
#endif
#ifndef CSIDL_APPDATA
#define CSIDL_APPDATA  0x001a
#endif
#ifndef CSIDL_PRINTHOOD
#define CSIDL_PRINTHOOD  0x001b
#endif
#ifndef CSIDL_LOCAL_APPDATA
#define CSIDL_LOCAL_APPDATA  0x001c
#endif
#ifndef CSIDL_ALTSTARTUP
#define CSIDL_ALTSTARTUP  0x001d
#endif
#ifndef CSIDL_COMMON_ALTSTARTUP
#define CSIDL_COMMON_ALTSTARTUP  0x001e
#endif
#ifndef CSIDL_COMMON_FAVORITES
#define CSIDL_COMMON_FAVORITES  0x001f
#endif
#ifndef CSIDL_INTERNET_CACHE
#define CSIDL_INTERNET_CACHE  0x0020
#endif
#ifndef CSIDL_COOKIES
#define CSIDL_COOKIES  0x0021
#endif
#ifndef CSIDL_HISTORY
#define CSIDL_HISTORY  0x0022
#endif
#ifndef CSIDL_COMMON_APPDATA
#define CSIDL_COMMON_APPDATA  0x0023
#endif
#ifndef CSIDL_WINDOWS
#define CSIDL_WINDOWS  0x0024
#endif
#ifndef CSIDL_SYSTEM
#define CSIDL_SYSTEM  0x0025
#endif
#ifndef CSIDL_PROGRAM_FILES
#define CSIDL_PROGRAM_FILES  0x0026
#endif
#ifndef CSIDL_MYPICTURES
#define CSIDL_MYPICTURES  0x0027
#endif
#ifndef CSIDL_PROFILE
#define CSIDL_PROFILE  0x0028
#endif
#ifndef CSIDL_SYSTEMX86
#define CSIDL_SYSTEMX86  0x0029
#endif
#ifndef CSIDL_PROGRAM_FILESX86
#define CSIDL_PROGRAM_FILESX86  0x002a
#endif
#ifndef CSIDL_PROGRAM_FILES_COMMON
#define CSIDL_PROGRAM_FILES_COMMON  0x002b
#endif
#ifndef CSIDL_PROGRAM_FILES_COMMONX86
#define CSIDL_PROGRAM_FILES_COMMONX86  0x002c
#endif
#ifndef CSIDL_COMMON_TEMPLATES
#define CSIDL_COMMON_TEMPLATES  0x002d
#endif
#ifndef CSIDL_COMMON_DOCUMENTS
#define CSIDL_COMMON_DOCUMENTS  0x002e
#endif
#ifndef CSIDL_COMMON_ADMINTOOLS
#define CSIDL_COMMON_ADMINTOOLS  0x002f
#endif
#ifndef CSIDL_ADMINTOOLS
#define CSIDL_ADMINTOOLS  0x0030
#endif
#ifndef CSIDL_CONNECTIONS
#define CSIDL_CONNECTIONS  0x0031
#endif
#ifndef CSIDL_COMMON_MUSIC
#define CSIDL_COMMON_MUSIC  0x0035
#endif
#ifndef CSIDL_COMMON_PICTURES
#define CSIDL_COMMON_PICTURES  0x0036
#endif
#ifndef CSIDL_COMMON_VIDEO
#define CSIDL_COMMON_VIDEO  0x0037
#endif
#ifndef CSIDL_RESOURCES
#define CSIDL_RESOURCES  0x0038
#endif
#ifndef CSIDL_RESOURCES_LOCALIZED
#define CSIDL_RESOURCES_LOCALIZED  0x0039
#endif
#ifndef CSIDL_COMMON_OEM_LINKS
#define CSIDL_COMMON_OEM_LINKS  0x003a
#endif
#ifndef CSIDL_CDBURN_AREA
#define CSIDL_CDBURN_AREA  0x003b
#endif
#ifndef CSIDL_COMPUTERSNEARME
#define CSIDL_COMPUTERSNEARME  0x003d
#endif

#define CSIDL_MAX    CSIDL_COMPUTERSNEARME



#ifdef __cplusplus
}
#endif

#endif


