// environ.cpp

#include <windows.h>
#include <stdlib.h>
#include <string.h>
#include "msc.h"
#include "environ.h"



//////////////////////////////
//      GetEnvAlloc ()      //
//////////////////////////////



// [mۂĊϐ擾iANSIŁj
// free() gĉ邱
// s NULL Ԃ
char *GetEnvAllocA ( const char *szName ) {

   int nLength = GetEnvironmentVariableA ( szName, NULL, 0 ) ;
   if ( nLength <= 0 ) return NULL ;

   char *szBuffer ;
   if ( ! ( szBuffer = (char*) malloc ( nLength * sizeof(char) ) ) ) return NULL ;

   int nResult = GetEnvironmentVariableA ( szName, szBuffer, nLength ) ;
   if ( nResult <= 0 || nResult >= nLength ) { free ( szBuffer ) ; return NULL ; }

   return szBuffer ;
}



// [mۂĊϐ擾iUNICODEŁj
// free() gĉ邱
// s NULL Ԃ
wchar_t *GetEnvAllocW ( const wchar_t *szName ) {

   int nLength = GetEnvironmentVariableW ( szName, NULL, 0 ) ;
   if ( nLength <= 0 ) return NULL ;

   wchar_t *szBuffer ;
   if ( ! ( szBuffer = (wchar_t*) malloc ( nLength * sizeof(wchar_t) ) ) ) return NULL ;

   int nResult = GetEnvironmentVariableW ( szName, szBuffer, nLength ) ;
   if ( nResult <= 0 || nResult >= nLength ) { free ( szBuffer ) ; return NULL ; }

   return szBuffer ;
}



//////////////////////////////
//         GetEnv ()        //
//////////////////////////////



// ϐ擾iANSIŁj
// s NULL Ԃ
// ܂ꂽ͎ɂ̊֐Ă΂܂ŗL
char *GetEnvA ( const char *szName ) {

   THREAD_DATA *pThreadData = GetThreadData () ;
   if ( ! pThreadData ) return NULL ;

   free ( pThreadData->szEnvironA ) ;

   pThreadData->szEnvironA = GetEnvAllocA ( szName ) ;

   return pThreadData->szEnvironA ;
}



// ϐ擾iUNICODEŁj
// s NULL Ԃ
// ܂ꂽ͎ɂ̊֐Ă΂܂ŗL
wchar_t *GetEnvW ( const wchar_t *szName ) {

   THREAD_DATA *pThreadData = GetThreadData () ;
   if ( ! pThreadData ) return NULL ;

   free ( pThreadData->szEnvironW ) ;

   pThreadData->szEnvironW = GetEnvAllocW ( szName ) ;

   return pThreadData->szEnvironW ;
}



//////////////////////////////
//         PutEnv ()        //
//////////////////////////////



// ϐݒ肷iANSIŁj
//  "O=l" ̌`
//  "O=" ȂAϐ폜
//  0 As -1 Ԃ
int PutEnvA ( const char *szString ) {

   int nResult = 0 ;

   char *szBuffer = strdup ( szString ) ;
   if ( szBuffer ) {
      char *szName = szBuffer ;
      char *szValue = strchr ( szBuffer, '=' ) ;
      if ( szValue ) {
         *szValue ++ = 0 ;
         if ( ! *szValue ) szValue = NULL ;
         nResult = SetEnvironmentVariableA ( szName, szValue ) ;
      }
      free ( szBuffer ) ;
   }

   return ( nResult ) ? 0 : -1 ;
}



// ϐݒ肷iUNICODEŁj
//  "O=l" ̌`
//  "O=" ȂAϐ폜
//  0 As -1 Ԃ
int PutEnvW ( const wchar_t *szString ) {

   int nResult = 0 ;

   wchar_t *szBuffer = wcsdup ( szString ) ;
   if ( szBuffer ) {
      wchar_t *szName = szBuffer ;
      wchar_t *szValue = wcschr ( szBuffer, '=' ) ;
      if ( szValue ) {
         *szValue ++ = 0 ;
         if ( ! *szValue ) szValue = NULL ;
         nResult = SetEnvironmentVariableW ( szName, szValue ) ;
      }
      free ( szBuffer ) ;
   }

   return ( nResult ) ? 0 : -1 ;
}



//////////////////////////////
//         SetEnv ()        //
//////////////////////////////



// ϐݒ肷iANSIŁj
//  szValue  NULL ȂAϐ폜
// IsOverwrite  0 Ȃ㏑Ȃ
//  0 As 0 ȊOԂ
int SetEnvA ( const char *szName, const char *szValue, int IsOverwrite ) {

   if ( ! IsOverwrite ) {
      int nLength = GetEnvironmentVariableA ( szName, NULL, 0 ) ;
      if ( nLength ) return 1 ;
   }

   int nResult = SetEnvironmentVariableA ( szName, szValue ) ;
   return ! nResult ;
}



// ϐݒ肷iUNICODEŁj
//  szValue  NULL ȂAϐ폜
// IsOverwrite  0 Ȃ㏑Ȃ
//  0 As 0 ȊOԂ
int SetEnvW ( const wchar_t *szName, const wchar_t *szValue, int IsOverwrite ) {

   if ( ! IsOverwrite ) {
      int nLength = GetEnvironmentVariableW ( szName, NULL, 0 ) ;
      if ( nLength ) return 1 ;
   }

   int nResult = SetEnvironmentVariableW ( szName, szValue ) ;
   return ! nResult ;
}



//////////////////////////////
//       AddEnvPath ()      //
//////////////////////////////



static inline char *strmove ( char *dst, const char *src ) ;



// ϐ PATH ɃpXǉiANSIŁj
//  0 As 0 ȊOԂ
int AddEnvPathA ( const char *szPath, int IsAddToTop ) {

   int nRetValue = 1 ;

   size_t nAddLength = strlen ( szPath ) ;
   if ( ! nAddLength ) return nRetValue ;

   // ϐ̃obt@m
   int nLength = GetEnvironmentVariableA ( "PATH", NULL, 0 ) ;
   char *szBuffer = (char*) malloc ( ( nLength + nAddLength + 2 ) * sizeof(char) ) ;
   if ( szBuffer ) {

      // ݂̊ϐ擾
      int nResult = GetEnvironmentVariableA ( "PATH", szBuffer, nLength ) ;
      if ( nResult < 0 || nResult && nResult >= nLength ) goto CAUGHT_ERROR ;
      if ( ! nResult ) *szBuffer = 0 ;

      // łɃpXo^Ă邩H
      for ( char *szString = szBuffer ; ( szString = strstr ( szString, szPath ) ) ; szString += nAddLength ) {
         if ( ( szString == szBuffer || *( szString - 1 ) == ';' ) &&               // 擪́H
              ( ! *( szString + nAddLength ) || *( szString + nAddLength ) == ';' ) // ́H
         ) {
            if ( IsAddToTop ) {
               if ( ! *( szString + nAddLength ) ) {
                  if ( szString == szBuffer ) *szString = 0 ;
                  else                        *( szString - 1 ) = 0 ;
               }
               else {
                  strmove ( szString, szString + nAddLength + 1 ) ;
               }
               break ;
            }
            else {
               nRetValue = 0 ;
               goto CAUGHT_ERROR ;
            }
         }
      }

      // Vϐ쐬
      if ( IsAddToTop ) {
         strmove ( szBuffer + nAddLength + 1, szBuffer ) ;
         strmove ( szBuffer, szPath ) ;
         if ( *( szBuffer + nAddLength + 1 ) ) szBuffer [ nAddLength ] = ';' ;
      }
      else {
         if ( *szBuffer ) strcat ( szBuffer, ";" ) ;
         strcat ( szBuffer, szPath ) ;
      }

      // Vϐۑ
      if ( ! SetEnvironmentVariableA ( "PATH", szBuffer ) ) goto CAUGHT_ERROR ;

      nRetValue = 0 ;
   }

   CAUGHT_ERROR :
   free ( szBuffer ) ;

   return nRetValue ;
}



// Rs[iANSIŁj
static inline char *strmove ( char *dst, const char *src ) {
   return (char*) memmove ( dst, src, ( strlen ( src ) + 1 ) * sizeof(char) ) ;
}



static inline wchar_t *wcsmove ( wchar_t *dst, const wchar_t *src ) ;



// ϐ PATH ɃpXǉiUNICODEŁj
//  0 As 0 ȊOԂ
int AddEnvPathW ( const wchar_t *szPath, int IsAddToTop ) {

   int nRetValue = 1 ;

   size_t nAddLength = wcslen ( szPath ) ;
   if ( ! nAddLength ) return nRetValue ;

   // ϐ̃obt@m
   int nLength = GetEnvironmentVariableW ( L"PATH", NULL, 0 ) ;
   wchar_t *szBuffer = (wchar_t*) malloc ( ( nLength + nAddLength + 2 ) * sizeof(wchar_t) ) ;
   if ( szBuffer ) {

      // ݂̊ϐ擾
      int nResult = GetEnvironmentVariableW ( L"PATH", szBuffer, nLength ) ;
      if ( nResult < 0 || nResult && nResult >= nLength ) goto CAUGHT_ERROR ;
      if ( ! nResult ) *szBuffer = 0 ;

      // łɃpXo^Ă邩H
      for ( wchar_t *szString = szBuffer ; ( szString = wcsstr ( szString, szPath ) ) ; szString += nAddLength ) {
         if ( ( szString == szBuffer || *( szString - 1 ) == ';' ) &&               // 擪́H
              ( ! *( szString + nAddLength ) || *( szString + nAddLength ) == ';' ) // ́H
         ) {
            if ( IsAddToTop ) {
               if ( ! *( szString + nAddLength ) ) {
                  if ( szString == szBuffer ) *szString = 0 ;
                  else                        *( szString - 1 ) = 0 ;
               }
               else {
                  wcsmove ( szString, szString + nAddLength + 1 ) ;
               }
               break ;
            }
            else {
               nRetValue = 0 ;
               goto CAUGHT_ERROR ;
            }
         }
      }

      // Vϐ쐬
      if ( IsAddToTop ) {
         wcsmove ( szBuffer + nAddLength + 1, szBuffer ) ;
         wcsmove ( szBuffer, szPath ) ;
         if ( *( szBuffer + nAddLength + 1 ) ) szBuffer [ nAddLength ] = ';' ;
      }
      else {
         if ( *szBuffer ) wcscat ( szBuffer, L";" ) ;
         wcscat ( szBuffer, szPath ) ;
      }

      // Vϐۑ
      if ( ! SetEnvironmentVariableW ( L"PATH", szBuffer ) ) goto CAUGHT_ERROR ;

      nRetValue = 0 ;
   }

   CAUGHT_ERROR :
   free ( szBuffer ) ;

   return nRetValue ;
}



// Rs[iUNICODEŁj
static inline wchar_t *wcsmove ( wchar_t *dst, const wchar_t *src ) {
   return (wchar_t*) memmove ( dst, src, ( wcslen ( src ) + 1 ) * sizeof(wchar_t) ) ;
}



//////////////////////////////
//        EnumEnv ()        //
//////////////////////////////



// ϐ񋓂iANSIŁj
// R[obN֐ 0 ԂA񋓂~
//                    0 ȊOԂA񋓂p
//  0 , s 0 ȊOԂ
int EnumEnvironmentVariablesA ( int ( CALLBACK *CallbackProc ) ( const char *szName, const char *szValue, LPARAM lParam ), LPARAM lParam ) {

   int nRetValue = 0 ;

   char *szEnvirion = GetEnvironmentStringsA () ;

   for ( char *szCurrent = szEnvirion ; *szCurrent ; szCurrent = strend ( szCurrent ) + 1 ) {

      char *szString = strdup ( szCurrent ) ;
      if ( ! szString ) {
         nRetValue = 1 ;
         break ;
      }

      char *szSeparator = strchr ( szString + 1, '=' ) ;
      if ( szSeparator ) *szSeparator = 0 ;

      char *szValue = ( szSeparator ) ? szSeparator + 1 : strend ( szString ) ;
      int nResult = CallbackProc ( szString, szValue, lParam ) ;

      free ( szString ) ;

      if ( ! nResult ) break ;
   }

   FreeEnvironmentStringsA ( szEnvirion ) ;

   return nRetValue ;
}



// ϐ񋓂iUNICODEŁj
// R[obN֐ 0 ԂA񋓂~
//                    0 ȊOԂA񋓂p
//  0 , s 0 ȊOԂ
int EnumEnvironmentVariablesW ( int ( CALLBACK *CallbackProc ) ( const wchar_t *szName, const wchar_t *szValue, LPARAM lParam ), LPARAM lParam ) {

   int nRetValue = 0 ;

   wchar_t *szEnvirion = GetEnvironmentStringsW () ;

   for ( wchar_t *szCurrent = szEnvirion ; *szCurrent ; szCurrent = wcsend ( szCurrent ) + 1 ) {

      wchar_t *szString = wcsdup ( szCurrent ) ;
      if ( ! szString ) {
         nRetValue = 1 ;
         break ;
      }

      wchar_t *szSeparator = wcschr ( szString + 1, '=' ) ;
      if ( szSeparator ) *szSeparator = 0 ;

      wchar_t *szValue = ( szSeparator ) ? szSeparator + 1 : wcsend ( szString ) ;
      int nResult = CallbackProc ( szString, szValue, lParam ) ;

      free ( szString ) ;

      if ( ! nResult ) break ;
   }

   FreeEnvironmentStringsW ( szEnvirion ) ;

   return nRetValue ;
}



