// reg.h

#ifndef REG_H
#define REG_H

#ifdef __cplusplus
extern "C" {
#endif


int GetRegInfoA ( HKEY hKey, const char *szSubkey, const char *szValueName, unsigned long dwDataTypeRequired, void *pData, unsigned long dwDataSizeMax, unsigned long dwMode ) ;
int GetRegInfoW ( HKEY hKey, const wchar_t *szSubkey, const wchar_t *szValueName, unsigned long dwDataTypeRequired, void *pData, unsigned long dwDataSizeMax, unsigned long dwMode ) ;
int SetRegInfoA ( HKEY hKey, const char *szSubkey, const char *szValueName, unsigned long dwDataType, const void *pData, unsigned long dwDataSize, unsigned long dwMode ) ;
int SetRegInfoW ( HKEY hKey, const wchar_t *szSubkey, const wchar_t *szValueName, unsigned long dwDataType, const void *pData, unsigned long dwDataSize, unsigned long dwMode ) ;

int GetRegStringA ( HKEY hKey, const char *szSubkey, const char *szValueName, char *pData, unsigned long dwDataSizeMax, unsigned long dwMode ) ;
int GetRegStringW ( HKEY hKey, const wchar_t *szSubkey, const wchar_t *szValueName, wchar_t *pData, unsigned long dwDataSizeMax, unsigned long dwMode ) ;
int SetRegStringA ( HKEY hKey, const char *szSubkey, const char *szValueName, const char *pData, unsigned long dwMode ) ;
int SetRegStringW ( HKEY hKey, const wchar_t *szSubkey, const wchar_t *szValueName, const wchar_t *pData, unsigned long dwMode ) ;

int DeleteRegInfoA ( HKEY hKey, const char *szSubkey, const char *szValueName, unsigned long dwMode ) ;
int DeleteRegInfoW ( HKEY hKey, const wchar_t *szSubkey, const wchar_t *szValueName, unsigned long dwMode ) ;
int IsRegKeyAccessibleA ( HKEY hKey, const char *szSubkey, REGSAM dwAccessMask, unsigned long dwMode ) ;
int IsRegKeyAccessibleW ( HKEY hKey, const wchar_t *szSubkey, REGSAM dwAccessMask, unsigned long dwMode ) ;

int EnumRegSubkeyA ( HKEY hKey, const char *szSubkey, int nNumber, char *szName, unsigned long dwMode ) ;
int EnumRegSubkeyW ( HKEY hKey, const wchar_t *szSubkey, int nNumber, wchar_t *szName, unsigned long dwMode ) ;
int EnumRegValueA ( HKEY hKey, const char *szSubkey, int nNumber, char *szName, unsigned long dwMode ) ;
int EnumRegValueW ( HKEY hKey, const wchar_t *szSubkey, int nNumber, wchar_t *szName, unsigned long dwMode ) ;


#ifdef UNICODE
#define GetRegInfo GetRegInfoW
#define SetRegInfo SetRegInfoW
#define GetRegString GetRegStringW
#define SetRegString SetRegStringW
#define DeleteRegInfo DeleteRegInfoW
#define IsRegKeyAccessible IsRegKeyAccessibleW
#define EnumRegSubkey EnumRegSubkeyW
#define EnumRegValue EnumRegValueW
#else
#define GetRegInfo GetRegInfoA
#define SetRegInfo SetRegInfoA
#define GetRegString GetRegStringA
#define SetRegString SetRegStringA
#define DeleteRegInfo DeleteRegInfoA
#define IsRegKeyAccessible IsRegKeyAccessibleA
#define EnumRegSubkey EnumRegSubkeyA
#define EnumRegValue EnumRegValueA
#endif


// dwMode
#define REG_MODE_NORMAL       0
#define REG_MODE_ALWAYS_32    1     // will be ignored on 32-bit Windows
#define REG_MODE_ALWAYS_64    2     // will be ignored on 32-bit Windows


#ifdef __cplusplus
}
#endif

#endif


