// chnconv_opt.cpp

#include <windows.h>
#include "msc.h"
#include "codepage.h"
#include "resource.h"
#include "chnconv.h"


#define CHNCONV_OPT_GLOBAL(type,name)              extern type name ;    type name = (type) 0
#define CHNCONV_OPT_GLOBAL_INIT(type,name,init)    extern type name ;    type name = init
#define CHNCONV_OPT_GLOBAL_ARRAY(type,name,size)   extern type name [] ; type name [size] = { 0 }
// C++ ł const ̓ftHgł͓ɂȂ̂ŁAextern ł̐錾Kv

#include "chnconv_opt.h"



////////////////////////////////////////
//    IvVt@C̓ǂݎ    //
////////////////////////////////////////



// ̃IvV
const OPTION_INTEGER OptionIntegerList [] = {
   { & IsGb2big5N,   "IsGb2big5N" },
   { & IsBig52gbN,   "IsBig52gbN" },
   { & IsNoGbk,      "IsNoGbk" },
   { & IsSenceCwFanti,  "IsSenceCwFanti" },
   { & IsCwTxtFanti,    "IsCwTxtFanti" },
   { & IsOutputNumber,  "IsOutputNumber" },
   { & IsInputNumber,   "IsInputNumber" },
   { & IsOneQuestionMark,  "IsOneQuestionMark" },
   { & IsConvertQuotation, "IsConvertQuotation" },
   { & IsUseSameFont,      "IsUseSameFont" },
   { & IsOutputCwNewFont,  "IsOutputCwNewFont" },
   { & IsTxtUnicodeHtml,   "IsTxtUnicodeHtml" },
   { & IsNoUseUnicode,     "IsNoUseUnicode" },
   { & IsConvertCjkEx,     "IsConvertCjkEx" },
   { & IsLinshiDaimaToCjkEx, "IsLinshiDaimaToCjkEx" },
   { & IsCjkExToLinshiDaima, "IsCjkExToLinshiDaima" },
   { & IsHkscsPuaToCjk,    "IsHkscsPuaToCjk" },
   { & nTmFontSize,        "TmFontSize" },
   { & IsWriteTmComment,   "IsWriteTmComment" } ,
#ifdef CHNCONV_EXE
   { & IsNoConfirm,     "IsNoConfirm" },
   { & IsNoRecycle,     "IsNoRecycle" },
   { & IsNoMessage,     "IsNoMessage" },
   { & IsNoAddExtension,   "IsNoAddExtension" },
   { & IsConfirmOnExit, "IsConfirmOnExit" },
   { & nSavedMuiLangId, "MuiLangId" },
   { & nSavedSrcType,   "SrcType" },
   { & nSavedDstType,   "DstType" },
   { & nSavedSrcCode,   "SrcCode" },
   { & nSavedDstCode,   "DstCode" },
   { & nSavedWindowX,   "WindowX" },
   { & nSavedWindowY,   "WindowY" },
#endif
} ;

const int OPTION_INTEGER_LIST_NELEM = NELEMOF ( OptionIntegerList ) ;



// ̃IvV (ANSI)
const OPTION_STRING_A OptionStringListA [] = {
   { szGbFont,          "GbFont",         FONTNAME_MAX },
   { szGbGothicFont,    "GbGothicFont",   FONTNAME_MAX },
   { szBig5Font,        "Big5Font",       FONTNAME_MAX },
   { szBig5GothicFont,  "Big5GothicFont", FONTNAME_MAX },
   { szPinyinFont,      "PinyinFont",     FONTNAME_MAX },
   { szPinyinGothicFont,"PinyinGothicFont",FONTNAME_MAX },
#ifdef CHNCONV_EXE
   { szBrowsePathA,     "BrowsePathA",    MAX_PATH },
#endif
} ;

const int OPTION_STRING_LIST_A_NELEM = NELEMOF ( OptionStringListA ) ;



#if defined CHNCONV_EXE || defined SETUP_C
// ̃IvV (UNICODE)
const OPTION_STRING_W OptionStringListW [] = {
   { szBrowsePathW,     "BrowsePathW",    MAX_PATH },
} ;

const int OPTION_STRING_LIST_W_NELEM = NELEMOF ( OptionStringListW ) ;
#endif



////////////////////////////////////////
//         R[hy[W̑I         //
////////////////////////////////////////



#ifdef CHNCONV_EXE
// R[hy[W̑I
const CODEPAGE AvailableCodeList [] = {
   { CP_JAPANESE_CW,    IDS_CP_JAPANESE_CW },
   { CP_JAPANESE_NH,    IDS_CP_JAPANESE_NH },
   { CP_JAPANESE_CWN,   IDS_CP_JAPANESE_CWN },
   { CP_JAPANESE_ZQ,    IDS_CP_JAPANESE_ZQ },
   { CP_JAPANESE_CX,    IDS_CP_JAPANESE_CX },
   { CP_JAPANESE_ZJ,    IDS_CP_JAPANESE_ZJ },
   { CP_JAPANESE_TM,    IDS_CP_JAPANESE_TM },
   { CP_JAPANESE_FW,    IDS_CP_JAPANESE_FW },
} ;

const int AVAILABLE_CODE_LIST_NELEM = NELEMOF ( AvailableCodeList ) ;
#endif



////////////////////////////////////////
//          IvV̉          //
////////////////////////////////////////



// IvV̉
unsigned long TranslateConversionMode ( int nSrcCodePage, int nDstCodePage ) {

   unsigned long dwConversionMode = 0 ;

   if ( IsOutputNumber ) dwConversionMode |= CONVMODE_OUTPUT_CODE_NUMBER ;
   if ( IsInputNumber ) dwConversionMode |= CONVMODE_INPUT_CODE_NUMBER ;
   if ( IsOneQuestionMark ) dwConversionMode |= CONVMODE_ONE_QUESTION_MARK ;
   if ( IsConvertQuotation ) dwConversionMode |= CONVMODE_QUOTATION_MARK ;
   if ( IsGb2big5N && nDstCodePage == CP_CHINESE_TRADITIONAL ) dwConversionMode |= CONVMODE_CHNCONV_NO_VARIANT ;
   if ( IsBig52gbN && nSrcCodePage == CP_CHINESE_TRADITIONAL ) dwConversionMode |= CONVMODE_CHNCONV_NO_VARIANT ;
   if ( IsNoGbk ) dwConversionMode |= CONVMODE_CHNCONV_NO_GBK ;
   if ( IsSenceCwFanti ) dwConversionMode |= CONVMODE_SENSE_CW_FANTIZI ;
   if ( IsCwTxtFanti ) dwConversionMode |= CONVMODE_CW_TXT_FANTIZI ;
   if ( ! IsUseSameFont ) dwConversionMode |= CONVMODE_PINYIN_BY_ASCII ;
   if ( IsOutputCwNewFont ) dwConversionMode |= CONVMODE_OUTPUT_NEW_FONT ;
   if ( IsTxtUnicodeHtml ) dwConversionMode |= CONVMODE_TXT_UNICODE_HTML ;
   if ( IsNoUseUnicode ) dwConversionMode |= CONVMODE_NO_USE_UNICODE ;
   if ( IsConvertCjkEx ) dwConversionMode |= CONVMODE_CONVERT_CJKEX ;
   if ( IsLinshiDaimaToCjkEx ) dwConversionMode |= CONVMODE_LINGSHIDAIMA_TO_CJKEX ;
   if ( IsCjkExToLinshiDaima ) dwConversionMode |= CONVMODE_CJKEX_TO_LINGSHIDAIMA ;
   if ( IsHkscsPuaToCjk ) dwConversionMode |= CONVMODE_HKSCS_PUA_TO_CJK ;
#ifdef CHNCONV_CONSOLE
   if ( IsConvertTxt ) dwConversionMode |= CONVMODE_CONVERT_TXT ;
   if ( IsConvertRtf ) dwConversionMode |= CONVMODE_CONVERT_RTF ;
#endif

   return dwConversionMode ;
}



// gIvV̉
unsigned long TranslateAdditionalMode ( int nSrcCodePage, int nDstCodePage ) {

   unsigned long dwAdditionalMode = 0 ;

   if ( IsWriteTmComment ) dwAdditionalMode |= ADDITIONAL_MODE_WRITE_TM_COMMENT ;

   return dwAdditionalMode ;
}



