// chnconv_opt.h

#ifndef CHNCONV_OPT_H
#define CHNCONV_OPT_H


#ifndef CHNCONV_OPT_GLOBAL
#define CHNCONV_OPT_GLOBAL(type,name)              extern type name
#endif

#ifndef CHNCONV_OPT_GLOBAL_INIT
#define CHNCONV_OPT_GLOBAL_INIT(type,name,init)    extern type name
#endif

#ifndef CHNCONV_OPT_GLOBAL_ARRAY
#define CHNCONV_OPT_GLOBAL_ARRAY(type,name,size)   extern type name []
#endif



// obt@̒
#define SHORTSTRING_MAX             0x80
#define MESSAGE_BUFFER_SIZE         ( MAX_PATH * 2 )
#define OPTION_FILE_LINE_BUFFER     ( ( MAX_PATH * 4 ) + 0x40 )



#if defined CHNCONV_EXE
// [UC^[tFCX̃t@C
#define MUILANG_PREFIX_A          "chnc_"
#define MUILANG_PREFIX_W         L"chnc_"
#endif



#if defined CHNCONV_EXE
// R[hy[W̑I
typedef struct {
   int nCodePage ;
   int nNameId ;
} CODEPAGE ;

extern const CODEPAGE AvailableCodeList [] ;
extern const int AVAILABLE_CODE_LIST_NELEM ;
#endif



#if defined CHNCONV_COM
// R}hCł̕ϐ
CHNCONV_OPT_GLOBAL ( int, IsConvertTxt ) ;
CHNCONV_OPT_GLOBAL ( int, IsConvertRtf ) ;
#endif

#if defined CHNCONV_EXE
// _CAOŗp̕ϐ
CHNCONV_OPT_GLOBAL_INIT ( int, nSrcType, TYPE_PSEUDO ) ;
CHNCONV_OPT_GLOBAL_INIT ( int, nDstType, TYPE_GB ) ;
CHNCONV_OPT_GLOBAL ( int, nSrcCode ) ; // z AvailableCodeList ̔ԍ
CHNCONV_OPT_GLOBAL ( int, nDstCode ) ;
CHNCONV_OPT_GLOBAL_INIT ( const char *, szDefaultGbFont,          DEFAULT_GB_FONT ) ;
CHNCONV_OPT_GLOBAL_INIT ( const char *, szDefaultBig5Font,        DEFAULT_BIG5_FONT ) ;
CHNCONV_OPT_GLOBAL_INIT ( const char *, szDefaultGbGothicFont,    DEFAULT_GB_GOTHIC_FONT ) ;
CHNCONV_OPT_GLOBAL_INIT ( const char *, szDefaultBig5GothicFont,  DEFAULT_BIG5_GOTHIC_FONT ) ;
CHNCONV_OPT_GLOBAL_INIT ( const char *, const szDefaultPinyinFont,         DEFAULT_PINYIN_FONT ) ;
CHNCONV_OPT_GLOBAL_INIT ( const char *, const szDefaultPinyinGothicFont,   DEFAULT_PINYIN_GOTHIC_FONT ) ;
#endif



// IvVt@C
#define CFG_FILENAME_A      "chnconv.cfg"
#define CFG_FILENAME_W     L"chnconv.cfg"
#if defined CHNCONV_EXE || defined SETUP_C
CHNCONV_OPT_GLOBAL ( int, IsOptionChanged ) ;      // IvVύX
CHNCONV_OPT_GLOBAL ( int, IsOptionReadOnly ) ;
CHNCONV_OPT_GLOBAL ( int, IsSavePath ) ;
CHNCONV_OPT_GLOBAL ( int, IsSaveCode ) ;
CHNCONV_OPT_GLOBAL ( int, IsSaveWindow ) ;
CHNCONV_OPT_GLOBAL ( int, IsIgnoreSaveWindow ) ;
#endif



// ̃IvV
CHNCONV_OPT_GLOBAL ( int, IsGb2big5N ) ;
CHNCONV_OPT_GLOBAL ( int, IsBig52gbN ) ;
CHNCONV_OPT_GLOBAL ( int, IsNoGbk ) ;
CHNCONV_OPT_GLOBAL ( int, IsSenceCwFanti ) ;
CHNCONV_OPT_GLOBAL ( int, IsCwTxtFanti ) ;
CHNCONV_OPT_GLOBAL ( int, IsOutputNumber ) ;
CHNCONV_OPT_GLOBAL ( int, IsInputNumber ) ;
CHNCONV_OPT_GLOBAL ( int, IsOneQuestionMark ) ;
CHNCONV_OPT_GLOBAL ( int, IsConvertQuotation ) ;
CHNCONV_OPT_GLOBAL_INIT ( int, IsUseSameFont, 1 ) ;
CHNCONV_OPT_GLOBAL ( int, IsOutputCwNewFont ) ;
CHNCONV_OPT_GLOBAL ( int, IsTxtUnicodeHtml ) ;
CHNCONV_OPT_GLOBAL ( int, IsNoUseUnicode ) ;
CHNCONV_OPT_GLOBAL ( int, IsConvertCjkEx ) ;
CHNCONV_OPT_GLOBAL ( int, IsLinshiDaimaToCjkEx ) ;
CHNCONV_OPT_GLOBAL ( int, IsCjkExToLinshiDaima ) ;
CHNCONV_OPT_GLOBAL ( int, IsHkscsPuaToCjk ) ;
CHNCONV_OPT_GLOBAL_INIT ( int, nTmFontSize, DEFAULT_FONT_SIZE ) ;
CHNCONV_OPT_GLOBAL ( int, IsWriteTmComment ) ;
#if defined CHNCONV_EXE || defined SETUP_C
CHNCONV_OPT_GLOBAL ( int, IsNoConfirm ) ;
CHNCONV_OPT_GLOBAL ( int, IsNoRecycle ) ;
CHNCONV_OPT_GLOBAL ( int, IsNoMessage ) ;
CHNCONV_OPT_GLOBAL ( int, IsNoAddExtension ) ;
CHNCONV_OPT_GLOBAL ( int, IsConfirmOnExit ) ;
CHNCONV_OPT_GLOBAL ( int, nSavedMuiLangId ) ;
CHNCONV_OPT_GLOBAL_INIT ( int, nSavedSrcType, -1 ) ;
CHNCONV_OPT_GLOBAL_INIT ( int, nSavedDstType, -1 ) ;
CHNCONV_OPT_GLOBAL_INIT ( int, nSavedSrcCode, -1 ) ;
CHNCONV_OPT_GLOBAL_INIT ( int, nSavedDstCode, -1 ) ;
CHNCONV_OPT_GLOBAL ( int, nSavedWindowX ) ;
CHNCONV_OPT_GLOBAL ( int, nSavedWindowY ) ;
#endif

// ̃IvV
CHNCONV_OPT_GLOBAL_ARRAY ( char, szGbFont, FONTNAME_MAX ) ;
CHNCONV_OPT_GLOBAL_ARRAY ( char, szGbGothicFont, FONTNAME_MAX ) ;
CHNCONV_OPT_GLOBAL_ARRAY ( char, szBig5Font, FONTNAME_MAX ) ;
CHNCONV_OPT_GLOBAL_ARRAY ( char, szBig5GothicFont, FONTNAME_MAX ) ;
CHNCONV_OPT_GLOBAL_ARRAY ( char, szPinyinFont, FONTNAME_MAX ) ;
CHNCONV_OPT_GLOBAL_ARRAY ( char, szPinyinGothicFont, FONTNAME_MAX ) ;
#if defined CHNCONV_EXE || defined SETUP_C
CHNCONV_OPT_GLOBAL_ARRAY ( char, szBrowsePathA, MAX_PATH ) ;
CHNCONV_OPT_GLOBAL_ARRAY ( wchar_t, szBrowsePathW, MAX_PATH ) ;
#endif



// IvVt@C̓ǂݎ



typedef struct {
   int *nValue ;
   const char *szName ;
} OPTION_INTEGER ;

extern const OPTION_INTEGER OptionIntegerList [] ;
extern const int OPTION_INTEGER_LIST_NELEM ;


typedef struct {
   char *szValue ;
   const char *szName ;
   int nMaxSize ;
} OPTION_STRING_A ;


extern const OPTION_STRING_A OptionStringListA [] ;
extern const int OPTION_STRING_LIST_A_NELEM ;


typedef struct {
   wchar_t *szValue ;
   const char *szName ;
   int nMaxSize ;
} OPTION_STRING_W ;

extern const OPTION_STRING_W OptionStringListW [] ;
extern const int OPTION_STRING_LIST_W_NELEM ;


typedef struct {
   unsigned short *pValue ;
   const char *szName ;
   int nSize ;
} OPTION_BINARY ;

extern const OPTION_BINARY OptionBinaryList ;
extern const int OPTION_BINARY_LIST_NELEM ;



// IvV̖|
unsigned long TranslateConversionMode ( int nSrcCodePage, int nDstCodePage ) ;
unsigned long TranslateAdditionalMode ( int nSrcCodePage, int nDstCodePage ) ;



#endif


