// sendmsg.cpp

#include <windows.h>
#include <stdio.h>
#include <stdlib.h>
#include "msc.h"
#include "sendmsg.h"



////////////////////////////////////////
//              ʊ֐              //
////////////////////////////////////////



#undef SendMessage



static inline LRESULT SendMessage ( HWND hWnd, UINT Msg, WPARAM wParam, LPARAM lParam ) {
   if ( IsNT () ) return SendMessageW ( hWnd, Msg, wParam, lParam ) ;
   else           return SendMessageA ( hWnd, Msg, wParam, lParam ) ;
}



static inline int LRESULT_TO_INT ( LRESULT nValue ) {
   if ( nValue != (int) nValue ) return -1 ;
   return (int) nValue ;
}



////////////////////////////////////////
//         EBhE         //
////////////////////////////////////////



HICON Wm_SetIcon ( HWND hWnd, int nIconSize, HICON hIcon ) {
   return (HICON) SendMessage ( hWnd, WM_SETICON, nIconSize, (LPARAM) hIcon ) ;
}



int Wm_SetFont ( HWND hWnd, HFONT hFont, int IsRedraw ) {
   return LRESULT_TO_INT ( SendMessage ( hWnd, WM_SETFONT, (WPARAM) hFont, IsRedraw ) ) ;
}



int Wm_Notify ( HWND hWnd, NMHDR *pNotifyMessageHeader ) {
   return LRESULT_TO_INT ( SendMessage ( hWnd, WM_NOTIFY, 0, (LPARAM) pNotifyMessageHeader ) ) ;
}



int Wm_GetTextA ( HWND hWnd, char *szString, int nMaxLen ) {
   if ( szString && nMaxLen ) *szString = 0 ;
   return LRESULT_TO_INT ( SendMessageA ( hWnd, WM_GETTEXT, nMaxLen, (LPARAM) szString ) ) ;
}



int Wm_GetTextW ( HWND hWnd, wchar_t *szString, int nMaxLen ) {
   if ( szString && nMaxLen ) *szString = 0 ;
   return LRESULT_TO_INT ( SendMessageW ( hWnd, WM_GETTEXT, nMaxLen, (LPARAM) szString ) ) ;
}



int Wm_SetTextA ( HWND hWnd, const char *szString ) {
   return LRESULT_TO_INT ( SendMessageA ( hWnd, WM_SETTEXT, 0, (LPARAM) szString ) ) ;
}



int Wm_SetTextW ( HWND hWnd, const wchar_t *szString ) {
   return LRESULT_TO_INT ( SendMessageW ( hWnd, WM_SETTEXT, 0, (LPARAM) szString ) ) ;
}



int Wm_GetTextLengthA ( HWND hWnd ) {
   return LRESULT_TO_INT ( SendMessageA ( hWnd, WM_GETTEXTLENGTH, 0, 0 ) ) ;
}



int Wm_GetTextLengthW ( HWND hWnd ) {
   return LRESULT_TO_INT ( SendMessageW ( hWnd, WM_GETTEXTLENGTH, 0, 0 ) ) ;
}



int Wm_KeyDown ( HWND hWnd, int nVirtualKey ) {
   return LRESULT_TO_INT ( SendMessage ( hWnd, WM_KEYDOWN, nVirtualKey, 1 ) ) ;
}



int Wm_Destroy ( HWND hWnd ) {
   return LRESULT_TO_INT ( SendMessage ( hWnd, WM_DESTROY, 0, 0 ) ) ;
}



int Wm_CopyData ( HWND hWnd, HWND hWndFrom, const COPYDATASTRUCT *pCopyDataStruct ) {
   return LRESULT_TO_INT ( SendMessage ( hWnd, WM_COPYDATA, (WPARAM) hWndFrom, (LPARAM) pCopyDataStruct ) ) ;
}



////////////////////////////////////////
//             _CAO             //
////////////////////////////////////////



int Dlg_SetFocus ( HWND hDlg, int nId ) {
   return LRESULT_TO_INT ( SendMessage ( hDlg, WM_NEXTDLGCTL, (WPARAM) GetDlgItem ( hDlg, nId ), TRUE ) ) ;
}



int Dlg_EnableWindow ( HWND hDlg, int nId, int IsEnable ) {
   HWND hControl = GetDlgItem ( hDlg, nId ) ;
   if ( ! IsEnable && hControl == GetFocus () ) SendMessage ( hDlg, WM_NEXTDLGCTL, 0, FALSE ) ;
   return EnableWindow ( hControl, IsEnable ) ;
}



////////////////////////////////////////
//         {^Rg[         //
////////////////////////////////////////



int Button_SetStyle ( HWND hWnd, int nStyle, int IsRedraw ) {
   return LRESULT_TO_INT ( SendMessage ( hWnd, BM_SETSTYLE, nStyle, MAKELPARAM ( IsRedraw, 0 ) ) ) ;
}



////////////////////////////////////////
//          ^uRg[          //
////////////////////////////////////////



int TabCtrl_InsertItemA ( HWND hWnd, int nItem, const TC_ITEMA *pItem ) {
   return LRESULT_TO_INT ( SendMessageA ( hWnd, TCM_INSERTITEMA, nItem, (LPARAM) pItem ) ) ;
}



int TabCtrl_InsertItemW ( HWND hWnd, int nItem, const TC_ITEMW *pItem ) {
   return LRESULT_TO_INT ( SendMessageW ( hWnd, TCM_INSERTITEMW, nItem, (LPARAM) pItem ) ) ;
}



int TabCtrl_AdjustRect ( HWND hWnd, int IsLarger, RECT *pRect ) {
   return LRESULT_TO_INT ( SendMessage ( hWnd, TCM_ADJUSTRECT, IsLarger, (LPARAM) pRect ) ) ;
}



int TabCtrl_GetCurSel ( HWND hWnd ) {
   return LRESULT_TO_INT ( SendMessage ( hWnd, TCM_GETCURSEL, 0, 0 ) ) ;
}



////////////////////////////////////////
//       GfBbgRg[       //
////////////////////////////////////////



int Edit_GetMargins ( HWND hWnd, int *pLeftMargin, int *pRightMargin ) {
   int nResult = LRESULT_TO_INT ( SendMessage ( hWnd, EM_GETMARGINS, 0, 0 ) ) ;
   if ( pLeftMargin ) *pLeftMargin = (short) nResult ;
   if ( pRightMargin ) *pRightMargin = (short) ( nResult >> 16 ) ;
   return nResult ;
}



int Edit_SetMargins ( HWND hWnd, short nLeftMargin, short nRightMargin ) {
   WPARAM flags = 0 ;
   if ( nLeftMargin != -1 ) flags |= EC_LEFTMARGIN ;
   if ( nRightMargin != -1 ) flags |= EC_RIGHTMARGIN ;
   return LRESULT_TO_INT ( SendMessage ( hWnd, EM_SETMARGINS, flags, MAKELPARAM ( nLeftMargin, nRightMargin ) ) ) ;
}



int Edit_SetReadOnly ( HWND hWnd, int IsReadOnly ) {
   return LRESULT_TO_INT ( SendMessage ( hWnd, EM_SETREADONLY, IsReadOnly, 0 ) ) ;
}



int Edit_SetSel ( HWND hWnd, int nStart, int nEnd ) {
   return LRESULT_TO_INT ( SendMessage ( hWnd, EM_SETSEL, nStart, nEnd ) ) ;
}



int Edit_LimitText ( HWND hWnd, int nMax ) {
   return LRESULT_TO_INT ( SendMessage ( hWnd, EM_LIMITTEXT, nMax, 0 ) ) ;
}



////////////////////////////////////////
//     R{{bNXRg[     //
////////////////////////////////////////



int ComboBox_AddStringA ( HWND hWnd, const char *szString ) {
   return LRESULT_TO_INT ( SendMessageA ( hWnd, CB_ADDSTRING, 0, (LPARAM) szString ) ) ;
}



int ComboBox_AddStringW ( HWND hWnd, const wchar_t *szString ) {
   return LRESULT_TO_INT ( SendMessageW ( hWnd, CB_ADDSTRING, 0, (LPARAM) szString ) ) ;
}



int ComboBox_InsertStringA ( HWND hWnd, int nIndex, const char *szString ) {
   return LRESULT_TO_INT ( SendMessageA ( hWnd, CB_INSERTSTRING, nIndex, (LPARAM) szString ) ) ;
}



int ComboBox_InsertStringW ( HWND hWnd, int nIndex, const wchar_t *szString ) {
   return LRESULT_TO_INT ( SendMessageW ( hWnd, CB_INSERTSTRING, nIndex, (LPARAM) szString ) ) ;
}



int ComboBox_GetCount ( HWND hWnd ) {
   return LRESULT_TO_INT ( SendMessage ( hWnd, CB_GETCOUNT, 0, 0 ) ) ;
}



int ComboBox_ResetContent ( HWND hWnd ) {
   return LRESULT_TO_INT ( SendMessage ( hWnd, CB_RESETCONTENT, 0, 0 ) ) ;
}



int ComboBox_GetCurSel ( HWND hWnd ) {
   return LRESULT_TO_INT ( SendMessage ( hWnd, CB_GETCURSEL, 0, 0 ) ) ;
}



int ComboBox_SetCurSel ( HWND hWnd, int nIndex ) {
   return LRESULT_TO_INT ( SendMessage ( hWnd, CB_SETCURSEL, nIndex, 0 ) ) ;
}



int ComboBox_SelectStringA ( HWND hWnd, int nIndexStart, const char *szString ) {
   return LRESULT_TO_INT ( SendMessageA ( hWnd, CB_SELECTSTRING, nIndexStart, (LPARAM) szString ) ) ;
}



int ComboBox_SelectStringW ( HWND hWnd, int nIndexStart, const wchar_t *szString ) {
   return LRESULT_TO_INT ( SendMessageW ( hWnd, CB_SELECTSTRING, nIndexStart, (LPARAM) szString ) ) ;
}



int ComboBox_FindStringExactA ( HWND hWnd, int nIndexStart, const char *szString ) {
   return LRESULT_TO_INT ( SendMessageA ( hWnd, CB_FINDSTRINGEXACT, nIndexStart, (LPARAM) szString ) ) ;
}



int ComboBox_FindStringExactW ( HWND hWnd, int nIndexStart, const wchar_t *szString ) {
   return LRESULT_TO_INT ( SendMessageW ( hWnd, CB_FINDSTRINGEXACT, nIndexStart, (LPARAM) szString ) ) ;
}



int ComboBox_GetItemHeight ( HWND hWnd ) {
   return LRESULT_TO_INT ( SendMessage ( hWnd, CB_GETITEMHEIGHT, 0, 0 ) ) ;
}



int ComboBox_SetEditSel ( HWND hWnd, short nStart, short nEnd ) {
   return LRESULT_TO_INT ( SendMessage ( hWnd, CB_SETEDITSEL, 0, MAKELPARAM ( nStart, nEnd ) ) ) ;
}



int ComboBox_LimitText ( HWND hWnd, int nMax ) {
   return LRESULT_TO_INT ( SendMessage ( hWnd, CB_LIMITTEXT, nMax, 0 ) ) ;
}



////////////////////////////////////////
//     Xg{bNXRg[     //
////////////////////////////////////////



int ListBox_AddStringA ( HWND hWnd, const char *szString ) {
   return LRESULT_TO_INT ( SendMessageA ( hWnd, LB_ADDSTRING, 0, (LPARAM) szString ) ) ;
}



int ListBox_AddStringW ( HWND hWnd, const wchar_t *szString ) {
   return LRESULT_TO_INT ( SendMessageW ( hWnd, LB_ADDSTRING, 0, (LPARAM) szString ) ) ;
}



int ListBox_InsertStringA ( HWND hWnd, int nIndex, const char *szString ) {
   return LRESULT_TO_INT ( SendMessageA ( hWnd, LB_INSERTSTRING, nIndex, (LPARAM) szString ) ) ;
}



int ListBox_InsertStringW ( HWND hWnd, int nIndex, const wchar_t *szString ) {
   return LRESULT_TO_INT ( SendMessageW ( hWnd, LB_INSERTSTRING, nIndex, (LPARAM) szString ) ) ;
}



int ListBox_GetCount ( HWND hWnd ) {
   return LRESULT_TO_INT ( SendMessage ( hWnd, LB_GETCOUNT, 0, 0 ) ) ;
}



int ListBox_ResetContent ( HWND hWnd ) {
   return LRESULT_TO_INT ( SendMessage ( hWnd, LB_RESETCONTENT, 0, 0 ) ) ;
}



int ListBox_GetCurSel ( HWND hWnd ) {
   return LRESULT_TO_INT ( SendMessage ( hWnd, LB_GETCURSEL, 0, 0 ) ) ;
}



int ListBox_SetCurSel ( HWND hWnd, int nIndex ) {
   return LRESULT_TO_INT ( SendMessage ( hWnd, LB_SETCURSEL, nIndex, 0 ) ) ;
}



int ListBox_GetTextA ( HWND hWnd, int nIndex, char *szString ) {
   if ( szString ) *szString = 0 ;
   return LRESULT_TO_INT ( SendMessageA ( hWnd, LB_GETTEXT, nIndex, (LPARAM) szString ) ) ;
}



int ListBox_GetTextW ( HWND hWnd, int nIndex, wchar_t *szString ) {
   if ( szString ) *szString = 0 ;
   return LRESULT_TO_INT ( SendMessageW ( hWnd, LB_GETTEXT, nIndex, (LPARAM) szString ) ) ;
}



int ListBox_GetTextLenA ( HWND hWnd, int nIndex ) {
   return LRESULT_TO_INT ( SendMessageA ( hWnd, LB_GETTEXTLEN, nIndex, 0 ) ) ;
}



int ListBox_GetTextLenW ( HWND hWnd, int nIndex ) {
   return LRESULT_TO_INT ( SendMessageW ( hWnd, LB_GETTEXTLEN, nIndex, 0 ) ) ;
}



////////////////////////////////////////
//       vOXRg[       //
////////////////////////////////////////



int ProgressCtrl_SetRange ( HWND hWnd, short nMin, short nMax ) {
   return LRESULT_TO_INT ( SendMessage ( hWnd, PBM_SETRANGE, 0, MAKELPARAM ( nMin, nMax ) ) ) ;
}



int ProgressCtrl_SetStep ( HWND hWnd, int nStep ) {
   return LRESULT_TO_INT ( SendMessage ( hWnd, PBM_SETSTEP, nStep, 0 ) ) ;
}



int ProgressCtrl_SetPos ( HWND hWnd, int nPos ) {
   return LRESULT_TO_INT ( SendMessage ( hWnd, PBM_SETPOS, nPos, 0 ) ) ;
}



int ProgressCtrl_StepIt ( HWND hWnd ) {
   return LRESULT_TO_INT ( SendMessage ( hWnd, PBM_STEPIT, 0, 0 ) ) ;
}



////////////////////////////////////////
//             c[o[             //
////////////////////////////////////////



int ToolBar_ButtonCount ( HWND hWnd ) {
   return LRESULT_TO_INT ( SendMessage ( hWnd, TB_BUTTONCOUNT, 0, 0 ) ) ;
}



int ToolBar_GetButton ( HWND hWnd, int nIndex, TBBUTTON *pButton ) {
   return LRESULT_TO_INT ( SendMessage ( hWnd, TB_GETBUTTON, nIndex, (LPARAM) pButton ) ) ;
}



#if _WIN32_IE < 0x0400
#define TB_GETBUTTONINFOW        (WM_USER + 63)
#define TB_GETBUTTONINFOA        (WM_USER + 65)
#endif



int ToolBar_GetButtonInfoA ( HWND hWnd, int nCommandId, TBBUTTONINFOA *pButtonInfo ) {
   return LRESULT_TO_INT ( SendMessageA ( hWnd, TB_GETBUTTONINFOA, nCommandId, (LPARAM) pButtonInfo ) ) ;
}



int ToolBar_GetButtonInfoW ( HWND hWnd, int nCommandId, TBBUTTONINFOW *pButtonInfo ) {
   return LRESULT_TO_INT ( SendMessageW ( hWnd, TB_GETBUTTONINFOW, nCommandId, (LPARAM) pButtonInfo ) ) ;
}



////////////////////////////////////////
//     R{{bNXRg[     //
////////////////////////////////////////



static int IsComctlVisualStyle ( void ) ;



#ifndef CB_SETMINVISIBLE
#define CB_SETMINVISIBLE   0x1701
#endif



// R{{bNXhbvƂ̍ݒ肷
//  0 As 0 ȊOԂ
int ComboBox_SetMaxHeight ( HWND hComboBox, int nItemMax ) {

   int nRetValue = 1 ;

   int nItem = ComboBox_GetCount ( hComboBox ) ;
   if ( nItem < 0 ) return nRetValue ;
   if ( nItem < nItemMax ) nItemMax = nItem ;
   if ( nItemMax < 1 ) nItemMax = 1 ;

   if ( IsComctlVisualStyle () ) {
      if ( SendMessageW ( hComboBox, CB_SETMINVISIBLE, nItemMax, 0 ) ) nRetValue = 0 ;
   }
   else {

      RECT Rect ;
      if ( ! GetWindowRect ( hComboBox, & Rect ) ) return nRetValue ;

      int nHeight = ComboBox_GetItemHeight ( hComboBox ) ;
      if ( nHeight < 0 ) return nRetValue ;
      nHeight = nHeight * ( nItemMax + 2 ) ;

      if ( SetWindowPos ( hComboBox, 0, 0, 0, Rect.right - Rect.left, nHeight, SWP_NOMOVE | SWP_NOACTIVATE | SWP_NOZORDER | SWP_NOOWNERZORDER ) ) nRetValue = 0 ;

      ComboBox_SetEditSel ( hComboBox, -1, 0 ) ;
   }

   return nRetValue ;
}



////////////////////////////////////////
//          XP Visual Style           //
////////////////////////////////////////



// shlwapi.h
typedef struct {
   DWORD cbSize ;
   DWORD dwMajorVersion ;        // Major version
   DWORD dwMinorVersion ;        // Minor version
   DWORD dwBuildNumber ;         // Build number
   DWORD dwPlatformID ;          // DLLVER_PLATFORM_*
} DLLVERSIONINFO ;



typedef HRESULT ( CALLBACK *DLLGETVERSION ) ( DLLVERSIONINFO *pdvi ) ;



static int IsComctlVisualStyle ( void ) {

   static volatile long nRetValueSaved = -1 ;
   if ( nRetValueSaved >= 0 ) return nRetValueSaved ;

   int nRetValue = 0 ;

   if ( IsWinXPorLater () ) {

      HINSTANCE hComctl32 = LoadLibraryW ( L"COMCTL32.DLL" ) ;
      DLLGETVERSION DllGetVersion = NULL ;

      if ( ! GETPROCADDRESS ( hComctl32, DLLGETVERSION, DllGetVersion ) ) {

         DLLVERSIONINFO DllVersionInfo = { sizeof(DLLVERSIONINFO) } ;

         if ( DllGetVersion ( &  DllVersionInfo ) == NOERROR ) {
            if ( DllVersionInfo.dwMajorVersion >= 6 ) nRetValue = 1 ;
         }
      }

      FreeLibrary ( hComctl32 ) ;
   }

   InterlockedExchange ( & nRetValueSaved, nRetValue ) ;

   return nRetValue ;
}



////////////////////////////////////////
//            t֐            //
////////////////////////////////////////



#define PRINTF_BUFFER_SIZE    ( MAX_PATH + 0x10 )



#if ! defined _MSC_VER || _MSC_VER < 1300
static int __cdecl vscprintf ( const char *format, va_list args ) ;
static int __cdecl vscwprintf ( const wchar_t *format, va_list args ) ;
#else
#define vscprintf _vscprintf
#define vscwprintf _vscwprintf
#endif



////////////////////////////////////////
//   bZ[W{bNXitj   //
////////////////////////////////////////



// t MessageBoxiANSIŁj
static int MessageBoxVaFormatA ( HWND hWnd, const char *szCaption, unsigned int uType, const char *format, va_list args ) {

   va_list args1 ;
   va_list args2 ;
   va_copy ( args1, args ) ;
   va_copy ( args2, args ) ;

   char buffer [ PRINTF_BUFFER_SIZE ] ;      // for short strings
   char *string = NULL ;
   char *message = buffer ;
   int result ;

   if ( ( result = vsnprintf ( buffer, PRINTF_BUFFER_SIZE, format, args ) ) < 0 || result > PRINTF_BUFFER_SIZE - 1 ) {

      buffer [ PRINTF_BUFFER_SIZE - 1 ] = 0 ;

      int length ;
      if ( ( length = vscprintf ( format, args1 ) ) < 0 ) goto CAUGHT_ERROR ;
      if ( ! ( string = (char*) malloc ( ( length + 1 ) * sizeof(char) ) ) ) goto CAUGHT_ERROR ;
      if ( ( result = vsnprintf ( string, length + 1, format, args2 ) ) < 0 || result > length ) goto CAUGHT_ERROR ;

      message = string ;
   }

   CAUGHT_ERROR :
   va_end ( args1 ) ;
   va_end ( args2 ) ;

   int retvalue = MessageBoxA ( hWnd, message, szCaption, uType ) ;

   free ( string ) ;

   return retvalue ;
}



// t MessageBoxiANSIŁj
int __cdecl MessageBoxFormatA ( HWND hWnd, const char *szCaption, unsigned int uType, const char *format,... ) {
   va_list args ;
   va_start ( args, format ) ;
   int retvalue = MessageBoxVaFormatA ( hWnd, szCaption, uType, format, args ) ;
   va_end ( args ) ;
   return retvalue ;
}



// t MessageBoxiUNICODEŁj
static int MessageBoxVaFormatW ( HWND hWnd, const wchar_t *szCaption, unsigned int uType, const wchar_t *format, va_list args ) {

   va_list args1 ;
   va_list args2 ;
   va_copy ( args1, args ) ;
   va_copy ( args2, args ) ;

   wchar_t buffer [ PRINTF_BUFFER_SIZE ] ;      // for short strings
   wchar_t *string = NULL ;
   wchar_t *message = buffer ;
   int result ;

   if ( ( result = vsnwprintf ( buffer, PRINTF_BUFFER_SIZE, format, args ) ) < 0 || result > PRINTF_BUFFER_SIZE - 1 ) {

      buffer [ PRINTF_BUFFER_SIZE - 1 ] = 0 ;

      int length ;
      if ( ( length = vscwprintf ( format, args1 ) ) < 0 ) goto CAUGHT_ERROR ;
      if ( ! ( string = (wchar_t*) malloc ( ( length + 1 ) * sizeof(wchar_t) ) ) ) goto CAUGHT_ERROR ;
      if ( ( result = vsnwprintf ( string, length + 1, format, args2 ) ) < 0 || result > length ) goto CAUGHT_ERROR ;

      message = string ;
   }

   CAUGHT_ERROR :
   va_end ( args1 ) ;
   va_end ( args2 ) ;

   int retvalue = MessageBoxW ( hWnd, message, szCaption, uType ) ;

   free ( string ) ;

   return retvalue ;
}



// t MessageBoxiUNICODEŁj
int __cdecl MessageBoxFormatW ( HWND hWnd, const wchar_t *szCaption, unsigned int uType, const wchar_t *format,... ) {
   va_list args ;
   va_start ( args, format ) ;
   int retvalue = MessageBoxVaFormatW ( hWnd, szCaption, uType, format, args ) ;
   va_end ( args ) ;
   return retvalue ;
}



////////////////////////////////////////
//       SendMessageitj      //
////////////////////////////////////////



// t SendMessageiANSIŁj
static LRESULT SendMessageVaFormatA ( HWND hWnd, UINT Msg, WPARAM wParam, const char *format, va_list args ) {

   va_list args1 ;
   va_list args2 ;
   va_copy ( args1, args ) ;
   va_copy ( args2, args ) ;

   char buffer [ PRINTF_BUFFER_SIZE ] ;      // for short strings
   char *string = NULL ;
   char *message = buffer ;
   int result ;

   if ( ( result = vsnprintf ( buffer, PRINTF_BUFFER_SIZE, format, args ) ) < 0 || result > PRINTF_BUFFER_SIZE - 1 ) {

      buffer [ PRINTF_BUFFER_SIZE - 1 ] = 0 ;

      int length ;
      if ( ( length = vscprintf ( format, args1 ) ) < 0 ) goto CAUGHT_ERROR ;
      if ( ! ( string = (char*) malloc ( ( length + 1 ) * sizeof(char) ) ) ) goto CAUGHT_ERROR ;
      if ( ( result = vsnprintf ( string, length + 1, format, args2 ) ) < 0 || result > length ) goto CAUGHT_ERROR ;

      message = string ;
   }

   CAUGHT_ERROR :
   va_end ( args1 ) ;
   va_end ( args2 ) ;

   LRESULT retvalue = SendMessageA ( hWnd, Msg, wParam, (LPARAM) message ) ;

   free ( string ) ;

   return retvalue ;
}



// t SendMessageiUNICODEŁj
static LRESULT SendMessageVaFormatW ( HWND hWnd, UINT Msg, WPARAM wParam, const wchar_t *format, va_list args ) {

   va_list args1 ;
   va_list args2 ;
   va_copy ( args1, args ) ;
   va_copy ( args2, args ) ;

   wchar_t buffer [ PRINTF_BUFFER_SIZE ] ;      // for short strings
   wchar_t *string = NULL ;
   wchar_t *message = buffer ;
   int result ;

   if ( ( result = vsnwprintf ( buffer, PRINTF_BUFFER_SIZE, format, args ) ) < 0 || result > PRINTF_BUFFER_SIZE - 1 ) {

      buffer [ PRINTF_BUFFER_SIZE - 1 ] = 0 ;

      int length ;
      if ( ( length = vscwprintf ( format, args1 ) ) < 0 ) goto CAUGHT_ERROR ;
      if ( ! ( string = (wchar_t*) malloc ( ( length + 1 ) * sizeof(wchar_t) ) ) ) goto CAUGHT_ERROR ;
      if ( ( result = vsnwprintf ( string, length + 1, format, args2 ) ) < 0 || result > length ) goto CAUGHT_ERROR ;

      message = string ;
   }

   CAUGHT_ERROR :
   va_end ( args1 ) ;
   va_end ( args2 ) ;

   LRESULT retvalue = SendMessageW ( hWnd, Msg, wParam, (LPARAM) message ) ;

   free ( string ) ;

   return retvalue ;
}



////////////////////////////////////////
//   EBhEʁitj   //
////////////////////////////////////////



// t Wm_SetTextiANSIŁj
int __cdecl Wm_SetTextFormatA ( HWND hWnd, const char *format,... ) {
   va_list args ;
   va_start ( args, format ) ;
   int retvalue = LRESULT_TO_INT ( SendMessageVaFormatA ( hWnd, WM_SETTEXT, 0, format, args ) ) ;
   va_end ( args ) ;
   return retvalue ;
}



// t Wm_SetTextiUNICODEŁj
int __cdecl Wm_SetTextFormatW ( HWND hWnd, const wchar_t *format,... ) {
   va_list args ;
   va_start ( args, format ) ;
   int retvalue = LRESULT_TO_INT ( SendMessageVaFormatW ( hWnd, WM_SETTEXT, 0, format, args ) ) ;
   va_end ( args ) ;
   return retvalue ;
}



// t Dlg_Wm_SetTextiANSIŁj
int __cdecl Dlg_Wm_SetTextFormatA ( HWND hDlg, int nId, const char *format,... ) {
   va_list args ;
   va_start ( args, format ) ;
   int retvalue = LRESULT_TO_INT ( SendMessageVaFormatA ( GetDlgItem ( hDlg, nId ), WM_SETTEXT, 0, format, args ) ) ;
   va_end ( args ) ;
   return retvalue ;
}



// t Dlg_Wm_SetTextiUNICODEŁj
int __cdecl Dlg_Wm_SetTextFormatW ( HWND hDlg, int nId, const wchar_t *format,... ) {
   va_list args ;
   va_start ( args, format ) ;
   int retvalue = LRESULT_TO_INT ( SendMessageVaFormatW ( GetDlgItem ( hDlg, nId ), WM_SETTEXT, 0, format, args ) ) ;
   va_end ( args ) ;
   return retvalue ;
}



////////////////////////////////////////
//     R{{bNXitj     //
////////////////////////////////////////



// t ComboBox_AddStringiANSIŁj
int __cdecl ComboBox_AddStringFormatA ( HWND hWnd, const char *format,... ) {
   va_list args ;
   va_start ( args, format ) ;
   int retvalue = LRESULT_TO_INT ( SendMessageVaFormatA ( hWnd, CB_ADDSTRING, 0, format, args ) ) ;
   va_end ( args ) ;
   return retvalue ;
}



// t ComboBox_AddStringiUNICODEŁj
int __cdecl ComboBox_AddStringFormatW ( HWND hWnd, const wchar_t *format,... ) {
   va_list args ;
   va_start ( args, format ) ;
   int retvalue = LRESULT_TO_INT ( SendMessageVaFormatW ( hWnd, CB_ADDSTRING, 0, format, args ) ) ;
   va_end ( args ) ;
   return retvalue ;
}



// t ComboBox_InsertStringiANSIŁj
int __cdecl ComboBox_InsertStringFormatA ( HWND hWnd, int nIndex, const char *format,... ) {
   va_list args ;
   va_start ( args, format ) ;
   int retvalue = LRESULT_TO_INT ( SendMessageVaFormatA ( hWnd, CB_INSERTSTRING, nIndex, format, args ) ) ;
   va_end ( args ) ;
   return retvalue ;
}



// t ComboBox_InsertStringiUNICODEŁj
int __cdecl ComboBox_InsertStringFormatW ( HWND hWnd, int nIndex, const wchar_t *format,... ) {
   va_list args ;
   va_start ( args, format ) ;
   int retvalue = LRESULT_TO_INT ( SendMessageVaFormatW ( hWnd, CB_INSERTSTRING, nIndex, format, args ) ) ;
   va_end ( args ) ;
   return retvalue ;
}



// t Dlg_ComboBox_AddStringiANSIŁj
int __cdecl Dlg_ComboBox_AddStringFormatA ( HWND hDlg, int nId, const char *format,... ) {
   va_list args ;
   va_start ( args, format ) ;
   int retvalue = LRESULT_TO_INT ( SendMessageVaFormatA ( GetDlgItem ( hDlg, nId ), CB_ADDSTRING, 0, format, args ) ) ;
   va_end ( args ) ;
   return retvalue ;
}



// t Dlg_ComboBox_AddStringiUNICODEŁj
int __cdecl Dlg_ComboBox_AddStringFormatW ( HWND hDlg, int nId, const wchar_t *format,... ) {
   va_list args ;
   va_start ( args, format ) ;
   int retvalue = LRESULT_TO_INT ( SendMessageVaFormatW ( GetDlgItem ( hDlg, nId ), CB_ADDSTRING, 0, format, args ) ) ;
   va_end ( args ) ;
   return retvalue ;
}



// t Dlg_ComboBox_InsertStringiANSIŁj
int __cdecl Dlg_ComboBox_InsertStringFormatA ( HWND hDlg, int nId, int nIndex, const char *format,... ) {
   va_list args ;
   va_start ( args, format ) ;
   int retvalue = LRESULT_TO_INT ( SendMessageVaFormatA ( GetDlgItem ( hDlg, nId ), CB_INSERTSTRING, nIndex, format, args ) ) ;
   va_end ( args ) ;
   return retvalue ;
}



// t Dlg_ComboBox_InsertStringiUNICODEŁj
int __cdecl Dlg_ComboBox_InsertStringFormatW ( HWND hDlg, int nId, int nIndex, const wchar_t *format,... ) {
   va_list args ;
   va_start ( args, format ) ;
   int retvalue = LRESULT_TO_INT ( SendMessageVaFormatW ( GetDlgItem ( hDlg, nId ), CB_INSERTSTRING, nIndex, format, args ) ) ;
   va_end ( args ) ;
   return retvalue ;
}



////////////////////////////////////////
//     Xg{bNXitj     //
////////////////////////////////////////



// t ListBox_AddStringiANSIŁj
int __cdecl ListBox_AddStringFormatA ( HWND hWnd, const char *format,... ) {
   va_list args ;
   va_start ( args, format ) ;
   int retvalue = LRESULT_TO_INT ( SendMessageVaFormatA ( hWnd, LB_ADDSTRING, 0, format, args ) ) ;
   va_end ( args ) ;
   return retvalue ;
}



// t ListBox_AddStringiUNICODEŁj
int __cdecl ListBox_AddStringFormatW ( HWND hWnd, const wchar_t *format,... ) {
   va_list args ;
   va_start ( args, format ) ;
   int retvalue = LRESULT_TO_INT ( SendMessageVaFormatW ( hWnd, LB_ADDSTRING, 0, format, args ) ) ;
   va_end ( args ) ;
   return retvalue ;
}



// t ListBox_InsertStringiANSIŁj
int __cdecl ListBox_InsertStringFormatA ( HWND hWnd, int nIndex, const char *format,... ) {
   va_list args ;
   va_start ( args, format ) ;
   int retvalue = LRESULT_TO_INT ( SendMessageVaFormatA ( hWnd, LB_INSERTSTRING, nIndex, format, args ) ) ;
   va_end ( args ) ;
   return retvalue ;
}



// t ListBox_InsertStringiUNICODEŁj
int __cdecl ListBox_InsertStringFormatW ( HWND hWnd, int nIndex, const wchar_t *format,... ) {
   va_list args ;
   va_start ( args, format ) ;
   int retvalue = LRESULT_TO_INT ( SendMessageVaFormatW ( hWnd, LB_INSERTSTRING, nIndex, format, args ) ) ;
   va_end ( args ) ;
   return retvalue ;
}



// t Dlg_ListBox_AddStringiANSIŁj
int __cdecl Dlg_ListBox_AddStringFormatA ( HWND hDlg, int nId, const char *format,... ) {
   va_list args ;
   va_start ( args, format ) ;
   int retvalue = LRESULT_TO_INT ( SendMessageVaFormatA ( GetDlgItem ( hDlg, nId ), LB_ADDSTRING, 0, format, args ) ) ;
   va_end ( args ) ;
   return retvalue ;
}



// t Dlg_ListBox_AddStringiUNICODEŁj
int __cdecl Dlg_ListBox_AddStringFormatW ( HWND hDlg, int nId, const wchar_t *format,... ) {
   va_list args ;
   va_start ( args, format ) ;
   int retvalue = LRESULT_TO_INT ( SendMessageVaFormatW ( GetDlgItem ( hDlg, nId ), LB_ADDSTRING, 0, format, args ) ) ;
   va_end ( args ) ;
   return retvalue ;
}



// t Dlg_ListBox_InsertStringiANSIŁj
int __cdecl Dlg_ListBox_InsertStringFormatA ( HWND hDlg, int nId, int nIndex, const char *format,... ) {
   va_list args ;
   va_start ( args, format ) ;
   int retvalue = LRESULT_TO_INT ( SendMessageVaFormatA ( GetDlgItem ( hDlg, nId ), LB_INSERTSTRING, nIndex, format, args ) ) ;
   va_end ( args ) ;
   return retvalue ;
}



// t Dlg_ListBox_InsertStringiUNICODEŁj
int __cdecl Dlg_ListBox_InsertStringFormatW ( HWND hDlg, int nId, int nIndex, const wchar_t *format,... ) {
   va_list args ;
   va_start ( args, format ) ;
   int retvalue = LRESULT_TO_INT ( SendMessageVaFormatW ( GetDlgItem ( hDlg, nId ), LB_INSERTSTRING, nIndex, format, args ) ) ;
   va_end ( args ) ;
   return retvalue ;
}



//////////////////////////////
//         vscprintf        //
//////////////////////////////



#undef vfwprintf  // not oem_vfwprintf



#if ! defined _MSC_VER || _MSC_VER < 1300
// Printfϊ̏o͂ɕKvȃobt@̒擾
// ԂiI[ NULL ܂܂Ȃj
static int __cdecl vscprintf ( const char *format, va_list args ) {
   FILE *stdnul = fopen ( "NUL", "wb" ) ;
   if ( ! stdnul ) return EOF ;
   int retvalue = vfprintf ( stdnul, format, args ) ;
   fclose ( stdnul ) ;
   return retvalue ;
}
#endif



#if ! defined _MSC_VER || _MSC_VER < 1300
// Printfϊ̏o͂ɕKvȃobt@̒擾
// ԂiI[ NULL ܂܂Ȃj
static int __cdecl vscwprintf ( const wchar_t *format, va_list args ) {
   FILE *stdnul = fopen ( "NUL", "wb" ) ;
   if ( ! stdnul ) return EOF ;
   int retvalue = vfwprintf ( stdnul, format, args ) ;
   fclose ( stdnul ) ;
   return retvalue ;
}
#endif



////////////////////////////////////////
//             WindowLong             //
////////////////////////////////////////



// EBhEvV[Wݒ肷iANSIŁj
WNDPROC SetWindowProcA ( HWND hWnd, WNDPROC WndProc ) {
   return (WNDPROC) SetWindowLongPtrA ( hWnd, GWLP_WNDPROC, (LONG_PTR) WndProc ) ;
}



// EBhEvV[Wݒ肷iUNICODEŁj
WNDPROC SetWindowProcW ( HWND hWnd, WNDPROC WndProc ) {
   return (WNDPROC) SetWindowLongPtrW ( hWnd, GWLP_WNDPROC, (LONG_PTR) WndProc ) ;
}



// EBhEvV[W擾iANSIŁj
WNDPROC GetWindowProcA ( HWND hWnd ) {
   return (WNDPROC) GetWindowLongPtrA ( hWnd, GWLP_WNDPROC ) ;
}



// EBhEvV[W擾iUNICODEŁj
WNDPROC GetWindowProcW ( HWND hWnd ) {
   return (WNDPROC) GetWindowLongPtrW ( hWnd, GWLP_WNDPROC ) ;
}



// _CAOvV[WԂlݒ肷
int SetDlgMsgResult ( HWND hWnd, LRESULT lResult ) {
   if ( IsNT () ) SetWindowLongPtrW ( hWnd, DWLP_MSGRESULT, lResult ) ;
   else           SetWindowLongPtrA ( hWnd, DWLP_MSGRESULT, lResult ) ;
   return 0 ;
}



