// shfolder.cpp

#include <windows.h>
#include <shlobj.h>
#include <stdlib.h>
#include <string.h>
#include "msc.h"
#include "shfolder.h"



static LPITEMIDLIST WINAPI ShOpenItemIdListInternal ( wchar_t *szPath ) ;
static HRESULT ShGetAttributesInternal ( LPCITEMIDLIST pItemIdList, SFGAOF *pSfGaof ) ;
static HRESULT ShBindToParent ( LPCITEMIDLIST pItemIdList, REFIID RefIid, void **ppObject, LPCITEMIDLIST *pItemIdListLast ) ;
static LPITEMIDLIST ShILCombine ( LPCITEMIDLIST pBase, LPCITEMIDLIST pAdd ) ;
static LPCITEMIDLIST ShILFindLastID ( LPCITEMIDLIST pItemIdList ) ;
static size_t ShILGetSize ( LPCITEMIDLIST pItemIdList ) ;
static HRESULT StrretToBufA ( STRRET *pStrret, LPCITEMIDLIST pItemIdList, char *szBuffer, int nBufferSize ) ;
static HRESULT StrretToBufW ( STRRET *pStrret, LPCITEMIDLIST pItemIdList, wchar_t *szBuffer, int nBufferSize ) ;


// IMalloc
#define ShAlloc   CoTaskMemAlloc
#define ShFree    CoTaskMemFree


#ifndef NTFUNC_IMPORT_IMPLICITLY
#define SHGetPathFromIDListW SHGetPathFromIDListW_
#define ShellExecuteExW ShellExecuteExW_
static BOOL WINAPI SHGetPathFromIDListW ( LPCITEMIDLIST pidl, LPWSTR pszPath ) ;
static BOOL WINAPI ShellExecuteExW ( LPSHELLEXECUTEINFOW lpExecInfo ) ;
#endif



///////////////////////////////////
//    ITEMIDLIST ̎擾Ɖ    //
///////////////////////////////////



// pX ITEMIDLIST 擾iANSIŁj
// szPath ɂ̓tpXA܂ GUID  "::{GUID}" w
//  ITEMIDLIST ̃|C^As NULL Ԃ
LPITEMIDLIST WINAPI ShOpenItemIdListA ( const char *szPath ) {

   wchar_t szPathTmp [ MAX_PATH ] ;
   if ( ! MultiByteToWideChar ( CP_ACP, 0, szPath, -1, szPathTmp, MAX_PATH ) ) return NULL ;

   return ShOpenItemIdListInternal ( szPathTmp ) ;
}



// pX ITEMIDLIST 擾iUNICODEŁj
// szPath ɂ̓tpXA܂ GUID  "::{GUID}" w
//  ITEMIDLIST ̃|C^As NULL Ԃ
LPITEMIDLIST WINAPI ShOpenItemIdListW ( const wchar_t *szPath ) {

   wchar_t *szPathTmp = wcsdup_max ( szPath, MAX_LONG_PATH ) ;
   if ( ! szPathTmp ) return NULL ;

   LPITEMIDLIST pItemIdList = ShOpenItemIdListInternal ( szPathTmp ) ;

   free ( szPathTmp ) ;
   return pItemIdList ;
}



// ShOpenItemIdList ̉֐
//  ITEMIDLIST ̃|C^As NULL Ԃ
static LPITEMIDLIST WINAPI ShOpenItemIdListInternal ( wchar_t *szPath ) {

   LPITEMIDLIST pItemIdList = NULL ;

   IShellFolder *pIShellFolder ;
   if ( SUCCEEDED ( SHGetDesktopFolder ( & pIShellFolder ) ) ) {
      pIShellFolder->ParseDisplayName ( NULL, NULL, szPath, NULL, & pItemIdList, NULL ) ;
      pIShellFolder->Release () ;
   }

   return pItemIdList ;
}



// ȃtH_[ ITEMIDLIST 擾
//  ITEMIDLIST ̃|C^As NULL Ԃ
LPITEMIDLIST WINAPI ShOpenSpecialItemIdList ( int nCsidl ) {

   LPITEMIDLIST pItemIdList ;

   if ( ! SUCCEEDED ( SHGetSpecialFolderLocation ( NULL, nCsidl, & pItemIdList ) ) ) pItemIdList = NULL ;

   return pItemIdList ;
}



// ITEMIDLIST 
//  0 , s 0 ȊOԂ
int WINAPI ShCloseItemIdList ( LPITEMIDLIST pItemIdList ) {

   ShFree ( pItemIdList ) ;

   return 0 ;
}



///////////////////////////////////
//       ITEMIDLIST ̉       //
///////////////////////////////////



// ITEMIDLIST pX擾iANSIŁj
//  0 , s 0 ȊOԂ
int WINAPI ShGetPathA ( LPCITEMIDLIST pItemIdList, char *szPath ) {

   *szPath = 0 ;
   int nRetValue = 1 ;

   if ( SHGetPathFromIDListA ( pItemIdList, szPath ) ) nRetValue = 0 ;

   return nRetValue ;
}



// ITEMIDLIST pX擾iUNICODEŁj
//  0 , s 0 ȊOԂ
int WINAPI ShGetPathW ( LPCITEMIDLIST pItemIdList, wchar_t *szPath ) {

   *szPath = 0 ;
   int nRetValue = 1 ;

   if ( SHGetPathFromIDListW ( pItemIdList, szPath ) ) nRetValue = 0 ;

   return nRetValue ;
}



// ITEMIDLIST \擾iANSIŁj
//  0 , s 0 ȊOԂ
int WINAPI ShGetDisplayNameA ( LPCITEMIDLIST pItemIdList, char *szName ) {

   *szName = 0 ;
   int nRetValue = 1 ;

   IShellFolder *pIShellFolder ;
   if ( SUCCEEDED ( ShBindToParent ( pItemIdList, IID_IShellFolder, (void**) & pIShellFolder, & pItemIdList ) ) ) {
      STRRET Strret ;
      if ( SUCCEEDED ( pIShellFolder->GetDisplayNameOf ( pItemIdList, SHGDN_INFOLDER, & Strret ) ) ) {
         if ( SUCCEEDED ( StrretToBufA ( & Strret, pItemIdList, szName, MAX_PATH ) ) ) nRetValue = 0 ;
      }
      pIShellFolder->Release () ;
   }

   return nRetValue ;
}



// ITEMIDLIST \擾iUNICODEŁj
//  0 , s 0 ȊOԂ
int WINAPI ShGetDisplayNameW ( LPCITEMIDLIST pItemIdList, wchar_t *szName ) {

   *szName = 0 ;
   int nRetValue = 1 ;

   IShellFolder *pIShellFolder ;
   if ( SUCCEEDED ( ShBindToParent ( pItemIdList, IID_IShellFolder, (void**) & pIShellFolder, & pItemIdList ) ) ) {
      STRRET Strret ;
      if ( SUCCEEDED ( pIShellFolder->GetDisplayNameOf ( pItemIdList, SHGDN_INFOLDER, & Strret ) ) ) {
         if ( SUCCEEDED ( StrretToBufW ( & Strret, pItemIdList, szName, MAX_PATH ) ) ) nRetValue = 0 ;
      }
      pIShellFolder->Release () ;
   }

   return nRetValue ;
}



// ITEMIDLIST pX܂ GUID 擾iANSIŁj
//  0 , s 0 ȊOԂ
int WINAPI ShGetNameForParsingA ( LPCITEMIDLIST pItemIdList, char *szName ) {

   *szName = 0 ;
   int nRetValue = 1 ;

   IShellFolder *pIShellFolder ;
   if ( SUCCEEDED ( ShBindToParent ( pItemIdList, IID_IShellFolder, (void**) & pIShellFolder, & pItemIdList ) ) ) {
      STRRET Strret ;
      if ( SUCCEEDED ( pIShellFolder->GetDisplayNameOf ( pItemIdList, SHGDN_FORPARSING, & Strret ) ) ) {
         if ( SUCCEEDED ( StrretToBufA ( & Strret, pItemIdList, szName, MAX_PATH ) ) ) nRetValue = 0 ;
      }
      pIShellFolder->Release () ;
   }

   return nRetValue ;
}



// ITEMIDLIST pX܂ GUID 擾iUNICODEŁj
//  0 , s 0 ȊOԂ
int WINAPI ShGetNameForParsingW ( LPCITEMIDLIST pItemIdList, wchar_t *szName ) {

   *szName = 0 ;
   int nRetValue = 1 ;

   IShellFolder *pIShellFolder ;
   if ( SUCCEEDED ( ShBindToParent ( pItemIdList, IID_IShellFolder, (void**) & pIShellFolder, & pItemIdList ) ) ) {
      STRRET Strret ;
      if ( SUCCEEDED ( pIShellFolder->GetDisplayNameOf ( pItemIdList, SHGDN_FORPARSING, & Strret ) ) ) {
         if ( SUCCEEDED ( StrretToBufW ( & Strret, pItemIdList, szName, MAX_PATH ) ) ) nRetValue = 0 ;
      }
      pIShellFolder->Release () ;
   }

   return nRetValue ;
}



// ITEMIDLIST 瑮擾
// iSFGAOFj shobjidl.h ̐錾
//  iSFGAOFj, s INVALID_FILE_ATTRIBUTES Ԃ
SFGAOF WINAPI ShGetAttributes ( LPCITEMIDLIST pItemIdList ) {

   SFGAOF SfGaof ;

   if ( ! SUCCEEDED ( ShGetAttributesInternal ( pItemIdList, & SfGaof ) ) ) SfGaof = (SFGAOF) INVALID_FILE_ATTRIBUTES ;

   return SfGaof ;
}



// ITEMIDLIST  CSIDL 擾
//  CSIDL As畉Ԃ
int WINAPI ShGetCsidl ( LPCITEMIDLIST pItemIdList ) {

   int nRetValue = -1 ;

   IShellFolder *pIShellFolder ;
   if ( SUCCEEDED ( SHGetDesktopFolder ( & pIShellFolder ) ) ) {

      for ( int nCsidl = CSIDL_DESKTOP ; nCsidl <= CSIDL_MAX ; nCsidl ++ ) {
         LPITEMIDLIST pItemIdListTmp = ShOpenSpecialItemIdList ( nCsidl ) ;
         if ( pItemIdListTmp ) {
            HRESULT hResult = pIShellFolder->CompareIDs ( 0, pItemIdList, pItemIdListTmp ) ;
            if ( SUCCEEDED ( hResult ) && ! (short) HRESULT_CODE ( hResult ) ) {
               nRetValue = nCsidl ;
               break ;
            }
            ShCloseItemIdList ( pItemIdListTmp ) ;
         }
      }

      pIShellFolder->Release () ;
   }

   return nRetValue ;
}



//  ITEMIDLIST r
// pIsError  NULL ł
//  pIsError  0 ZbgArʂԂ
// s pIsError  0 ȊOZbg
int WINAPI ShCompareItemIdList ( LPCITEMIDLIST pItemIdList1, LPCITEMIDLIST pItemIdList2, int *pIsError ) {

   HRESULT hResult = E_FAIL ;

   IShellFolder *pIShellFolder ;
   if ( SUCCEEDED ( SHGetDesktopFolder ( & pIShellFolder ) ) ) {
      hResult = pIShellFolder->CompareIDs ( 0, pItemIdList1, pItemIdList2 ) ;
      pIShellFolder->Release () ;
   }

   if ( pIsError ) *pIsError = ! SUCCEEDED ( hResult ) ;

   return (short) HRESULT_CODE ( hResult ) ;
}



///////////////////////////////////
//       ITEMIDLIST ̗       //
///////////////////////////////////



// tH_ ITEMIDLIST  q ITEMIDLIST 
// R[obN֐ 0 ԂA񋓂~
//                    0 ȊOԂA񋓂p
//  0 , s 0 ȊOԂ
int WINAPI ShEnumItemIdList ( LPCITEMIDLIST pItemIdList, int ( CALLBACK *CallbackProc ) ( LPITEMIDLIST pItemIdList, LPARAM lParam ), unsigned long dwFlags, LPARAM lParam ) {

   int nRetValue = 1 ;

   IShellFolder *pIShellFolder ;
   LPCITEMIDLIST pItemIdListLast ;

   if ( SUCCEEDED ( ShBindToParent ( pItemIdList, IID_IShellFolder, (void**) & pIShellFolder, & pItemIdListLast ) ) ) {

      IShellFolder *pIShellFolderSub ;
      if ( IsDesktopItemIdList ( pItemIdListLast ) ) pIShellFolderSub = pIShellFolder ;
      else if ( ! SUCCEEDED ( pIShellFolder->BindToObject ( pItemIdListLast, NULL, IID_IShellFolder, (void**) & pIShellFolderSub ) ) ) pIShellFolderSub = NULL ;

      if ( pIShellFolderSub ) {

         unsigned long dwEnumFlags = ( SHCONTF_FOLDERS | SHCONTF_NONFOLDERS ) ;
         if ( dwFlags & ENUMITEMIDLIST_FOLDER_ONLY ) dwEnumFlags &= ~ SHCONTF_NONFOLDERS ;
         if ( dwFlags & ENUMITEMIDLIST_FILE_ONLY ) dwEnumFlags &= ~ SHCONTF_FOLDERS ;
         if ( dwFlags & ENUMITEMIDLIST_HIDDEN ) dwEnumFlags |= SHCONTF_INCLUDEHIDDEN ;

         IEnumIDList *pIEnumIdList ;
         if ( SUCCEEDED ( pIShellFolderSub->EnumObjects ( NULL, dwEnumFlags, & pIEnumIdList ) ) ) {

            nRetValue = 0 ;

            LPITEMIDLIST pItemIdListSub ;
            unsigned long dwNumber ;
            while ( ! pIEnumIdList->Next ( 1, & pItemIdListSub, & dwNumber ) ) {

               LPITEMIDLIST pItemIdListSubFul = ShILCombine ( pItemIdList, pItemIdListSub ) ;
               ShCloseItemIdList ( pItemIdListSub ) ;
               if ( ! pItemIdListSubFul ) continue ;

               int IsContinue = CallbackProc ( pItemIdListSubFul, lParam ) ;

               if ( ! ( dwFlags & ENUMITEMIDLIST_CLOSE_BY_USER ) ) ShCloseItemIdList ( pItemIdListSubFul ) ;
               if ( ! IsContinue ) break ;
            }

            pIEnumIdList->Release () ;
         }

         if ( pIShellFolderSub != pIShellFolder ) pIShellFolderSub->Release () ;
      }

      pIShellFolder->Release () ;
   }

   return nRetValue ;
}



///////////////////////////////////
//       ITEMIDLIST ̑       //
///////////////////////////////////



// ʂȃtH_JiANSIŁj
//  0 , s 0 ȊOԂ
int WINAPI ShExecuteA ( HWND hWnd, const char *szVerb, LPCITEMIDLIST pItemIdList, const char *szArguments, const char *szDirectory, int nShowCmd ) {

   size_t nLength = ShILGetSize ( pItemIdList ) ;
   LPITEMIDLIST pItemIdListTmp = (LPITEMIDLIST) malloc ( nLength ) ;
   if ( ! pItemIdListTmp ) return 1 ;
   memmove ( pItemIdListTmp, pItemIdList, nLength ) ;

   SHELLEXECUTEINFOA ShellExecuteInfo = { 0 } ;
   ShellExecuteInfo.cbSize = sizeof(SHELLEXECUTEINFOA) ;
   ShellExecuteInfo.hwnd = hWnd ;
   ShellExecuteInfo.lpVerb = szVerb ;
   ShellExecuteInfo.lpParameters = szArguments ;
   ShellExecuteInfo.lpDirectory = szDirectory ;
   ShellExecuteInfo.nShow = nShowCmd ;
   ShellExecuteInfo.fMask = SEE_MASK_INVOKEIDLIST | SEE_MASK_FLAG_NO_UI ;
   ShellExecuteInfo.lpIDList = pItemIdListTmp ;

   int nResult = ! ShellExecuteExA ( & ShellExecuteInfo ) ;

   free ( pItemIdListTmp ) ;
   return nResult ;
}



// ʂȃtH_JiUNICODEŁj
//  0 , s 0 ȊOԂ
int WINAPI ShExecuteW ( HWND hWnd, const wchar_t *szVerb, LPCITEMIDLIST pItemIdList, const wchar_t *szArguments, const wchar_t *szDirectory, int nShowCmd ) {

   size_t nLength = ShILGetSize ( pItemIdList ) ;
   LPITEMIDLIST pItemIdListTmp = (LPITEMIDLIST) malloc ( nLength ) ;
   if ( ! pItemIdListTmp ) return 1 ;
   memmove ( pItemIdListTmp, pItemIdList, nLength ) ;

   SHELLEXECUTEINFOW ShellExecuteInfo = { 0 } ;
   ShellExecuteInfo.cbSize = sizeof(SHELLEXECUTEINFOW) ;
   ShellExecuteInfo.hwnd = hWnd ;
   ShellExecuteInfo.lpVerb = szVerb ;
   ShellExecuteInfo.lpParameters = szArguments ;
   ShellExecuteInfo.lpDirectory = szDirectory ;
   ShellExecuteInfo.nShow = nShowCmd ;
   ShellExecuteInfo.fMask = SEE_MASK_INVOKEIDLIST | SEE_MASK_FLAG_NO_UI ;
   ShellExecuteInfo.lpIDList = pItemIdListTmp ;

   int nResult = ! ShellExecuteExW ( & ShellExecuteInfo ) ;

   free ( pItemIdListTmp ) ;
   return nResult ;
}



///////////////////////////////////
//     ITEMIDLIST XV̒ʒm     //
///////////////////////////////////



// VFɕύXʒm
// Cxg shlobj.h ̐錾
// Cxg 0 w肵 SHCNE_UPDATEITEM ƌȂ
//  0 As 0 ȊOԂ
int WINAPI ShChangeNotify ( int nEvent, LPCITEMIDLIST pItemIdList1, LPCITEMIDLIST pItemIdList2, int IsImmediately ) {

   if ( ! nEvent ) nEvent = SHCNE_UPDATEITEM ;

   SHChangeNotify ( nEvent, SHCNF_IDLIST | ( IsImmediately ) ? SHCNF_FLUSH : 0, pItemIdList1, pItemIdList2 ) ;

   return 0 ;
}



/////////////////////////////////
//          ֐           //
/////////////////////////////////



// SHBindToParent Ɠ
// Win95/98/NT4 ł̓GNX|[gĂȂߎOŏ
//  0 As 0 ȊOԂ
static HRESULT ShBindToParent ( LPCITEMIDLIST pItemIdList, REFIID RefIid, void **ppObject, LPCITEMIDLIST *pItemIdListLast ) {

   if ( ! ppObject ) return E_POINTER ;
   if ( ! pItemIdList ) return E_INVALIDARG ;

   *ppObject = NULL ;
   if ( pItemIdListLast ) *pItemIdListLast = NULL ;

   IShellFolder *pIShellFolder ;
   HRESULT hResult = SHGetDesktopFolder ( & pIShellFolder ) ;
   if ( SUCCEEDED ( hResult ) ) {

      LPCITEMIDLIST pLast = ShILFindLastID ( pItemIdList ) ;

      if ( pLast == pItemIdList ) hResult = pIShellFolder->QueryInterface ( RefIid, ppObject ) ;
      else {
         size_t nLength = (const char*) pLast - (const char*) pItemIdList ;
         LPITEMIDLIST pParent = (LPITEMIDLIST) malloc ( nLength + sizeof(pItemIdList->mkid.cb) ) ;
         if ( ! pParent ) hResult = E_OUTOFMEMORY ;
         else {
            memmove ( pParent, pItemIdList, nLength ) ;
            ((LPITEMIDLIST)( (char*) pParent + nLength ))->mkid.cb = 0 ;
            hResult = pIShellFolder->BindToObject ( pParent, 0, RefIid, ppObject ) ;
            free ( pParent ) ;
         }
      }

      pIShellFolder->Release () ;

      if ( pItemIdListLast ) *pItemIdListLast = pLast ;
   }

   return hResult ;
}



// ILCombine Ɠ
// Win95/98/NT4 ł̓GNX|[gĂȂߎOŏ
// Q ITEMIDLIST AAV ITEMIDLIST 쐬
// ǂ炩 NULL Ȃ΁AITEMIDLIST ̕
static LPITEMIDLIST ShILCombine ( LPCITEMIDLIST pBase, LPCITEMIDLIST pAdd ) {

   if ( ! pBase && ! pAdd ) return NULL ;

   size_t nBaseSize = ( pBase ) ? ( ShILGetSize ( pBase ) - sizeof(pBase->mkid.cb) ) : 0 ;
   size_t nAddSize = ( pAdd ) ? ( ShILGetSize ( pAdd ) - sizeof(pAdd->mkid.cb) ) : 0 ;

   LPITEMIDLIST pNew = (LPITEMIDLIST) ShAlloc ( nBaseSize + nAddSize + sizeof(pBase->mkid.cb) ) ;
   if ( ! pNew ) return NULL ;

   if ( pBase ) memmove ( pNew, pBase, nBaseSize ) ;
   if ( pAdd ) memmove ( (char*) pNew + nBaseSize, pAdd, nAddSize ) ;
   ((LPITEMIDLIST)( (char*) pNew + nBaseSize + nAddSize ))->mkid.cb = 0 ;

   return pNew ;
}



// ILFindLastID Ɠ
// Win95/98/NT4 ł̓GNX|[gĂȂߎOŏ
// ITEMIDLIST 疖 ITEMID 擾
static LPCITEMIDLIST ShILFindLastID ( LPCITEMIDLIST pItemIdList ) {

   if ( ! pItemIdList ) return NULL ;

   LPCITEMIDLIST pCurrent = pItemIdList ;

   while ( 1 ) {
      LPCITEMIDLIST pNext = (LPCITEMIDLIST) ( (const char*) pCurrent + pCurrent->mkid.cb ) ;
      if ( ! pNext->mkid.cb ) break ;
      pCurrent = pNext ;
   }

   return pCurrent ;
}



// ILGetSize Ɠ
// Win95/98/NT4 ł̓GNX|[gĂȂߎOŏ
// ITEMIDLIST ̃TCYԂ
static size_t ShILGetSize ( LPCITEMIDLIST pItemIdList ) {

   if ( ! pItemIdList ) return 0 ;

   LPCITEMIDLIST pLast = ShILFindLastID ( pItemIdList ) ;

   return (const char*) pLast - (const char*) pItemIdList + pLast->mkid.cb + sizeof(pItemIdList->mkid.cb) ;
}



// ITEMIDLIST 瑮擾
// OɕKvȏ SFGAOF Ƀ}XNĂ
static HRESULT ShGetAttributesInternal ( LPCITEMIDLIST pItemIdList, SFGAOF *pSfGaof ) {

   HRESULT hResult = E_FAIL ;

   IShellFolder *pIShellFolder ;
   if ( SUCCEEDED ( ShBindToParent ( pItemIdList, IID_IShellFolder, (void**) & pIShellFolder, & pItemIdList ) ) ) {
      hResult = pIShellFolder->GetAttributesOf ( 1, & pItemIdList, pSfGaof ) ;
      pIShellFolder->Release () ;
   }

   return hResult ;
}



//////////////////////////////
//       NT FUNCTIONS       //
//////////////////////////////



#ifndef NTFUNC_IMPORT_IMPLICITLY



typedef BOOL ( WINAPI *SHGETPATHFROMIDLISTW ) ( LPCITEMIDLIST pidl, LPWSTR pszPath ) ;
typedef BOOL ( WINAPI *SHELLEXECUTEEXW ) ( LPSHELLEXECUTEINFOW lpExecInfo ) ;
static HINSTANCE hShell32 ;
static int FreeLibraryOnDetach ( void ) ;



static BOOL WINAPI SHGetPathFromIDListW ( LPCITEMIDLIST pidl, LPWSTR pszPath ) {
#undef SHGetPathFromIDListW

   static SHGETPATHFROMIDLISTW SHGetPathFromIDListW ;
   static volatile int IsTried ;

   if ( ! IsTried ) {
#ifdef _MT
      EnterCriticalSection ( & LoadDllSection ) ;
      __try {
         if ( ! IsTried ) {
#endif
            if ( ! hShell32 && ( hShell32 = LoadLibraryW ( L"SHELL32.DLL" ) ) ) FreeLibraryOnDetach () ;
            GETPROCADDRESS ( hShell32, SHGETPATHFROMIDLISTW, SHGetPathFromIDListW ) ;
            IsTried = 1 ;
#ifdef _MT
         }
      } __finally {
         LeaveCriticalSection ( & LoadDllSection ) ;
      }
#endif
   }
   if ( ! SHGetPathFromIDListW ) return FALSE ;

   return SHGetPathFromIDListW ( pidl, pszPath ) ;
}



static BOOL WINAPI ShellExecuteExW ( LPSHELLEXECUTEINFOW lpExecInfo ) {
#undef ShellExecuteExW

   static SHELLEXECUTEEXW ShellExecuteExW ;
   static volatile int IsTried ;

   if ( ! IsTried ) {
#ifdef _MT
      EnterCriticalSection ( & LoadDllSection ) ;
      __try {
         if ( ! IsTried ) {
#endif
            if ( ! hShell32 && ( hShell32 = LoadLibraryW ( L"SHELL32.DLL" ) ) ) FreeLibraryOnDetach () ;
            GETPROCADDRESS ( hShell32, SHELLEXECUTEEXW, ShellExecuteExW ) ;
            IsTried = 1 ;
#ifdef _MT
         }
      } __finally {
         LeaveCriticalSection ( & LoadDllSection ) ;
      }
#endif
   }
   if ( ! ShellExecuteExW ) return FALSE ;

   return ShellExecuteExW ( lpExecInfo ) ;
}



static void __cdecl ExitProc ( void ) {
   if ( hShell32 ) FreeLibrary ( hShell32 ) ;
}



static int FreeLibraryOnDetach ( void ) {
#ifdef _USRDLL
   return atexit ( ExitProc ) ;
#else
   return 0 ;
#endif
}



#endif



/////////////////////////////////
//           STRRET            //
/////////////////////////////////



// StrRetToBufA Ɠ
// Win95/98/NT4 ł̓GNX|[gĂȂߎOŏ
// STRRET 𕶎ɕϊ
static HRESULT StrretToBufA ( STRRET *pStrret, LPCITEMIDLIST pItemIdList, char *szBuffer, int nBufferSize ) {

   HRESULT hResult = E_FAIL ;

   switch ( pStrret->uType ) {
      case STRRET_WSTR :
         if ( nBufferSize && pStrret->pOleStr ) {
            w2alcpy ( szBuffer, pStrret->pOleStr, nBufferSize ) ;
            ShFree ( pStrret->pOleStr ) ;
            pStrret->pOleStr = NULL ;
            hResult = S_OK ;
         }
         break ;
      case STRRET_OFFSET :
         if ( nBufferSize ) {
            strlcpy ( szBuffer, (const char*) pItemIdList + pStrret->uOffset, nBufferSize ) ;
            hResult = S_OK ;
         }
         break ;
      case STRRET_CSTR :
         if ( nBufferSize ) {
            strlcpy ( szBuffer, pStrret->cStr, nBufferSize ) ;
            hResult = S_OK ;
         }
         break ;
   }

   return hResult ;
}



// StrRetToBufW Ɠ
// Win95/98/NT4 ł̓GNX|[gĂȂߎOŏ
// STRRET 𕶎ɕϊ
static HRESULT StrretToBufW ( STRRET *pStrret, LPCITEMIDLIST pItemIdList, wchar_t *szBuffer, int nBufferSize ) {

   HRESULT hResult = E_FAIL ;

   switch ( pStrret->uType ) {
      case STRRET_WSTR :
         if ( nBufferSize && pStrret->pOleStr ) {
            wcslcpy ( szBuffer, pStrret->pOleStr, nBufferSize ) ;
            ShFree ( pStrret->pOleStr ) ;
            pStrret->pOleStr = NULL ;
            hResult = S_OK ;
         }
         break ;
      case STRRET_OFFSET :
         if ( nBufferSize ) {
            a2wlcpy ( szBuffer, (const char*) pItemIdList + pStrret->uOffset, nBufferSize ) ;
            hResult = S_OK ;
         }
         break ;
      case STRRET_CSTR :
         if ( nBufferSize ) {
            a2wlcpy ( szBuffer, pStrret->cStr, nBufferSize ) ;
            hResult = S_OK ;
         }
         break ;
   }

   return hResult ;
}



////////////////////////////////////
//       [eBeBi1j      //
////////////////////////////////////



// CSIDL̃tH_擾iANSIŁj
// Win95 ł̓GNX|[gĂȂߎOŏ
//  SHGetSpecialFolderPath ƓA fCreate ͖
//  0 , s 0 ȊOԂ
int WINAPI GetSpecialFolderPathA ( HWND hWnd, char *szPath, int nCsidl, int fCreate ) {

   int nResult = 1 ;
   *szPath = 0 ;

   LPITEMIDLIST pItemIdList = ShOpenSpecialItemIdList ( nCsidl ) ;
   if ( pItemIdList ) {
      if ( ! ShGetPathA ( pItemIdList, szPath ) ) nResult = 0 ;
      ShCloseItemIdList ( pItemIdList ) ;
   }

   return nResult ;
}



// CSIDL̃tH_擾iUNICODEŁj
// Win95 ł̓GNX|[gĂȂߎOŏ
//  SHGetSpecialFolderPath ƓA fCreate ͖
//  0 , s 0 ȊOԂ
int WINAPI GetSpecialFolderPathW ( HWND hWnd, wchar_t *szPath, int nCsidl, int fCreate ) {

   int nResult = 1 ;
   *szPath = 0 ;

   LPITEMIDLIST pItemIdList = ShOpenSpecialItemIdList ( nCsidl ) ;
   if ( pItemIdList ) {
      if ( ! ShGetPathW ( pItemIdList, szPath ) ) nResult = 0 ;
      ShCloseItemIdList ( pItemIdList ) ;
   }

   return nResult ;
}



////////////////////////////////////
//       [eBeBi2j      //
////////////////////////////////////



// CSIDL̃tH_JiANSIŁj
//  0 , s 0 ȊOԂ
int WINAPI OpenSpecialFolderA ( HWND hWnd, const char *szVerb, int nCsidl, int nShowCmd ) {

   int nResult = 1 ;

   LPITEMIDLIST pItemIdList = ShOpenSpecialItemIdList ( nCsidl ) ;
   if ( pItemIdList ) {
      if ( ! ShExecuteA ( hWnd, szVerb, pItemIdList, NULL, NULL, nShowCmd ) ) nResult = 0 ;
      ShCloseItemIdList ( pItemIdList ) ;
   }

   return nResult ;
}



// CSIDL̃tH_JiUNICODEŁj
//  0 , s 0 ȊOԂ
int WINAPI OpenSpecialFolderW ( HWND hWnd, const wchar_t *szVerb, int nCsidl, int nShowCmd ) {

   int nResult = 1 ;

   LPITEMIDLIST pItemIdList = ShOpenSpecialItemIdList ( nCsidl ) ;
   if ( pItemIdList ) {
      if ( ! ShExecuteW ( hWnd, szVerb, pItemIdList, NULL, NULL, nShowCmd ) ) nResult = 0 ;
      ShCloseItemIdList ( pItemIdList ) ;
   }

   return nResult ;
}



////////////////////////////////////
//       [eBeBi3j      //
////////////////////////////////////



// VFɍXVʒmiANSIŁj
// Cxg shlobj.h ̐錾
// Cxg 0 w肵 SHCNE_UPDATEITEM ƌȂ
//  0 As 0 ȊOԂ
int WINAPI ShellChangeNotifyA ( int nEvent, const char *szPathName1, const char *szPathName2, int IsImmediately ) {

   LPITEMIDLIST pItemIdList1 = NULL ;
   LPITEMIDLIST pItemIdList2 = NULL ;
   int nResult = 1 ;

   if ( szPathName1 ) {
      pItemIdList1 = ShOpenItemIdListA ( szPathName1 ) ;
      if ( ! pItemIdList1 ) goto CAUGHT_ERROR ;
   }
   if ( szPathName2 ) {
      pItemIdList1 = ShOpenItemIdListA ( szPathName2 ) ;
      if ( ! pItemIdList2 ) goto CAUGHT_ERROR ;
   }

   nResult = ShChangeNotify ( nEvent, pItemIdList1, pItemIdList2, IsImmediately ) ;

   CAUGHT_ERROR :
   if ( pItemIdList1 ) ShCloseItemIdList ( pItemIdList1 ) ;
   if ( pItemIdList2 ) ShCloseItemIdList ( pItemIdList2 ) ;

   return nResult ;
}



// VFɍXVʒmiUNICODEŁj
// Cxg shlobj.h ̐錾
// Cxg 0 w肵 SHCNE_UPDATEITEM ƌȂ
//  0 As 0 ȊOԂ
int WINAPI ShellChangeNotifyW ( int nEvent, const wchar_t *szPathName1, const wchar_t *szPathName2, int IsImmediately ) {

   LPITEMIDLIST pItemIdList1 = NULL ;
   LPITEMIDLIST pItemIdList2 = NULL ;
   int nResult = 1 ;

   if ( szPathName1 ) {
      pItemIdList1 = ShOpenItemIdListW ( szPathName1 ) ;
      if ( ! pItemIdList1 ) goto CAUGHT_ERROR ;
   }
   if ( szPathName2 ) {
      pItemIdList1 = ShOpenItemIdListW ( szPathName2 ) ;
      if ( ! pItemIdList2 ) goto CAUGHT_ERROR ;
   }

   nResult = ShChangeNotify ( nEvent, pItemIdList1, pItemIdList2, IsImmediately ) ;

   CAUGHT_ERROR :
   if ( pItemIdList1 ) ShCloseItemIdList ( pItemIdList1 ) ;
   if ( pItemIdList2 ) ShCloseItemIdList ( pItemIdList2 ) ;

   return nResult ;
}



